/**
 * \file
 *
 * \brief DFLLǗ
 *
 * 쌠 (c) 2010-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef CLK_DFLL_H_INCLUDED
#define CLK_DFLL_H_INCLUDED

#include <parts.h>
#include "conf_clock.h"

#if UC3L
# include "uc3l/dfll.h"
#elif SAM4L
# include "sam4l/dfll.h"
#else
# error Unsupported chip type
#endif

/**
 * \ingroup clk_group
 * \defgroup dfll_group DFLLǗ
 *
 * ޼َgŒ艻H(DFLL)PLLƂقړl̕@łႭsQƊ
 * ۯɐmȎg𐶐̂Ɏgp邱Ƃł܂BDFLL͈ʓI
 * ɂZnԂƂႢד܂B͎QƊۯ̎gpȂ
 * Ⴂx̎g𐶐JHŎgp邱Ƃł܂B
 *
 * @\x邱ƂŊՊԂő傫ȕω邩܂B
 *
 * \par :ҰިދDFLL0\ݒ
 *
 * ȉ̗͌`ԐݒقʂĎw肵ҰpĕHDFLL0`
 * Ԑݒ肵ċ@܂B
 * \code
	dfll_enable_config_defaults(0); \endcode
 *
 * ҰpĕHDFLL0`Ԑݒ肵ċAǂx̂߂
 * ިނ̂悤ȓ@\邽߂ɁȀ菇gp邱Ƃł
 * B
 * \code
	struct dfll_config dfllcfg;

	dfll_enable_source(CONFIG_DFLL0_SOURCE);
	dfll_config_defaults(&dfllcfg, 0);
	dfll_config_enable_dithering(&dfllcfg);
	dfll_enable(&dfllcfg, 0);
	dfll_wait_for_accurate_lock(0); \endcode
 *
 * Ō̊֐ĂяoԂƁADFLL0͉\Ȍ萳mɊ`Ԑݒɍv
 * gősĂ܂B`Ԑݒɑ΂ǂ̒ǉύX
 * dfll_config_enable_dithering()ɑ΂ĂяoƓꏊɒǉ邱Ƃł
 * ܂Aިނ֎~ꍇɌ"m"Œ艻BȂƂɒӂ
 * ĂB
 *
 * @{
 */

//! \name ߓLDFLL
//@{
/**
 * \def NR_DFLLS
 * \brief ߏDFLL
 */
/**
 * \def DFLL_MIN_HZ
 * \brief DFLLłŏg
 */
/**
 * \def DFLL_MAX_HZ
 * \brief DFLLłőg
 */
//@}

/**
 * \typedef dfll_refclk_t
 * \brief DFLLp̎QƊۯʂ̂Ɏgp^
 */

//! \name DFLL`Ԑݒ
//@{

/**
 * \struct dfll_config
 * \brief DFLL`Ԑݒʰ޳L\
 *
 * ̍\݂̂͌DFLL`Ԑݒ\1܂͂葽޲Ll܂݂
 * B̍\̂̓e͈ʓIɊՖɈႢAgp҂DFLL`ԐݒAPIʂ
 * Aǂ̗̈౸ׂł͂܂B
 */

/**
 * \fn void dfll_config_init_open_loop_mode(struct dfll_config *cfg)
 * \brief JHp\a cfg DFLL`Ԑݒ`Ԑݒ
 *
 * \param  cfg DFLL`Ԑݒ
 */
/**
 * \fn void dfll_config_init_closed_loop_mode(struct dfll_config *cfg,
 *              dfll_refclk_t refclk, uint16_t div, uint16_t mul)
 * \brief Hp\a cfg DFLL`Ԑݒ`Ԑݒ
 *
 * \param  cfg    DFLL`Ԑݒ
 * \param  refclk QƊۯ
 * \param  div    QƊۯ
 * \param  mul    {(̂)
 */
/**
 * \def dfll_config_defaults(cfg, dfll_id)
 * \brief ҰpDFLL`Ԑݒ
 *
 * ̊֐߂A\a cfgDFLLCONFIG_DFLLx_SOURCE
 * (CONFIG_DFLLx_MUL / CONFIG_DFLLx_DIV){̎gős`Ԑݒ܂݂
 * B`Ԑݒ͏ɕ{ȂŕHgp܂B
 *
 * \param  cfg     DFLL`Ԑݒ
 * \param  dfll_id DFLLɑ΂Ċgp
 */
/**
 * \def dfll_get_default_rate(dfll_id)
 * \brief \a dfll_id̊葬xHzŕԂ܂B
 */

/**
 * \fn void dfll_config_set_fractional_multiplier(struct dfll_config *cfg,
 *              uint16_t mul_i, uint16_t mul_f)
 * \brief {ݒ
 *
 * ̊֐͊JHŖŁA{x޲łp\łB
 *
 * {̏16ޯĂƉ肳܂Bײނ͕Kvȏꍇʰ޳ɍ
 * 悤ɂ̒l̈ړmɂ܂B
 *
 * \param  cfg   ύXDFLL`Ԑݒ
 * \param  mul_i {̐
 * \param  mul_f {̏
 */
/**
 * \fn void dfll_config_enable_dithering(struct dfll_config *cfg)
 * \brief 萳mȎĝ߂ިނ
 *
 * VCOւׂ̍LSB͂͐{ɑ΂镪ߎB邽߂ިނ
 * ܂B
 *
 * \param  cfg ύXDFLL`Ԑݒ
 */
/**
 * \fn void dfll_config_disable_dithering(struct dfll_config *cfg)
 * \brief ިދ֎~
 *
 * \see dfll_config_enable_dithering()
 *
 * \param  cfg ύXDFLL`Ԑݒ
 */
/**
 * \fn void dfll_config_set_initial_tuning(struct dfll_config *cfg,
 *              uint16_t coarse, uint16_t fine)
 * \brief VCOݒ
 *
 * JHŁA͏o͂̎g߂܂B
 *
 * HŁAVCȌl񋟂܂BDFLL]ޏo͎gɍ
 * 悤ɂ̒lIɒƂ͌Al̒Ӑ[I͑ě
 * 艻B鎞Ԃ炵܂B
 *
 * \param  cfg    ύXDFLL`Ԑݒ
 * \param  coarse g̑a
 * \param  fine   g̔
 */
/**
 * \fn void dfll_config_set_max_step(struct dfll_config *cfg,
 *              uint16_t coarse, uint16_t fine)
 * \brief VCOőiKʂݒ
 *
 * ̊֐͊JHŖłB
 *
 * ɂA痼̒l͂eX̍ő50%ɐݒ肳܂B荂
 * ǂ̒lɐݒ肷邱Ƃ܂񂪁AႢ̐ݒ͑ěŒ艻
 * B蒷Ԃ]ɂĎg̍s߂炷܂B
 *
 * \param  cfg    ύXDFLL`Ԑݒ
 * \param  coarse VCOa̍őiK
 * \param  fine   VCO̍őiK
 */
/**
 * \fn void dfll_config_enable_ssg(struct dfll_config *cfg,
 *              uint16_t amplitude, uint16_t step_size)
 * \brief U߸ѐ
 *
 * \param  cfg       ύXDFLL`Ԑݒ
 * \param  amplitude ߸ѕU̐U
 * \param  step_size ߸ѕU̒iK
 */
/**
 * \fn void dfll_config_disable_ssg(struct dfll_config *cfg)
 * \brief U߸ѐ֎~
 *
 * \param  cfg ύXDFLL`Ԑݒ
 */
//@}

//! \name DFLLʰ޳Wł̑ݍp
//@{
/**
 * \fn void dfll_enable_open_loop(const struct dfll_config *cfg,
 *              unsigned int dfll_id)
 * \brief \a cfǧ`Ԑݒɂ\a dfll_idDFLLJHŋ܂B
 *
 * \pre \a cfǧ`Ԑݒ͊JH`ԐݒȂ΂Ȃ܂B
 *
 * \param  cfg     ɂ`Ԑݒ
 * \param  dfll_id DFLL̎ʎq
 */
/**
 * \fn void dfll_enable_closed_loop(const struct dfll_config *cfg,
 *              unsigned int dfll_id)
 * \brief \a cfǧ`Ԑݒɂ\a dfll_idDFLLHŋ܂B
 *
 * \pre \a cfǧ`Ԑݒ͕H`ԐݒȂ΂Ȃ܂B
 *
 * \param  cfg     ɂ`Ԑݒ
 * \param  dfll_id DFLL̎ʎq
 */
/**
 * \fn void dfll_disable_open_loop(unsigned int dfll_id)
 * \brief \a dfll_idɂĎʂDFLL֎~
 *
 * \pre DFLL͊JHŋĂȂ΂Ȃ܂B
 *
 * \param  dfll_id ֎~DFLL̎ʎq
 */
/**
 * \fn void dfll_disable_closed_loop(unsigned int dfll_id)
 * \brief \a dfll_idɂĎʂDFLL֎~
 *
 * \pre DFLL͕HŋĂȂ΂Ȃ܂B
 *
 * \param  dfll_id ֎~DFLL̎ʎq
 */
/**
 * \fn bool dfll_is_coarse_locked(unsigned int dfll_id)
 * \brief DFLLaŒ艻BĂ邩ۂ𔻒
 *
 * \param  dfll_id ׂDFLL̎ʎq
 *
 * \retval true  DFLL肵VCOal̍ŏIl܂B
 * \retval false DFLL肵VCOal𖢂ȂA܂͋Ă
 *               ܂B
 */
/**
 * \fn bool dfll_is_fine_locked(unsigned int dfll_id)
 * \brief DFLLŒ艻BĂ邩ۂ𔻒
 *
 * \param  dfll_id ׂDFLL̎ʎq
 *
 * \retval true  DFLL肵VCOl̍ŏIl܂B
 * \retval false DFLL肵VCOl𖢂ȂA܂͋Ă
 *               ܂B
 */
/**
 * \fn bool dfll_is_accurate_locked(unsigned int dfll_id)
 * \brief DFLLmȌŒ艻BĂ邩ۂ𔻒
 *
 * \param  dfll_id ׂDFLL̎ʎq
 *
 * \retval true  DFLL͌肳ꂽŏIި ިè ق܂B
 * \retval false DFLL͌肳ꂽި ިè قȂA܂ިދ
 *               ŋĂ܂B
 */
/**
 * \fn void dfll_enable_source(enum dfll_refclk_t src)
 * \brief DFLL̋BsĂȂꍇɋ
 *        ܂B
 *
 * \param  src DFLL̎ʎq
 */
/**
 * \fn void dfll_enable_config_defaults(unsigned int dfll_id)
 * \brief `ԐݒDFLL
 *        DFLLŒ艻ĂȂ΁ADFLL܂B
 *
 * \param  dfll_id DFLL̎ʎq
 */

/**
 * \brief aŒ艻B邽߂\a dfll_idɂĎʂDFLLɑ΂
 *        ҋ@
 *
 * \param  dfll_id ҂DFLL̎ʎq
 *
 * \retval STATUS_OK   DFLL͑aŒ艻B
 * \retval ERR_TIMEOUT Œ艻ҋ@Ԓ
 */
static inline int dfll_wait_for_coarse_lock(unsigned int dfll_id)
{
	/* ׂ:ԋ@\ǉ */
	while (!dfll_is_coarse_locked(dfll_id)) {
		/* 邱ƂȂ */
	}

	return 0;
}

/**
 * \brief Œ艻B邽߂\a dfll_idɂĎʂDFLLɑ΂
 *        ҋ@
 *
 * \param  dfll_id ҂DFLL̎ʎq
 *
 * \retval STATUS_OK   DFLL͔Œ艻B
 * \retval ERR_TIMEOUT Œ艻ҋ@Ԓ
 */
static inline int dfll_wait_for_fine_lock(unsigned int dfll_id)
{
	/* ׂ:ԋ@\ǉ */
	while (!dfll_is_fine_locked(dfll_id)) {
		/* 邱ƂȂ */
	}

	return 0;
}

/**
 * \brief mȌŒ艻B邽߂\a dfll_idɂĎʂDFLLɑ΂
 *        ҋ@
 *
 * \param  dfll_id ҂DFLL̎ʎq
 *
 * \retval STATUS_OK   DFLL͐mȌŒ艻B
 * \retval ERR_TIMEOUT Œ艻ҋ@Ԓ
 */
static inline int dfll_wait_for_accurate_lock(unsigned int dfll_id)
{
	/* ׂ:ԋ@\ǉ */
	while (!dfll_is_accurate_locked(dfll_id)) {
		/* 邱ƂȂ */
	}

	return 0;
}

//@}
//! @}

#endif /* CLK_DFLL_H_INCLUDED */
