/**
 * \file
 *
 * \brief ߓLUǗ֐
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef CHIP_OSC_H_INCLUDED
#define CHIP_OSC_H_INCLUDED

#include <board.h>

#ifdef __cplusplus
extern "C" {
#endif


/**
 * \weakgroup osc_group
 * @{
 */

//! \name U펯ʎq
//@{
#define OSC_ID_OSC0				0	//!< OU0
#define OSC_ID_OSC32			1	//!< O32kHzU
#define OSC_ID_RC32K			2	//!< 32kHz RCU
#define OSC_ID_RC80M			3	//!< 80MHz RCU
#define OSC_ID_RCFAST			4	//!< 4-8-12MHz RCFASTU
#define OSC_ID_RC1M				5	//!< 1MHz RCU
#define OSC_ID_RCSYS			6	//!< RCU
//@}

//! \name OSC0l
//@{
//! XINɐڑꂽOۯ
#define OSC_MODE_EXTERNAL		0
//! XIN/XOUTɐڑꂽؽ
#define OSC_MODE_XTAL			SCIF_OSCCTRL0_MODE
//@}

//! \name OSC32l
//@{
//! XIN32ɐڑꂽOۯ
#define OSC32_MODE_EXTERNAL		BSCIF_OSCCTRL32_MODE(0)
//! XIN32/XOUT32ɐڑꂽؽ
#define OSC32_MODE_XTAL			BSCIF_OSCCTRL32_MODE(1)
//! dXIN32/XOUT32ɐڑꂽؽ
#define OSC32_MODE_XTAL_HC		BSCIF_OSCCTRL32_MODE(4)
//@}

//! \name OSC0nl
//@{
//! 0
#define OSC_STARTUP_0			SCIF_OSCCTRL0_STARTUP(0)
//! 64(560s)
#define OSC_STARTUP_64			SCIF_OSCCTRL0_STARTUP(1)
//! 128(1.1ms)
#define OSC_STARTUP_128			SCIF_OSCCTRL0_STARTUP(2)
//! 2048(18ms)
#define OSC_STARTUP_2048		SCIF_OSCCTRL0_STARTUP(3)
//! 4096(36ms)
#define OSC_STARTUP_4096		SCIF_OSCCTRL0_STARTUP(4)
//! 8192(71ms)
#define OSC_STARTUP_8192		SCIF_OSCCTRL0_STARTUP(5)
//! 16384(143ms)
#define OSC_STARTUP_16384		SCIF_OSCCTRL0_STARTUP(6)
//! 32768(285ms)
#define OSC_STARTUP_32768		SCIF_OSCCTRL0_STARTUP(7)
//@}

//! \name OSC32nl
//@{
//! 0
#define OSC32_STARTUP_0			BSCIF_OSCCTRL32_STARTUP(0)
//! 128(1.1ms)
#define OSC32_STARTUP_128		BSCIF_OSCCTRL32_STARTUP(1)
//! 8192(72.3ms)
#define OSC32_STARTUP_8192		BSCIF_OSCCTRL32_STARTUP(2)
//! 16384(143ms)
#define OSC32_STARTUP_16384		BSCIF_OSCCTRL32_STARTUP(3)
//! 65536(570ms)
#define OSC32_STARTUP_65536		BSCIF_OSCCTRL32_STARTUP(4)
//! 131072(1.1s)
#define OSC32_STARTUP_131072	BSCIF_OSCCTRL32_STARTUP(5)
//! 262144(2.3s)
#define OSC32_STARTUP_262144	BSCIF_OSCCTRL32_STARTUP(6)
//! 524288(4.6s)
#define OSC32_STARTUP_524288	BSCIF_OSCCTRL32_STARTUP(7)
//@}

/**
 * \def OSC0_STARTUP_TIMEOUT
 * \brief OSC0Jn҂߂̒ᑬۯ
 *
 * 25%̒ǉS]TOSC0_STARTUP_VALUEɑΉᑬۯ
 * B̐ԌoߎɔU킪ĂȂꍇAJnɎsƉ肳
 * ܂B
 */
/**
 * \def OSC0_MODE_VALUE
 * \brief PM_OSCCTRL(0)MODEޯė̈ɏˑl
 */
/**
 * \def OSC0_STARTUP_VALUE
 * \brief PM_OSCCTRL(0)STARTUPޯė̈ɏˑl
 */
#if defined(BOARD_OSC0_STARTUP_US)
#   if BOARD_OSC0_STARTUP_US == 0
#      define OSC0_STARTUP_VALUE    OSC_STARTUP_0
#      define OSC0_STARTUP_TIMEOUT  8
#   elif BOARD_OSC0_STARTUP_US <= 557
#      define OSC0_STARTUP_VALUE    OSC_STARTUP_64
#      define OSC0_STARTUP_TIMEOUT  80
#   elif BOARD_OSC0_STARTUP_US <= 1100
#      define OSC0_STARTUP_VALUE    OSC_STARTUP_128
#      define OSC0_STARTUP_TIMEOUT  160
#   elif BOARD_OSC0_STARTUP_US <= 18000
#      define OSC0_STARTUP_VALUE    OSC_STARTUP_2048
#      define OSC0_STARTUP_TIMEOUT  2560
#   elif BOARD_OSC0_STARTUP_US <= 36000
#      define OSC0_STARTUP_VALUE    OSC_STARTUP_4096
#      define OSC0_STARTUP_TIMEOUT  5120
#   elif BOARD_OSC0_STARTUP_US <= 71000
#      define OSC0_STARTUP_VALUE    OSC_STARTUP_8192
#      define OSC0_STARTUP_TIMEOUT  10240
#   elif BOARD_OSC0_STARTUP_US <= 143000
#      define OSC0_STARTUP_VALUE    OSC_STARTUP_16384
#      define OSC0_STARTUP_TIMEOUT  20480
#   elif BOARD_OSC0_STARTUP_US <= 285000
#      define OSC0_STARTUP_VALUE    OSC_STARTUP_32768
#      define OSC0_STARTUP_TIMEOUT  40960
#   else
#      error BOARD_OSC0_STARTUP_US is too high
#   endif
#   if BOARD_OSC0_IS_XTAL == true
#      define OSC0_MODE_VALUE       OSC_MODE_XTAL
#      if BOARD_OSC0_HZ < 2000000
#         define OSC0_GAIN_VALUE      SCIF_OSCCTRL0_GAIN(0)
#      elif BOARD_OSC0_HZ < 4000000
#         define OSC0_GAIN_VALUE      SCIF_OSCCTRL0_GAIN(1)
#      elif BOARD_OSC0_HZ < 8000000
#         define OSC0_GAIN_VALUE      SCIF_OSCCTRL0_GAIN(2)
#      elif BOARD_OSC0_HZ < 16000000
#         define OSC0_GAIN_VALUE      SCIF_OSCCTRL0_GAIN(3)
#      else
#         define OSC0_GAIN_VALUE      ((0x1u << 4) | SCIF_OSCCTRL0_GAIN(0))
#      endif
#   else
#      define OSC0_MODE_VALUE       OSC_MODE_EXTERNAL
#   endif
#else
#   if defined(BOARD_OSC0_HZ)
#      error BOARD_OSC0_STARTUP_US must be defined by the board code
#   endif
#   ifdef __DOXYGEN__
#      define OSC0_STARTUP_VALUE     UNDEFINED
#      define OSC0_STARTUP_TIMEOUT   UNDEFINED
#      define OSC0_MODE_VALUE        UNDEFINED
#   endif
#endif

#if defined(BOARD_OSC32_STARTUP_US)
#   if BOARD_OSC32_STARTUP_US == 0
#      define OSC32_STARTUP_VALUE    OSC32_STARTUP_0
#   elif BOARD_OSC32_STARTUP_US   <= 1100
#      define OSC32_STARTUP_VALUE    OSC32_STARTUP_128
#   elif BOARD_OSC32_STARTUP_US   <= 72300
#      define OSC32_STARTUP_VALUE    OSC32_STARTUP_8192
#   elif BOARD_OSC32_STARTUP_US   <= 143000
#      define OSC32_STARTUP_VALUE    OSC32_STARTUP_16384
#   elif BOARD_OSC32_STARTUP_US   <= 570000
#      define OSC32_STARTUP_VALUE    OSC32_STARTUP_65536
#   elif BOARD_OSC32_STARTUP_US   <= 1100000
#      define OSC32_STARTUP_VALUE    OSC32_STARTUP_131072
#   elif BOARD_OSC32_STARTUP_US   <= 2300000
#      define OSC32_STARTUP_VALUE    OSC32_STARTUP_262144
#   elif BOARD_OSC32_STARTUP_US   <= 4600000
#      define OSC32_STARTUP_VALUE    OSC32_STARTUP_524288
#   else
#      error BOARD_OSC32_STARTUP_US is too high
#   endif
#   if BOARD_OSC32_IS_XTAL == true
#      define OSC32_MODE_VALUE       OSC32_MODE_XTAL
#   else
#      define OSC32_MODE_VALUE       OSC32_MODE_EXTERNAL
#   endif
#else
#   if defined(BOARD_OSC32_HZ)
#      error BOARD_OSC32_STARTUP_US must be defined by the board code
#   endif
#   ifdef __DOXYGEN__
#      define OSC32_STARTUP_VALUE     UNDEFINED
#      define OSC32_STARTUP_TIMEOUT   UNDEFINED
#      define OSC32_MODE_VALUE        UNDEFINED
#   endif
#endif

// `Ԑݒ肪ꍇARCRASTUɑ΂4MHz̎ggp
#ifndef CONFIG_RCFAST_FRANGE
#define CONFIG_RCFAST_FRANGE	0
#endif

/**
 * \name L`ԐݒҰ
 * ȉ̒`͊œSĂ̔Uɑ΂ĊɂĒ񋟂Ȃ
 * Ȃ܂B
 */
//@{
/**
 * \def BOARD_OSC0_HZ
 * \brief HzłOSC0̸ۯg
 */
/**
 * \def BOARD_OSC0_STARTUP_US
 * \brief msłOSC0̎n
 */
/**
 * \def BOARD_OSC0_IS_XTAL
 * \brief OSC0͊Oۯł͂Ȃؽقgp
 */
/**
 * \def BOARD_OSC32_HZ
 * \brief HzłOSC32̸ۯg
 */
/**
 * \def BOARD_OSC32_STARTUP_US
 * \brief msłOSC32̎n
 */
/**
 * \def BOARD_OSC32_IS_XTAL
 * \brief OSC32͊Oۯł͂Ȃؽقgp
 */
/**
 * \def BOARD_OSC32_SELCURR
 * \brief OSC32pؽٓdI
 *
 * `ȂꍇAl(300nA)gp܂B
 */
#ifndef BOARD_OSC32_SELCURR
#   define BOARD_OSC32_SELCURR     BSCIF_OSCCTRL32_SELCURR(10)
#endif

/**
 * \name RCUgE
 * RCU̎g͉xω̌ʂƂďϓ邩܂B
 * ̒`͐ԁAꂽۯgȂǂ̏ƉvẐɎgp
 * 邩ȂƉ񋟂܂B
 */
//@{
#define OSC_RCSYS_NOMINAL_HZ		115000		//!< HzłRCSYS̕Wg
#define OSC_RCSYS_MIN_HZ			100000		//!< HzłRXSYS̍Œg
#define OSC_RCSYS_MAX_HZ			120000		//!< HzłRXSYS̍ōg

#define OSC_RC32K_NOMINAL_HZ		32768		//!< HzłRC32Ǩ̎g
#define OSC_RC32K_MIN_HZ			20000		//!< HzłRC32K̍Œg
#define OSC_RC32K_MAX_HZ			44000		//!< HzłRC32K̍ōg

#define OSC_RC80M_NOMINAL_HZ		80000000	//!< HzłRC80M̌̎g

#define OSC_RCFAST4M_NOMINAL_HZ		4000000		//!< HzłRCFAST4M̌̎g

#define OSC_RCFAST8M_NOMINAL_HZ		8000000		//!< HzłRCFAST8M̌̎g

#define OSC_RCFAST12M_NOMINAL_HZ	12000000	//!< HzłRCFAST12M̌̎g

#define OSC_RC1M_NOMINAL_HZ			1000000		//!< HzłRC1M̌̎g
//@}

#ifndef __ASSEMBLY__

#include <compiler.h>

extern void osc_priv_enable_osc0(void);
extern void osc_priv_disable_osc0(void);
extern void osc_priv_enable_osc32(void);
extern void osc_priv_disable_osc32(void);
extern void osc_priv_enable_rc32k(void);
extern void osc_priv_disable_rc32k(void);
extern void osc_priv_enable_rc80m(void);
extern void osc_priv_disable_rc80m(void);
extern void osc_priv_enable_rcfast(void);
extern void osc_priv_disable_rcfast(void);
extern void osc_priv_enable_rc1m(void);
extern void osc_priv_disable_rc1m(void);

static inline void osc_enable(uint8_t id)
{
	switch (id) {
#ifdef BOARD_OSC0_HZ
	case OSC_ID_OSC0:
		osc_priv_enable_osc0();
		break;
#endif

#ifdef BOARD_OSC32_HZ
	case OSC_ID_OSC32:
		osc_priv_enable_osc32();
		break;
#endif

	case OSC_ID_RC32K:
		osc_priv_enable_rc32k();
		break;

	case OSC_ID_RC80M:
		osc_priv_enable_rc80m();
		break;

	case OSC_ID_RCFAST:
		osc_priv_enable_rcfast();
		break;

	case OSC_ID_RC1M:
		osc_priv_enable_rc1m();
		break;

	case OSC_ID_RCSYS:
		/* RCSYS͏ɑs */
		break;

	default:
		/* unhandled_case(id); */
		break;
	}
}

static inline void osc_disable(uint8_t id)
{
	switch (id) {
#ifdef BOARD_OSC0_HZ
	case OSC_ID_OSC0:
		osc_priv_disable_osc0();
		break;
#endif

#ifdef BOARD_OSC32_HZ
	case OSC_ID_OSC32:
		osc_priv_disable_osc32();
		break;
#endif

	case OSC_ID_RC32K:
		osc_priv_disable_rc32k();
		break;

	case OSC_ID_RC80M:
		osc_priv_disable_rc80m();
		break;

	case OSC_ID_RCFAST:
		osc_priv_disable_rcfast();
		break;

	case OSC_ID_RC1M:
		osc_priv_disable_rc1m();
		break;

	case OSC_ID_RCSYS:
		/* RCSYS͏ɑs */
		break;

	default:
		/* unhandled_case(id); */
		break;
	}
}

static inline bool osc_is_ready(uint8_t id)
{
	switch (id) {
#ifdef BOARD_OSC0_HZ
	case OSC_ID_OSC0:
		return !!(SCIF->SCIF_PCLKSR & SCIF_PCLKSR_OSC0RDY);
#endif

#ifdef BOARD_OSC32_HZ
	case OSC_ID_OSC32:
		return !!(BSCIF->BSCIF_PCLKSR & BSCIF_PCLKSR_OSC32RDY);
#endif

	case OSC_ID_RC32K:
		return !!(BSCIF->BSCIF_RC32KCR & (BSCIF_RC32KCR_EN));

	case OSC_ID_RC80M:
		return !!(SCIF->SCIF_RC80MCR & (SCIF_RC80MCR_EN));

	case OSC_ID_RCFAST:
		return !!(SCIF->SCIF_RCFASTCFG & (SCIF_RCFASTCFG_EN));

	case OSC_ID_RC1M:
		return !!(BSCIF->BSCIF_RC1MCR & (BSCIF_RC1MCR_CLKOE));

	case OSC_ID_RCSYS:
		/* RCSYS͏ɑs */
		return true;

	default:
		/* unhandled_case(id); */
		return false;
	}
}

static inline uint32_t osc_get_rate(uint8_t id)
{
	switch (id) {
#ifdef BOARD_OSC0_HZ
	case OSC_ID_OSC0:
		return BOARD_OSC0_HZ;
#endif

#ifdef BOARD_OSC32_HZ
	case OSC_ID_OSC32:
		return BOARD_OSC32_HZ;
#endif

	case OSC_ID_RC32K:
		return OSC_RC32K_NOMINAL_HZ;

	case OSC_ID_RC80M:
		return OSC_RC80M_NOMINAL_HZ;

	case OSC_ID_RCFAST:
		if (CONFIG_RCFAST_FRANGE == 2) {
			return OSC_RCFAST12M_NOMINAL_HZ;

		} else if (CONFIG_RCFAST_FRANGE == 1) {
			return OSC_RCFAST8M_NOMINAL_HZ;

		} else {
			return OSC_RCFAST4M_NOMINAL_HZ;
		}

	case OSC_ID_RC1M:
		return OSC_RC1M_NOMINAL_HZ;

	case OSC_ID_RCSYS:
		return OSC_RCSYS_NOMINAL_HZ;

	default:
		/* unhandled_case(id); */
		return 0;
	}
}

#endif /* !__ASSEMBLY__ */

//! @}

#ifdef __cplusplus
}
#endif

#endif /* CHIP_OSC_H_INCLUDED */
