/**
 * \file
 *
 * \brief USBuʐMu׽(CDC)̪`
 *
 * 쌠 (c) 2009 - 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _UDI_CDC_H_
#define _UDI_CDC_H_

#include "conf_usb.h"
#include "usb_protocol.h"
#include "usb_protocol_cdc.h"
#include "udd.h"
#include "udc_desc.h"
#include "udi.h"

// ߰Đ
#ifndef  UDI_CDC_PORT_NB
# define  UDI_CDC_PORT_NB 1
#endif
#if (UDI_CDC_PORT_NB < 1) || (UDI_CDC_PORT_NB > 7)
# error UDI_CDC_PORT_NB must be between 1 and 7
#endif

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \addtogroup udi_cdc_group_udc
 * @{
 */

//! IDCpWUDI API܂ޑS\
extern UDC_DESC_STORAGE udi_api_t udi_api_cdc_comm;
extern UDC_DESC_STORAGE udi_api_t udi_api_cdc_data;
//@}

/**
 * \ingroup udi_cdc_group
 * \defgroup udi_cdc_group_desc USB荞݋Lqq
 *
 * ȉ̍\̂͗\ߒ`ꂽUSB-̪Lqq񋟂܂B͍ŏIIUSB
 * Lqq`̂ɎgpȂ΂Ȃ܂B
 */
//@{

/**
 * \brief ʐM׽ ̪Lqq
 *
 * CDCʐM׽ ̪ɑ΂ĘAg@\ƴ߲ċLqq²̪Lqq
 */
typedef struct {
	usb_iface_desc_t iface;					//!< W̪Lqq
	usb_cdc_hdr_desc_t header;				//!< CDC擪@\Lqq
	usb_cdc_acm_desc_t acm;					//!< CDCېl@\Lqq
	usb_cdc_union_desc_t union_desc;		//!< CDCp̋@\Lqq
	usb_cdc_call_mgmt_desc_t call_mgmt;		//!< CDCĂяoǗ@\Lqq
	usb_ep_desc_t ep_notify;				//!< ʒm߲ċLqq
} udi_cdc_comm_desc_t;

/**
 * \brief ް ׽ ̪Lqq
 *
 * CDCް ׽ ̪ɑ΂Ēg߲ċLqq²̪Lqq
 */
typedef struct {
	usb_iface_desc_t iface;		//!< W̪Lqq
	usb_ep_desc_t ep_in;		//!< ްIN/OUT߲ݵTLqq
	usb_ep_desc_t ep_out;
} udi_cdc_data_desc_t;

#define UDI_CDC_COMM_EP_SIZE		64		//!< SĂ̑xɑ΂CDCʐM߲Ă̑傫
#define UDI_CDC_DATA_EPS_FS_SIZE	64		//!< FSxpCDCް ߲Ă̑傫(8,16,32,64޲)
#define UDI_CDC_DATA_EPS_HS_SIZE	512		//!< HSxpCDCް ߲Ă̑傫(512޲Ă̂)

/**
 * \name ̪Lqq̓e
 * USBu7܂ł̲̪邱Ƃł܂B
 */
//@{
//! ɂĂ̲̪ƘAg镶͂܂B
#ifndef UDI_CDC_IAD_STRING_ID_0
#define UDI_CDC_IAD_STRING_ID_0		0
#endif
#ifndef UDI_CDC_COMM_STRING_ID_0
#define UDI_CDC_COMM_STRING_ID_0	0
#endif
#ifndef UDI_CDC_DATA_STRING_ID_0
#define UDI_CDC_DATA_STRING_ID_0	0
#endif
#define UDI_CDC_IAD_DESC_0			UDI_CDC_IAD_DESC(0)
#define UDI_CDC_COMM_DESC_0			UDI_CDC_COMM_DESC(0)
#define UDI_CDC_DATA_DESC_0_FS		UDI_CDC_DATA_DESC_FS(0)
#define UDI_CDC_DATA_DESC_0_HS		UDI_CDC_DATA_DESC_HS(0)

//! ɂĂ̲̪ƘAg镶͂܂B
#ifndef UDI_CDC_IAD_STRING_ID_1
#define UDI_CDC_IAD_STRING_ID_1		0
#endif
#ifndef UDI_CDC_COMM_STRING_ID_1
#define UDI_CDC_COMM_STRING_ID_1	0
#endif
#ifndef UDI_CDC_DATA_STRING_ID_1
#define UDI_CDC_DATA_STRING_ID_1	0
#endif
#define UDI_CDC_IAD_DESC_1			UDI_CDC_IAD_DESC(1)
#define UDI_CDC_COMM_DESC_1			UDI_CDC_COMM_DESC(1)
#define UDI_CDC_DATA_DESC_1_FS		UDI_CDC_DATA_DESC_FS(1)
#define UDI_CDC_DATA_DESC_1_HS		UDI_CDC_DATA_DESC_HS(1)

//! ɂĂ̲̪ƘAg镶͂܂B
#ifndef UDI_CDC_IAD_STRING_ID_2
#define UDI_CDC_IAD_STRING_ID_2		0
#endif
#ifndef UDI_CDC_COMM_STRING_ID_2
#define UDI_CDC_COMM_STRING_ID_2	0
#endif
#ifndef UDI_CDC_DATA_STRING_ID_2
#define UDI_CDC_DATA_STRING_ID_2	0
#endif
#define UDI_CDC_IAD_DESC_2			UDI_CDC_IAD_DESC(2)
#define UDI_CDC_COMM_DESC_2			UDI_CDC_COMM_DESC(2)
#define UDI_CDC_DATA_DESC_2_FS		UDI_CDC_DATA_DESC_FS(2)
#define UDI_CDC_DATA_DESC_2_HS		UDI_CDC_DATA_DESC_HS(2)

//! ɂĂ̲̪ƘAg镶͂܂B
#ifndef UDI_CDC_IAD_STRING_ID_3
#define UDI_CDC_IAD_STRING_ID_3		0
#endif
#ifndef UDI_CDC_COMM_STRING_ID_3
#define UDI_CDC_COMM_STRING_ID_3	0
#endif
#ifndef UDI_CDC_DATA_STRING_ID_3
#define UDI_CDC_DATA_STRING_ID_3	0
#endif
#define UDI_CDC_IAD_DESC_3			UDI_CDC_IAD_DESC(3)
#define UDI_CDC_COMM_DESC_3			UDI_CDC_COMM_DESC(3)
#define UDI_CDC_DATA_DESC_3_FS		UDI_CDC_DATA_DESC_FS(3)
#define UDI_CDC_DATA_DESC_3_HS		UDI_CDC_DATA_DESC_HS(3)

//! ɂĂ̲̪ƘAg镶͂܂B
#ifndef UDI_CDC_IAD_STRING_ID_4
#define UDI_CDC_IAD_STRING_ID_4		0
#endif
#ifndef UDI_CDC_COMM_STRING_ID_4
#define UDI_CDC_COMM_STRING_ID_4	0
#endif
#ifndef UDI_CDC_DATA_STRING_ID_4
#define UDI_CDC_DATA_STRING_ID_4	0
#endif
#define UDI_CDC_IAD_DESC_4			UDI_CDC_IAD_DESC(4)
#define UDI_CDC_COMM_DESC_4			UDI_CDC_COMM_DESC(4)
#define UDI_CDC_DATA_DESC_4_FS		UDI_CDC_DATA_DESC_FS(4)
#define UDI_CDC_DATA_DESC_4_HS		UDI_CDC_DATA_DESC_HS(4)

//! ɂĂ̲̪ƘAg镶͂܂B
#ifndef UDI_CDC_IAD_STRING_ID_5
#define UDI_CDC_IAD_STRING_ID_5		0
#endif
#ifndef UDI_CDC_COMM_STRING_ID_5
#define UDI_CDC_COMM_STRING_ID_5	0
#endif
#ifndef UDI_CDC_DATA_STRING_ID_5
#define UDI_CDC_DATA_STRING_ID_5	0
#endif
#define UDI_CDC_IAD_DESC_5			UDI_CDC_IAD_DESC(5)
#define UDI_CDC_COMM_DESC_5			UDI_CDC_COMM_DESC(5)
#define UDI_CDC_DATA_DESC_5_FS		UDI_CDC_DATA_DESC_FS(5)
#define UDI_CDC_DATA_DESC_5_HS		UDI_CDC_DATA_DESC_HS(5)

//! ɂĂ̲̪ƘAg镶͂܂B
#ifndef UDI_CDC_IAD_STRING_ID_6
#define UDI_CDC_IAD_STRING_ID_6		0
#endif
#ifndef UDI_CDC_COMM_STRING_ID_6
#define UDI_CDC_COMM_STRING_ID_6	0
#endif
#ifndef UDI_CDC_DATA_STRING_ID_6
#define UDI_CDC_DATA_STRING_ID_6	0
#endif
#define UDI_CDC_IAD_DESC_6			UDI_CDC_IAD_DESC(6)
#define UDI_CDC_COMM_DESC_6			UDI_CDC_COMM_DESC(6)
#define UDI_CDC_DATA_DESC_6_FS		UDI_CDC_DATA_DESC_FS(6)
#define UDI_CDC_DATA_DESC_6_HS		UDI_CDC_DATA_DESC_HS(6)
//@}

//! SĂ̑xɑ΂CDC IAD̪Lqq̓e
#define UDI_CDC_IAD_DESC(port) { \
   .bLength							= sizeof(usb_iad_desc_t),\
   .bDescriptorType					= USB_DT_IAD,\
   .bInterfaceCount					= 2,\
   .bFunctionClass					= CDC_CLASS_COMM,\
   .bFunctionSubClass				= CDC_SUBCLASS_ACM,\
   .bFunctionProtocol				= CDC_PROTOCOL_V25TER,\
   .bFirstInterface					= UDI_CDC_COMM_IFACE_NUMBER_##port,\
   .iFunction						= UDI_CDC_IAD_STRING_ID_##port,\
   }

//! SĂ̑xɑ΂CDC COMM̪Lqq̓e
#define UDI_CDC_COMM_DESC(port) { \
   .iface.bLength					= sizeof(usb_iface_desc_t),\
   .iface.bDescriptorType			= USB_DT_INTERFACE,\
   .iface.bAlternateSetting			= 0,\
   .iface.bNumEndpoints				= 1,\
   .iface.bInterfaceClass			= CDC_CLASS_COMM,\
   .iface.bInterfaceSubClass		= CDC_SUBCLASS_ACM,\
   .iface.bInterfaceProtocol		= CDC_PROTOCOL_V25TER,\
   .header.bFunctionLength			= sizeof(usb_cdc_hdr_desc_t),\
   .header.bDescriptorType			= CDC_CS_INTERFACE,\
   .header.bDescriptorSubtype		= CDC_SCS_HEADER,\
   .header.bcdCDC					= LE16(0x0110),\
   .call_mgmt.bFunctionLength		= sizeof(usb_cdc_call_mgmt_desc_t),\
   .call_mgmt.bDescriptorType		= CDC_CS_INTERFACE,\
   .call_mgmt.bDescriptorSubtype	= CDC_SCS_CALL_MGMT,\
   .call_mgmt.bmCapabilities		= \
			CDC_CALL_MGMT_SUPPORTED | CDC_CALL_MGMT_OVER_DCI,\
   .acm.bFunctionLength				= sizeof(usb_cdc_acm_desc_t),\
   .acm.bDescriptorType				= CDC_CS_INTERFACE,\
   .acm.bDescriptorSubtype			= CDC_SCS_ACM,\
   .acm.bmCapabilities				= CDC_ACM_SUPPORT_LINE_REQUESTS,\
   .union_desc.bFunctionLength		= sizeof(usb_cdc_union_desc_t),\
   .union_desc.bDescriptorType		= CDC_CS_INTERFACE,\
   .union_desc.bDescriptorSubtype	= CDC_SCS_UNION,\
   .ep_notify.bLength				= sizeof(usb_ep_desc_t),\
   .ep_notify.bDescriptorType		= USB_DT_ENDPOINT,\
   .ep_notify.bmAttributes			= USB_EP_TYPE_INTERRUPT,\
   .ep_notify.wMaxPacketSize		= LE16(UDI_CDC_COMM_EP_SIZE),\
   .ep_notify.bInterval				= 0x10,\
   .ep_notify.bEndpointAddress		= UDI_CDC_COMM_EP_##port,\
   .iface.bInterfaceNumber			= UDI_CDC_COMM_IFACE_NUMBER_##port,\
   .call_mgmt.bDataInterface		= UDI_CDC_DATA_IFACE_NUMBER_##port,\
   .union_desc.bMasterInterface		= UDI_CDC_COMM_IFACE_NUMBER_##port,\
   .union_desc.bSlaveInterface0		= UDI_CDC_DATA_IFACE_NUMBER_##port,\
   .iface.iInterface				= UDI_CDC_COMM_STRING_ID_##port,\
   }

//! CDCް ̪Lqq̓e
#define UDI_CDC_DATA_DESC_COMMON \
   .iface.bLength					= sizeof(usb_iface_desc_t),\
   .iface.bDescriptorType			= USB_DT_INTERFACE,\
   .iface.bAlternateSetting			= 0,\
   .iface.bNumEndpoints				= 2,\
   .iface.bInterfaceClass			= CDC_CLASS_DATA,\
   .iface.bInterfaceSubClass		= 0,\
   .iface.bInterfaceProtocol		= 0,\
   .ep_in.bLength					= sizeof(usb_ep_desc_t),\
   .ep_in.bDescriptorType			= USB_DT_ENDPOINT,\
   .ep_in.bmAttributes				= USB_EP_TYPE_BULK,\
   .ep_in.bInterval					= 0,\
   .ep_out.bLength					= sizeof(usb_ep_desc_t),\
   .ep_out.bDescriptorType			= USB_DT_ENDPOINT,\
   .ep_out.bmAttributes				= USB_EP_TYPE_BULK,\
   .ep_out.bInterval				= 0,

#define UDI_CDC_DATA_DESC_FS(port) { \
   UDI_CDC_DATA_DESC_COMMON \
   .ep_in.wMaxPacketSize			= LE16(UDI_CDC_DATA_EPS_FS_SIZE),\
   .ep_out.wMaxPacketSize			= LE16(UDI_CDC_DATA_EPS_FS_SIZE),\
   .ep_in.bEndpointAddress			= UDI_CDC_DATA_EP_IN_##port,\
   .ep_out.bEndpointAddress			= UDI_CDC_DATA_EP_OUT_##port,\
   .iface.bInterfaceNumber			= UDI_CDC_DATA_IFACE_NUMBER_##port,\
   .iface.iInterface				= UDI_CDC_DATA_STRING_ID_##port,\
   }

#define UDI_CDC_DATA_DESC_HS(port) { \
   UDI_CDC_DATA_DESC_COMMON \
   .ep_in.wMaxPacketSize			= LE16(UDI_CDC_DATA_EPS_HS_SIZE),\
   .ep_out.wMaxPacketSize			= LE16(UDI_CDC_DATA_EPS_HS_SIZE),\
   .ep_in.bEndpointAddress			= UDI_CDC_DATA_EP_IN_##port,\
   .ep_out.bEndpointAddress			= UDI_CDC_DATA_EP_OUT_##port,\
   .iface.bInterfaceNumber			= UDI_CDC_DATA_IFACE_NUMBER_##port,\
   .iface.iInterface				= UDI_CDC_DATA_STRING_ID_##port,\
   }

//@}

/**
 * \ingroup udi_group
 * \defgroup udi_cdc_group ʐM׽u(CDC)pUSBu̪(UDI)
 *
 * USB׽ĝɍʉpɂĎgp鋤API
 *
 * ٰ݂USB CDC߲Ăް̓]ƐɎgp܂B
 *
 * \ref udi_cdc_quickstartB
 * @{
 */

/**
 * \name PCDC̪xpɑ΂̪
 */
//@{

/**
 * \brief DCDM̏ԕωʒm
 *
 * \param  b_set trueȂDCD͋AȂ΋֎~
 */
void udi_cdc_ctrl_signal_dcd(bool b_set);

/**
 * \brief DSRM̏ԕωʒm
 *
 * \param  b_set trueȂDSR͋AȂ΋֎~
 */
void udi_cdc_ctrl_signal_dsr(bool b_set);

/**
 * \brief ڰݸވُʒm
 */
void udi_cdc_signal_framing_error(void);

/**
 * \brief èʒm
 */
void udi_cdc_signal_parity_error(void);

/**
 * \brief ްݒʒm
 */
void udi_cdc_signal_overrun(void);

/**
 * \brief M޲Đ擾
 *
 * \return p\ް
 */
iram_size_t udi_cdc_get_nb_received_data(void);

/**
 * \brief ̊֐CDCŕMꂽlׂ܂B
 *
 * \return ޲ĂǂݍݏȂ\c 1
 */
bool udi_cdc_is_rx_ready(void);

/**
 * \brief ҂CDC̒l擾
 *
 * \return CDCœǂ񂾒l
 */
int udi_cdc_getc(void);

/**
 * \brief CDCRAMɏՕǂݍ
 *
 * \param  buf  ǂ񂾒l
 * \param  size ǂ񂾒l̐
 *
 * \return cް
 */
iram_size_t udi_cdc_read_buf(void* buf, iram_size_t size);

/**
 * \brief MɏՕ̋޲Đ擾
 *
 * \return MɏՕ̋޲Đ
 */
iram_size_t udi_cdc_get_free_tx_buffer(void);

/**
 * \brief ̊֐͐Vo\𒲂ׂ܂B
 * ߲LIBscanfo͐ύXx邽߂int^gp܂B
 *
 * \return V𑗂邱Ƃłꍇ\c 1
 */
bool udi_cdc_is_tx_ready(void);

/**
 * \brief CDC޲ďo
 * ߲LIBscanfo͐ύXx邽߂int^gp܂B
 *
 * \param  value o͂l
 *
 * \return ֐ɏIꍇ\c 1AȂ\c 0
 */
int udi_cdc_putc(int value);

/**
 * \brief CDCRAMɏՕ
 *
 * \param  buf  l
 * \param  size l̐
 *
 * \return cް
 */
iram_size_t udi_cdc_write_buf(const void* buf, iram_size_t size);
//@}

/**
 * \name CDC̪xpɑ΂̪
 */
//@{

/**
 * \brief DCDM̏ԕωʒm
 *
 * \param  port  ǗʐM߰Ĕԍ
 * \param  b_set trueȂDCD͋AȂ΋֎~
 */
void udi_cdc_multi_ctrl_signal_dcd(uint8_t port, bool b_set);

/**
 * \brief DSRM̏ԕωʒm
 *
 * \param  port  ǗʐM߰Ĕԍ
 * \param  b_set trueȂDSR͋AȂ΋֎~
 */
void udi_cdc_multi_ctrl_signal_dsr(uint8_t port, bool b_set);

/**
 * \brief ڰݸވُʒm
 *
 * \param  port ǗʐM߰Ĕԍ
 */
void udi_cdc_multi_signal_framing_error(uint8_t port);

/**
 * \brief èʒm
 *
 * \param  port ǗʐM߰Ĕԍ
 */
void udi_cdc_multi_signal_parity_error(uint8_t port);

/**
 * \brief ްݒʒm
 *
 * \param  port ǗʐM߰Ĕԍ
 */
void udi_cdc_multi_signal_overrun(uint8_t port);

/**
 * \brief M޲Đ擾
 *
 * \param  port ǗʐM߰Ĕԍ
 *
 * \return p\ް
 */
iram_size_t udi_cdc_multi_get_nb_received_data(uint8_t port);

/**
 * \brief ̊֐CDCŕMꂽ𒲂ׂ܂B
 *
 * \param  port ǗʐM߰Ĕԍ
 *
 * \return ޲ĂǂݍݏȂ\c 1
 */
bool udi_cdc_multi_is_rx_ready(uint8_t port);

/**
 * \brief ҂CDCŒl擾
 *
 * \param  port ǗʐM߰Ĕԍ
 *
 * \return CDCœǂ񂾒l
 */
int udi_cdc_multi_getc(uint8_t port);

/**
 * \brief CDCRAMɏՕǂݍ
 *
 * \param  port ǗʐM߰Ĕԍ
 * \param  buf  ǂ񂾒l
 * \param  size ǂޒl̐
 *
 * \return cް
 */
iram_size_t udi_cdc_multi_read_buf(uint8_t port, void* buf, iram_size_t size);

/**
 * \brief MɏՕ̋޲Đ擾
 *
 * \param  port ǗʐM߰Ĕԍ
 *
 * \return MɏՕ̋޲Đ
 */
iram_size_t udi_cdc_multi_get_free_tx_buffer(uint8_t port);

/**
 * \brief ̊֐͐Vo\lׂ܂B
 * ߲LIBscanfo͐ύXx邽߂int^gp܂B
 *
 * \param  port ǗʐM߰Ĕԍ
 *
 * \return V𑗂邱Ƃłꍇ\c 1
 */
bool udi_cdc_multi_is_tx_ready(uint8_t port);

/**
 * \brief CDC޲ďo
 * ߲LIBscanfo͐ύXx邽߂int^gp܂B
 *
 * \param  port  ǗʐM߰Ĕԍ
 * \param  value o͂l
 *
 * \return ֐ɏI\c 1AȂ\c 0
 */
int udi_cdc_multi_putc(uint8_t port, int value);

/**
 * \brief CDCRAMɏՕ
 *
 * \param  port ǗʐM߰Ĕԍ
 * \param  buf  l
 * \param  size l̐
 *
 * \return cް
 */
iram_size_t udi_cdc_multi_write_buf(uint8_t port, const void* buf, iram_size_t size);
//@}

//@}

/**
 * \page udi_cdc_quickstart USBuʐM׽uPʕ(UDI CDC)pJn̎
 *
 * ͎gpʂ̑IPʕ`Ԑݒ肵Ďg@̒iKIȎwł
 * \ref udi_cdc_group "USBu̪CDCPʕ(UDI CDC)"pJn̎
 * B
 *
 * gpM͏̺ޒfЂ܂݂܂B\ݒiK̺ޒfЂ͓Ǝ֐
 * ʂ邱ƂłAgiK͗Ⴆ΁A剞p֐ɕʂ邱Ƃł
 * B
 *
 * \section udi_cdc_basic_use_case {IȎgp
 * ̊{IȎgpʂŁA"USB CDC (P̪u)"Pʕ1̒ʐM߰Ă
 * Ŏgp܂B
 * "USB CDC (u)"Pʕ̎g\ref udi_cdc_use_cases "xȎgp"
 * ŋLq܂B
 *
 * \section udi_cdc_basic_use_case_setup \ݒiK
 * \subsection udi_cdc_basic_use_case_setup_prereq OKv
 * \copydetails udc_basic_use_case_setup_prereq
 * \subsection udi_cdc_basic_use_case_setup_code ޗ
 * \copydetails udc_basic_use_case_setup_code
 * \subsection udi_cdc_basic_use_case_setup_flow Ƃ̗
 * \copydetails udc_basic_use_case_setup_flow
 *
 * \section udi_cdc_basic_use_case_usage giK
 *
 * \subsection udi_cdc_basic_use_case_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define UDI_CDC_ENABLE_EXT(port) my_callback_cdc_enable()
 * extern bool my_callback_cdc_enable(void);
 * #define UDI_CDC_DISABLE_EXT(port) my_callback_cdc_disable()
 * extern void my_callback_cdc_disable(void);
 * #define  UDI_CDC_LOW_RATE
 *
 * #define  UDI_CDC_DEFAULT_RATE             115200
 * #define  UDI_CDC_DEFAULT_STOPBITS         CDC_STOP_BITS_1
 * #define  UDI_CDC_DEFAULT_PARITY           CDC_PAR_NONE
 * #define  UDI_CDC_DEFAULT_DATABITS         8
 *
 * #include "udi_cdc_conf.h" // conf_usb.ḩق̍Ō
 * \endcode
 *
 * pÇقɒǉ܂B:
 * \code
 * static bool my_flag_autorize_cdc_transfert = false;
 * bool my_callback_cdc_enable(void)
 * {
 *    my_flag_autorize_cdc_transfert = true;
 *    return true;
 * }
 * void my_callback_cdc_disable(void)
 * {
 *    my_flag_autorize_cdc_transfert = false;
 * }
 *
 * void task(void)
 * {
 *    if (my_flag_autorize_cdc_transfert) {
 *        udi_cdc_putc('A');
 *        udi_cdc_getc();
 *    }
 * }
 * \endcode
 *
 * \subsection udi_cdc_basic_use_case_setup_flow Ƃ̗
 * -# conf_usb.hp\USBuCDC`Ԑݒłȉ̌`Ԑݒ܂ނƂ
 *    mɂĂB:
 *   - \code #define USB_DEVICE_SERIAL_NAME  "12...EF" // CDCpިʔ \endcode
 *     \note CDC̪gp鎞USBʔԂ͕K{łB
 *   - \code #define UDI_CDC_ENABLE_EXT(port) my_callback_cdc_enable()
 * extern bool my_callback_cdc_enable(void); \endcode
 *     \note u(USBǔoƎ)AUSBνĂ͑u`ԐݒJn܂B
 *           uUSB CDC̪νĂɂĎ󂯓ꂽUSBνĂ͂
 *           ̲̪UDI_CDC_ENABLE_EXT()Ăі߂֐Ă΂true
 *           Ԃ܂B̂ɁA̎ێ󂯎莞ACDC̪łް]F
 *           ܂B
 *   - \code #define UDI_CDC_DISABLE_EXT(port) my_callback_cdc_disable()
 * extern void my_callback_cdc_disable(void); \endcode
 *     \note USBuOA܂USBνĂɂؾĂƁAUSB̪
 *           ֎~AUDI_CDC_DISABLE_EXT()Ăі߂֐Ă΂܂B̂ɁACDC
 *           ̪ް]~Ȃ΂Ȃ܂B
 *   - \code #define  UDI_CDC_LOW_RATE \endcode
 *     \note CDCɏՕ̑傫炷߁AνĂւCDCu]ᑬ(<512000ް)
 *           ̎ɂ`ĂB
 *   - \code #define  UDI_CDC_DEFAULT_RATE             115200
 * #define  UDI_CDC_DEFAULT_STOPBITS         CDC_STOP_BITS_1
 * #define  UDI_CDC_DEFAULT_PARITY           CDC_PAR_NONE
 * #define  UDI_CDC_DEFAULT_DATABITS         8 \endcode
 *     \note nł̒ʐM߰Ă̊`Ԑݒ
 * -# CDCł̑o܂͑ҋ@:
 *   - \code // CDCł̑ҋ@Ǝ擾
 * int udi_cdc_getc(void);
 * // CDCRAMɏՕǂݍ
 * iram_size_t udi_cdc_read_buf(int* buf, iram_size_t size);
 * // CDC޲ďo
 * int udi_cdc_putc(int value);
 * // CDCRAMɏՕ
 * iram_size_t udi_cdc_write_buf(const int* buf, iram_size_t size); \endcode
 *
 * \section udi_cdc_use_cases xȎgp
 * UDI CDCPʕ̂ƍxȎgpɂĂ͈ȉ̎gpʂB:
 * - \subpage udi_cdc_use_case_composite
 * - \subpage udc_use_case_1
 * - \subpage udc_use_case_2
 * - \subpage udc_use_case_3
 * - \subpage udc_use_case_4
 * - \subpage udc_use_case_5
 * - \subpage udc_use_case_6
 */

/**
 * \page udi_cdc_use_case_composite ułCDC
 *
 * USBu1USB׽gpUSBułB̎gpʂŁA"USB
 *  CDC(u)"PʕUSBu쐬Ɏgp܂B̂ɁAUSBPʕ
 * "USB HIDϳ(u)"̂悤ȕʂ"u"ƒg邱Ƃł܂B
 *
 * ܂Aȉ̉pLqQƂ邱Ƃł܂B
 * <A href="http://www.atmel.com/dyn/resources/prod_documents/doc8445.pdf">
 * AVR4902 ASF - USBu</A>
 *
 * \section udi_cdc_use_case_composite_setup \ݒiK
 * ̎gpʂ̍\ݒ躰ނɊւē߂ɂ\ref udi_cdc_basic_use_case "
 * {IȎgp"ɏ]Ȃ΂Ȃ܂B
 *
 * \section udi_cdc_use_case_composite_usage giK
 *
 * \subsection udi_cdc_use_case_composite_usage_code ޗ
 * conf_usb.h̓e:
 * \code
 * #define USB_DEVICE_EP_CTRL_SIZE  64
 * #define USB_DEVICE_NB_INTERFACE (X+2)
 * #define USB_DEVICE_MAX_EP (X+3)
 *
 * #define  UDI_CDC_DATA_EP_IN_0          (1 | USB_EP_DIR_IN)  // M
 * #define  UDI_CDC_DATA_EP_OUT_0         (2 | USB_EP_DIR_OUT) // M
 * #define  UDI_CDC_COMM_EP_0             (3 | USB_EP_DIR_IN)  // ʒm߲
 * #define  UDI_CDC_COMM_IFACE_NUMBER_0   X+0
 * #define  UDI_CDC_DATA_IFACE_NUMBER_0   X+1
 *
 * #define UDI_COMPOSITE_DESC_T \
 *    usb_iad_desc_t udi_cdc_iad; \
 *    udi_cdc_comm_desc_t udi_cdc_comm; \
 *    udi_cdc_data_desc_t udi_cdc_data; \
 *    ...
 * #define UDI_COMPOSITE_DESC_FS \
 *    .udi_cdc_iad               = UDI_CDC_IAD_DESC_0, \
 *    .udi_cdc_comm              = UDI_CDC_COMM_DESC_0, \
 *    .udi_cdc_data              = UDI_CDC_DATA_DESC_0_FS, \
 *    ...
 * #define UDI_COMPOSITE_DESC_HS \
 *    .udi_cdc_iad               = UDI_CDC_IAD_DESC_0, \
 *    .udi_cdc_comm              = UDI_CDC_COMM_DESC_0, \
 *    .udi_cdc_data              = UDI_CDC_DATA_DESC_0_HS, \
 *    ...
 * #define UDI_COMPOSITE_API \
 *    &udi_api_cdc_comm,       \
 *    &udi_api_cdc_data,       \
 *    ...
 * \endcode
 *
 * \subsection udi_cdc_use_case_composite_usage_flow Ƃ̗
 * -# conf_usb.hp\USBu`ԐݒɕKvƂȉҰ܂
 *    ƂmɂĂB:
 *   - \code // ߲Ă̑傫B͕K{:
 * // - Suɑ΂8,16,32,64(RAMߖ񂷂邽߂8܂B)
 * // - up64
 * #define USB_DEVICE_EP_CTRL_SIZE  64
 * // USBuł̪̑
 * // CDCp2܂B
 * #define USB_DEVICE_NB_INTERFACE (X+2)
 * // USBuł߲̑Đ
 * // ͊e̪ɑ΂Ċe߲Ă܂܂Ȃ΂Ȃ܂B
 * // CDCp3܂B
 * #define USB_DEVICE_MAX_EP (X+3) \endcode
 * -# conf_usb.hűLqq܂ނƂmɂĂB
 *   - \code // ȂɂCDCpɑI΂ꂽ߲Ĕԍ
 * // ߲Ĕԍ1Jn
 * #define  UDI_CDC_DATA_EP_IN_0            (1 | USB_EP_DIR_IN)  // M
 * #define  UDI_CDC_DATA_EP_OUT_0           (2 | USB_EP_DIR_OUT) // M
 * #define  UDI_CDC_COMM_EP_0               (3 | USB_EP_DIR_IN)  // ʒm߲
 * // ̪̲̪wW0Jn
 * #define  UDI_CDC_COMM_IFACE_NUMBER_0     X+0
 * #define  UDI_CDC_DATA_IFACE_NUMBER_0     X+1 \endcode
 * -# conf_usb.hUSBu`ԐݒɕKvƂȉҰ܂ނƂm
 *    ɂĂB:
 *   - \code // USB̪Lqq\
 * #define UDI_COMPOSITE_DESC_T \
 *    ...
 *    usb_iad_desc_t udi_cdc_iad; \
 *    udi_cdc_comm_desc_t udi_cdc_comm; \
 *    udi_cdc_data_desc_t udi_cdc_data; \
 *    ...
 * // SpUSB̪Lqql
 * #define UDI_COMPOSITE_DESC_FS \
 *    ...
 *    .udi_cdc_iad               = UDI_CDC_IAD_DESC_0, \
 *    .udi_cdc_comm              = UDI_CDC_COMM_DESC_0, \
 *    .udi_cdc_data              = UDI_CDC_DATA_DESC_0_FS, \
 *    ...
 * // pUSB̪Lqql
 * #define UDI_COMPOSITE_DESC_HS \
 *    ...
 *    .udi_cdc_iad               = UDI_CDC_IAD_DESC_0, \
 *    .udi_cdc_comm              = UDI_CDC_COMM_DESC_0, \
 *    .udi_cdc_data              = UDI_CDC_DATA_DESC_0_HS, \
 *    ...
 * // USB̪API
 * #define UDI_COMPOSITE_API \
 *    ...
 *    &udi_api_cdc_comm,       \
 *    &udi_api_cdc_data,       \
 *    ... \endcode
 *   - \note 4̈ꗗŗ^ꂽLqq͑SĂ̲-̪wWɂĒ`
 *           ꂽԂƓłȂ΂Ȃ܂B̪wW
 *           UDI_X_IFACE_NUMBER`ʂĒ`܂B\n
 *           ܂ACDC͕uɑ΂USB̪gLqq(IAD)KvłB
 */

#ifdef __cplusplus
}
#endif
#endif // _UDI_CDC_H_
