/**
 * \file
 *
 * \brief P̪CDCUSBupLqq
 *
 * 쌠 (c) 2009-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "conf_usb.h"
#include "udd.h"
#include "udc_desc.h"
#include "udi_cdc.h"


/**
 * \defgroup udi_cdc_group_single_desc P̪pUSBuLqq
 *
 * ȉ̍\̂͒P̪CDCUSBuɕKvƂUSBuLqq
 * ܂B
 *
 * ͍XȂ`̕KvȂŎgpĂ܂B
 *
 * @{
 */

//! CDCup2̲̪
#define  USB_DEVICE_NB_INTERFACE		(2*UDI_CDC_PORT_NB)

//! USBuLqq
COMPILER_WORD_ALIGNED
UDC_DESC_STORAGE usb_dev_desc_t udc_device_desc = {
	.bLength					= sizeof(usb_dev_desc_t),
	.bDescriptorType			= USB_DT_DEVICE,
	.bcdUSB						= LE16(USB_V2_0),
#if UDI_CDC_PORT_NB > 1
	.bDeviceClass				= 0,
#else
	.bDeviceClass				= CDC_CLASS_DEVICE,
#endif
	.bDeviceSubClass			= 0,
	.bDeviceProtocol			= 0,
	.bMaxPacketSize0			= USB_DEVICE_EP_CTRL_SIZE,
	.idVendor					= LE16(USB_DEVICE_VENDOR_ID),
	.idProduct					= LE16(USB_DEVICE_PRODUCT_ID),
	.bcdDevice					= LE16((USB_DEVICE_MAJOR_VERSION << 8)
								| USB_DEVICE_MINOR_VERSION),
#ifdef USB_DEVICE_MANUFACTURE_NAME
	.iManufacturer				= 1,
#else
	.iManufacturer				= 0,	// ҕȂ
#endif
#ifdef USB_DEVICE_PRODUCT_NAME
	.iProduct					= 2,
#else
	.iProduct					= 0,	// iȂ
#endif
#ifdef USB_DEVICE_SERIAL_NAME
	.iSerialNumber				= 3,
#else
	.iSerialNumber				= 0,	// ʔԕȂ
#endif
	.bNumConfigurations = 1
};

#ifdef USB_DEVICE_HS_SUPPORT
//! HSpUSBuCqLqq
COMPILER_WORD_ALIGNED
UDC_DESC_STORAGE usb_dev_qual_desc_t udc_device_qual = {
	.bLength					= sizeof(usb_dev_qual_desc_t),
	.bDescriptorType			= USB_DT_DEVICE_QUALIFIER,
	.bcdUSB						= LE16(USB_V2_0),
#if UDI_CDC_PORT_NB > 1
	.bDeviceClass				= 0,
#else
	.bDeviceClass				= CDC_CLASS_DEVICE,
#endif
	.bDeviceSubClass			= 0,
	.bDeviceProtocol			= 0,
	.bMaxPacketSize0			= USB_DEVICE_EP_CTRL_SIZE,
	.bNumConfigurations			= 1
};
#endif

//! USBu`ԐݒLqqp\
COMPILER_PACK_SET(1)
typedef struct {
	usb_conf_desc_t conf;
#if UDI_CDC_PORT_NB == 1
	udi_cdc_comm_desc_t udi_cdc_comm_0;
	udi_cdc_data_desc_t udi_cdc_data_0;
#else
#  define UDI_CDC_DESC_STRUCTURE(index, unused) \
	usb_iad_desc_t      udi_cdc_iad_##index; \
	udi_cdc_comm_desc_t udi_cdc_comm_##index; \
	udi_cdc_data_desc_t udi_cdc_data_##index;
	MREPEAT(UDI_CDC_PORT_NB, UDI_CDC_DESC_STRUCTURE, ~)
#  undef UDI_CDC_DESC_STRUCTURE
#endif
} udc_desc_t;
COMPILER_PACK_RESET()

//! Sƍ̂߂ɖꂽUSBu`ԐݒLqq
COMPILER_WORD_ALIGNED
UDC_DESC_STORAGE udc_desc_t udc_desc_fs = {
	.conf.bLength				= sizeof(usb_conf_desc_t),
	.conf.bDescriptorType		= USB_DT_CONFIGURATION,
	.conf.wTotalLength			= LE16(sizeof(udc_desc_t)),
	.conf.bNumInterfaces		= USB_DEVICE_NB_INTERFACE,
	.conf.bConfigurationValue	= 1,
	.conf.iConfiguration		= 0,
	.conf.bmAttributes			= USB_CONFIG_ATTR_MUST_SET | USB_DEVICE_ATTR,
	.conf.bMaxPower				= USB_CONFIG_MAX_POWER(USB_DEVICE_POWER),
#if UDI_CDC_PORT_NB == 1
	.udi_cdc_comm_0				= UDI_CDC_COMM_DESC_0,
	.udi_cdc_data_0				= UDI_CDC_DATA_DESC_0_FS,
#else
#  define UDI_CDC_DESC_FS(index, unused) \
	.udi_cdc_iad_##index		= UDI_CDC_IAD_DESC_##index,\
	.udi_cdc_comm_##index		= UDI_CDC_COMM_DESC_##index,\
	.udi_cdc_data_##index		= UDI_CDC_DATA_DESC_##index##_FS,
						MREPEAT(UDI_CDC_PORT_NB, UDI_CDC_DESC_FS, ~)
#  undef UDI_CDC_DESC_FS
#endif
};

#ifdef USB_DEVICE_HS_SUPPORT
COMPILER_WORD_ALIGNED
UDC_DESC_STORAGE udc_desc_t udc_desc_hs = {
	.conf.bLength				= sizeof(usb_conf_desc_t),
	.conf.bDescriptorType		= USB_DT_CONFIGURATION,
	.conf.wTotalLength			= LE16(sizeof(udc_desc_t)),
	.conf.bNumInterfaces		= USB_DEVICE_NB_INTERFACE,
	.conf.bConfigurationValue	= 1,
	.conf.iConfiguration		= 0,
	.conf.bmAttributes			= USB_CONFIG_ATTR_MUST_SET | USB_DEVICE_ATTR,
	.conf.bMaxPower				= USB_CONFIG_MAX_POWER(USB_DEVICE_POWER),
#if UDI_CDC_PORT_NB == 1
	.udi_cdc_comm_0				= UDI_CDC_COMM_DESC_0,
	.udi_cdc_data_0				= UDI_CDC_DATA_DESC_0_HS,
#else
#  define UDI_CDC_DESC_HS(index, unused) \
	.udi_cdc_iad_##index		= UDI_CDC_IAD_DESC_##index, \
	.udi_cdc_comm_##index		= UDI_CDC_COMM_DESC_##index, \
	.udi_cdc_data_##index		= UDI_CDC_DATA_DESC_##index##_HS,
						MREPEAT(UDI_CDC_PORT_NB, UDI_CDC_DESC_HS, ~)
#  undef UDI_CDC_DESC_HS
#endif
};
#endif

/**
 * \name SĂUSBu`𖞑UDC\
 */
//@{

//! eUSB̪ɑ΂UDIg
UDC_DESC_STORAGE udi_api_t *udi_apis[USB_DEVICE_NB_INTERFACE] = {
#  define UDI_CDC_API(index, unused) \
	&udi_api_cdc_comm, \
	&udi_api_cdc_data,
	MREPEAT(UDI_CDC_PORT_NB, UDI_CDC_API, ~)
#  undef UDI_CDC_API
};

//! FSHSUSBLqqUDIɒǉ
UDC_DESC_STORAGE udc_config_speed_t udc_config_fs[1] = { {
	.desc          = (usb_conf_desc_t UDC_DESC_STORAGE*)&udc_desc_fs,
	.udi_apis = udi_apis,
}};
#ifdef USB_DEVICE_HS_SUPPORT
UDC_DESC_STORAGE udc_config_speed_t udc_config_hs[1] = { {
	.desc          = (usb_conf_desc_t UDC_DESC_STORAGE*)&udc_desc_hs,
	.udi_apis = udi_apis,
}};
#endif

//! UDCɑ΂S\̂USBuɂĂ̑Sǉ
UDC_DESC_STORAGE udc_config_t udc_config = {
	.confdev_lsfs = &udc_device_desc,
	.conf_lsfs = udc_config_fs,
#ifdef USB_DEVICE_HS_SUPPORT
	.confdev_hs = &udc_device_desc,
	.qualifier = &udc_device_qual,
	.conf_hs = udc_config_hs,
#endif
};

//@}
//@}
