/**
 * \file
 *
 * \brief USER_BOARDͯ ̧
 *
 * ̧قUSER_BOARD̋@\Ɋ֘A`ƻ޽܂݂܂B
 *
 * ̊gpɂBOARD=USER_BOARD`ĂB
 *
 * 쌠 (c) 2012 - 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef USER_BOARD_INCLUDED
#define USER_BOARD_INCLUDED

#include "compiler.h"

/** ̖O */
#define BOARD_NAME "USER_BOARD"

/**
 * \defgroup sam4l_group USER_BOARD
 * @{
 */

/**
 * \defgroup sam4l_feature_group @\`
 * @{
 */

//! \name ̑ް
//@{
//@}

//! OSC0Ug(Hz)Ǝn(RCOsc)
#define FOSC0					(12000000)

//! OSC32Ug(Hz)Ǝn(RCOsc)
#define FOSC32					(32768)

/**
 * \name U`Ԑݒ
 *
 */
//@{
#define BOARD_OSC32_IS_XTAL		true
#define BOARD_OSC32_HZ			FOSC32
#define BOARD_OSC32_STARTUP_US	(1100000)
#define BOARD_OSC32_SELCURR		BSCIF_OSCCTRL32_SELCURR(10)
#define BOARD_OSC0_IS_XTAL		true
#define BOARD_OSC0_HZ			FOSC0
#define BOARD_OSC0_STARTUP_US	(1100)
//@}

/*! \name LED
 */
//! @{
#define LED_COUNT				1
//! @}

/**
 * \name LED
 *
 * LED0Low̒PꉩFLEDłB
 */
//@{
#define LED0					PA10	/* ATSAM4LC2A̺߲ق̂߂PA10Ɋ蓖 */
#define LED0_GPIO				PIN_PA10
#define LED0_GPIO_MASK			GPIO_PA10
#if defined(SAM4L_EK_REV1)
#  define LED0_ACTIVE_LEVEL		IOPORT_PIN_LEVEL_LOW
#  define LED0_INACTIVE_LEVEL	IOPORT_PIN_LEVEL_HIGH
#else
#  define LED0_ACTIVE_LEVEL		IOPORT_PIN_LEVEL_HIGH
#  define LED0_INACTIVE_LEVEL	IOPORT_PIN_LEVEL_LOW
#endif
//@}

/*! \name SAM4L4C VBUSd͐GPIOڑ
 */
//! @{
#define USB_VBOF_PIN			PIN_PA08	/* I/Oݏo͂Ƃ */
#define USB_VBOF_ACTIVE_LEVEL	0
#define USB_VBOF_INACTIVE_LEVEL	1
//! @}

/*! \name SAM4L4C VBUSُ팟oGPIOڑ
 */
//! @{
#define USB_VBERR_FLAGS			IOPORT_MODE_PULLUP | IOPORT_MODE_GLITCH_FILTER
#define USB_VBERR_PIN			PIN_PA09	/* I/Oݓ͂Ƃ */
/* VBErrݗpEICȂ pin */
//! @}

/*! \name SAM4L4C IDoGPIOڑ
 */
//! @{
#define USB_ID_FLAGS			IOPORT_MODE_PULLUP | IOPORT_MODE_GLITCH_FILTER
#define USB_ID_PIN				PIN_PA06 /* As IO pin input */
/* IDݗpEICȂ */
//! @}


//! \name zCOM߰ėpGPIOɑ΂USARTڑ
// @{
//#define COM_PORT_USART		USART0
//#define COM_PORT_USART_ID		ID_USART0
//#define COM_PORT_RX_PIN		PIN_PA05B_USART0_RXD
//#define COM_PORT_RX_GPIO		GPIO_PA05B_USART0_RXD 
//#define COM_PORT_RX_MUX		MUX_PA05B_USART0_RXD
//#define COM_PORT_TX_PIN		PIN_PA07B_USART0_TXD
//#define COM_PORT_TX_GPIO		GPIO_PA07B_USART0_TXD
//#define COM_PORT_TX_MUX		MUX_PA07B_USART0_TXD

#define COM_PORT_USART			USART0
#define COM_PORT_USART_ID		ID_USART0
#define COM_PORT_RX_PIN			PIN_PA11A_USART0_RXD
#define COM_PORT_RX_GPIO		GPIO_PA11A_USART0_RXD
#define COM_PORT_RX_MUX			MUX_PA11A_USART0_RXD
#define COM_PORT_TX_PIN			PIN_PA12A_USART0_TXD
#define COM_PORT_TX_GPIO		GPIO_PA12A_USART0_TXD
#define COM_PORT_TX_MUX			MUX_PA12A_USART0_TXD
// @}

#endif /* USER_BOARD_INCLUDED */
