/**
 * \file
 *
 * \brief SAMp\񓯊M(USART)ײ
 *
 * 쌠 (c) 2011-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef USART_H_INCLUDED
#define USART_H_INCLUDED

#include "compiler.h"

/**
 * \defgroup group_sam_drivers_usart \񓯊M(USART)
 *
 * See \ref sam_usart_quickstart.
 *
 * SAM\񓯊MpײގłB
 *
 * @{
 */

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
extern "C" {
#endif
/**INDENT-ON**/
/// @endcond

/** ۯʑ */
#define SPI_CPHA	(1 << 0)

/** ۯɐ */
#define SPI_CPOL	(1 << 1)

/** SPI` */
#define SPI_MODE_0	0
#define SPI_MODE_1	(SPI_CPHA)
#define SPI_MODE_2	(SPI_CPOL)
#define SPI_MODE_3	(SPI_CPOL | SPI_CPHA)

/* RS232Ɠl̓鎞̓Ұ */
typedef struct {
	/* USARTްڰĐݒ(]uŕsgp) */
	uint32_t baudrate;

	/*
	 * ȉ1łׂޯĐ: US_MR_CHRL_5_BITAUS_MR_CHRL_6_BITA
	 * US_MR_CHRL_7_BITAUS_MR_CHRL_8_BITAUS_MR_MODE9.
	 */
	uint32_t char_length;

	/*
	 * ȉ1łׂè`: US_MR_PAR_EVENAUS_MR_PAR_ODDA
	 * US_MR_PAR_SPACEAUS_MR_PAR_MARKAUS_MR_PAR_NOAUS_MR_PAR_MULTIDROP
	 */
	uint32_t parity_type;

	/*
	 * 2̕Ԃ̒~ޯĐ: US_MR_NBSTOP_1_BITAUS_MR_NBSTOP_1_5_BITA
	 * US_MR_NBSTOP_2_BIT
	 * \note US_MR_NBSTOP_1_5_BIT͔񓯊łx܂B
	 */
	uint32_t stop_bits;

	/*
	 * łّsAȉ1łׂ: US_MR_CHMODE_NORMALA
	 * US_MR_CHMODE_AUTOMATICAUS_MR_CHMODE_LOCAL_LOOPBACKA
	 * US_MR_CHMODE_REMOTE_LOOPBACK
	 */
	uint32_t channel_mode;

	/* IrDAhgA̓Ŗp */
	uint32_t irda_filter;
} sam_usart_opt_t;

/* ISO7816쏉̓Ұ */
typedef struct {
	/* ISO7816ۯ̎gݒ */
	uint32_t iso7816_hz;

	/*
	 * SĂޯċԂłISO7816ۯ݂̐((1`2047A0͸ۯ֎~)B
	 * ްڰđx = iso7816_hz / fidi_ratio
	 */
	uint32_t fidi_ratio;

	/*
	 * è ޯĂ̌vZ@: Wɑ΂US_MR_PAR_EVENA]ɑ΂
	 * US_MR_PAR_ODD
	 */
	uint32_t parity_type;

	/*
	 * 񉞗p֎~:
	 *   - 0: NACK܂B
	 *   - 1: NACK͐܂B
	 *
	 * \note ޯĂISO7816AKT=0Młgp܂B
	 */
	uint32_t inhibit_nack;

	/*
	 * ANACK֎~
	 *  - 0: NACK͎Mè肪NƒISOɑ܂BA
	 * èmax_iterations̈Œl𐔂グ܂Bè
	 * ISOłNACK𐶐܂B̒lɒBƒISOŒǉȂNACK
	 * ܂BITERATION׸ނLɂ܂B
	 */
	uint32_t dis_suc_nack;

	/* őJԂ(0`7) */
	uint32_t max_iterations;

	/*
	 * M镶ޯď:
	 *   - 0: LSBs;
	 *   - 1: MSBs
	 */
	uint32_t bit_order;

	/*
	 * gpK:
	 *   - 0: T=0;
	 *   - 1: T=1
	 */
	uint32_t protocol_type;
} usart_iso7816_opt_t;

/* SPI쏉̓Ұ */
typedef struct {
	/* SPIۯ̎gݒ(]uŕsgp) */
	uint32_t baudrate;

	/*
	 * ȉ1łׂޯĐ: US_MR_CHRL_5_BITAUS_MR_CHRL_6_BITA
	 * US_MR_CHRL_7_BITAUS_MR_CHRL_8_BITAUS_MR_MODE9
	 */
	uint32_t char_length;

	/*
	 * ȉ1łׂgpSPI:SPI_MODE_0ASPI_MODE_1ASPI_MODE_2A
	 * SPI_MODE_3
	 */
	uint32_t spi_mode;

	/*
	 * ȉ1łׂłّs: US_MR_CHMODE_NORMALA
	 * US_MR_CHMODE_AUTOMATICAUS_MR_CHMODE_LOCAL_LOOPBACKA
	 * US_MR_CHMODE_REMOTE_LOOPBACK
	 */
	uint32_t channel_mode;
} usart_spi_opt_t;

void usart_reset(Usart *p_usart);
uint32_t usart_init_rs232(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt, uint32_t ul_mck);
uint32_t usart_init_hw_handshaking(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt, uint32_t ul_mck);
#if (SAM3S || SAM4S || SAM3U || SAM4L || SAM4E)
uint32_t usart_init_modem(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt, uint32_t ul_mck);
#endif
uint32_t usart_init_sync_master(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt, uint32_t ul_mck);
uint32_t usart_init_sync_slave(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt);
uint32_t usart_init_rs485(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt, uint32_t ul_mck);
uint32_t usart_init_irda(Usart *p_usart,
		const sam_usart_opt_t *p_usart_opt, uint32_t ul_mck);
uint32_t usart_init_iso7816(Usart *p_usart,
		const usart_iso7816_opt_t *p_usart_opt, uint32_t ul_mck);
uint32_t usart_init_spi_master(Usart *p_usart,
		const usart_spi_opt_t *p_usart_opt, uint32_t ul_mck);
uint32_t usart_init_spi_slave(Usart *p_usart,
		const usart_spi_opt_t *p_usart_opt);
#if (SAM3XA || SAM4L)
uint32_t usart_init_lin_master(Usart *p_usart, uint32_t ul_baudrate,
		uint32_t ul_mck);
uint32_t usart_init_lin_slave(Usart *p_usart, uint32_t ul_baudrate,
		uint32_t ul_mck);
void usart_lin_abort_tx(Usart *p_usart);
void usart_lin_send_wakeup_signal(Usart *p_usart);
void usart_lin_set_node_action(Usart *p_usart, uint8_t uc_action);
void usart_lin_disable_parity(Usart *p_usart);
void usart_lin_enable_parity(Usart *p_usart);
void usart_lin_disable_checksum(Usart *p_usart);
void usart_lin_enable_checksum(Usart *p_usart);
void usart_lin_set_checksum_type(Usart *p_usart, uint8_t uc_type);
void usart_lin_set_data_len_mode(Usart *p_usart, uint8_t uc_mode);
void usart_lin_disable_frame_slot(Usart *p_usart);
void usart_lin_enable_frame_slot(Usart *p_usart);
void usart_lin_set_wakeup_signal_type(Usart *p_usart, uint8_t uc_type);
void usart_lin_set_response_data_len(Usart *p_usart, uint8_t uc_len);
void usart_lin_disable_pdc_mode(Usart *p_usart);
void usart_lin_enable_pdc_mode(Usart *p_usart);
void usart_lin_set_tx_identifier(Usart *p_usart, uint8_t uc_id);
uint8_t usart_lin_read_identifier(Usart *p_usart);
uint8_t usart_lin_get_data_length(Usart *usart);
#endif
void usart_enable_tx(Usart *p_usart);
void usart_disable_tx(Usart *p_usart);
void usart_reset_tx(Usart *p_usart);
void usart_set_tx_timeguard(Usart *p_usart, uint32_t timeguard);
void usart_enable_rx(Usart *p_usart);
void usart_disable_rx(Usart *p_usart);
void usart_reset_rx(Usart *p_usart);
void usart_set_rx_timeout(Usart *p_usart, uint32_t timeout);
void usart_enable_interrupt(Usart *p_usart, uint32_t ul_sources);
void usart_disable_interrupt(Usart *p_usart, uint32_t ul_sources);
uint32_t usart_get_interrupt_mask(Usart *p_usart);
uint32_t usart_get_status(Usart *p_usart);
void usart_reset_status(Usart *p_usart);
void usart_start_tx_break(Usart *p_usart);
void usart_stop_tx_break(Usart *p_usart);
void usart_start_rx_timeout(Usart *p_usart);
uint32_t usart_send_address(Usart *p_usart, uint32_t ul_addr);
void usart_reset_iterations(Usart *p_usart);
void usart_reset_nack(Usart *p_usart);
void usart_restart_rx_timeout(Usart *p_usart);
#if (SAM3S || SAM4S || SAM3U || SAM4L || SAM4E)
void usart_drive_DTR_pin_low(Usart *p_usart);
void usart_drive_DTR_pin_high(Usart *p_usart);
#endif
void usart_drive_RTS_pin_low(Usart *p_usart);
void usart_drive_RTS_pin_high(Usart *p_usart);
void usart_spi_force_chip_select(Usart *p_usart);
void usart_spi_release_chip_select(Usart *p_usart);
uint32_t usart_is_tx_ready(Usart *p_usart);
uint32_t usart_is_tx_empty(Usart *p_usart);
uint32_t usart_is_rx_ready(Usart *p_usart);
uint32_t usart_is_rx_buf_end(Usart *p_usart);
uint32_t usart_is_tx_buf_end(Usart *p_usart);
uint32_t usart_is_rx_buf_full(Usart *p_usart);
uint32_t usart_is_tx_buf_empty(Usart *p_usart);
uint32_t usart_write(Usart *p_usart, uint32_t c);
uint32_t usart_putchar(Usart *p_usart, uint32_t c);
void usart_write_line(Usart *p_usart, const char *string);
uint32_t usart_read(Usart *p_usart, uint32_t *c);
uint32_t usart_getchar(Usart *p_usart, uint32_t *c);
#if (SAM3XA || SAM3U)
uint32_t *usart_get_tx_access(Usart *p_usart);
uint32_t *usart_get_rx_access(Usart *p_usart);
#endif
#if (!SAM4L)
Pdc *usart_get_pdc_base(Usart *p_usart);
#endif
void usart_enable_writeprotect(Usart *p_usart);
void usart_disable_writeprotect(Usart *p_usart);
uint32_t usart_get_writeprotect_status(Usart *p_usart);
uint8_t usart_get_error_number(Usart *p_usart);
#if (SAM3S || SAM4S || SAM3U || SAM3XA || SAM4L || SAM4E)
void usart_man_set_tx_pre_len(Usart *p_usart, uint8_t uc_len);
void usart_man_set_tx_pre_pattern(Usart *p_usart, uint8_t uc_pattern);
void usart_man_set_tx_polarity(Usart *p_usart, uint8_t uc_polarity);
void usart_man_set_rx_pre_len(Usart *p_usart, uint8_t uc_len);
void usart_man_set_rx_pre_pattern(Usart *p_usart, uint8_t uc_pattern);
void usart_man_set_rx_polarity(Usart *p_usart, uint8_t uc_polarity);
void usart_man_enable_drift_compensation(Usart *p_usart);
void usart_man_disable_drift_compensation(Usart *p_usart);
#endif

#if SAM4L
uint32_t usart_get_version(Usart *p_usart);
#endif

/// @cond 0
/**INDENT-OFF**/
#ifdef __cplusplus
}
#endif
/**INDENT-ON**/
/// @endcond

//! @}

/**
 * \page sam_usart_quickstart SAM USARTPʕpJn̎
 *
 * ͎gpʂ̑Iײނ`Ԑݒ肵Ďgp@̒iKIȎxł
 * \ref group_sam_drivers_usart "USARTPʕ"pJn̎łB
 *
 * gʂ͂̺ޒfЂ܂݂܂B\ݒiK̺ޒfЂ͓Ǝ
 * ֐ɕʂ邱ƂłAgiK͗ႦΎ剞p֐ɕʂ邱Ƃ
 * ܂B
 *
 * \note SAM޲USARTUAERT̗̒Pʕ܂݁A҂͑O҂̋@
 *       \IȕWɂȂ܂AIɂ͓ƗӋ@\łBUARTPʕ
 *       USARTײނƌ݊܂AUARTײނɂĎx@
 *       \Ɠɑ΂ĂłB
 *
 * \section usart_basic_use_case {IȎgp
 * \section usart_use_cases USARTgp
 * - \ref usart_basic_use_case
 * - \subpage usart_use_case_1
 * - \subpage usart_use_case_2
 *
 * \section usart_basic_use_case {IȎgp - M
 * ̎gpʂŁAUSARTPʕ͈ȉ̂悤Ɍ`Ԑݒ肳܂B:
 * - USART0gp
 * - ްڰ: 9600
 * - : 8ޯ
 * - è: Ȃ
 * - ~ޯ: 1ޯ
 * - RS232
 *
 * \section usart_basic_use_case_setup \ݒiK
 *
 * \subsection usart_basic_use_case_setup_prereq OKv
 * -# \ref sysclk_group "System Clock Management (sysclock)"
 * -# \ref ioport_group "Common IOPORT API (ioport)"
 *
 * \subsection usart_basic_use_case_setup_code ޗ
 * ȉ̌`Ԑݒ肪ۼުĂɒǉȂ΂Ȃ܂(ʓIconf_usart.ḩ
 * ɂłAȂ̎剞p̧قɒǉ邱Ƃł܂)B
 * \code
 *    #define USART_SERIAL                 USART0
 *    #define USART_SERIAL_ID              ID_USART0  //USART0 for sam4l
 *    #define USART_SERIAL_PIO             PINS_USART_PIO
 *    #define USART_SERIAL_TYPE            PINS_USART_TYPE
 *    #define USART_SERIAL_PINS            PINS_USART_PINS
 *    #define USART_SERIAL_MASK            PINS_USART_MASK
 *    #define USART_SERIAL_BAUDRATE        9600
 *    #define USART_SERIAL_CHAR_LENGTH     US_MR_CHRL_8_BIT
 *    #define USART_SERIAL_PARITY          US_MR_PAR_NO
 *    #define USART_SERIAL_STOP_BIT        US_MR_NBSTOP_1_BIT
 * \endcode
 *
 * pɒǉ܂B:
 * \code
 *    sysclk_init();
 *
 *    board_init();
 *
 *    const sam_usart_opt_t usart_console_settings = {
 *        USART_SERIAL_BAUDRATE,
 *        USART_SERIAL_CHAR_LENGTH,
 *        USART_SERIAL_PARITY,
 *        USART_SERIAL_STOP_BIT,
 *        US_MR_CHMODE_NORMAL
 *    };
 *
 *    sysclk_enable_peripheral_clock(USART_SERIAL_ID);
 *
 *    usart_init_rs232(USART_SERIAL, &usart_console_settings,
 *            sysclk_get_main_hz());
 *    usart_enable_tx(USART_SERIAL);
 *    usart_enable_rx(USART_SERIAL);
 * \endcode
 *
 * \subsection usart_basic_use_case_setup_flow Ƃ̗
 * -#  ۯ
 *   \code
 *   sysclk_init();
 *   \endcode
 * -# ֐vĂԂƂɂUSARTM݂`Ԑݒ:
 *   \code
 *    board_init();
 *   \endcode
 * \note conf_board.ḩقŒ`ݒ
 * -# USARTCӑI\̂쐬:
 *   \code
 *   const sam_usart_opt_t usart_console_settings = {
 *        USART_SERIAL_BAUDRATE,
 *        USART_SERIAL_CHAR_LENGTH,
 *        USART_SERIAL_PARITY,
 *        USART_SERIAL_STOP_BIT,
 *        US_MR_CHMODE_NORMAL
 *   };
 *   \endcode
 * -# USARTPʕւ̸ۯ:
 *   \code
 *   sysclk_enable_peripheral_clock(USART_SERIAL_ID);
 *   \endcode
 * -# USARTPʕRS232ŏ:
 *   \code
 *   usart_init_rs232(USART_SERIAL, &usart_console_settings,
 *           sysclk_get_main_hz());
 *   \endcode
 * -# USARTPʕ̑M:
 *   \code
 *   usart_enable_tx(USART_SERIAL);
 *   usart_enable_rx(USART_SERIAL);
 *   \endcode
 *
 * \section usart_basic_use_case_usage giK
 *
 * \subsection usart_basic_use_case_usage_code ޗ
 * pÇقɒǉ܂B:
 * \code
 * usart_putchar(USART_SERIAL, 'a');
 * \endcode
 *
 * \subsection usart_basic_use_case_usage_flow Ƃ̗
 * -# USARToRŕ𑗏o
 *   \code usart_putchar(USART_SERIAL, 'a'); \endcode
 */

/**
 * \page usart_use_case_1 USARTMƑԂ
 *
 * ̎gpʂŁAUSARTPʕ͈ȉ̂悤Ɍ`Ԑݒ肳܂B:
 * - USART0gp
 * - ްڰ: 9600
 * - : 8ޯ
 * - è: Ȃ
 * - ~ޯ: 1
 * - RS232
 *
 * gpʂ͌`Ԑݒ肵USARTŎM҂A̕𓯂USART֑
 * ܂B
 *
 * \section usart_use_case_1_setup \ݒiK
 *
 * \subsection usart_use_case_1_setup_prereq OKv
 * -# \ref sysclk_group "System Clock Management (sysclock)"
 * -# \ref ioport_group "Common IOPORT API (ioport)"
 *
 * \subsection usart_use_case_1_setup_code ޗ
 * ȉ̌`Ԑݒ肪ۼުĂɒǉȂ΂Ȃ܂(ʓIconf_usart.ḩ
 * ɂłAȂ̎剞p̧قɒǉ邱Ƃł܂)B
 * \code
 *    #define USART_SERIAL                 USART0
 *    #define USART_SERIAL_ID              ID_USART0  //USART0 for sam4l
 *    #define USART_SERIAL_PIO             PINS_USART_PIO
 *    #define USART_SERIAL_TYPE            PINS_USART_TYPE
 *    #define USART_SERIAL_PINS            PINS_USART_PINS
 *    #define USART_SERIAL_MASK            PINS_USART_MASK
 *    #define USART_SERIAL_BAUDRATE        9600
 *    #define USART_SERIAL_CHAR_LENGTH     US_MR_CHRL_8_BIT
 *    #define USART_SERIAL_PARITY          US_MR_PAR_NO
 *    #define USART_SERIAL_STOP_BIT        US_MR_NBSTOP_1_BIT
 * \endcode
 *
 * M޲ėp̕ϐǉȂ΂Ȃ܂B:
 * \code
 *    uint32_t received_byte;
 * \endcode
 *
 * pɒǉ܂B:
 * \code
 *    sysclk_init();
 *
 *    board_init();
 *
 *    const sam_usart_opt_t usart_console_settings = {
 *        USART_SERIAL_BAUDRATE,
 *        USART_SERIAL_CHAR_LENGTH,
 *        USART_SERIAL_PARITY,
 *        USART_SERIAL_STOP_BIT,
 *        US_MR_CHMODE_NORMAL
 *    };
 *
 *    sysclk_enable_peripheral_clock(USART_SERIAL_ID);
 *
 *    usart_init_rs232(USART_SERIAL, &usart_console_settings,
 *            sysclk_get_main_hz());
 *    usart_enable_tx(USART_SERIAL);
 *    usart_enable_rx(USART_SERIAL);
 * \endcode
 *
 * \subsection usart_use_case_1_setup_flow Ƃ̗
 * -#  ۯ:
 *   \code
 *   sysclk_init();
 *   \endcode
 * -# ֐ĂяoɂUSARTM݂`Ԑݒ:
 *   \code
 *    board_init();
 *   \endcode
 * \note conf_board.ḩقŒ`ݒ
 * -# USARTCӑI\̂쐬:
 *   \code
 *   const sam_usart_opt_t usart_console_settings = {
 *        USART_SERIAL_BAUDRATE,
 *        USART_SERIAL_CHAR_LENGTH,
 *        USART_SERIAL_PARITY,
 *        USART_SERIAL_STOP_BIT,
 *        US_MR_CHMODE_NORMAL
 *   };
 *   \endcode
 * -# USARTPʕւ̸ۯ:
 *   \code sysclk_enable_peripheral_clock(USART_SERIAL_ID); \endcode
 * -# USARTPʕRS232ŏ:
 *   \code
 *   usart_init_rs232(USART_SERIAL, &usart_console_settings,
 *           sysclk_get_main_hz());
 *   \endcode
 * -# USARTPʕ̑M:
 *   \code
 *   usart_enable_tx(USART_SERIAL);
 *   usart_enable_rx(USART_SERIAL);
 *   \endcode
 *
 * \section usart_use_case_1_usage giK
 *
 * \subsection usart_use_case_1_usage_code ޗ
 * Ⴆ΁ApÇقmianJԂɒǉ܂B:
 * \code
 * received_byte = usart_getchar(USART_SERIAL);
 * usart_putchar(USART_SERIAL, received_byte);
 * \endcode
 *
 * \subsection usart_use_case_1_usage_flow Ƃ̗
 * -# Mҋ@:
 *   \code usart_getchar(USART_SERIAL, &received_byte); \endcode
 * -# Ԃ:
 *   \code usart_putchar(USART_SERIAL, received_byte); \endcode
 */

/**
 * \page usart_use_case_2 荞݌oRłUSARTMƑԂ
 *
 * ̎gpʂŁAUSARTPʕ͈ȉ̂悤Ɍ`Ԑݒ肳܂B:
 * - USART0gp
 * - ްڰ: 9600
 * - : 8ޯ
 * - è: Ȃ
 * - ~ޯ: 1
 * - RS232
 *
 * gpʂ͌`Ԑݒ肵USARTŎM҂A̕𓯂USART֑
 * ܂BM\ref usart_use_case_1 Ŏgpꂽ߰ݸޖ@ނ늄
 * 荞ݏoRŎs܂B
 *
 * \section usart_use_case_2_setup \ݒiK
 *
 * \subsection usart_use_case_2_setup_prereq OKv
 * -# \ref sysclk_group "System Clock Management (sysclock)"
 * -# \ref pio_group "Parallel Input/Output Controller (pio)"
 * -# \ref pmc_group "Power Management Controller (pmc)"
 *
 * \subsection usart_use_case_2_setup_code ޗ
 * ȉ̌`Ԑݒ肪ۼުĂɒǉȂ΂Ȃ܂(ʓIconf_usart.ḩ
 * ɂłAȂ̎剞p̧قɒǉ邱Ƃł܂)B
 * \code
 *    #define USART_SERIAL                 USART0
 *    #define USART_SERIAL_ID              ID_USART0  //USART0 for sam4l
 *    #define USART_SERIAL_ISR_HANDLER     USART0_Handler
 *    #define USART_SERIAL_PIO             PINS_USART_PIO
 *    #define USART_SERIAL_TYPE            PINS_USART_TYPE
 *    #define USART_SERIAL_PINS            PINS_USART_PINS
 *    #define USART_SERIAL_MASK            PINS_USART_MASK
 *    #define USART_SERIAL_BAUDRATE        9600
 *    #define USART_SERIAL_CHAR_LENGTH     US_MR_CHRL_8_BIT
 *    #define USART_SERIAL_PARITY          US_MR_PAR_NO
 *    #define USART_SERIAL_STOP_BIT        US_MR_NBSTOP_1_BIT
 * \endcode
 *
 * M޲ėp̕ϐǉȂ΂Ȃ܂B:
 * \code
 *    uint32_t received_byte;
 * \endcode
 *
 * pɒǉ܂B:
 * \code
 *    sysclk_init();
 *
 *    board_init();
 *
 *    const sam_usart_opt_t usart_console_settings = {
 *        USART_SERIAL_BAUDRATE,
 *        USART_SERIAL_CHAR_LENGTH,
 *        USART_SERIAL_PARITY,
 *        USART_SERIAL_STOP_BIT,
 *        US_MR_CHMODE_NORMAL
 *    };
 *
 *    sysclk_enable_peripheral_clock(USART_SERIAL_ID);
 *
 *    usart_init_rs232(USART_SERIAL, &usart_console_settings,
 *            sysclk_get_main_hz());
 *    usart_enable_tx(USART_SERIAL);
 *    usart_enable_rx(USART_SERIAL);
 *
 *    usart_enable_interrupt(USART_SERIAL, US_IER_RXRDY);
 *    NVIC_EnableIRQ(USART_SERIAL_IRQ);
 * \endcode
 *
 * \subsection usart_use_case_2_setup_flow Ƃ̗
 * -#  ۯ:
 *   \code
 *   sysclk_init();
 *   \endcode
 * -# ֐ĂяoɂUSARTM݂`Ԑݒ:
 *   \code
 *    board_init();
 *   \endcode
 * \note conf_board.ḩقŒ`ݒ.
 * -# USARTCӑI\̂쐬:
 *   \code
 *   const sam_usart_opt_t usart_console_settings = {
 *        USART_SERIAL_BAUDRATE,
 *        USART_SERIAL_CHAR_LENGTH,
 *        USART_SERIAL_PARITY,
 *        USART_SERIAL_STOP_BIT,
 *        US_MR_CHMODE_NORMAL
 *   };
 *   \endcode
 * -# USARTPʕւ̸ۯ:
 *   \code sysclk_enable_peripheral_clock(USART_SERIAL_ID); \endcode
 * -# USARTPʕRS232ŏ:
 *   \code
 *   usart_init_rs232(USART_SERIAL, &usart_console_settings,
 *           sysclk_get_main_hz());
 *   \endcode
 * -# USARTPʕ̑M:
 *   \code
 *   usart_enable_tx(USART_SERIAL);
 *   usart_enable_rx(USART_SERIAL);
 *   \endcode
 * -# USARTPʕɑ΂USARTM荞݂ƑS̊荞݂
 *   \code
 *   usart_enable_interrupt(USART_SERIAL, US_IER_RXRDY);
 *   NVIC_EnableIRQ(USART_SERIAL_IRQ);
 *   \endcode
 * \section usart_use_case_2_usage giK
 *
 * \subsection usart_use_case_2_usage_code ޗ
 * Ȃ̎剞p̧قUSART荞ݏǉ܂B:
 * \code
 * void USART_SERIAL_ISR_HANDLER(void)
 * {
 *    uint32_t dw_status = usart_get_status(USART_SERIAL);
 *
 *    if (dw_status & US_CSR_RXRDY) {
 *        uint32_t received_byte;
 *
 *        usart_read(USART_SERIAL, &received_byte);
 *        usart_write(USART_SERIAL, received_byte);
 *    }
 * }
 * \endcode
 *
 * \subsection usart_use_case_2_usage_flow Ƃ̗
 * -# USART ISRUSARTPʕ荞׸ނ擾܂B:
 *   \code uint32_t dw_status = usart_get_status(USART_SERIAL); \endcode
 * -# USARTM荞݂:
 *   \code if (dw_status & US_CSR_RXRDY) \endcode
 * -# MꂽꍇAꎞϐɎ擾:
 *   \code usart_read(USART_SERIAL, &received_byte); \endcode
 * -# ̕𑗂Ԃ:
 *   \code usart_write(USART_SERIAL, received_byte); \endcode
 */

#endif /* USART_H_INCLUDED */
