/**
 * \file
 *
 * \brief USBuײ
 *        ׳UDDƌ݊
 *
 * 쌠 (c) 2012 - 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "conf_usb.h"
#include "sysclk.h"
#include "udd.h"
#include "usbc_otg.h"
#include "usbc_device.h"
#include <string.h>

#ifndef UDD_NO_SLEEP_MGR
#   include "sleepmgr.h"
#endif

#if !(SAM4L)
#   error The current USBC Device Driver supports only SAM4L.
#endif
#ifndef UDD_USB_INT_FUN
#   define UDD_USB_INT_FUN USBC_Handler
#endif

#ifndef UDD_USB_INT_LEVEL
#   define UDD_USB_INT_LEVEL 5	// ɂUSB荞݂͒D挠܂B
#endif

#define UDD_EP_USED(ep)      (USB_DEVICE_MAX_EP >= ep)


// ޯޗp
//#define USBC_DEBUG
#ifdef USBC_DEBUG
#   define dbg_print printf
#else
#   define dbg_print(...)
#endif

/**
 * \ingroup udd_group
 * \defgroup udd_usbc_group USBCuײ
 *
 * \section USBC_CONF USBCƎ`Ԑݒ
 * ȉUSBCײތ`Ԑݒ͉pconf_usb.hŲݸٰނȂ΂Ȃ܂B
 *
 * UDD_USB_INT_LEVEL<br>
 * 荞ݗD挠(0`15)ɂ5()ύX邽߂̔CӑI
 *
 * UDD_USB_INT_FUN<br>
 * O\Œ`ꂽ̂Ɋ荞݊֐킹邽߂̔CӑI
 *
 * \section Ăі߂Ǘ
 * USBײނ͊荞݂ɂĊSɊǗAIȍƂv܂B
 * ɂAUSBۂ͏]̂ɌĂі߂gp܂BĂі߂ͺْ߲
 * ɐÓIŁA܂ͺގs̕ϐŐ錾܂B
 *
 * in conf_usb.hŒ`ÓI錾:
 * - UDC_VBUS_EVENT(bool b_present)<br>
 *   VBUSٕω}邽
 * - UDC_SUSPEND_EVENT()<br>
 *   USB޽x~ֈڍs鎞ɌĂ΂܂B
 * - UDC_RESUME_EVENT()<br>
 *   USB޽Nオ鎞ɂ΂܂B
 * - UDC_SOF_EVENT()<br>
 *   eSOFMɂ΂܂B: HS/FS삾Ŋe1ms
 *
 * "߲ ޮ"ƌĂ΂铮IĂі߂͈ȉ̊֐oRudd_ep_job_t\
 * ɓo^܂B:
 * - udd_ep_run()<br>
 *   ]IɂĂԂ
 * - udd_ep_wait_stall_clear()<br>
 *   ߲Ē~֎~鎞ɌĂԂ
 *
 * \section d͓Ǘ
 * Fꂽx~:
 * - USB(IDLE)ԂŁAUSBCUSBۯKvűٓ܂łF܂B
 * - USBx~(SUSPEND)ԂŁAUSBCUSBۯsvłAŏۯĎnݸނ
 *   v܂B̂ɑҋ@(WAIT)܂͕ێ(RETENTION)̓܂ŔF܂B
 * - USBȋdŎgpVBUSĎޯ(BACKUP)܂ŔF܂B
 *
 * USBC_SLEEP_MODE_USB_IDLESLEEPMGR_IDLEƓłB
 *
 * USBC_SLEEP_MODE_USB_SUSPENDUSBd͓Ɉˑ܂B
 * USBۯnݸނUSBx:
 * | d͓ | x | ۯn | Fx~ |
 * | X        | LS, FS   | >10ms    | SLEEPMGR_BACKUP    |
 * | X        | HS       | >3ms     | SLEEPMGR_BACKUP    |
 * | ȋd | LS, FS   | <=10ms   | SLEEPMGR_RET       |
 * | ȋd | HS       | <=3ms    | SLEEPMGR_RET       |
 * | ޽d  | LS, FS   | <=10ms   | SLEEPMGR_RET       |
 * | ޽d  | HS       | <=3ms    | SLEEPMGR_RET       |
 *
 * @{
 */


// USBu`Ԑݒ𒲍
#ifndef USB_DEVICE_EP_CTRL_SIZE
#   error USB_DEVICE_EP_CTRL_SIZE not defined
#endif
#ifndef USB_DEVICE_MAX_EP
#   error USB_DEVICE_MAX_EP not defined
#endif
#if USB_DEVICE_MAX_EP > UDD_MAX_PEP_NB
#   error USB_DEVICE_MAX_EP is too high and not supported by this part
#endif
#if (SAM4L)
#   ifdef USB_DEVICE_HS_SUPPORT
#      error The High speed mode is not supported on this part, please remove USB_DEVICE_HS_SUPPORT in conf_usb.h
#   endif
#endif

/**
 * \name d͊Ǘٰ
 */
//@{

#ifndef UDD_NO_SLEEP_MGR

//! x~ق̒`
#if OTG_ID_IO || OTG_VBUS_IO
#   define USBC_SLEEP_MODE_USB_SUSPEND  SLEEPMGR_SLEEP_1
#else
#   define USBC_SLEEP_MODE_USB_SUSPEND  SLEEPMGR_RET
#endif
#   define USBC_SLEEP_MODE_USB_IDLE     SLEEPMGR_ACTIVE

//! USB̏
static bool udd_b_idle;


/*! \brief CPUܰ޳ݓ܂͔ۂ
 *
 * \param  b_enable ܰ޳ݓFɂtrue
 */
static void udd_sleep_mode(bool b_idle)
{
	if (!b_idle && udd_b_idle) {
		sleepmgr_unlock_mode(USBC_SLEEP_MODE_USB_IDLE);
	}
	if (b_idle && !udd_b_idle) {
		sleepmgr_lock_mode(USBC_SLEEP_MODE_USB_IDLE);
	}
	udd_b_idle = b_idle;
}
#else

static void udd_sleep_mode(bool b_idle)
{
	UNUSED(b_idle);
}
#endif  // UDD_NO_SLEEP_MGR

//@}

/**
 * \name USB I/O߯ޏ
 */
//@{

#if (OTG_VBUS_IO || OTG_VBUS_EIC)
/**
 * USB VBUSݕω
 */
static void uhd_vbus_handler(void)
{
	pad_ack_vbus_interrupt();
	dbg_print("VBUS ");
# ifndef USB_DEVICE_ATTACH_AUTO_DISABLE
	if (Is_pad_vbus_high()) {
		udd_attach();
	} else {
		udd_detach();
	}
# endif
# ifdef UDC_VBUS_EVENT
	UDC_VBUS_EVENT(Is_pad_vbus_high());
# endif
}
#endif

//@}

/**
 * @brief ߲ċLqq\ɂĂUSB SRAMް
 * USB SRAM̓e͈ȉ邱Ƃł܂B:
 * - ߲ďԂ}邽߂ɲ̪ɂUSBʰ޳ɂύX
 *   ɂAͿĳɂēǂ܂܂B
 * - ߲Ă𐧌䂷邽߂USBĳɂύX
 *   ɂAʰ޳ɂēǂ܂܂B
 * ް͊ł
 *
 * @{
 */
UDC_BSS(32)
static volatile usb_desc_table_t udd_g_ep_table[2 * (USB_DEVICE_MAX_EP + 1)];

/**
 * \name ߲ĒʊǗٰ
 *
 * ̊֐߲͐ĊǗs܂B͐Pʏ
 * SETUP/DATA/HANDSHAKEiK܂B
 */
//@{

//! SETUPvǗɂĂ̏^ċL^邽߂̑S̕ϐ
COMPILER_WORD_ALIGNED udd_ctrl_request_t udd_g_ctrlreq;

//! udd_ep_control_stateɑ΂߲Đԋ@\ɂsޯĒ`
typedef enum {
	UDD_EPCTRL_SETUP					= 0,	//!< SETUP߹đ҂
	UDD_EPCTRL_DATA_OUT					= 1,	//!< OUTް ߹đ҂
	UDD_EPCTRL_DATA_IN					= 2,	//!< INް ߹đ҂
	UDD_EPCTRL_HANDSHAKE_WAIT_IN_ZLP	= 3,	//!< IN ZLP߹đ҂
	UDD_EPCTRL_HANDSHAKE_WAIT_OUT_ZLP	= 4,	//!< OUT ZLP߹đ҂
	UDD_EPCTRL_STALL_REQ				= 5,	//!< INOUT߹ĂŋꂽSTALL
} udd_ctrl_ep_state_t;

//! ߲ĐǗ̏
static udd_ctrl_ep_state_t udd_ep_control_state;

//! O̖{̊ɏՕް ߹ĒiK̑Mް
static uint16_t udd_ctrl_prev_payload_nb_trans;

//! udd_g_ctrlreq{̊ɏՕƂőMꂽް
static uint16_t udd_ctrl_payload_nb_trans;

/**
 * \brief ߲(SETUP/OUT߲0)ŎMꂽްi[ɏՕ
 *
 * {̊ɏՕ߲Ă̑傫ꍇRAMɏՕ̂
 * gp
 */
UDC_BSS(4) uint8_t udd_ctrl_buffer[USB_DEVICE_EP_CTRL_SIZE];

/**
 * \brief ߲Ăؾ
 *
 * USBؾČ܂UDD鎞ɂ΂܂B
 */
static void udd_reset_ep_ctrl(void);

/**
 * \brief ߲ĊǗؾ
 *
 * Called after a USB line reset or at the end of SETUP request (after ZLP)
 */
static void udd_ctrl_init(void);

//! \brief ߲ĂSETUP߹Ă̊ǗꂽM
static void udd_ctrl_setup_received(void);

//! \brief ߲ĂIN߹Ă̊ǗꂽM
static void udd_ctrl_in_sent(void);

//! \brief ߲ĂOUT߹Ă̊ǗꂽM
static void udd_ctrl_out_received(void);

//! \brief ߲ĂIN߹Ă̊Ǘꂽꎖ
static void udd_ctrl_underflow(void);

//! \brief ߲ĂOUT߹Ă̊Ǘꂽꎖ
static void udd_ctrl_overflow(void);

//! \brief ߲ĂIN/OUT߹Ă̊Ǘꂽ~
static void udd_ctrl_stall_data(void);

//! \brief ߲ĂZLP IN𑗏o
static void udd_ctrl_send_zlp_in(void);

//! \brief ߲ĂZLP OUT𑗏o
static void udd_ctrl_send_zlp_out(void);

//! \brief SETUPvɘAgĂі߂ĂԁB
static void udd_ctrl_endofrequest(void);


/**
 * \brief ߲ėp劄荞ٰ
 *
 * ߲͐Ďۂ𐳂⏕֐ɐ؂ւ܂B
 *
 * \return ߲ĂɂĂ̎ۂ\c 1AȂ\c 0
 */
static bool udd_ctrl_interrupt(void);

//@}

/**
 * \name (ٸ)/荞/(ɽ)߲Ă̊Ǘ
 *
 * UDDʹ߲ďް]Ǘ܂B:
 * - USBuDMAŴ߲ďް]Jn
 * - ߂ꂽȂAZLP߹Ă𑗏o
 * - ]I}邽߂ɓo^ꂽĂі߂Ăяo
 * ]̒~ƒ~̋@\x܂B
 */
//@{
#if (0!=USB_DEVICE_MAX_EP)

//! ߲Ăœo^ꂽƂɂĂ̍\̒`
typedef struct {

	union {

		//! ]IŌĂԌĂі߂
		udd_callback_trans_t call_trans;
		//! ߲Ē~鎞ɌĂԌĂі߂
		udd_callback_halt_cleared_t call_nohalt;
	};

	//! ƒɑ܂͖̂ɓRAMɒuɏՕ
	uint8_t *buf;
	//! ܂͖ɏՕ̑傫
	iram_size_t buf_size;
	//! ߲Ăœ]ް̑
	iram_size_t nb_trans;

	//! Ƃ̴߲͂Ăœo^܂B
	uint8_t busy:1;
	//! Z߹ĂIN߲Ăł̂̍Ƃɑ΂ėv܂B
	uint8_t b_shortpacket:1;
	//! ɏՕ͌OUT߲ĂŎgp܂B
	uint8_t b_use_out_cache_buffer:1;

} udd_ep_job_t;


//! /荞/̴߲Ăł̍Ƃo^邽߂̔z
static udd_ep_job_t udd_ep_job[USB_DEVICE_MAX_EP];

/**
 * \brief /荞̴݂߲ĂŎMްi[ɏՕ
 *
 * {̊ɏՕ߲Ă̑傫ꍇRAMɏՕ̂
 * gp
 *
 * \warning ی삳ꂽ荞ݴ߲Ă̑傫͍ő512޲ĂłB
 * \warning ߲Ă̼͂тɂĕی삳ꂸAgp҂͏ɴ߲Ă
 *          傫ɑΉɏՕgpȂ΂Ȃ܂B
 */
#if (defined USB_DEVICE_LOW_SPEED)
UDC_BSS(4) uint8_t udd_ep_out_cache_buffer[USB_DEVICE_MAX_EP][8];
#elif (defined USB_DEVICE_HS_SUPPORT)
UDC_BSS(4) uint8_t udd_ep_out_cache_buffer[USB_DEVICE_MAX_EP][512];
#else
UDC_BSS(4) uint8_t udd_ep_out_cache_buffer[USB_DEVICE_MAX_EP][64];
#endif

/**
 * \brief IꂽƂƒgĂі߂ĂԁB
 *
 * \param  ep ~Ƃ̴߲Ĕԍ
 */
static void udd_ep_trans_done(udd_ep_id_t ep);

/**
 * \brief /荞/̴߲ėp劄荞-
 *
 * ʹ߲Ďۂ𐳂⏕֐ɐ؂ւ܂B
 *
 * \return /荞/̴߲ĂɂĂ̎ۂ\c 1A
 *         \c 0
 */
static bool udd_ep_interrupt(void);

#endif // (0!=USB_DEVICE_MAX_EP)
//@}

/**
 * \brief USBu荞݂Ǘ邽߂USBC荞݂ɂČĂ΂֐
 *
 * USBu荞ݎۂ͈ȉ̂悤3̕ɕ܂B:
 * - USB(SOFAؾāAx~AĊJANオ)
 * - ߲Ď(SETUPMAް]IAAA~)
 * - /荞/̴߲Ď(ް]I̍Ō)
 *
 * : ŁAUSB ISR(INTXՕ)USB荞݂꓾Ȃ߁AUSB
 *     荞݂鎞ɑS̊荞ݎՕ܂BӋ@\Pʕ
 *     ZpQ $2.8.3. 荞ݗv̎ՕB
 */
#ifdef UHD_ENABLE
void udd_interrupt(void);	// GCCx邽
void udd_interrupt(void)
#else
ISR(UDD_USB_INT_FUN)
#endif
{
	if (Is_udd_sof()) {
		udd_ack_sof();
		udc_sof_notify();
#ifdef UDC_SOF_EVENT
		UDC_SOF_EVENT();
#endif
		goto udd_interrupt_sof_end;
	}

	dbg_print("%c ", udd_is_high_speed() ? 'H' : 'F');

	if (udd_ctrl_interrupt()) {
		// Ǘꂽ߲Ăɂĉ銄荞
		goto udd_interrupt_end;
	}

#if (0!=USB_DEVICE_MAX_EP)
	if (udd_ep_interrupt()) {
		// Ǘꂽ/荞/̴߲Ăɂĉ銄荞
		goto udd_interrupt_end;
	}
#endif

	// USB޽ ؾČo
	if (Is_udd_reset()) {
		udd_ack_reset();
		dbg_print("RST ");
		// is̑Sƒ~
#if (USB_DEVICE_MAX_EP != 0)
		// e߲Ăɑ΂čƂ~߂B
		{
			uint8_t i;
			for (i = 1; i <= USB_DEVICE_MAX_EP; i++) {
				udd_ep_abort(i);
			}
		}
#endif
		// USBuKwؾ
		udc_reset();
		udd_disable_endpoints();
		// ߲Đؾ
		udd_reset_ep_ctrl();
		// ߲ĐǗؾ
		udd_ctrl_init();
		goto udd_interrupt_end;
	}

	if (Is_udd_suspend_interrupt_enabled() && Is_udd_suspend()) {
		udd_ack_suspend();
		dbg_print("SUSP ");
		otg_unfreeze_clock();

		udd_disable_suspend_interrupt();

		// Ů荞݂邽߁A荞݋̑OɋNオԂ
		udd_ack_wake_up();
		udd_enable_wake_up_interrupt();
		otg_freeze_clock();		// Nオ莖یx~𔲂o߂ɕK{
		udd_sleep_mode(false);	// x~(SUSPEND)ֈڍs
#ifdef UDC_SUSPEND_EVENT
		UDC_SUSPEND_EVENT();
#endif
		goto udd_interrupt_end;
	}

	if (Is_udd_wake_up_interrupt_enabled() && Is_udd_wake_up()) {
		udd_ack_wake_up();
		dbg_print("WKUP ");
		// Nオ芄荞݉Ƌx~荞݋
		otg_unfreeze_clock();

		// x~USBۯAʂƂUSBۯx~
		while (!Is_otg_clock_usable());

		udd_disable_wake_up_interrupt();

		// Ů荞݂邽߁A荞݋̑Oɋx~Ԃ
		udd_ack_suspend();
		udd_enable_suspend_interrupt();
		udd_sleep_mode(true);	// (IDLE)ֈڍs
#ifdef UDC_RESUME_EVENT
		UDC_RESUME_EVENT();
#endif
		goto udd_interrupt_end;
	}

udd_interrupt_end:
	dbg_print("\n\r");
udd_interrupt_sof_end:
	otg_data_memory_barrier();
	return;
}


bool udd_include_vbus_monitoring(void)
{
#if (OTG_VBUS_IO || OTG_VBUS_EIC)
	return true;
#else
	return false;
#endif
}


void udd_enable(void)
{
	irqflags_t flags;

	flags = cpu_irq_save();

#ifdef UHD_ENABLE
	//* DUAL ROLE INITIALIZATION
	if (otg_dual_enable()) {
		// otg_dual_enable()ɂČ݂̓삪JnB
		cpu_irq_restore(flags);
		return;
	}
#else
	//* Pꑕu쏉
	sysclk_enable_usb();

	/* ́Auł\BUSBC荞݂UDD荞݂Ɍq܂B */
	NVIC_ClearPendingIRQ(USBC_IRQn);
	NVIC_SetPriority(USBC_IRQn, UDD_USB_INT_LEVEL);
	NVIC_EnableIRQ(USBC_IRQn);

	/* ޯ(BACKUP)SAM USBNオ葕uɑ΂ċx~̔o
	 * ̂߁Aɔ񓯊USB荞݂F
	 */
	usbc_async_wake_up_enable();
	bpm_enable_fast_wakeup(BPM);
#endif

#if (OTG_ID_EIC || OTG_ID_IO) && (defined UHD_ENABLE)
	// uID݂ɂđI΂Ă邱Ƃ𒲍
	if (!Is_pad_id_device()) {
		cpu_irq_restore(flags);
		return;	// u݂̓łȂB
	}
#else
	// ID݂gpȂAu
	otg_enable_device_mode();
#endif

	// USBʰ޳
	otg_enable();
	otg_unfreeze_clock();
	(void)Is_otg_clock_frozen();

	memset((uint8_t *) udd_g_ep_table, 0, sizeof(udd_g_ep_table));
	otg_register_desc_tab(udd_g_ep_table);

	// ϐؾ
#if (0!=USB_DEVICE_MAX_EP)
	{
		uint8_t i;
		for (i = 0; i < USB_DEVICE_MAX_EP; i++) {
			udd_ep_job[i].busy = false;
		}
	}
#endif

	// `Ԑݒ̧قɂėvUSBxݒ
#ifdef USB_DEVICE_LOW_SPEED
	udd_low_speed_enable();
#else
	udd_low_speed_disable();
#  ifdef USB_DEVICE_HS_SUPPORT
	udd_high_speed_enable();
#  else
	udd_high_speed_disable();
#  endif
#endif
	otg_freeze_clock();

#ifndef UDD_NO_SLEEP_MGR
	// USBx~ɑ΂ĔFꂽx~
	udd_b_idle = false;
	sleepmgr_lock_mode(USBC_SLEEP_MODE_USB_SUSPEND);
#endif

	/* VBUSĎ */
#if OTG_VBUS_EIC || OTG_VBUS_IO
	pad_vbus_init(UDD_USB_INT_LEVEL);
	/* VBUSHigh̎VBUS荞݂Bνē~/JnԂ̒Z
	 * ݸނ̂߂ɉ\łB
	 */
	if (Is_pad_vbus_high()) {
		uhd_vbus_handler();
	}
#else
	// VBUSoȂAHighƉ
# ifndef USB_DEVICE_ATTACH_AUTO_DISABLE
	udd_attach();
# endif
#endif

	cpu_irq_restore(flags);
}

void udd_disable(void)
{
	irqflags_t flags;

#ifdef UHD_ENABLE
#  if OTG_ID_IO || OTG_ID_EIC
	if (!Is_pad_id_device()) {
		return;	// νē쑖sAUDD֎~𖳎
	}
# else
	if (Is_otg_host_mode_enabled()) {
		return;	// νē쑖sAUDD֎~𖳎
	}
# endif
#endif
	flags = cpu_irq_save();
	otg_unfreeze_clock();
	udd_detach();
#ifndef UDD_NO_SLEEP_MGR
	sleepmgr_unlock_mode(USBC_SLEEP_MODE_USB_SUSPEND);
#endif

#ifndef UHD_ENABLE
	otg_disable();
	sysclk_disable_usb();
	// Ȃ΁AUSBۯ֎~USBdǗUHCɂčs܂B
#endif
	cpu_irq_restore(flags);
}

void udd_attach(void)
{
	irqflags_t flags;
	flags = cpu_irq_save();

	// nɉUSB޽Ԃ͖mŁA]ďԂ͂ǂUSBۂ葹˂Ȃ
	// ߂ɱ(IDLE)ƌ􂳂܂B
	udd_sleep_mode(true);
	otg_unfreeze_clock();
	while(!Is_otg_clock_usable());

	// VBUS݂ȂΎtF
	udd_attach_device();

	// USBۋ
	udd_enable_reset_interrupt();
	udd_enable_suspend_interrupt();
	udd_enable_wake_up_interrupt();
	udd_enable_sof_interrupt();

	// ȉ̊荞׸ނؾ
	udd_ack_reset();
	udd_ack_sof();

	// ŏ̋x~荞݂Ȃ΂Ȃ܂B
	udd_raise_suspend();
	udd_ack_wake_up();
	otg_freeze_clock();
	cpu_irq_restore(flags);
}


void udd_detach(void)
{
	otg_unfreeze_clock();

	// ޽瑕uO
	udd_detach_device();
	otg_freeze_clock();
	udd_sleep_mode(false);
}


bool udd_is_high_speed(void)
{
#ifdef USB_DEVICE_HS_SUPPORT
	return !Is_udd_full_speed_mode();
#else
	return false;
#endif
}


void udd_set_address(uint8_t address)
{
	udd_disable_address();
	udd_configure_address(address);
	udd_enable_address();
}


uint8_t udd_getaddress(void)
{
	return udd_get_configured_address();
}


uint16_t udd_get_frame_number(void)
{
	return udd_frame_number();
}

uint16_t udd_get_micro_frame_number(void)
{
#ifdef USB_DEVICE_HS_SUPPORT
	return udd_micro_frame_number();
#else
	return 0;
#endif
}


void udd_send_remotewakeup(void)
{
#ifndef UDD_NO_SLEEP_MGR
	if (!udd_b_idle)
#endif
	{
		udd_sleep_mode(true);	// (IDLE)ֈڍs
		otg_unfreeze_clock();
		udd_initiate_remote_wake_up();
	}
}


void udd_set_setup_payload( uint8_t *payload, uint16_t payload_size )
{
	udd_g_ctrlreq.payload = payload;
	udd_g_ctrlreq.payload_size = payload_size;
}


#if (0!=USB_DEVICE_MAX_EP)
bool udd_ep_alloc(udd_ep_id_t ep, uint8_t bmAttributes,
		uint16_t MaxEndpointSize)
{
	uint8_t ep_addr = ep & USB_EP_ADDR_MASK;
	if (Is_udd_endpoint_enabled(ep_addr)) {
		return false;
	}

	// ߲Ă̑傫8,16,32,64,128,256,512,܂1023
	Assert(MaxEndpointSize < 1024);
	Assert((MaxEndpointSize == 1023) || !(MaxEndpointSize & (MaxEndpointSize - 1)));
	Assert(MaxEndpointSize >= 8);

	// ߲Č`
	Assert(((bmAttributes & USB_EP_TYPE_MASK) == USB_EP_TYPE_ISOCHRONOUS)
		|| ((bmAttributes & USB_EP_TYPE_MASK) == USB_EP_TYPE_BULK)
		|| ((bmAttributes & USB_EP_TYPE_MASK) == USB_EP_TYPE_INTERRUPT));

	udd_configure_endpoint(ep_addr, bmAttributes,
			((ep & USB_EP_DIR_IN) ? USBC_UECFG0_EPDIR_IN
				: USBC_UECFG0_EPDIR_OUT),
			MaxEndpointSize, USBC_UECFG0_EPBK_SINGLE);

	udd_enable_busy_bank0(ep_addr);
	udd_enable_endpoint(ep_addr);

#if (defined USB_DISABLE_NYET_FOR_OUT_ENDPOINT)
	// OUT߲Ăɑ΂NYET@\֎~BOUT߹ĂpĊeOUT߹Ă͏
	// NYETłB
	if (!(ep & USB_EP_DIR_IN)) {
		udd_disable_nyet(ep_addr);
	}
#endif
	return true;
}

void udd_ep_free(udd_ep_id_t ep)
{
	udd_ep_abort(ep);
#if( defined UDC_RAM_ACCESS_ERROR_EVENT )
	if( Is_udd_ram_access_error(ep & 0x7F) ){
		UDC_RAM_ACCESS_ERROR_EVENT();
	}
#endif
	udd_disable_endpoint(ep & 0x7F);
}

bool udd_ep_is_halted(udd_ep_id_t ep)
{
	return Is_udd_endpoint_stall_requested(ep & USB_EP_ADDR_MASK);
}

bool udd_ep_set_halt(udd_ep_id_t ep)
{
	uint8_t ep_index = ep & USB_EP_ADDR_MASK;

	if (USB_DEVICE_MAX_EP < ep_index) {
		return false;
	}

	// ߲Ē~
	udd_enable_stall_handshake(ep_index);
	udd_ep_abort(ep);
	return true;
}


bool udd_ep_clear_halt(udd_ep_id_t ep)
{
	udd_ep_job_t *ptr_job;

	ep &= USB_EP_ADDR_MASK;
	if (USB_DEVICE_MAX_EP < ep) {
		return false;
	}
	ptr_job = &udd_ep_job[ep - 1];

	if (Is_udd_endpoint_stall_requested(ep)) {
		// ~v폜
		udd_disable_stall_handshake(ep);
		if (Is_udd_stall(ep)) {
			udd_ack_stall(ep);
			// ~Ǎްݐ؂ւؾ
			udd_reset_data_toggle(ep);
		}

		// Ƃ~œo^ꍇAĂі߂s
		if (ptr_job->busy == true) {
			ptr_job->busy = false;
			ptr_job->call_nohalt();
		}
	}
	return true;
}

bool udd_ep_run(udd_ep_id_t ep, bool b_shortpacket,
		uint8_t * buf, iram_size_t buf_size,
		udd_callback_trans_t callback)
{
	udd_ep_id_t ep_num;
	udd_ep_job_t *ptr_job;
	irqflags_t flags;

	ep_num = ep & USB_EP_ADDR_MASK;
	if (USB_DEVICE_MAX_EP < ep_num) {
		return false;
	}
	if ((!Is_udd_endpoint_enabled(ep_num))
			|| Is_udd_endpoint_stall_requested(ep_num)) {
		return false;	// ߲Ă͒~܂B
	}

	// ߲ĂɂĂ̍Ƃ擾
	ptr_job = &udd_ep_job[ep_num - 1];

	flags = cpu_irq_save();
	if (ptr_job->busy == true) {
		cpu_irq_restore(flags);
		return false;	// Ƃɐis
	}
	ptr_job->busy = true;
	cpu_irq_restore(flags);

	// s̍ƂȂAV̂܂B
	ptr_job->buf = buf;
	ptr_job->buf_size = buf_size;
	ptr_job->nb_trans = 0;
	ptr_job->call_trans = callback;
	ptr_job->b_shortpacket = b_shortpacket;
	ptr_job->b_use_out_cache_buffer = false;

	if ( (USB_EP_DIR_IN != (ep & USB_EP_DIR_IN))
	&& (USBC_UECFG0_EPTYPE_ISOCHRONOUS == udd_get_endpoint_type(ep_num))
	&& (0 != (buf_size % udd_get_endpoint_size(ep_num)))) {
		// gp҂͊ɏՕeʊ铙IN߲ėp߲ėeʂ̏]gp
		// ΂Ȃ܂B
		ptr_job->busy = false;
		return false;
	}

	dbg_print("(run%x,%dB) ", ep, buf_size);

	// ]͕킷邽߂ɏl
	udd_udesc_rst_buf0_ctn(ep_num);
	udd_udesc_rst_buf0_size(ep_num);

	// ̓]v
	udd_ep_trans_done(ep);
	return true;
}


void udd_ep_abort(udd_ep_id_t ep)
{
	irqflags_t flags;
	udd_ep_job_t *ptr_job;

	ep &= USB_EP_ADDR_MASK;

	// ߲Ă̊荞݂֎~
	flags = cpu_irq_save();
	udd_disable_endpoint_interrupt(ep);
	cpu_irq_restore(flags);

	// ]~
	udd_enable_busy_bank0(ep);

	// Ɗ̌ɌĂі߂Ăяo
	ptr_job = &udd_ep_job[ep - 1];
	if (!ptr_job->busy) {
		return;
	}
	dbg_print("abort%x ", ep);
	ptr_job->busy = false;
	if (NULL != ptr_job->call_trans) {
		if (Is_udd_endpoint_in(ep)) {
			ep |= USB_EP_DIR_IN;
		}
		// ]\܂͌Ăі߂~
		ptr_job->call_trans(UDD_EP_TRANSFER_ABORT, ptr_job->nb_trans, ep);
	}
}


bool udd_ep_wait_stall_clear(udd_ep_id_t ep,
		udd_callback_halt_cleared_t callback)
{
	udd_ep_job_t *ptr_job;

	ep &= USB_EP_ADDR_MASK;
	if (USB_DEVICE_MAX_EP < ep) {
		return false;
	}

	ptr_job = &udd_ep_job[ep - 1];

	if (!Is_udd_endpoint_enabled(ep)) {
		return false;	// ߲ĂĂȂB
	}

	// Wait clear halt endpoint
	if (ptr_job->busy == true) {
		return false;	// Ƃɐis
	}

	if (Is_udd_endpoint_stall_requested(ep)) {
		// ߲Ă~ꂻ̌ɌĂі߂o^
		ptr_job->busy = true;
		ptr_job->call_nohalt = callback;
	} else {
		// ߲Ă~ꂸ̌ɌĂі߂𒼐ڌĂяo
		callback();
	}
	return true;
}
#endif // (0!=USB_DEVICE_MAX_EP)


#ifdef USB_DEVICE_HS_SUPPORT

void udd_test_mode_j(void)
{
	udd_enable_hs_test_mode();
	udd_enable_hs_test_mode_j();
}


void udd_test_mode_k(void)
{
	udd_enable_hs_test_mode();
	udd_enable_hs_test_mode_k();
}


void udd_test_mode_se0_nak(void)
{
	udd_enable_hs_test_mode();
}


void udd_test_mode_packet(void)
{
	irqflags_t flags;
	const uint8_t test_packet[] = {
		// 00000000 * 9
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		// 01010101 * 8
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
		// 01110111 * 8
		0xEE, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE, 0xEE,
		// 0, {111111S * 15}, 111111
		0xFE, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
				0xFF, 0xFF,
		// S, 111111S, {0111111S * 7}
		0x7F, 0xBF, 0xDF, 0xEF, 0xF7, 0xFB, 0xFD,
		// 00111111, {S0111111 * 9}, S0
		0xFC, 0x7E, 0xBF, 0xDF, 0xEF, 0xF7, 0xFB, 0xFD, 0x7E
	};

	// ߲ĂIN߲ĂɍČ`Ԑݒ
	udd_disable_endpoint(0);
	udd_configure_endpoint(0, USB_EP_TYPE_BULK, USBC_UECFG0_EPDIR_IN,
			64, USBC_UECFG0_EPBK_SINGLE);

	udd_enable_hs_test_mode();
	udd_enable_hs_test_mode_packet();

	// ߲0߹đo
	udd_udesc_set_buf0_addr(0, (uint8_t *) test_packet);
	flags = cpu_irq_save();
	udd_enable_in_send_interrupt(0);
	cpu_irq_restore(flags);

	udd_ack_in_send(0);
}
#endif // USB_DEVICE_HS_SUPPORT



//--------------------------------------------------------
//--- ߲ĂǗ邽߂ٰ̓

static void udd_reset_ep_ctrl(void)
{
	irqflags_t flags;

	// USBڽ0ؾ
	udd_configure_address(0);
	udd_enable_address();

	// ߲Ă蓖ĂČ`Ԑݒ
	udd_configure_endpoint(0,
			USB_EP_TYPE_CONTROL,
			USBC_UECFG0_EPDIR_OUT,
			USB_DEVICE_EP_CTRL_SIZE, USBC_UECFG0_EPBK_SINGLE);

	// ߲ĐɓɏՕgp
	udd_udesc_set_buf0_addr(0, udd_ctrl_buffer);

	// ߲Đŕ߹ĂgpȂłB
	udd_udesc_rst_buf0_size(0);
	udd_enable_endpoint(0);
	udd_disable_busy_bank0(0);
	flags = cpu_irq_save();
	udd_enable_setup_received_interrupt(0);
	udd_enable_out_received_interrupt(0);
	udd_enable_endpoint_interrupt(0);
	cpu_irq_restore(flags);
}

static void udd_ctrl_init(void)
{
	// INްiK̒~̏ꍇ:
	// SETUP߹ĂMꂽʰ޳ɂĎIɍs邽߁AIN]
	// ~̕KvȂ(TXINI)BSETUPMTXINI荞݂𐶐Ȃ
	// Ɋ荞݂֎~Ȃ΂Ȃ܂B
	udd_disable_in_send_interrupt(0);
	// OUT ZLPۂ̏ꍇSETUP۔Oɏ܂B
	udd_ack_out_received(0);

	udd_g_ctrlreq.callback = NULL;
	udd_g_ctrlreq.over_under_run = NULL;
	udd_g_ctrlreq.payload_size = 0;
	udd_ep_control_state = UDD_EPCTRL_SETUP;
}


static void udd_ctrl_setup_received(void)
{
	irqflags_t flags;

	if (UDD_EPCTRL_SETUP != udd_ep_control_state) {
		// BꂽDATA܂ZLPiKA܂͋K񒆎~܂B
		udd_ctrl_endofrequest();

		// ߲ĊǗď
		udd_ctrl_init();
	}
	// SETUPv\̂𖞂B
	if (8 != udd_udesc_get_buf0_ctn(0)) {
		udd_ctrl_stall_data();
		udd_ack_setup_received(0);
		return;	// ُްԍSETUP߹ĂɑΉ܂B
	}
	memcpy((uint8_t *) & udd_g_ctrlreq.req, udd_ctrl_buffer, 8);

	// gpCPUɍ悤LSB/MSBǗ
	udd_g_ctrlreq.req.wValue = le16_to_cpu(udd_g_ctrlreq.req.wValue);
	udd_g_ctrlreq.req.wIndex = le16_to_cpu(udd_g_ctrlreq.req.wIndex);
	udd_g_ctrlreq.req.wLength = le16_to_cpu(udd_g_ctrlreq.req.wLength);

	// SETUPv𕜍
	if (udc_process_setup() == false) {
		// mSETUPv̌ɒ~
		udd_ctrl_stall_data();
		udd_ack_setup_received(0);
		return;
	}
	udd_ack_setup_received(0);

	if (Udd_setup_is_in()) {
		// vꂽINްiK
		udd_ctrl_prev_payload_nb_trans = 0;
		udd_ctrl_payload_nb_trans = 0;
		udd_ep_control_state = UDD_EPCTRL_DATA_IN;
		udd_ctrl_in_sent();	// ŏް]o
	} else {
		if (0 == udd_g_ctrlreq.req.wLength) {
			// vꂽްiKȂASETUPv̉IN ZLPo
			udd_ctrl_send_zlp_in();
			return;
		}

		// vꂽOUTްiK
		udd_ctrl_prev_payload_nb_trans = 0;
		udd_ctrl_payload_nb_trans = 0;
		udd_ep_control_state = UDD_EPCTRL_DATA_OUT;

		// Kُ팟ô߁AްINiKNAK荞݋
		udd_ack_nak_in(0);
		flags = cpu_irq_save();
		udd_enable_nak_in_interrupt(0);
		cpu_irq_restore(flags);
	}
}

static void udd_ctrl_in_sent(void)
{
	static bool b_shortpacket = false;
	uint16_t nb_remain;
	irqflags_t flags;

	flags = cpu_irq_save();
	udd_disable_in_send_interrupt(0);
	cpu_irq_restore(flags);

	if (UDD_EPCTRL_HANDSHAKE_WAIT_IN_ZLP == udd_ep_control_state) {
		// INZLPoǍSETUPvIL
		udd_ctrl_endofrequest();
		// ߲ĊǗď
		udd_ctrl_init();
		return;
	}
	Assert(udd_ep_control_state == UDD_EPCTRL_DATA_IN);

	nb_remain = udd_g_ctrlreq.payload_size - udd_ctrl_payload_nb_trans;
	if (0 == nb_remain) {
		// ݂̊ɏՕ{̂̑SeAO̖{̊ɏՕɂđĂ鑍
		// ްXV
		udd_ctrl_prev_payload_nb_trans += udd_ctrl_payload_nb_trans;
		if ((udd_g_ctrlreq.req.wLength == udd_ctrl_prev_payload_nb_trans)
				|| b_shortpacket) {
			// vꂽSް]܂͒Z߹đoǍްiKIB
			// ޼ipOUT ZLP𐶐
			udd_ctrl_send_zlp_out();
			return;
		}
		// ްiKĂȂ߁AVɏՕKv
		if ((!udd_g_ctrlreq.over_under_run)
				|| (!udd_g_ctrlreq.over_under_run())) {
			// ް݁ǍINZLPoBłnb_remain=0IN ZLPo
			// ܂B
		} else {
			// V{̊ɏՕ^B
			udd_ctrl_payload_nb_trans = 0;
			nb_remain = udd_g_ctrlreq.payload_size;
		}
	}
	// ]pĎް𑗏o
	if (nb_remain >= USB_DEVICE_EP_CTRL_SIZE) {
		nb_remain = USB_DEVICE_EP_CTRL_SIZE;
		b_shortpacket = false;
	} else {
		b_shortpacket = true;
	}
	//** dvȗ̈
	// łUSBؾĐMȂްINiK~̏ꍇ̂݁B
	// INްʹ߲0 DPRAMŎSETUPMɓ߲0 DPRAMŏ
	// ͂Ȃ܂BɂAOUT ZLPMINްݑOɒׂȂ΂
	// 炸AOUT ZLPSMȂꍇAǂZLP OUTSETUP̎MOް
	// ͑f(800s)Ȃ΂Ȃ܂B
	flags = cpu_irq_save();
	if (Is_udd_out_received(0)) {
		// OUT ZLPɂĒ~ꂽINްiK
		cpu_irq_restore(flags);
		udd_ep_control_state = UDD_EPCTRL_HANDSHAKE_WAIT_OUT_ZLP;
		return;	// INްiKo
	}
	// fINް
	memcpy(udd_ctrl_buffer,
			udd_g_ctrlreq.payload + udd_ctrl_payload_nb_trans,
			nb_remain);
	udd_ctrl_payload_nb_trans += nb_remain;
	udd_udesc_set_buf0_ctn(0, nb_remain);

	// ؂Đ߲ĊɏՕŗp\ް𑗏o
	udd_ack_in_send(0);
	udd_enable_in_send_interrupt(0);

	// INްiK̒~ꍇAOUT߲ĂɎROUT ZLP󂯓邽
	// ߁AOUT NAK荞݂Kv͂܂B
	cpu_irq_restore(flags);
}

static void udd_ctrl_out_received(void)
{
	irqflags_t flags;
	uint16_t nb_data;

	if (UDD_EPCTRL_DATA_OUT != udd_ep_control_state) {
		if ((UDD_EPCTRL_DATA_IN == udd_ep_control_state) ||
				(UDD_EPCTRL_HANDSHAKE_WAIT_OUT_ZLP == udd_ep_control_state)) {
			// SETUPvI:
			// - ~ꂽްINiKA܂
			// - fZLP OUTɂĉBꂽŌްINiKA܂
			// - ʂɎMZLP OUT
			udd_ctrl_endofrequest();
		} else {
			// SETUPv̋Kُ
			udd_ctrl_stall_data();
		}
		// ߲ĊǗď
		udd_ctrl_init();
		return;
	}
	// OUTiKɎMްǂݍ
	nb_data = udd_udesc_get_buf0_ctn(0);
	if (udd_g_ctrlreq.payload_size < (udd_ctrl_payload_nb_trans + nb_data)) {
		// {̊ɏՕB
		nb_data = udd_g_ctrlreq.payload_size -
				udd_ctrl_payload_nb_trans;
	}

	memcpy((uint8_t *) (udd_g_ctrlreq.payload + udd_ctrl_payload_nb_trans),
			udd_ctrl_buffer, nb_data);
	udd_ctrl_payload_nb_trans += nb_data;

	if ((USB_DEVICE_EP_CTRL_SIZE != nb_data) ||
			(udd_g_ctrlreq.req.wLength <=
			(udd_ctrl_prev_payload_nb_trans + udd_ctrl_payload_nb_trans)))
	{
		// Z߹Ă̂ߎMIB~𐶐ްM̏ꍇAZLPoOɒ
		// Ăі߂ĂяoB
		udd_g_ctrlreq.payload_size = udd_ctrl_payload_nb_trans;
		if (NULL != udd_g_ctrlreq.over_under_run) {
			if (!udd_g_ctrlreq.over_under_run()) {
				// ZLP~
				udd_ctrl_stall_data();

				// ~(STALL)ɂNAKu邽߂OUTACKM
				udd_ack_out_received(0);
				return;
			}
		}
		// SETUPvACK̂߂IN ZLP𑗏o
		udd_ack_out_received(0);
		udd_ctrl_send_zlp_in();
		return;
	}

	if (udd_g_ctrlreq.payload_size == udd_ctrl_payload_nb_trans) {
		// ް݁ǍɐV{̊ɏՕvB
		if (!udd_g_ctrlreq.over_under_run) {
			// V{̊ɏՕv邽߂ɗp\ȌĂі߂Ȃ
			udd_ctrl_stall_data();

			// ~(STALL)ɂNAKu邽߂OUTACKM
			udd_ack_out_received(0);
			return;
		}
		if (!udd_g_ctrlreq.over_under_run()) {
			// zꂽV{̊ɏՕȂ
			udd_ctrl_stall_data();

			// ~(STALL)ɂNAKu邽߂OUTACKM
			udd_ack_out_received(0);
			return;
		}
		// V{̊ɏՕp\BMްXV
		udd_ctrl_prev_payload_nb_trans += udd_ctrl_payload_nb_trans;

		// {̊ɏՕł̎Mď
		udd_ctrl_payload_nb_trans = 0;
	}
	// ̎MF邽߂ɐ߲Ă̊ɏՕ󂯂B
	udd_ack_out_received(0);

	// Kُo邽߁AްINiKłNAK荞݂
	udd_ack_nak_in(0);
	flags = cpu_irq_save();
	udd_enable_nak_in_interrupt(0);
	cpu_irq_restore(flags);
}

static void udd_ctrl_underflow(void)
{
	if (Is_udd_out_received(0))
		return;	// OUTްMꂽꍇɉꖳ

	if (UDD_EPCTRL_DATA_OUT == udd_ep_control_state) {
		// νĂOUTPʏ~]݁ǍOUTްiK҂߂ɒ~AIN
		//  ZLP޼B
		udd_ctrl_send_zlp_in();

	} else if (UDD_EPCTRL_HANDSHAKE_WAIT_OUT_ZLP == udd_ep_control_state) {
		// OUT޼uɂđ҂܂AνĂ͗]INް]݁Ǎ
		// ɗ]INް~
		udd_enable_stall_handshake(0);
	}
}

static void udd_ctrl_overflow(void)
{
	if (Is_udd_in_send(0)) {
		return;	// INްMꂽꍇɏꖳ
	}

	// OUT߲ĂɋOUT ZLP󂯓邽߁AUDD_EPCTRL_DATA_IN
	// ǗȂꍇB

	if (UDD_EPCTRL_HANDSHAKE_WAIT_IN_ZLP == udd_ep_control_state) {
		// IN޼uɂđ҂܂AνĂ͗]OUTް]݁Ǎ
		// ɗ]OUTް~
		udd_enable_stall_handshake(0);
	}
}

static void udd_ctrl_stall_data(void)
{
	// INOUT߲̐ĂőS߹Ē~(STALL)
	udd_ep_control_state = UDD_EPCTRL_STALL_REQ;
	udd_enable_stall_handshake(0);
}

static void udd_ctrl_send_zlp_in(void)
{
	irqflags_t flags;

	udd_ep_control_state = UDD_EPCTRL_HANDSHAKE_WAIT_IN_ZLP;

	// ؂Đ߲ĂŋIN߹Ă𑗏o
	udd_udesc_rst_buf0_ctn(0);

	flags = cpu_irq_save();

	// IN߲ĂZLPo
	udd_ack_in_send(0);
	udd_enable_in_send_interrupt(0);

	// Kُo邽߁AްOUTiKNAK荞݂
	udd_ack_nak_out(0);
	udd_enable_nak_out_interrupt(0);
	cpu_irq_restore(flags);
}

static void udd_ctrl_send_zlp_out(void)
{
	irqflags_t flags;

	udd_ep_control_state = UDD_EPCTRL_HANDSHAKE_WAIT_OUT_ZLP;

	// Kُo邽߁AްINiKNAK荞݂
	flags = cpu_irq_save();
	udd_ack_nak_in(0);
	udd_enable_nak_in_interrupt(0);
	cpu_irq_restore(flags);
}

static void udd_ctrl_endofrequest(void)
{
	// Ăі߂o^Ă΂ĂԁB
	if (udd_g_ctrlreq.callback) {
		udd_g_ctrlreq.callback();
	}
}

static bool udd_ctrl_interrupt(void)
{

	if (!Is_udd_endpoint_interrupt(0)) {
		return false;	// ߲ĂŊ荞ݎۂȂ
	}

	dbg_print("0: ");

	// ɂďƉ̊荞݂֎~
	udd_disable_nak_in_interrupt(0);
	udd_disable_nak_out_interrupt(0);

	// ߲Ăł̎ۂ
	if (Is_udd_setup_received(0)) {
		dbg_print("stup ");
		// MSETUP߹
		udd_ctrl_setup_received();
		return true;
	}
	if (Is_udd_out_received(0)) {
		dbg_print("out ");
		// MOUT߹
		udd_ctrl_out_received();
		return true;
	}
	if (Is_udd_in_send(0) && Is_udd_in_send_interrupt_enabled(0)) {
		dbg_print("in ");
		// IN߹
		udd_ctrl_in_sent();
		return true;
	}
	if (Is_udd_nak_out(0)) {
		dbg_print("nako ");
		// OUT߹Ăł̏
		udd_ack_nak_out(0);
		udd_ctrl_overflow();
		return true;
	}
	if (Is_udd_nak_in(0)) {
		dbg_print("naki ");
		// IN߹Ăł̉
		udd_ack_nak_in(0);
		udd_ctrl_underflow();
		return true;
	}
	return false;
}


//-----------------------------------------------------------------------
//--- (ٸ)/荞/(ɽ)߲ĂǗ邽߂ٰ̓

#if (0!=USB_DEVICE_MAX_EP)

static void udd_ep_trans_done(udd_ep_id_t ep)
{
	udd_ep_job_t *ptr_job;
	uint16_t ep_size, nb_trans;
	uint16_t next_trans;
	udd_ep_id_t ep_num;
	irqflags_t flags;

	ep_num = ep & USB_EP_ADDR_MASK;
	ep_size = udd_get_endpoint_size(ep_num);

	// ߲ĂɑΉƂ擾
	ptr_job = &udd_ep_job[ep_num - 1];

	// ߲Ă̊荞݂֎~
	flags = cpu_irq_save();
	udd_disable_endpoint_interrupt(ep_num);
	cpu_irq_restore(flags);

	if (!ptr_job->busy) {
		return;	// sƂȂA(шُ)𖳎
	}

	if (USB_EP_DIR_IN == (ep & USB_EP_DIR_IN)) {
		// INł̓]
		nb_trans = udd_udesc_get_buf0_size(ep_num);

		// VIN߹Ă̕o{
		udd_enable_busy_bank0(ep_num);

		// ACK荞
		udd_ack_in_send(ep_num);

		if (0 == nb_trans) {
			if (0 == udd_nb_busy_bank(ep_num)) {
				// S޲Ă]Ǎɗvꂽnb޲ĂB
				nb_trans = udd_udesc_get_buf0_ctn(ep_num);
			}
		}
		// ]ꂽްXV
		dbg_print("i%d ", nb_trans);
		ptr_job->nb_trans += nb_trans;

		// ްoKv
		if ((ptr_job->nb_trans != ptr_job->buf_size)
				|| ptr_job->b_shortpacket) {
			next_trans = ptr_job->buf_size - ptr_job->nb_trans;
			if (UDD_ENDPOINT_MAX_TRANS < next_trans) {
				// USBʰ޳UDD_ENDPOINT_MAX_TRANS޲Ă̍ő]ʂx
				next_trans = UDD_ENDPOINT_MAX_TRANS -
						(UDD_ENDPOINT_MAX_TRANS % ep_size);
				udd_udesc_set_buf0_autozlp(ep_num, false);
			} else {
				// včŏI߹ĂZ߹ĂłȂꍇAZLPKv
				udd_udesc_set_buf0_autozlp(ep_num, ptr_job->b_shortpacket);
				ptr_job->b_shortpacket = false;	// ʂZLPvKvȂ
			}

			udd_udesc_set_buf0_ctn(ep_num, next_trans);
			udd_udesc_rst_buf0_size(ep_num);

			// USBʰ޳DMAŒڎgpҊɏՕqB
			udd_udesc_set_buf0_addr(ep_num,
					&ptr_job->buf[ptr_job->nb_trans]);

			// ]Jn
			udd_ack_fifocon(ep_num);
			udd_disable_busy_bank0(ep_num);

			// 荞݋
			flags = cpu_irq_save();
			udd_enable_in_send_interrupt(ep_num);
			udd_enable_endpoint_interrupt(ep_num);
			cpu_irq_restore(flags);
			return;
		}
	} else {
		// OUTœ]
		nb_trans = udd_udesc_get_buf0_ctn(ep_num);

		// VOUT߹Ă̎M{
		udd_enable_busy_bank0(ep_num);

		// ACK荞
		udd_ack_out_received(ep_num);
		udd_ack_fifocon(ep_num);

		dbg_print("o%d ", nb_trans);

		// ɏՕgpҊɏՕ֎Mް𕡎ʂKv邩
		// B
		if (ptr_job->b_use_out_cache_buffer) {
			memcpy(&ptr_job->buf[ptr_job->nb_trans],
					udd_ep_out_cache_buffer[ep_num - 1],
					ptr_job->buf_size % ep_size);
		}

		// ]ްXV
		ptr_job->nb_trans += nb_trans;
		if (ptr_job->nb_trans > ptr_job->buf_size) {
			ptr_job->nb_trans = ptr_job->buf_size;
		}

		// vꂽȎSްMĎgpҊɏՕtłȂ΁Aް
		// MKv܂B
		if ((nb_trans == udd_udesc_get_buf0_size(ep_num))
			&& (ptr_job->nb_trans != ptr_job->buf_size)) {
			next_trans = ptr_job->buf_size - ptr_job->nb_trans;
			if (UDD_ENDPOINT_MAX_TRANS < next_trans) {
				// USBʰ޳UDD_ENDPOINT_MAX_TRANS޲Ă̍ő]ʂx
				// B
				next_trans = UDD_ENDPOINT_MAX_TRANS
						- (UDD_ENDPOINT_MAX_TRANS % ep_size);
			} else {
				next_trans -= next_trans % ep_size;
			}

			udd_udesc_rst_buf0_ctn(ep_num);
			if (next_trans < ep_size) {
				// ʂ܂͊荞̴݂߲ĂɷɏՕgp
				ptr_job->b_use_out_cache_buffer = true;
				udd_udesc_set_buf0_addr(ep_num,
						udd_ep_out_cache_buffer[ep_num-1]);
				udd_udesc_set_buf0_size(ep_num, ep_size);
			} else {
				// USBʰ޳DMAŒڎgpҊɏՕqB
				udd_udesc_set_buf0_addr(ep_num, &ptr_job->buf[ptr_job->nb_trans]);
				udd_udesc_set_buf0_size(ep_num, next_trans);
			}
			// ]Jn
			udd_disable_busy_bank0(ep_num);

			// 荞݋
			flags = cpu_irq_save();
			udd_enable_out_received_interrupt(ep_num);
			udd_enable_endpoint_interrupt(ep_num);
			cpu_irq_restore(flags);
			return;
		}
	}

	// ƊǍɌĂі߂ĂԁB
	dbg_print("done%x ", ep);
	ptr_job->busy = false;
	if (NULL != ptr_job->call_trans) {
		ptr_job->call_trans(UDD_EP_TRANSFER_OK, ptr_job->nb_trans, ep);
	}
	return;
}

static bool udd_ep_interrupt(void)
{
	udd_ep_id_t ep, ep_addr;

	// ߲(0)ƈقȂe߲Ăɑ΂
	for (ep = 1; ep <= USB_DEVICE_MAX_EP; ep++) {
		if (!Is_udd_endpoint_interrupt_enabled(ep)
				|| !Is_udd_endpoint_interrupt(ep)) {
			continue;
		}
		ep_addr = Is_udd_endpoint_in(ep) ? (ep | USB_EP_DIR_IN) : ep;
		dbg_print("%x: ", ep_addr);
		udd_ep_trans_done(ep_addr);
		return true;
	}
	return false;
}
#endif // (0!=USB_DEVICE_MAX_EP)

//@}
//@}
