/**
 * \file
 *
 * \brief SAM4Lpޯ (WDT)ײ
 *
 * 쌠 (c) 2012-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef WDT_SAM4L_H_INCLUDED
#define WDT_SAM4L_H_INCLUDED

#include "compiler.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \defgroup group_sam_drivers_wdt_sam4l WDT_SAM4L - SAM4Lޯ 
 *
 * WDT(ޯ )pײށBײނWDT̎ȋ@\ւ̱񋟂
 * ܂Bޯ ςͿĳsl܂ŎɂȂꍇɼт̌Œh
 * ̂Ɏgp邱Ƃł܂B͑SؾĂ܂۾ ؾĂ𐶐邱
 * Ƃł܂B
 *
 * \ref sam_wdt_sam4l_quickstart B
 *
 * @{
 */

/**
 * \brief ޯ ϊԌ`Ԑݒ
 *
 * ޯ  ۯݐƂĊԂvlɑ΂Aޯ ϒPʕ
 * ̐ݒ\Ȋԗp
 *
 * Ttimeoutp = 2pow(PSEL+1) / Fclk_cnt
 * Ttimebanp = 2pow(TBAN+1) / Fclk_cnt
 */
enum wdt_period {
	WDT_PERIOD_NONE				=  0,
	WDT_PERIOD_MIN_CLK			=  7,
	WDT_PERIOD_256_CLK			=  7,	/* PSEL = TBAN =  7 */
	WDT_PERIOD_512_CLK			=  8,	/* PSEL = TBAN =  8 */
	WDT_PERIOD_1024_CLK			=  9,	/* PSEL = TBAN =  9 */
	WDT_PERIOD_2048_CLK			= 10,	/* PSEL = TBAN = 10 */
	WDT_PERIOD_4096_CLK			= 11,	/* PSEL = TBAN = 11 */
	WDT_PERIOD_8192_CLK			= 12,	/* PSEL = TBAN = 12 */
	WDT_PERIOD_16384_CLK		= 13,	/* PSEL = TBAN = 13 */
	WDT_PERIOD_32768_CLK		= 14,	/* PSEL = TBAN = 14 */
	WDT_PERIOD_65536_CLK		= 15,	/* PSEL = TBAN = 15 */
	WDT_PERIOD_131072_CLK		= 16,	/* PSEL = TBAN = 16 */
	WDT_PERIOD_262144_CLK		= 17,	/* PSEL = TBAN = 17 */
	WDT_PERIOD_524288_CLK		= 18,	/* PSEL = TBAN = 18 */
	WDT_PERIOD_1048576_CLK		= 19,	/* PSEL = TBAN = 19 */
	WDT_PERIOD_2097152_CLK		= 20,	/* PSEL = TBAN = 20 */
	WDT_PERIOD_4194304_CLK		= 21,	/* PSEL = TBAN = 21 */
	WDT_PERIOD_8388608_CLK		= 22,	/* PSEL = TBAN = 22 */
	WDT_PERIOD_16777216_CLK		= 23,	/* PSEL = TBAN = 23 */
	WDT_PERIOD_33554432_CLK		= 24,	/* PSEL = TBAN = 24 */
	WDT_PERIOD_67108864_CLK		= 25,	/* PSEL = TBAN = 25 */
	WDT_PERIOD_134217728_CLK	= 26,	/* PSEL = TBAN = 26 */
	WDT_PERIOD_268435456_CLK	= 27,	/* PSEL = TBAN = 27 */
	WDT_PERIOD_536870912_CLK	= 28,	/* PSEL = TBAN = 28 */
	WDT_PERIOD_1073741824_CLK	= 29,	/* PSEL = TBAN = 29 */
	WDT_PERIOD_2147483648_CLK	= 30,	/* PSEL = TBAN = 30 */
	WDT_PERIOD_4294967296_CLK	= 31,	/* PSEL = TBAN = 31 */
	WDT_PERIOD_MAX_CLK			= 31,
};

/**
 * \brief ޯ ό`Ԑݒ\
 *
 * ޯ ώ̗p`Ԑݒ\́B̍\͎̂gp҉pɂĕύX
 * O\ref wdt_get_config_defaults() ֐ɂď邱Ƃł܂B
 */
struct wdt_config {
	/** ۯI */
	uint32_t clk_src;
/** ۯƂļRC(RCSYS)UI */
#define WDT_CLK_SRC_RCSYS	0
/** ۯƂ32kHzUI */
#define WDT_CLK_SRC_32K		WDT_CTRL_CSSEL

	/** WDT` */
	uint32_t wdt_mode;
/** { */
#define WDT_MODE_BASIC		0
/**  */
#define WDT_MODE_WINDOW		WDT_CTRL_MODE

	/** WDT܂łCLK_CNT */
	enum wdt_period timeout_period;
	/** ؾđJ܂łCLK_CNT */
	enum wdt_period window_period;
	/** ޯ ؾČׯZ蒼֎~ */
	bool disable_flash_cali;
	/** ޯ ؾČ㳫ޯދ֎~ */
	bool disable_wdt_after_reset;

	/**
	 * ݒȂAޯނČ݂̌`ԐݒɎ{(SFVޯĐݒ)
	 *
	 * \note ؾĂSFVޯĂ܂B
	 */
	bool always_on;
};

/**
 * \brief ޯ  ײ ĳ̍\
 *
 * ޯ  ײގ̗p޲̍\́B́A\̂޲̓ʰ
 * ̂ƘAg\ref wdt_init() ֐ɂďׂłB
 */
struct wdt_dev_inst {
	/** WDTPʕ̊ڽ */
	Wdt *hw_dev;
	/** WDT`Ԑݒ\̂ւ̈ʒuwq */
	struct wdt_config  *wdt_cfg;
};

void wdt_get_config_defaults(struct wdt_config *const cfg);

bool wdt_init(
		struct wdt_dev_inst *const dev_inst,
		Wdt *const wdt,
		struct wdt_config *const cfg);

void wdt_enable(struct wdt_dev_inst *const dev_inst);

void wdt_disable(struct wdt_dev_inst *const dev_inst);

void wdt_clear(struct wdt_dev_inst *const dev_inst);

/**
 * \brief ޯ ϏԂ擾
 *
 * \return ޯ ϏԂޯĎՕ
 */
static inline uint32_t wdt_get_status(struct wdt_dev_inst *const dev_inst)
{
	Wdt *wdt = dev_inst->hw_dev;

	return wdt->WDT_SR;
}

bool wdt_reset_mcu(void);

/**
 * @}
 */

#ifdef __cplusplus
}
#endif

/**
 * \page sam_wdt_sam4l_quickstart SAM4Lޯ ϗpJn̎
 *
 * ͎gpʂ̑Iײނ`Ԑݒ肵Ďgp@̒iKIȎxł
 * \ref group_sam_drivers_wdt_sam4l "SAM4Lޯ ײ"pJn̎
 * B
 *
 * gpʂ͏̺ޒfЂ܂݂܂B\ݒiK̺ޒfЂ͓Ǝ֐
 * ʂ邱ƂłAgiK͗Ⴆ΁A剞p֐ɕʂ邱Ƃł
 * B
 *
 * \section wdt_sam4l_use_cases gp
 * - \ref wdt_sam4l_basic_use_case
 * - \ref wdt_sam4l_reset_mcu
 *
 * \section wdt_sam4l_basic_use_case {IȎgp
 * ̊{IȎgpʂŁAޯނ͋ۯƂRCSYSgpAԊ
 * Ԃ0.57bƂČ`Ԑݒ肳܂B̌ɳޯނ100msɋN܂B
 *
 * \subsection sam_wdt_sam4l_quickstart_prereq OKv
 * - \ref sysclk_group
 *
 * \section wdt_sam4l_basic_use_case_setup \ݒiK
 * \note ޯ ۯ(CLK_WDT)ؾĂŋA苟ͼRC(RCSYS)U
 * łBޯ ۯƂ32kHzU]ޏꍇAɋ邱Ƃ
 * mɂĂB:
 * \code
 * // KvȂWDTۯ
 * if (BPM->BPM_PMCON & BPM_PMCON_CK32S) {
 *     // 32K RCU
 *     if (!osc_is_ready(OSC_ID_RC32K)) {
 *         osc_enable(OSC_ID_RC32K);
 *         osc_wait_ready(OSC_ID_RC32K);
 *     }
 * } else {
 *     // OOSC32U
 *     if (!osc_is_ready(OSC_ID_OSC32)) {
 *         osc_enable(OSC_ID_OSC32);
 *         osc_wait_ready(OSC_ID_OSC32);
 *     }
 * }
 * \endcode
 *
 * \subsection wdt_sam4l_basic_use_case_setup_code \ݒ躰ޗ
 * ޯނ\ݒ肷邽߂ɉpÇقɈȉ̺ނǉ܂B:
 * \code
 *    // WDT
 *    struct wdt_dev_inst g_wdt_inst;
 *
 *    // WDT`Ԑݒ
 *    struct wdt_config   g_wdt_cfg;
 *
 *    // ޯނƋ
 *    wdt_get_config_defaults(&g_wdt_cfg);
 *    g_wdt_cfg.timeout_period = WDT_PERIOD_65536_CLK;
 *    wdt_init(&g_wdt_inst, WDT, &g_wdt_cfg);
 * \endcode
 *
 * \subsection wdt_sam4l_basic_use_case_setup_workflow \ݒƂ̗
 * -# ޯނ̎̂ƌ`Ԑݒi[ϐ쐬:
 *   \code
 *     struct wdt_dev_inst g_wdt_inst;
 *     struct wdt_config   g_wdt_cfg;
 *   \endcode
 * -# `Ԑݒ擾AԊԂ0.57sɕύX
 *    (Ttimeout = 2pow(PSEL+1) / Fclk_cnt = 65535 / 115000).
 *  \code
 *    wdt_get_config_defaults(&g_wdt_cfg);
 *    g_wdt_cfg.timeout_period = WDT_PERIOD_65536_CLK;
 *  \endcode
 * -# ޯޏ
 *  \code
 *    wdt_init(&g_wdt_inst, WDT, &g_wdt_cfg);
 *  \endcode
 *
 * \section wdt_sam4l_basic_use_case_usage giK
 * \subsection wdt_sam4l_basic_use_example_code gޗ
 * Ⴆ΁ApÇقmainJԂɒǉ܂B:
 * \code
 *   wdt_enable(&g_wdt_inst);
 *
 *   while (1) {
 *        wdt_clear(&g_wdt_inst);
 *        // 100msx
 *   }
 * \endcode
 *
 * \subsection wdt_sam4l_basic_use_workflow gƂ̗
 * -# ޯދ
 *  \code wdt_enable(&g_wdt_inst); \endcode
 * -# 100msɳޯނNB:
 *  \code
 *   while (1) {
 *        wdt_clear(&g_wdt_inst);
 *        // 100msx
 *   }
 *  \endcode
 * -# w۸т쐬܂BMCUwdt_clear()̺ތɒǉ邱Ƃ
 *    łǍAͳޯނ̊ĎłB0.57sƎ
 *    ꍇAޯސԊԂ͂ɂĒׂłB
 *
 * \section wdt_sam4l_reset_mcu WDTɂMCUؾ
 * \Ȍ蒼WDTؾĂ𐶐邱ƂɂMCUؾĂ邱Ƃł܂B
 * \code
 * bool ret;
 *
 * ret = wdt_reset_mcu();
 * \endcode
 */

#endif /* WDT_SAM4L_H_INCLUDED */
