/**
 * \file
 *
 * \brief AESAp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_AESA_COMPONENT_
#define _SAM4L_AESA_COMPONENT_

/* ========================================================================== */
/** AESApĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_AESA VÍKi */
/*@{*/

#define REV_AESA						0x102

/* -------- AESA_CTRL : (AESAψ:0x00) (R/W 32)ڼ޽ -------- */
#define AESA_CTRL_OFFSET				0x00			/**< \brief (AESA_CTRLψ)ڼ޽ */
#define AESA_CTRL_RESETVALUE			0x00000000		/**< \brief (AESA_CTRL reset_value)ڼ޽ */

#define AESA_CTRL_ENABLE_Pos			0				/**< \brief (AESA_CTRL)Pʕ */
#define AESA_CTRL_ENABLE				(0x1u << AESA_CTRL_ENABLE_Pos)
#define AESA_CTRL_DKEYGEN_Pos			1				/**< \brief (AESA_CTRL) */
#define AESA_CTRL_DKEYGEN				(0x1u << AESA_CTRL_DKEYGEN_Pos)
#define AESA_CTRL_NEWMSG_Pos			2				/**< \brief (AESA_CTRL)Vү */
#define AESA_CTRL_NEWMSG				(0x1u << AESA_CTRL_NEWMSG_Pos)
#define AESA_CTRL_SWRST_Pos				8				/**< \brief (AESA_CTRL)ĳ ؾ */
#define AESA_CTRL_SWRST					(0x1u << AESA_CTRL_SWRST_Pos)
#define AESA_CTRL_MASK					0x00000107u		/**< \brief (AESA_CTRL)MASKڼ޽ */

/* -------- AESA_MODE : (AESAψ:0x04) (R/W 32)`ڼ޽ -------- */
#define AESA_MODE_OFFSET				0x04			/**< \brief (AESA_MODEψ)`ڼ޽ */
#define AESA_MODE_RESETVALUE			0x000F0000		/**< \brief (AESA_MODE reset_value)`ڼ޽ */

#define AESA_MODE_ENCRYPT_Pos			0				/**< \brief (AESA_MODE)Í */
#define AESA_MODE_ENCRYPT				(0x1u << AESA_MODE_ENCRYPT_Pos)
#define AESA_MODE_KEYSIZE_Pos			1				/**< \brief (AESA_MODE)̑傫 */
#define AESA_MODE_KEYSIZE_Msk			(0x3u << AESA_MODE_KEYSIZE_Pos)
#define AESA_MODE_KEYSIZE(value)		((AESA_MODE_KEYSIZE_Msk & ((value) << AESA_MODE_KEYSIZE_Pos)))
#define AESA_MODE_DMA_Pos				3				/**< \brief (AESA_MODE)DMA */
#define AESA_MODE_DMA					(0x1u << AESA_MODE_DMA_Pos)
#define AESA_MODE_OPMODE_Pos			4				/**< \brief (AESA_MODE)閧` */
#define AESA_MODE_OPMODE_Msk			(0x7u << AESA_MODE_OPMODE_Pos)
#define AESA_MODE_OPMODE(value)			((AESA_MODE_OPMODE_Msk & ((value) << AESA_MODE_OPMODE_Pos)))
#define AESA_MODE_CFBS_Pos				8				/**< \brief (AESA_MODE)ÍAް Ă̑傫 */
#define AESA_MODE_CFBS_Msk				(0x7u << AESA_MODE_CFBS_Pos)
#define AESA_MODE_CFBS(value)			((AESA_MODE_CFBS_Msk & ((value) << AESA_MODE_CFBS_Pos)))
#define AESA_MODE_CTYPE_Pos				16				/**< \brief (AESA_MODE)v푪` */
#define AESA_MODE_CTYPE_Msk				(0xFu << AESA_MODE_CTYPE_Pos)
#define AESA_MODE_CTYPE(value)			((AESA_MODE_CTYPE_Msk & ((value) << AESA_MODE_CTYPE_Pos)))
#define AESA_MODE_MASK					0x000F077Fu		/**< \brief (AESA_MODE)MASKڼ޽ */

/* -------- AESA_DATABUFPTR : (AESAψ:0x08) (R/W 32)ްɏՕʒuwqڼ޽ -------- */
#define AESA_DATABUFPTR_OFFSET			0x08			/**< \brief (AESA_DATABUFPTRψ)ްɏՕʒuwqڼ޽ */
#define AESA_DATABUFPTR_RESETVALUE		0x00000000		/**< \brief (AESA_DATABUFPTR reset_value)ްɏՕʒuwqڼ޽ */

#define AESA_DATABUFPTR_IDATAW_Pos		0				/**< \brief (AESA_DATABUFPTR)ް */
#define AESA_DATABUFPTR_IDATAW_Msk		(0x3u << AESA_DATABUFPTR_IDATAW_Pos)
#define AESA_DATABUFPTR_IDATAW(value)	((AESA_DATABUFPTR_IDATAW_Msk & ((value) << AESA_DATABUFPTR_IDATAW_Pos)))
#define AESA_DATABUFPTR_ODATAW_Pos		4				/**< \brief (AESA_DATABUFPTR)oް */
#define AESA_DATABUFPTR_ODATAW_Msk		(0x3u << AESA_DATABUFPTR_ODATAW_Pos)
#define AESA_DATABUFPTR_ODATAW(value)	((AESA_DATABUFPTR_ODATAW_Msk & ((value) << AESA_DATABUFPTR_ODATAW_Pos)))
#define AESA_DATABUFPTR_MASK			0x00000033u		/**< \brief (AESA_DATABUFPTR)MASKڼ޽ */

/* -------- AESA_SR : (AESAψ:0x0C) (R/  32)ڼ޽ -------- */
#define AESA_SR_OFFSET					0x0C			/**< \brief (AESA_SRψ)ڼ޽ */
#define AESA_SR_RESETVALUE				0x00010000		/**< \brief (AESA_SR reset_value)ڼ޽ */

#define AESA_SR_ODATARDY_Pos			0				/**< \brief (AESA_SR)oް */
#define AESA_SR_ODATARDY				(0x1u << AESA_SR_ODATARDY_Pos)
#define AESA_SR_IBUFRDY_Pos				16				/**< \brief (AESA_SR)͊ɏՕ */
#define AESA_SR_IBUFRDY					(0x1u << AESA_SR_IBUFRDY_Pos)
#define AESA_SR_MASK					0x00010001u		/**< \brief (AESA_SR)MASKڼ޽ */

/* -------- AESA_IER : (AESAψ:0x10) ( /W 32)荞݋ڼ޽ -------- */
#define AESA_IER_OFFSET 				0x10			/**< \brief (AESA_IERψ)荞݋ڼ޽ */
#define AESA_IER_RESETVALUE				0x00000000		/**< \brief (AESA_IER reset_value)荞݋ڼ޽ */

#define AESA_IER_ODATARDY_Pos			0				/**< \brief (AESA_IER)o͂Ł[O荞݋ */
#define AESA_IER_ODATARDY				(0x1u << AESA_IER_ODATARDY_Pos)
#define AESA_IER_IBUFRDY_Pos			16				/**< \brief (AESA_IER)͊ɏՕ荞݋ */
#define AESA_IER_IBUFRDY				(0x1u << AESA_IER_IBUFRDY_Pos)
#define AESA_IER_MASK					0x00010001u		/**< \brief (AESA_IER)MASKڼ޽ */

/* -------- AESA_IDR : (AESAψ:0x14) ( /W 32)荞݋֎~ڼ޽ -------- */
#define AESA_IDR_OFFSET 				0x14			/**< \brief (AESA_IDRψ)荞݋֎~ڼ޽ */
#define AESA_IDR_RESETVALUE				0x00000000		/**< \brief (AESA_IDR reset_value)荞݋֎~ڼ޽ */

#define AESA_IDR_ODATARDY_Pos			0				/**< \brief (AESA_IDR)oް荞݋֎~ */
#define AESA_IDR_ODATARDY				(0x1u << AESA_IDR_ODATARDY_Pos)
#define AESA_IDR_IBUFRDY_Pos			16				/**< \brief (AESA_IDR)͊ɏՕ荞݋֎~ */
#define AESA_IDR_IBUFRDY				(0x1u << AESA_IDR_IBUFRDY_Pos)
#define AESA_IDR_MASK					0x00010001u		/**< \brief (AESA_IDR)MASKڼ޽ */

/* -------- AESA_IMR : (AESAψ:0x18) (R/  32)荞ݎՕڼ޽ -------- */
#define AESA_IMR_OFFSET					0x18			/**< \brief (AESA_IMRψ)荞ݎՕڼ޽ */
#define AESA_IMR_RESETVALUE				0x00000000		/**< \brief (AESA_IMR reset_value)荞ݎՕڼ޽ */

#define AESA_IMR_ODATARDY_Pos			0				/**< \brief (AESA_IMR)oް荞ݎՕ */
#define AESA_IMR_ODATARDY				(0x1u << AESA_IMR_ODATARDY_Pos)
#define AESA_IMR_IBUFRDY_Pos			16				/**< \brief (AESA_IMR)͊ɏՕ荞ݎՕ */
#define AESA_IMR_IBUFRDY				(0x1u << AESA_IMR_IBUFRDY_Pos)
#define AESA_IMR_MASK					0x00010001u		/**< \brief (AESA_IMR)MASKڼ޽ */

/* -------- AESA_KEY : (AESAψ:0x20) ( /W 32) KEY ڼ޽ -------- */
#define AESA_KEY_OFFSET					0x20			/**< \brief (AESA_KEYψ)ڼ޽ */
#define AESA_KEY_RESETVALUE				0x00000000		/**< \brief (AESA_KEY reset_value)ڼ޽ */

#define AESA_KEY_KEY0_Pos				0				/**< \brief (AESA_KEY)0 */
#define AESA_KEY_KEY0_Msk				(0xFFFFFFFFu << AESA_KEY_KEY0_Pos)
#define AESA_KEY_KEY0(value)			((AESA_KEY_KEY0_Msk & ((value) << AESA_KEY_KEY0_Pos)))
#define AESA_KEY_MASK					0xFFFFFFFFu		/**< \brief (AESA_KEY)MASKڼ޽ */

/* -------- AESA_INITVECT : (AESAψ:0x40) ( /W 32) INITVECT ޸ڼ޽ -------- */
#define AESA_INITVECT_OFFSET			0x40			/**< \brief (AESA_INITVECTψ)޸ڼ޽ */
#define AESA_INITVECT_RESETVALUE		0x00000000		/**< \brief (AESA_INITVECT reset_value)޸ڼ޽ */

#define AESA_INITVECT_INITVECT0_Pos		0				/**< \brief (AESA_INITVECT)޸0 */
#define AESA_INITVECT_INITVECT0_Msk		(0xFFFFFFFFu << AESA_INITVECT_INITVECT0_Pos)
#define AESA_INITVECT_INITVECT0(value)	((AESA_INITVECT_INITVECT0_Msk & ((value) << AESA_INITVECT_INITVECT0_Pos)))
#define AESA_INITVECT_MASK				0xFFFFFFFFu		/**< \brief (AESA_INITVECT)MASKڼ޽ */

/* -------- AESA_IDATA : (AESAψ:0x50) ( /W 32)ް ڼ޽ -------- */
#define AESA_IDATA_OFFSET				0x50			/**< \brief (AESA_IDATAψ)ް ڼ޽ */
#define AESA_IDATA_RESETVALUE			0x00000000		/**< \brief (AESA_IDATA reset_value)ް ڼ޽ */

#define AESA_IDATA_IDATA_Pos			0				/**< \brief (AESA_IDATA)ް */
#define AESA_IDATA_IDATA_Msk			(0xFFFFFFFFu << AESA_IDATA_IDATA_Pos)
#define AESA_IDATA_IDATA(value)			((AESA_IDATA_IDATA_Msk & ((value) << AESA_IDATA_IDATA_Pos)))
#define AESA_IDATA_MASK					0xFFFFFFFFu		/**< \brief (AESA_IDATA)MASKڼ޽ */

/* -------- AESA_ODATA : (AESAψ:0x60) (R/  32)oް ڼ޽ -------- */
#define AESA_ODATA_OFFSET				0x60			/**< \brief (AESA_ODATAψ)oް ڼ޽ */
#define AESA_ODATA_RESETVALUE			0x00000000		/**< \brief (AESA_ODATA reset_value)oް ڼ޽ */

#define AESA_ODATA_ODATA_Pos			0				/**< \brief (AESA_ODATA)oް*/
#define AESA_ODATA_ODATA_Msk			(0xFFFFFFFFu << AESA_ODATA_ODATA_Pos)
#define AESA_ODATA_ODATA(value)			((AESA_ODATA_ODATA_Msk & ((value) << AESA_ODATA_ODATA_Pos)))
#define AESA_ODATA_MASK					0xFFFFFFFFu		/**< \brief (AESA_ODATA)MASKڼ޽ */

/* -------- AESA_DRNGSEED : (AESAψ:0x70) ( /W 32) DRNGxڼ޽ -------- */
#define AESA_DRNGSEED_OFFSET			0x70			/**< \brief (AESA_DRNGSEEDψ)DRNGxڼ޽ */
#define AESA_DRNGSEED_RESETVALUE		0x00000000		/**< \brief (AESA_DRNGSEED reset_value)DRNGxڼ޽ */

#define AESA_DRNGSEED_SEED_Pos			0				/**< \brief (AESA_DRNGSEED)DRNGx */
#define AESA_DRNGSEED_SEED_Msk			(0xFFFFFFFFu << AESA_DRNGSEED_SEED_Pos)
#define AESA_DRNGSEED_SEED(value)		((AESA_DRNGSEED_SEED_Msk & ((value) << AESA_DRNGSEED_SEED_Pos)))
#define AESA_DRNGSEED_MASK				0xFFFFFFFFu		/**< \brief (AESA_DRNGSEED)MASKڼ޽ */

/* -------- AESA_PARAMETER : (AESAψ:0xF8) (R/  32)Ұ ڼ޽ -------- */
#define AESA_PARAMETER_OFFSET			0xF8			/**< \brief (AESA_PARAMETERψ)Ұ ڼ޽ */
#define AESA_PARAMETER_RESETVALUE		0x00000112		/**< \brief (AESA_PARAMETER reset_value)Ұ ڼ޽ */

#define AESA_PARAMETER_KEYSIZE_Pos		0				/**< \brief (AESA_PARAMETER)ő̌̑傫 */
#define AESA_PARAMETER_KEYSIZE_Msk		(0x3u << AESA_PARAMETER_KEYSIZE_Pos)
#define AESA_PARAMETER_KEYSIZE(value)	((AESA_PARAMETER_KEYSIZE_Msk & ((value) << AESA_PARAMETER_KEYSIZE_Pos)))
#define AESA_PARAMETER_OPMODE_Pos		2				/**< \brief (AESA_PARAMETER)ő閧`Ԑ */
#define AESA_PARAMETER_OPMODE_Msk		(0x7u << AESA_PARAMETER_OPMODE_Pos)
#define AESA_PARAMETER_OPMODE(value)	((AESA_PARAMETER_OPMODE_Msk & ((value) << AESA_PARAMETER_OPMODE_Pos)))
#define AESA_PARAMETER_CTRMEAS_Pos		8				/**< \brief (AESA_PARAMETER)v푪 */
#define AESA_PARAMETER_CTRMEAS			(0x1u << AESA_PARAMETER_CTRMEAS_Pos)
#define AESA_PARAMETER_MASK				0x0000011Fu		/**< \brief (AESA_PARAMETER)MASKڼ޽ */

/* -------- AESA_VERSION : (AESAψ:0xFC) (R/  32)ڼ޽ -------- */
#define AESA_VERSION_OFFSET				0xFC			/**< \brief (AESA_VERSIONψ)ڼ޽ */
#define AESA_VERSION_RESETVALUE			0x00000102		/**< \brief (AESA_VERSION reset_value)ڼ޽ */

#define AESA_VERSION_VERSION_Pos		0				/**< \brief (AESA_VERSION)Ŕԍ*/
#define AESA_VERSION_VERSION_Msk		(0xFFFu << AESA_VERSION_VERSION_Pos)
#define AESA_VERSION_VERSION(value)		((AESA_VERSION_VERSION_Msk & ((value) << AESA_VERSION_VERSION_Pos)))
#define AESA_VERSION_VARIANT_Pos		16				/**< \brief (AESA_VERSION)ώԍ*/
#define AESA_VERSION_VARIANT_Msk		(0xFu << AESA_VERSION_VARIANT_Pos)
#define AESA_VERSION_VARIANT(value)		((AESA_VERSION_VARIANT_Msk & ((value) << AESA_VERSION_VARIANT_Pos)))
#define AESA_VERSION_MASK				0x000F0FFFu		/**< \brief (AESA_VERSION)MASKڼ޽ */

/** \brief AesaInitvectʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  WoReg   AESA_INITVECT;			/**< \brief (AESAψ:0x00)޸ڼ޽ */
} AesaInitvect;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief AesaKeyʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  WoReg   AESA_KEY;					/**< \brief (AESAψ:0x00)ڼ޽ */
} AesaKey;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief AESAʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RwReg   AESA_CTRL;				/**< \brief (AESAψ:0x00)ڼ޽ */
  RwReg   AESA_MODE;				/**< \brief (AESAψ:0x04)`ڼ޽ */
  RwReg   AESA_DATABUFPTR;			/**< \brief (AESAψ:0x08)ްɏՕʒuwqڼ޽ */
  RoReg   AESA_SR;					/**< \brief (AESAψ:0x0C)ڼ޽ */
  WoReg   AESA_IER;					/**< \brief (AESAψ:0x10)荞݋ڼ޽ */
  WoReg   AESA_IDR;					/**< \brief (AESAψ:0x14)荞݋֎~ڼ޽ */
  RoReg   AESA_IMR;					/**< \brief (AESAψ:0x18)荞ݎՕڼ޽ */
  RoReg8  Reserved1[0x4];
  AesaKey AESA_KEY[8];				/**< \brief (AESAψ:0x20)AesaQ */
  AesaInitvect AESA_INITVECT[4];	/**< \brief (AESAψ:0x40)AesaInitvectQ */
  WoReg   AESA_IDATA;				/**< \brief (AESAψ:0x50)ް ڼ޽ */
  RoReg8  Reserved2[0xC];
  RoReg   AESA_ODATA;				/**< \brief (AESAψ:0x60)oް ڼ޽ */
  RoReg8  Reserved3[0xC];
  WoReg   AESA_DRNGSEED;			/**< \brief (AESAψ:0x70)DRNGxڼ޽ */
  RoReg8  Reserved4[0x84];
  RoReg   AESA_PARAMETER;			/**< \brief (AESAψ:0xF8)Ұ ڼ޽ */
  RoReg   AESA_VERSION;				/**< \brief (AESAψ:0xFC)ڼ޽ */
} Aesa;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_AESA_COMPONENT_ */
