/**
 * \file
 *
 * \brief FREQMp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_FREQM_COMPONENT_
#define _SAM4L_FREQM_COMPONENT_

/* ========================================================================== */
/** FREQMpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_FREQM gv */
/*@{*/

#define REV_FREQM						0x311

/* -------- FREQM_CTRL : (FREQMψ:0x000) ( /W 32)ڼ޽ -------- */
#define FREQM_CTRL_OFFSET				0x000			/**< \brief (FREQM_CTRLψ)ڼ޽ */
#define FREQM_CTRL_RESETVALUE			0x00000000		/**< \brief (FREQM_CTRL reset_value)ڼ޽ */

#define FREQM_CTRL_START_Pos			0				/**< \brief (FREQM_CTRL)gJn */
#define FREQM_CTRL_START				(0x1u << FREQM_CTRL_START_Pos)
#define FREQM_CTRL_MASK					0x00000001u		/**< \brief (FREQM_CTRL)MASKڼ޽ */

/* -------- FREQM_MODE : (FREQMψ:0x004) (R/W 32)`ڼ޽ -------- */
#define FREQM_MODE_OFFSET				0x004			/**< \brief (FREQM_MODEψ)`ڼ޽ */
#define FREQM_MODE_RESETVALUE			0x00000000		/**< \brief (FREQM_MODE reset_value)`ڼ޽ */

#define FREQM_MODE_REFSEL_Pos			0				/**< \brief (FREQM_MODE)ۯI */
#define FREQM_MODE_REFSEL_Msk			(0x3u << FREQM_MODE_REFSEL_Pos)
#define FREQM_MODE_REFSEL(value)		((FREQM_MODE_REFSEL_Msk & ((value) << FREQM_MODE_REFSEL_Pos)))
#define FREQM_MODE_REFNUM_Pos			8				/**< \brief (FREQM_MODE)ۯ */
#define FREQM_MODE_REFNUM_Msk			(0xFFu << FREQM_MODE_REFNUM_Pos)
#define FREQM_MODE_REFNUM(value)		((FREQM_MODE_REFNUM_Msk & ((value) << FREQM_MODE_REFNUM_Pos)))
#define FREQM_MODE_CLKSEL_Pos			16				/**< \brief (FREQM_MODE)ۯI */
#define FREQM_MODE_CLKSEL_Msk			(0x1Fu << FREQM_MODE_CLKSEL_Pos)
#define FREQM_MODE_CLKSEL(value)		((FREQM_MODE_CLKSEL_Msk & ((value) << FREQM_MODE_CLKSEL_Pos)))
#define FREQM_MODE_REFCEN_Pos			31				/**< \brief (FREQM_MODE)ۯ */
#define FREQM_MODE_REFCEN				(0x1u << FREQM_MODE_REFCEN_Pos)
#define FREQM_MODE_MASK					0x801FFF03u		/**< \brief (FREQM_MODE)MASKڼ޽ */

/* -------- FREQM_STATUS : (FREQMψ:0x008) (R/  32)ڼ޽ -------- */
#define FREQM_STATUS_OFFSET				0x008			/**< \brief (FREQM_STATUSψ)ڼ޽ */
#define FREQM_STATUS_RESETVALUE			0x00000000		/**< \brief (FREQM_STATUS reset_value)ڼ޽ */

#define FREQM_STATUS_BUSY_Pos			0				/**< \brief (FREQM_STATUS)gis */
#define FREQM_STATUS_BUSY				(0x1u << FREQM_STATUS_BUSY_Pos)
#define FREQM_STATUS_RCLKBUSY_Pos		1				/**< \brief (FREQM_STATUS)ۯZ */
#define FREQM_STATUS_RCLKBUSY			(0x1u << FREQM_STATUS_RCLKBUSY_Pos)
#define FREQM_STATUS_MASK				0x00000003u		/**< \brief (FREQM_STATUS)MASKڼ޽ */

/* -------- FREQM_VALUE : (FREQMψ:0x00C) (R/  32)lڼ޽ -------- */
#define FREQM_VALUE_OFFSET				0x00C			/**< \brief (FREQM_VALUEψ)lڼ޽ */
#define FREQM_VALUE_RESETVALUE			0x00000000		/**< \brief (FREQM_VALUE reset_value)lڼ޽ */

#define FREQM_VALUE_VALUE_Pos			0				/**< \brief (FREQM_VALUE)肵g */
#define FREQM_VALUE_VALUE_Msk			(0xFFFFFFu << FREQM_VALUE_VALUE_Pos)
#define FREQM_VALUE_VALUE(value)		((FREQM_VALUE_VALUE_Msk & ((value) << FREQM_VALUE_VALUE_Pos)))
#define FREQM_VALUE_MASK				0x00FFFFFFu		/**< \brief (FREQM_VALUE)MASKڼ޽ */

/* -------- FREQM_IER : (FREQMψ:0x010) ( /W 32)荞݋ڼ޽ -------- */
#define FREQM_IER_OFFSET				0x010			/**< \brief (FREQM_IERψ)荞݋ڼ޽ */
#define FREQM_IER_RESETVALUE			0x00000000		/**< \brief (FREQM_IER reset_value)荞݋ڼ޽ */

#define FREQM_IER_DONE_Pos				0				/**< \brief (FREQM_IER)gI */
#define FREQM_IER_DONE					(0x1u << FREQM_IER_DONE_Pos)
#define FREQM_IER_RCLKRDY_Pos			1				/**< \brief (FREQM_IER)ۯ */
#define FREQM_IER_RCLKRDY				(0x1u << FREQM_IER_RCLKRDY_Pos)
#define FREQM_IER_MASK					0x00000003u		/**< \brief (FREQM_IER)MASKڼ޽ */

/* -------- FREQM_IDR : (FREQMψ:0x014) ( /W 32)荞݋֎~ڼ޽ -------- */
#define FREQM_IDR_OFFSET				0x014			/**< \brief (FREQM_IDRψ)荞݋֎~ڼ޽ */
#define FREQM_IDR_RESETVALUE			0x00000000		/**< \brief (FREQM_IDR reset_value)荞݋֎~ڼ޽ */

#define FREQM_IDR_DONE_Pos				0				/**< \brief (FREQM_IDR)gI */
#define FREQM_IDR_DONE					(0x1u << FREQM_IDR_DONE_Pos)
#define FREQM_IDR_RCLKRDY_Pos			1				/**< \brief (FREQM_IDR)ۯ */
#define FREQM_IDR_RCLKRDY				(0x1u << FREQM_IDR_RCLKRDY_Pos)
#define FREQM_IDR_MASK					0x00000003u		/**< \brief (FREQM_IDR)MASKڼ޽ */

/* -------- FREQM_IMR : (FREQMψ:0x018) (R/  32)荞ݎՕڼ޽ -------- */
#define FREQM_IMR_OFFSET				0x018			/**< \brief (FREQM_IMRψ)荞ݎՕڼ޽ */
#define FREQM_IMR_RESETVALUE			0x00000000		/**< \brief (FREQM_IMR reset_value)荞ݎՕڼ޽ */

#define FREQM_IMR_DONE_Pos				0				/**< \brief (FREQM_IMR)gI */
#define FREQM_IMR_DONE					(0x1u << FREQM_IMR_DONE_Pos)
#define FREQM_IMR_RCLKRDY_Pos			1				/**< \brief (FREQM_IMR)ۯ */
#define FREQM_IMR_RCLKRDY				(0x1u << FREQM_IMR_RCLKRDY_Pos)
#define FREQM_IMR_MASK					0x00000003u		/**< \brief (FREQM_IMR)MASKڼ޽ */

/* -------- FREQM_ISR : (FREQMψ:0x01C) (R/  32)荞ݏڼ޽ -------- */
#define FREQM_ISR_OFFSET				0x01C			/**< \brief (FREQM_ISRψ)荞ݏڼ޽ */
#define FREQM_ISR_RESETVALUE			0x00000000		/**< \brief (FREQM_ISR reset_value)荞ݏڼ޽ */

#define FREQM_ISR_DONE_Pos				0				/**< \brief (FREQM_ISR)gI */
#define FREQM_ISR_DONE					(0x1u << FREQM_ISR_DONE_Pos)
#define FREQM_ISR_RCLKRDY_Pos			1				/**< \brief (FREQM_ISR)ۯ */
#define FREQM_ISR_RCLKRDY				(0x1u << FREQM_ISR_RCLKRDY_Pos)
#define FREQM_ISR_MASK					0x00000003u		/**< \brief (FREQM_ISR)MASKڼ޽ */

/* -------- FREQM_ICR : (FREQMψ:0x020) ( /W 32)荞݉ڼ޽ -------- */
#define FREQM_ICR_OFFSET				0x020			/**< \brief (FREQM_ICRψ)荞݉ڼ޽ */
#define FREQM_ICR_RESETVALUE			0x00000000		/**< \brief (FREQM_ICR reset_value)荞݉ڼ޽ */

#define FREQM_ICR_DONE_Pos				0				/**< \brief (FREQM_ICR)gI */
#define FREQM_ICR_DONE					(0x1u << FREQM_ICR_DONE_Pos)
#define FREQM_ICR_RCLKRDY_Pos			1				/**< \brief (FREQM_ICR)ۯ */
#define FREQM_ICR_RCLKRDY				(0x1u << FREQM_ICR_RCLKRDY_Pos)
#define FREQM_ICR_MASK					0x00000003u		/**< \brief (FREQM_ICR)MASKڼ޽ */

/* -------- FREQM_VERSION : (FREQMψ:0x3FC) (R/  32)ڼ޽ -------- */
#define FREQM_VERSION_OFFSET			0x3FC			/**< \brief (FREQM_VERSIONψ)ڼ޽ */
#define FREQM_VERSION_RESETVALUE		0x00000311		/**< \brief (FREQM_VERSION reset_value)ڼ޽ */

#define FREQM_VERSION_VERSION_Pos		0				/**< \brief (FREQM_VERSION)Ŕԍ */
#define FREQM_VERSION_VERSION_Msk		(0xFFFu << FREQM_VERSION_VERSION_Pos)
#define FREQM_VERSION_VERSION(value)	((FREQM_VERSION_VERSION_Msk & ((value) << FREQM_VERSION_VERSION_Pos)))
#define FREQM_VERSION_VARIANT_Pos		16				/**< \brief (FREQM_VERSION)ώԍ */
#define FREQM_VERSION_VARIANT_Msk		(0xFu << FREQM_VERSION_VARIANT_Pos)
#define FREQM_VERSION_VARIANT(value)	((FREQM_VERSION_VARIANT_Msk & ((value) << FREQM_VERSION_VARIANT_Pos)))
#define FREQM_VERSION_MASK				0x000F0FFFu		/**< \brief (FREQM_VERSION)MASKڼ޽ */

/** \brief FREQMʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  WoReg   FREQM_CTRL;		/**< \brief (FREQMψ:0x000)ڼ޽ */
  RwReg   FREQM_MODE;		/**< \brief (FREQMψ:0x004)`ڼ޽ */
  RoReg   FREQM_STATUS;		/**< \brief (FREQMψ:0x008)ڼ޽ */
  RoReg   FREQM_VALUE;		/**< \brief (FREQMψ:0x00C)lڼ޽ */
  WoReg   FREQM_IER;		/**< \brief (FREQMψ:0x010)荞݋ڼ޽ */
  WoReg   FREQM_IDR;		/**< \brief (FREQMψ:0x014)荞݋֎~ڼ޽ */
  RoReg   FREQM_IMR;		/**< \brief (FREQMψ:0x018)荞ݎՕڼ޽ */
  RoReg   FREQM_ISR;		/**< \brief (FREQMψ:0x01C)荞ݏڼ޽ */
  WoReg   FREQM_ICR;		/**< \brief (FREQMψ:0x020)荞݉ڼ޽ */
  RoReg8  Reserved1[0x3D8];
  RoReg   FREQM_VERSION;	/**< \brief (FREQMψ:0x3FC)ڼ޽ */
} Freqm;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_FREQM_COMPONENT_ */
