/**
 * \file
 *
 * \brief HCACHEp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_HCACHE_COMPONENT_
#define _SAM4L_HCACHE_COMPONENT_

/* ========================================================================== */
/** HCACHEpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_HCACHE Cortex M I&D */
/*@{*/

#define REV_HCACHE						0x101

/* -------- HCACHE_CTRL : (HCACHEψ:0x08) ( /W 32)ڼ޽ -------- */
#define HCACHE_CTRL_OFFSET				0x08			/**< \brief (HCACHE_CTRLψ)ڼ޽ */

#define HCACHE_CTRL_CEN_Pos				0				/**< \brief (HCACHE_CTRL) */
#define HCACHE_CTRL_CEN					(0x1u << HCACHE_CTRL_CEN_Pos)
#define   HCACHE_CTRL_CEN_NO				(0x0u <<  0)	/**< \brief (HCACHE_CTRL)֎~ */
#define   HCACHE_CTRL_CEN_YES				(0x1u <<  0)	/**< \brief (HCACHE_CTRL)틖 */
#define HCACHE_CTRL_MASK				0x00000001u		/**< \brief (HCACHE_CTRL)MASKڼ޽ */

/* -------- HCACHE_SR : (HCACHEψ:0x0C) (R/W 32)ڼ޽ -------- */
#define HCACHE_SR_OFFSET				0x0C			/**< \brief (HCACHE_SRψ)ڼ޽ */

#define HCACHE_SR_CSTS_Pos				0				/**< \brief (HCACHE_SR) */
#define HCACHE_SR_CSTS					(0x1u << HCACHE_SR_CSTS_Pos)
#define   HCACHE_SR_CSTS_DIS				(0x0u <<  0)	/**< \brief (HCACHE_SR)֎~ */
#define   HCACHE_SR_CSTS_EN					(0x1u <<  0)	/**< \brief (HCACHE_SR)틖 */
#define HCACHE_SR_MASK					0x00000001u		/**< \brief (HCACHE_SR)MASKڼ޽ */

/* -------- HCACHE_MAINT0 : (HCACHEψ:0x20) ( /W 32)ێڼ޽0 -------- */
#define HCACHE_MAINT0_OFFSET			0x20			/**< \brief (HCACHE_MAINT0ψ)ێڼ޽0 */

#define HCACHE_MAINT0_INVALL_Pos		0				/**< \brief (HCACHE_MAINT0)SĂ𖳌 */
#define HCACHE_MAINT0_INVALL			(0x1u << HCACHE_MAINT0_INVALL_Pos)
#define   HCACHE_MAINT0_INVALL_NO			(0x0u <<  0)	/**< \brief (HCACHE_MAINT0) */
#define   HCACHE_MAINT0_INVALL_YES			(0x1u <<  0)	/**< \brief (HCACHE_MAINT0)So^𖳌 */
#define HCACHE_MAINT0_MASK				0x00000001u		/**< \brief (HCACHE_MAINT0)MASKڼ޽ */

/* -------- HCACHE_MAINT1 : (HCACHEψ:0x24) ( /W 32)ێڼ޽1 -------- */
#define HCACHE_MAINT1_OFFSET			0x24			/**< \brief (HCACHE_MAINT1ψ)ێڼ޽1 */

#define HCACHE_MAINT1_INDEX_Pos			4				/**< \brief (HCACHE_MAINT1)wW𖳌 */
#define HCACHE_MAINT1_INDEX_Msk			(0xFu << HCACHE_MAINT1_INDEX_Pos)
#define HCACHE_MAINT1_INDEX(value)		((HCACHE_MAINT1_INDEX_Msk & ((value) << HCACHE_MAINT1_INDEX_Pos)))
#define HCACHE_MAINT1_MASK				0x000000F0u		/**< \brief (HCACHE_MAINT1)MASKڼ޽ */

/* -------- HCACHE_MCFG : (HCACHEψ:0x28) (R/W 32)Ď`ԐݒĎ`Ԑݒ -------- */
#define HCACHE_MCFG_OFFSET				0x28			/**< \brief (HCACHE_MCFGψ)Ď`Ԑݒ */

#define HCACHE_MCFG_MODE_Pos			0				/**< \brief (HCACHE_MCFG)Ďv퓮 */
#define HCACHE_MCFG_MODE_Msk			(0x3u << HCACHE_MCFG_MODE_Pos)
#define HCACHE_MCFG_MODE(value)			((HCACHE_MCFG_MODE_Msk & ((value) << HCACHE_MCFG_MODE_Pos)))
#define   HCACHE_MCFG_MODE_CYCLE			(0x0u <<  0)	/**< \brief (HCACHE_MCFG)v */
#define   HCACHE_MCFG_MODE_IHIT				(0x1u <<  0)	/**< \brief (HCACHE_MCFG)ߓv */
#define   HCACHE_MCFG_MODE_DHIT				(0x2u <<  0)	/**< \brief (HCACHE_MCFG)ްv */
#define HCACHE_MCFG_MASK				0x00000003u		/**< \brief (HCACHE_MCFG)MASKڼ޽ */

/* -------- HCACHE_MEN : (HCACHEψ:0x2C) (R/W 32)Ďڼ޽ -------- */
#define HCACHE_MEN_OFFSET				0x2C			/**< \brief (HCACHE_MENψ)Ďڼ޽ */

#define HCACHE_MEN_MENABLE_Pos			0				/**< \brief (HCACHE_MEN)Ď */
#define HCACHE_MEN_MENABLE				(0x1u << HCACHE_MEN_MENABLE_Pos)
#define   HCACHE_MEN_MENABLE_DIS			(0x0u <<  0)	/**< \brief (HCACHE_MEN)Ďv֎~ */
#define   HCACHE_MEN_MENABLE_EN				(0x1u <<  0)	/**< \brief (HCACHE_MEN)Ďv틖 */
#define HCACHE_MEN_MASK					0x00000001u		/**< \brief (HCACHE_MEN)MASKڼ޽ */

/* -------- HCACHE_MCTRL : (HCACHEψ:0x30) ( /W 32)Ďڼ޽ -------- */
#define HCACHE_MCTRL_OFFSET				0x30			/**< \brief (HCACHE_MCTRLψ)Ďڼ޽ */

#define HCACHE_MCTRL_SWRST_Pos			0				/**< \brief (HCACHE_MCTRL)Ďĳ ؾ */
#define HCACHE_MCTRL_SWRST				(0x1u << HCACHE_MCTRL_SWRST_Pos)
#define   HCACHE_MCTRL_SWRST_NO				(0x0u <<  0)	/**< \brief (HCACHE_MCTRL) */
#define   HCACHE_MCTRL_SWRST_YES			(0x1u <<  0)	/**< \brief (HCACHE_MCTRL)یvڼ޽ ؾ */
#define HCACHE_MCTRL_MASK				0x00000001u		/**< \brief (HCACHE_MCTRL)MASKڼ޽ */

/* -------- HCACHE_MSR : (HCACHEψ:0x34) (R/  32)Ďڼ޽ -------- */
#define HCACHE_MSR_OFFSET				0x34			/**< \brief (HCACHE_MSRψ)Ďڼ޽ */

#define HCACHE_MSR_EVENTCNT_Pos			0				/**< \brief (HCACHE_MSR)Ďیv */
#define HCACHE_MSR_EVENTCNT_Msk			(0xFFFFFFFFu << HCACHE_MSR_EVENTCNT_Pos)
#define HCACHE_MSR_EVENTCNT(value)		((HCACHE_MSR_EVENTCNT_Msk & ((value) << HCACHE_MSR_EVENTCNT_Pos)))
#define HCACHE_MSR_MASK					0xFFFFFFFFu		/**< \brief (HCACHE_MSR)MASKڼ޽ */

/* -------- HCACHE_VERSION : (HCACHEψ:0xFC) (R/  32)ڼ޽ -------- */
#define HCACHE_VERSION_OFFSET			0xFC			/**< \brief (HCACHE_VERSIONψ)ڼ޽ */
#define HCACHE_VERSION_RESETVALUE		0x00000101		/**< \brief (HCACHE_VERSION reset_value)ڼ޽ */

#define HCACHE_VERSION_VERSION_Pos		0				/**< \brief (HCACHE_VERSION) */
#define HCACHE_VERSION_VERSION_Msk		(0xFFFu << HCACHE_VERSION_VERSION_Pos)
#define HCACHE_VERSION_VERSION(value)	((HCACHE_VERSION_VERSION_Msk & ((value) << HCACHE_VERSION_VERSION_Pos)))
#define HCACHE_VERSION_MFN_Pos			16				/**< \brief (HCACHE_VERSION) MFN */
#define HCACHE_VERSION_MFN_Msk			(0xFu << HCACHE_VERSION_MFN_Pos)
#define HCACHE_VERSION_MFN(value)		((HCACHE_VERSION_MFN_Msk & ((value) << HCACHE_VERSION_MFN_Pos)))
#define HCACHE_VERSION_MASK				0x000F0FFFu		/**< \brief (HCACHE_VERSION)MASKڼ޽ */

/** \brief HCACHEʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RoReg8  Reserved1[0x8];
  WoReg   HCACHE_CTRL;      /**< \brief (HCACHEψ:0x08)ڼ޽ */
  RwReg   HCACHE_SR; 		/**< \brief (HCACHEψ:0x0C)ڼ޽ */
  RoReg8  Reserved2[0x10];
  WoReg   HCACHE_MAINT0;    /**< \brief (HCACHEψ:0x20)ێڼ޽0 */
  WoReg   HCACHE_MAINT1;    /**< \brief (HCACHEψ:0x24)ێڼ޽1 */
  RwReg   HCACHE_MCFG;      /**< \brief (HCACHEψ:0x28)Ď`Ԑݒ */
  RwReg   HCACHE_MEN;		/**< \brief (HCACHEψ:0x2C)Ďڼ޽ */
  WoReg   HCACHE_MCTRL;     /**< \brief (HCACHEψ:0x30)Ďڼ޽ */
  RoReg   HCACHE_MSR;		/**< \brief (HCACHEψ:0x34)Ďڼ޽ */
  RoReg8  Reserved3[0xC4];
  RoReg   HCACHE_VERSION;   /**< \brief (HCACHEψ:0xFC)ڼ޽ */
} Hcache;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_HCACHE_COMPONENT_ */
