/**
 * \file
 *
 * \brief PDCAp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_PDCA_COMPONENT_
#define _SAM4L_PDCA_COMPONENT_

/* ========================================================================== */
/** PDCApĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_PDCA Peripheral DMA */
/*@{*/

#define REV_PDCA					0x124

/* -------- PDCA_MAR : (PDCAψ:0x000) (R/W 32)  ڽ ڼ޽ -------- */
#define PDCA_MAR_OFFSET				0x000			/**< \brief (PDCA_MARψ) ڽ ڼ޽ */
#define PDCA_MAR_RESETVALUE			0x00000000		/**< \brief (PDCA_MAR reset_value) ڽ ڼ޽ */

#define PDCA_MAR_MADDR_Pos			0				/**< \brief (PDCA_MAR) ڽ */
#define PDCA_MAR_MADDR_Msk			(0xFFFFFFFFu << PDCA_MAR_MADDR_Pos)
#define PDCA_MAR_MADDR(value)		((PDCA_MAR_MADDR_Msk & ((value) << PDCA_MAR_MADDR_Pos)))
#define PDCA_MAR_MASK				0xFFFFFFFFu		/**< \brief (PDCA_MAR)MASKڼ޽ */

/* -------- PDCA_PSR : (PDCAψ:0x004) (R/W 32)َӋ@\Iڼ޽ -------- */
#define PDCA_PSR_OFFSET				0x004			/**< \brief (PDCA_PSRψ)Ӌ@\Iڼ޽ */

#define PDCA_PSR_PID_Pos			0				/**< \brief (PDCA_PSR)Ӌ@\ʎq */
#define PDCA_PSR_PID_Msk			(0xFFu << PDCA_PSR_PID_Pos)
#define PDCA_PSR_PID(value)			((PDCA_PSR_PID_Msk & ((value) << PDCA_PSR_PID_Pos)))
#define PDCA_PSR_MASK				0x000000FFu		/**< \brief (PDCA_PSR)MASKڼ޽ */

/* -------- PDCA_TCR : (PDCAψ:0x008) (R/W 32)ٓ]vڼ޽ -------- */
#define PDCA_TCR_OFFSET				0x008			/**< \brief (PDCA_TCRψ)]vڼ޽ */
#define PDCA_TCR_RESETVALUE			0x00000000		/**< \brief (PDCA_TCR reset_value)]vڼ޽ */

#define PDCA_TCR_TCV_Pos			0				/**< \brief (PDCA_TCR)]vl */
#define PDCA_TCR_TCV_Msk			(0xFFFFu << PDCA_TCR_TCV_Pos)
#define PDCA_TCR_TCV(value)			((PDCA_TCR_TCV_Msk & ((value) << PDCA_TCR_TCV_Pos)))
#define PDCA_TCR_MASK				0x0000FFFFu		/**< \brief (PDCA_TCR)MASKڼ޽ */

/* -------- PDCA_MARR : (PDCAψ:0x00C) (R/W 32)  ڽĐݒڼ޽ -------- */
#define PDCA_MARR_OFFSET			0x00C			/**< \brief (PDCA_MARRψ) ڽĐݒڼ޽ */
#define PDCA_MARR_RESETVALUE		0x00000000		/**< \brief (PDCA_MARR reset_value) ڽĐݒڼ޽ */

#define PDCA_MARR_MARV_Pos			0				/**< \brief (PDCA_MARR) ڽĐݒl */
#define PDCA_MARR_MARV_Msk			(0xFFFFFFFFu << PDCA_MARR_MARV_Pos)
#define PDCA_MARR_MARV(value)		((PDCA_MARR_MARV_Msk & ((value) << PDCA_MARR_MARV_Pos)))
#define PDCA_MARR_MASK				0xFFFFFFFFu		/**< \brief (PDCA_MARR)MASKڼ޽ */

/* -------- PDCA_TCRR : (PDCAψ:0x010) (R/W 32)ٓ]vĐݒڼ޽ -------- */
#define PDCA_TCRR_OFFSET			0x010			/**< \brief (PDCA_TCRRψ)]vĐݒڼ޽ */
#define PDCA_TCRR_RESETVALUE		0x00000000		/**< \brief (PDCA_TCRR reset_value)]vĐݒڼ޽ */

#define PDCA_TCRR_TCRV_Pos			0				/**< \brief (PDCA_TCRR)]vĐݒl */
#define PDCA_TCRR_TCRV_Msk			(0xFFFFu << PDCA_TCRR_TCRV_Pos)
#define PDCA_TCRR_TCRV(value)		((PDCA_TCRR_TCRV_Msk & ((value) << PDCA_TCRR_TCRV_Pos)))
#define PDCA_TCRR_MASK				0x0000FFFFu		/**< \brief (PDCA_TCRR)MASKڼ޽ */

/* -------- PDCA_CR : (PDCAψ:0x014) ( /W 32)ِڼ޽ -------- */
#define PDCA_CR_OFFSET				0x014			/**< \brief (PDCA_CRψ)ڼ޽ */
#define PDCA_CR_RESETVALUE			0x00000000		/**< \brief (PDCA_CR reset_value)ڼ޽ */

#define PDCA_CR_TEN_Pos				0				/**< \brief (PDCA_CR)] */
#define PDCA_CR_TEN					(0x1u << PDCA_CR_TEN_Pos)
#define PDCA_CR_TDIS_Pos			1				/**< \brief (PDCA_CR)]֎~ */
#define PDCA_CR_TDIS				(0x1u << PDCA_CR_TDIS_Pos)
#define PDCA_CR_ECLR_Pos			8				/**< \brief (PDCA_CR)ُ */
#define PDCA_CR_ECLR				(0x1u << PDCA_CR_ECLR_Pos)
#define PDCA_CR_MASK				0x00000103u		/**< \brief (PDCA_CR)MASKڼ޽ */

/* -------- PDCA_MR : (PDCAψ:0x018) (R/W 32)ٓ`ڼ޽ -------- */
#define PDCA_MR_OFFSET				0x018			/**< \brief (PDCA_MRψ)`ڼ޽ */
#define PDCA_MR_RESETVALUE			0x00000000		/**< \brief (PDCA_MR reset_value)`ڼ޽ */

#define PDCA_MR_SIZE_Pos			0				/**< \brief (PDCA_MR)]̑傫 */
#define PDCA_MR_SIZE_Msk			(0x3u << PDCA_MR_SIZE_Pos)
#define PDCA_MR_SIZE(value)			((PDCA_MR_SIZE_Msk & ((value) << PDCA_MR_SIZE_Pos)))
#define   PDCA_MR_SIZE_BYTE				(0x0u <<  0)	/**< \brief (PDCA_MR) */
#define   PDCA_MR_SIZE_HALF_WORD		(0x1u <<  0)	/**< \brief (PDCA_MR) */
#define   PDCA_MR_SIZE_WORD				(0x2u <<  0)	/**< \brief (PDCA_MR) */
#define PDCA_MR_ETRIG_Pos			2				/**< \brief (PDCA_MR)ۋN */
#define PDCA_MR_ETRIG				(0x1u << PDCA_MR_ETRIG_Pos)
#define PDCA_MR_RING_Pos			3				/**< \brief (PDCA_MR)ɏՕ */
#define PDCA_MR_RING				(0x1u << PDCA_MR_RING_Pos)
#define PDCA_MR_MASK				0x0000000Fu		/**< \brief (PDCA_MR)MASKڼ޽ */

/* -------- PDCA_SR : (PDCAψ:0x01C) (R/  32)ُڼ޽ -------- */
#define PDCA_SR_OFFSET				0x01C			/**< \brief (PDCA_SRψ)ڼ޽ */
#define PDCA_SR_RESETVALUE			0x00000000		/**< \brief (PDCA_SR reset_value)ڼ޽ */

#define PDCA_SR_TEN_Pos				0				/**< \brief (PDCA_SR)] */
#define PDCA_SR_TEN					(0x1u << PDCA_SR_TEN_Pos)
#define PDCA_SR_MASK				0x00000001u		/**< \brief (PDCA_SR)MASKڼ޽ */

/* -------- PDCA_IER : (PDCAψ:0x020) ( /W 32)ي荞݋ڼ޽ -------- */
#define PDCA_IER_OFFSET				0x020			/**< \brief (PDCA_IERψ)荞݋ڼ޽ */
#define PDCA_IER_RESETVALUE			0x00000000		/**< \brief (PDCA_IER reset_value)荞݋ڼ޽ */

#define PDCA_IER_RCZ_Pos			0				/**< \brief (PDCA_IER)Đݒv=0 */
#define PDCA_IER_RCZ				(0x1u << PDCA_IER_RCZ_Pos)
#define PDCA_IER_TRC_Pos			1				/**< \brief (PDCA_IER)] */
#define PDCA_IER_TRC				(0x1u << PDCA_IER_TRC_Pos)
#define PDCA_IER_TERR_Pos			2				/**< \brief (PDCA_IER)]ُ */
#define PDCA_IER_TERR				(0x1u << PDCA_IER_TERR_Pos)
#define PDCA_IER_MASK				0x00000007u		/**< \brief (PDCA_IER)MASKڼ޽ */

/* -------- PDCA_IDR : (PDCAψ:0x024) ( /W 32)ي荞݋֎~ڼ޽ -------- */
#define PDCA_IDR_OFFSET				0x024			/**< \brief (PDCA_IDRψ)荞݋֎~ڼ޽ */
#define PDCA_IDR_RESETVALUE			0x00000000		/**< \brief (PDCA_IDR reset_value)荞݋֎~ڼ޽ */

#define PDCA_IDR_RCZ_Pos			0				/**< \brief (PDCA_IDR)Đݒv=0 */
#define PDCA_IDR_RCZ				(0x1u << PDCA_IDR_RCZ_Pos)
#define PDCA_IDR_TRC_Pos			1				/**< \brief (PDCA_IDR)] */
#define PDCA_IDR_TRC				(0x1u << PDCA_IDR_TRC_Pos)
#define PDCA_IDR_TERR_Pos			2				/**< \brief (PDCA_IDR)]ُ */
#define PDCA_IDR_TERR				(0x1u << PDCA_IDR_TERR_Pos)
#define PDCA_IDR_MASK				0x00000007u		/**< \brief (PDCA_IDR)MASKڼ޽ */

/* -------- PDCA_IMR : (PDCAψ:0x028) (R/  32)ي荞ݎՕڼ޽ -------- */
#define PDCA_IMR_OFFSET				0x028			/**< \brief (PDCA_IMRψ)荞ݎՕڼ޽ */
#define PDCA_IMR_RESETVALUE			0x00000000		/**< \brief (PDCA_IMR reset_value)荞ݎՕڼ޽ */

#define PDCA_IMR_RCZ_Pos			0				/**< \brief (PDCA_IMR)Đݒv=0 */
#define PDCA_IMR_RCZ				(0x1u << PDCA_IMR_RCZ_Pos)
#define PDCA_IMR_TRC_Pos			1				/**< \brief (PDCA_IMR)] */
#define PDCA_IMR_TRC				(0x1u << PDCA_IMR_TRC_Pos)
#define PDCA_IMR_TERR_Pos			2				/**< \brief (PDCA_IMR)]ُ */
#define PDCA_IMR_TERR				(0x1u << PDCA_IMR_TERR_Pos)
#define PDCA_IMR_MASK				0x00000007u		/**< \brief (PDCA_IMR)MASKڼ޽ */

/* -------- PDCA_ISR : (PDCAψ:0x02C) (R/  32)ي荞ݏڼ޽ -------- */
#define PDCA_ISR_OFFSET				0x02C			/**< \brief (PDCA_ISRψ)荞ݏڼ޽ */
#define PDCA_ISR_RESETVALUE			0x00000000		/**< \brief (PDCA_ISR reset_value)荞ݏڼ޽ */

#define PDCA_ISR_RCZ_Pos			0				/**< \brief (PDCA_ISR)Đݒv=0 */
#define PDCA_ISR_RCZ				(0x1u << PDCA_ISR_RCZ_Pos)
#define PDCA_ISR_TRC_Pos			1				/**< \brief (PDCA_ISR)] */
#define PDCA_ISR_TRC				(0x1u << PDCA_ISR_TRC_Pos)
#define PDCA_ISR_TERR_Pos			2				/**< \brief (PDCA_ISR)]ُ */
#define PDCA_ISR_TERR				(0x1u << PDCA_ISR_TERR_Pos)
#define PDCA_ISR_MASK				0x00000007u		/**< \brief (PDCA_ISR)MASKڼ޽ */

/* -------- PDCA_PCONTROL : (PDCAψ:0x800) (R/W 32)Ӌ@\ڼ޽ -------- */
#define PDCA_PCONTROL_OFFSET		0x800			/**< \brief (PDCA_PCONTROLψ)Ӌ@\ڼ޽ */
#define PDCA_PCONTROL_RESETVALUE	0x00000000		/**< \brief (PDCA_PCONTROL reset_value)Ӌ@\ڼ޽ */

#define PDCA_PCONTROL_CH0EN_Pos		0				/**< \brief (PDCA_PCONTROL)0 */
#define PDCA_PCONTROL_CH0EN			(0x1u << PDCA_PCONTROL_CH0EN_Pos)
#define PDCA_PCONTROL_CH1EN_Pos		1				/**< \brief (PDCA_PCONTROL)1 */
#define PDCA_PCONTROL_CH1EN			(0x1u << PDCA_PCONTROL_CH1EN_Pos)
#define PDCA_PCONTROL_CH0OF_Pos		4				/**< \brief (PDCA_PCONTROL)0~ */
#define PDCA_PCONTROL_CH0OF			(0x1u << PDCA_PCONTROL_CH0OF_Pos)
#define PDCA_PCONTROL_CH1OF_Pos		5				/**< \brief (PDCA_PCONTROL)1~ */
#define PDCA_PCONTROL_CH1OF			(0x1u << PDCA_PCONTROL_CH1OF_Pos)
#define PDCA_PCONTROL_CH0RES_Pos	8				/**< \brief (PDCA_PCONTROL)0vؾ */
#define PDCA_PCONTROL_CH0RES		(0x1u << PDCA_PCONTROL_CH0RES_Pos)
#define PDCA_PCONTROL_CH1RES_Pos	9				/**< \brief (PDCA_PCONTROL)1vؾ */
#define PDCA_PCONTROL_CH1RES		(0x1u << PDCA_PCONTROL_CH1RES_Pos)
#define PDCA_PCONTROL_MON0CH_Pos	16				/**< \brief (PDCA_PCONTROL)v0ŊĎPDCA */
#define PDCA_PCONTROL_MON0CH_Msk	(0x3Fu << PDCA_PCONTROL_MON0CH_Pos)
#define PDCA_PCONTROL_MON0CH(value)	((PDCA_PCONTROL_MON0CH_Msk & ((value) << PDCA_PCONTROL_MON0CH_Pos)))
#define PDCA_PCONTROL_MON1CH_Pos	24				/**< \brief (PDCA_PCONTROL)v1ŊĎPDCA */
#define PDCA_PCONTROL_MON1CH_Msk	(0x3Fu << PDCA_PCONTROL_MON1CH_Pos)
#define PDCA_PCONTROL_MON1CH(value)	((PDCA_PCONTROL_MON1CH_Msk & ((value) << PDCA_PCONTROL_MON1CH_Pos)))
#define PDCA_PCONTROL_MASK			0x3F3F0333u		/**< \brief (PDCA_PCONTROL)MASKڼ޽ */

/* -------- PDCA_PRDATA0 : (PDCAψ:0x804) (R/  32)0ǂݍް -------- */
#define PDCA_PRDATA0_OFFSET			0x804			/**< \brief (PDCA_PRDATA0ψ)0ǂݍް */
#define PDCA_PRDATA0_RESETVALUE		0x00000000		/**< \brief (PDCA_PRDATA0 reset_value)0ǂݍް */

#define PDCA_PRDATA0_DATA_Pos		0				/**< \brief (PDCA_PRDATA0)ŏIؾĂvꂽް */
#define PDCA_PRDATA0_DATA_Msk		(0xFFFFFFFFu << PDCA_PRDATA0_DATA_Pos)
#define PDCA_PRDATA0_DATA(value)	((PDCA_PRDATA0_DATA_Msk & ((value) << PDCA_PRDATA0_DATA_Pos)))
#define PDCA_PRDATA0_MASK			0xFFFFFFFFu		/**< \brief (PDCA_PRDATA0)MASKڼ޽ */

/* -------- PDCA_PRSTALL0 : (PDCAψ:0x808) (R/  32)0ǂݍݒ~ -------- */
#define PDCA_PRSTALL0_OFFSET		0x808			/**< \brief (PDCA_PRSTALL0ψ)0ǂݍݒ~ */
#define PDCA_PRSTALL0_RESETVALUE	0x00000000		/**< \brief (PDCA_PRSTALL0 reset_value)0ǂݍݒ~ */

#define PDCA_PRSTALL0_STALL_Pos		0				/**< \brief (PDCA_PRSTALL0)ŏIؾĂvꂽ~ */
#define PDCA_PRSTALL0_STALL_Msk		(0xFFFFFFFFu << PDCA_PRSTALL0_STALL_Pos)
#define PDCA_PRSTALL0_STALL(value)	((PDCA_PRSTALL0_STALL_Msk & ((value) << PDCA_PRSTALL0_STALL_Pos)))
#define PDCA_PRSTALL0_MASK			0xFFFFFFFFu		/**< \brief (PDCA_PRSTALL0)MASKڼ޽ */

/* -------- PDCA_PRLAT0 : (PDCAψ:0x80C) (R/  32)0ǂݍݍőx -------- */
#define PDCA_PRLAT0_OFFSET			0x80C			/**< \brief (PDCA_PRLAT0ψ)0ǂݍݍőx */
#define PDCA_PRLAT0_RESETVALUE		0x00000000		/**< \brief (PDCA_PRLAT0 reset_value)0ǂݍݍőx */

#define PDCA_PRLAT0_LAT_Pos			0				/**< \brief (PDCA_PRLAT0)ŏIؾĂvꂽő]Jn */
#define PDCA_PRLAT0_LAT_Msk			(0xFFFFu << PDCA_PRLAT0_LAT_Pos)
#define PDCA_PRLAT0_LAT(value)		((PDCA_PRLAT0_LAT_Msk & ((value) << PDCA_PRLAT0_LAT_Pos)))
#define PDCA_PRLAT0_MASK			0x0000FFFFu		/**< \brief (PDCA_PRLAT0)MASKڼ޽ */

/* -------- PDCA_PWDATA0 : (PDCAψ:0x810) (R/  32)0ް -------- */
#define PDCA_PWDATA0_OFFSET			0x810			/**< \brief (PDCA_PWDATA0ψ)0ް */
#define PDCA_PWDATA0_RESETVALUE		0x00000000		/**< \brief (PDCA_PWDATA0 reset_value)0ް */

#define PDCA_PWDATA0_DATA_Pos		0				/**< \brief (PDCA_PWDATA0)ŏIؾĂvꂽް */
#define PDCA_PWDATA0_DATA_Msk		(0xFFFFFFFFu << PDCA_PWDATA0_DATA_Pos)
#define PDCA_PWDATA0_DATA(value)	((PDCA_PWDATA0_DATA_Msk & ((value) << PDCA_PWDATA0_DATA_Pos)))
#define PDCA_PWDATA0_MASK			0xFFFFFFFFu		/**< \brief (PDCA_PWDATA0)MASKڼ޽ */

/* -------- PDCA_PWSTALL0 : (PDCAψ:0x814) (R/  32)0ݒ~ -------- */
#define PDCA_PWSTALL0_OFFSET		0x814			/**< \brief (PDCA_PWSTALL0ψ)0ݒ~ */
#define PDCA_PWSTALL0_RESETVALUE	0x00000000		/**< \brief (PDCA_PWSTALL0 reset_value)0ݒ~ */

#define PDCA_PWSTALL0_STALL_Pos		0				/**< \brief (PDCA_PWSTALL0)ŏIؾĂvꂽ~ */
#define PDCA_PWSTALL0_STALL_Msk		(0xFFFFFFFFu << PDCA_PWSTALL0_STALL_Pos)
#define PDCA_PWSTALL0_STALL(value)	((PDCA_PWSTALL0_STALL_Msk & ((value) << PDCA_PWSTALL0_STALL_Pos)))
#define PDCA_PWSTALL0_MASK			0xFFFFFFFFu		/**< \brief (PDCA_PWSTALL0)MASKڼ޽ */

/* -------- PDCA_PWLAT0 : (PDCAψ:0x818) (R/  32)l0ݍőx -------- */
#define PDCA_PWLAT0_OFFSET			0x818			/**< \brief (PDCA_PWLAT0ψ)l0ݍőx */
#define PDCA_PWLAT0_RESETVALUE		0x00000000		/**< \brief (PDCA_PWLAT0 reset_value)l0ݍőx */

#define PDCA_PWLAT0_LAT_Pos			0				/**< \brief (PDCA_PWLAT0)ŏIؾĂvꂽő]Jn */
#define PDCA_PWLAT0_LAT_Msk			(0xFFFFu << PDCA_PWLAT0_LAT_Pos)
#define PDCA_PWLAT0_LAT(value)		((PDCA_PWLAT0_LAT_Msk & ((value) << PDCA_PWLAT0_LAT_Pos)))
#define PDCA_PWLAT0_MASK			0x0000FFFFu		/**< \brief (PDCA_PWLAT0)MASKڼ޽ */

/* -------- PDCA_PRDATA1 : (PDCAψ:0x81C) (R/  32)1ǂݍް -------- */
#define PDCA_PRDATA1_OFFSET			0x81C			/**< \brief (PDCA_PRDATA1ψ)1ǂݍް */
#define PDCA_PRDATA1_RESETVALUE		0x00000000		/**< \brief (PDCA_PRDATA1 reset_value)1ǂݍް */

#define PDCA_PRDATA1_DATA_Pos		0				/**< \brief (PDCA_PRDATA1)ŏIؾĂvꂽް */
#define PDCA_PRDATA1_DATA_Msk		(0xFFFFFFFFu << PDCA_PRDATA1_DATA_Pos)
#define PDCA_PRDATA1_DATA(value)	((PDCA_PRDATA1_DATA_Msk & ((value) << PDCA_PRDATA1_DATA_Pos)))
#define PDCA_PRDATA1_MASK			0xFFFFFFFFu		/**< \brief (PDCA_PRDATA1)MASKڼ޽ */

/* -------- PDCA_PRSTALL1 : (PDCAψ:0x820) (R/  32)1ǂݍݒ~ -------- */
#define PDCA_PRSTALL1_OFFSET		0x820			/**< \brief (PDCA_PRSTALL1ψ)1ǂݍݒ~ */
#define PDCA_PRSTALL1_RESETVALUE	0x00000000		/**< \brief (PDCA_PRSTALL1 reset_value)1ǂݍݒ~ */

#define PDCA_PRSTALL1_STALL_Pos		0				/**< \brief (PDCA_PRSTALL1)ŏIؾĂvꂽ~ */
#define PDCA_PRSTALL1_STALL_Msk		(0xFFFFFFFFu << PDCA_PRSTALL1_STALL_Pos)
#define PDCA_PRSTALL1_STALL(value)	((PDCA_PRSTALL1_STALL_Msk & ((value) << PDCA_PRSTALL1_STALL_Pos)))
#define PDCA_PRSTALL1_MASK			0xFFFFFFFFu		/**< \brief (PDCA_PRSTALL1)MASKڼ޽ */

/* -------- PDCA_PRLAT1 : (PDCAψ:0x824) (R/  32)1ǂݍݍőx -------- */
#define PDCA_PRLAT1_OFFSET			0x824			/**< \brief (PDCA_PRLAT1ψ)1ǂݍݍőx */
#define PDCA_PRLAT1_RESETVALUE		0x00000000		/**< \brief (PDCA_PRLAT1 reset_value)1ǂݍݍőx */

#define PDCA_PRLAT1_LAT_Pos			0				/**< \brief (PDCA_PRLAT1)ŏIؾĂvꂽő]Jn */
#define PDCA_PRLAT1_LAT_Msk			(0xFFFFu << PDCA_PRLAT1_LAT_Pos)
#define PDCA_PRLAT1_LAT(value)		((PDCA_PRLAT1_LAT_Msk & ((value) << PDCA_PRLAT1_LAT_Pos)))
#define PDCA_PRLAT1_MASK			0x0000FFFFu		/**< \brief (PDCA_PRLAT1)MASKڼ޽ */

/* -------- PDCA_PWDATA1 : (PDCAψ:0x828) (R/  32)1ް -------- */
#define PDCA_PWDATA1_OFFSET			0x828			/**< \brief (PDCA_PWDATA1ψ)1ް */
#define PDCA_PWDATA1_RESETVALUE		0x00000000		/**< \brief (PDCA_PWDATA1 reset_value)1ް */

#define PDCA_PWDATA1_DATA_Pos		0				/**< \brief (PDCA_PWDATA1)ŏIؾĂvꂽް */
#define PDCA_PWDATA1_DATA_Msk		(0xFFFFFFFFu << PDCA_PWDATA1_DATA_Pos)
#define PDCA_PWDATA1_DATA(value)	((PDCA_PWDATA1_DATA_Msk & ((value) << PDCA_PWDATA1_DATA_Pos)))
#define PDCA_PWDATA1_MASK			0xFFFFFFFFu		/**< \brief (PDCA_PWDATA1)MASKڼ޽ */

/* -------- PDCA_PWSTALL1 : (PDCAψ:0x82C) (R/  32)1ݒ~ -------- */
#define PDCA_PWSTALL1_OFFSET		0x82C			/**< \brief (PDCA_PWSTALL1ψ)1ݒ~ */
#define PDCA_PWSTALL1_RESETVALUE	0x00000000		/**< \brief (PDCA_PWSTALL1 reset_value)1ݒ~ */

#define PDCA_PWSTALL1_STALL_Pos		0				/**< \brief (PDCA_PWSTALL1)ŏIؾĂvꂽ~ */
#define PDCA_PWSTALL1_STALL_Msk		(0xFFFFFFFFu << PDCA_PWSTALL1_STALL_Pos)
#define PDCA_PWSTALL1_STALL(value)  ((PDCA_PWSTALL1_STALL_Msk & ((value) << PDCA_PWSTALL1_STALL_Pos)))
#define PDCA_PWSTALL1_MASK			0xFFFFFFFFu		/**< \brief (PDCA_PWSTALL1)MASKڼ޽ */

/* -------- PDCA_PWLAT1 : (PDCAψ:0x830) (R/  32)1ǂݍݍőx -------- */
#define PDCA_PWLAT1_OFFSET			0x830			/**< \brief (PDCA_PWLAT1ψ)1ǂݍݍőx */
#define PDCA_PWLAT1_RESETVALUE		0x00000000		/**< \brief (PDCA_PWLAT1 reset_value)1ǂݍݍőx */

#define PDCA_PWLAT1_LAT_Pos			0				/**< \brief (PDCA_PWLAT1)ŏIؾĂvꂽő]Jn */
#define PDCA_PWLAT1_LAT_Msk			(0xFFFFu << PDCA_PWLAT1_LAT_Pos)
#define PDCA_PWLAT1_LAT(value)		((PDCA_PWLAT1_LAT_Msk & ((value) << PDCA_PWLAT1_LAT_Pos)))
#define PDCA_PWLAT1_MASK			0x0000FFFFu		/**< \brief (PDCA_PWLAT1)MASKڼ޽ */

/* -------- PDCA_VERSION : (PDCAψ:0x834) (R/  32)ڼ޽ -------- */
#define PDCA_VERSION_OFFSET			0x834			/**< \brief (PDCA_VERSIONψ)ڼ޽ */
#define PDCA_VERSION_RESETVALUE		0x00000124		/**< \brief (PDCA_VERSION reset_value)ڼ޽ */

#define PDCA_VERSION_VERSION_Pos	0				/**< \brief (PDCA_VERSION)Ŕԍ */
#define PDCA_VERSION_VERSION_Msk	(0xFFFu << PDCA_VERSION_VERSION_Pos)
#define PDCA_VERSION_VERSION(value)	((PDCA_VERSION_VERSION_Msk & ((value) << PDCA_VERSION_VERSION_Pos)))
#define PDCA_VERSION_VARIANT_Pos	16				/**< \brief (PDCA_VERSION)ώԍ */
#define PDCA_VERSION_VARIANT_Msk	(0xFu << PDCA_VERSION_VARIANT_Pos)
#define PDCA_VERSION_VARIANT(value)	((PDCA_VERSION_VARIANT_Msk & ((value) << PDCA_VERSION_VARIANT_Pos)))
#define PDCA_VERSION_MASK			0x000F0FFFu		/**< \brief (PDCA_VERSION)MASKڼ޽ */

/** \brief PdcaChannelʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RwReg   PDCA_MAR;			/**< \brief (PDCAψ:0x000) ڽ ڼ޽ */
  RwReg   PDCA_PSR;			/**< \brief (PDCAψ:0x004)Ӌ@\Iڼ޽ */
  RwReg   PDCA_TCR;			/**< \brief (PDCAψ:0x008)]vڼ޽ */
  RwReg   PDCA_MARR;		/**< \brief (PDCAψ:0x00C) ڽĐݒڼ޽ */
  RwReg   PDCA_TCRR;		/**< \brief (PDCAψ:0x010)]vĐݒڼ޽ */
  WoReg   PDCA_CR;			/**< \brief (PDCAψ:0x014)ڼ޽ */
  RwReg   PDCA_MR;			/**< \brief (PDCAψ:0x018)`ڼ޽ */
  RoReg   PDCA_SR;			/**< \brief (PDCAψ:0x01C)ڼ޽ */
  WoReg   PDCA_IER;			/**< \brief (PDCAψ:0x020)荞݋ڼ޽ */
  WoReg   PDCA_IDR;			/**< \brief (PDCAψ:0x024)荞݋֎~ڼ޽ */
  RoReg   PDCA_IMR;			/**< \brief (PDCAψ:0x028)荞ݎՕڼ޽ */
  RoReg   PDCA_ISR;			/**< \brief (PDCAψ:0x02C)荞ݏڼ޽ */
  RoReg8  Reserved1[0x10];
} PdcaChannel;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief PDCAʰ޳ ڼ޽s */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  PdcaChannel PDCA_CHANNEL[16];   /**< \brief (PDCAψ:0x000) PdcaChannel groups [CHANNEL_LENGTH] */
  RoReg8  Reserved1[0x400];
  RwReg   PDCA_PCONTROL;	/**< \brief (PDCAψ:0x800)Ӌ@\ڼ޽ */
  RoReg   PDCA_PRDATA0;		/**< \brief (PDCAψ:0x804)0ǂݍް */
  RoReg   PDCA_PRSTALL0;	/**< \brief (PDCAψ:0x808)0ǂݍݒ~ */
  RoReg   PDCA_PRLAT0;		/**< \brief (PDCAψ:0x80C)0ǂݍݍőx */
  RoReg   PDCA_PWDATA0;		/**< \brief (PDCAψ:0x810)0ް */
  RoReg   PDCA_PWSTALL0;	/**< \brief (PDCAψ:0x814)0ݒ~ */
  RoReg   PDCA_PWLAT0;		/**< \brief (PDCAψ:0x818)0ݍőx */
  RoReg   PDCA_PRDATA1;		/**< \brief (PDCAψ:0x81C)1ǂݍް */
  RoReg   PDCA_PRSTALL1;	/**< \brief (PDCAψ:0x820)1ǂݍݒ~ */
  RoReg   PDCA_PRLAT1;		/**< \brief (PDCAψ:0x824)1ǂݍݍőx */
  RoReg   PDCA_PWDATA1;		/**< \brief (PDCAψ:0x828)1ް */
  RoReg   PDCA_PWSTALL1;	/**< \brief (PDCAψ:0x82C)1ݒ~ */
  RoReg   PDCA_PWLAT1;		/**< \brief (PDCAψ:0x830)1ݍőx */
  RoReg   PDCA_VERSION;		/**< \brief (PDCAψ:0x834)ڼ޽ */
} Pdca;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_PDCA_COMPONENT_ */
