/**
 * \file
 *
 * \brief PEVCp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_PEVC_COMPONENT_
#define _SAM4L_PEVC_COMPONENT_

/* ========================================================================== */
/** PEVCpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_PEVC Ӌ@\ې */
/*@{*/

#define REV_PEVC						0x200

/* -------- PEVC_CHSR : (PEVCψ:0x000) (R/  32)ُڼ޽ -------- */
#define PEVC_CHSR_OFFSET				0x000			/**< \brief (PEVC_CHSRψ)ُڼ޽ */
#define PEVC_CHSR_RESETVALUE			0x00000000		/**< \brief (PEVC_CHSR reset_value)ُڼ޽ */

#define PEVC_CHSR_CHS_Pos				0				/**< \brief (PEVC_CHSR)ُ */
#define PEVC_CHSR_CHS_Msk				(0xFFFFFFFFu << PEVC_CHSR_CHS_Pos)
#define PEVC_CHSR_CHS(value)			((PEVC_CHSR_CHS_Msk & ((value) << PEVC_CHSR_CHS_Pos)))
#define   PEVC_CHSR_CHS_0					(0x0u <<  0)	/**< \brief (PEVC_CHSR)j֎~ */
#define   PEVC_CHSR_CHS_1					(0x1u <<  0)	/**< \brief (PEVC_CHSR)j */
#define PEVC_CHSR_MASK					0xFFFFFFFFu		/**< \brief (PEVC_CHSR)MASKڼ޽ */

/* -------- PEVC_CHER : (PEVCψ:0x004) ( /W 32)ًڼ޽ -------- */
#define PEVC_CHER_OFFSET				0x004			/**< \brief (PEVC_CHERψ)ًڼ޽ */
#define PEVC_CHER_RESETVALUE			0x00000000		/**< \brief (PEVC_CHER reset_value)ًڼ޽ */

#define PEVC_CHER_CHE_Pos				0				/**< \brief (PEVC_CHER)ً */
#define PEVC_CHER_CHE_Msk				(0xFFFFFFFFu << PEVC_CHER_CHE_Pos)
#define PEVC_CHER_CHE(value)			((PEVC_CHER_CHE_Msk & ((value) << PEVC_CHER_CHE_Pos)))
#define   PEVC_CHER_CHE_0					(0x0u <<  0)	/**< \brief (PEVC_CHER)Ȃ */
#define   PEVC_CHER_CHE_1					(0x1u <<  0)	/**< \brief (PEVC_CHER)j */
#define PEVC_CHER_MASK					0xFFFFFFFFu		/**< \brief (PEVC_CHER)MASKڼ޽ */

/* -------- PEVC_CHDR : (PEVCψ:0x008) ( /W 32)ً֎~ڼ޽ -------- */
#define PEVC_CHDR_OFFSET				0x008			/**< \brief (PEVC_CHDRψ)ً֎~ڼ޽ */
#define PEVC_CHDR_RESETVALUE			0x00000000		/**< \brief (PEVC_CHDR reset_value)ً֎~ڼ޽ */

#define PEVC_CHDR_CHD_Pos				0				/**< \brief (PEVC_CHDR)ً֎~ */
#define PEVC_CHDR_CHD_Msk				(0xFFFFFFFFu << PEVC_CHDR_CHD_Pos)
#define PEVC_CHDR_CHD(value)			((PEVC_CHDR_CHD_Msk & ((value) << PEVC_CHDR_CHD_Pos)))
#define   PEVC_CHDR_CHD_0					(0x0u <<  0)	/**< \brief (PEVC_CHDR)Ȃ */
#define   PEVC_CHDR_CHD_1					(0x1u <<  0)	/**< \brief (PEVC_CHDR)j֎~ */
#define PEVC_CHDR_MASK					0xFFFFFFFFu		/**< \brief (PEVC_CHDR)MASKڼ޽ */

/* -------- PEVC_SEV : (PEVCψ:0x010) ( /W 32)ĳ -------- */
#define PEVC_SEV_OFFSET					0x010			/**< \brief (PEVC_SEVψ)ĳ */
#define PEVC_SEV_RESETVALUE				0x00000000		/**< \brief (PEVC_SEV reset_value)ĳ */

#define PEVC_SEV_SEV_Pos				0				/**< \brief (PEVC_SEV)ĳ */
#define PEVC_SEV_SEV_Msk				(0xFFFFFFFFu << PEVC_SEV_SEV_Pos)
#define PEVC_SEV_SEV(value)				((PEVC_SEV_SEV_Msk & ((value) << PEVC_SEV_SEV_Pos)))
#define   PEVC_SEV_SEV_0					(0x0u <<  0)	/**< \brief (PEVC_SEV)Ȃ */
#define   PEVC_SEV_SEV_1					(0x1u <<  0)	/**< \brief (PEVC_SEV)jɑ΂CPUĳۋ */
#define PEVC_SEV_MASK					0xFFFFFFFFu		/**< \brief (PEVC_SEV)MASKڼ޽ */

/* -------- PEVC_BUSY : (PEVCψ:0x014) (R/  32)/gpZ -------- */
#define PEVC_BUSY_OFFSET				0x014			/**< \brief (PEVC_BUSYψ)/gpZ */
#define PEVC_BUSY_RESETVALUE			0x00000000		/**< \brief (PEVC_BUSY reset_value)/gpZ */

#define PEVC_BUSY_BUSY_Pos				0				/**< \brief (PEVC_BUSY)ُ */
#define PEVC_BUSY_BUSY_Msk				(0xFFFFFFFFu << PEVC_BUSY_BUSY_Pos)
#define PEVC_BUSY_BUSY(value)			((PEVC_BUSY_BUSY_Msk & ((value) << PEVC_BUSY_BUSY_Pos)))
#define   PEVC_BUSY_BUSY_0					(0x0u <<  0)	/**< \brief (PEVC_BUSY)Ȃ */
#define   PEVC_BUSY_BUSY_1					(0x1u <<  0)	/**< \brief (PEVC_BUSY)j܂͎gpjZ */
#define PEVC_BUSY_MASK					0xFFFFFFFFu		/**< \brief (PEVC_BUSY)MASKڼ޽ */

/* -------- PEVC_TRIER : (PEVCψ:0x020) ( /W 32)N荞ݎՕڼ޽ -------- */
#define PEVC_TRIER_OFFSET				0x020			/**< \brief (PEVC_TRIERψ)N荞ݎՕڼ޽ */
#define PEVC_TRIER_RESETVALUE			0x00000000		/**< \brief (PEVC_TRIER reset_value)N荞ݎՕڼ޽ */

#define PEVC_TRIER_TRIE_Pos				0				/**< \brief (PEVC_TRIER)N荞݋ */
#define PEVC_TRIER_TRIE_Msk				(0xFFFFFFFFu << PEVC_TRIER_TRIE_Pos)
#define PEVC_TRIER_TRIE(value)			((PEVC_TRIER_TRIE_Msk & ((value) << PEVC_TRIER_TRIE_Pos)))
#define   PEVC_TRIER_TRIE_0					(0x0u <<  0)	/**< \brief (PEVC_TRIER)Ȃ */
#define   PEVC_TRIER_TRIE_1					(0x1u <<  0)	/**< \brief (PEVC_TRIER)Nj荞݋ */
#define PEVC_TRIER_MASK					0xFFFFFFFFu		/**< \brief (PEVC_TRIER)MASKڼ޽ */

/* -------- PEVC_TRIDR : (PEVCψ:0x024) ( /W 32)N荞ݎՕ֎~ڼ޽ -------- */
#define PEVC_TRIDR_OFFSET				0x024			/**< \brief (PEVC_TRIDRψ)N荞ݎՕ֎~ڼ޽ */
#define PEVC_TRIDR_RESETVALUE			0x00000000		/**< \brief (PEVC_TRIDR reset_value)N荞ݎՕ֎~ڼ޽ */

#define PEVC_TRIDR_TRID_Pos				0				/**< \brief (PEVC_TRIDR)N荞݋֎~ */
#define PEVC_TRIDR_TRID_Msk				(0xFFFFFFFFu << PEVC_TRIDR_TRID_Pos)
#define PEVC_TRIDR_TRID(value)			((PEVC_TRIDR_TRID_Msk & ((value) << PEVC_TRIDR_TRID_Pos)))
#define   PEVC_TRIDR_TRID_0					(0x0u <<  0)	/**< \brief (PEVC_TRIDR)Ȃ */
#define   PEVC_TRIDR_TRID_1					(0x1u <<  0)	/**< \brief (PEVC_TRIDR)Nj荞݋֎~ */
#define PEVC_TRIDR_MASK					0xFFFFFFFFu		/**< \brief (PEVC_TRIDR)MASKڼ޽ */

/* -------- PEVC_TRIMR : (PEVCψ:0x028) (R/  32)N荞ݎՕڼ޽ -------- */
#define PEVC_TRIMR_OFFSET				0x028			/**< \brief (PEVC_TRIMRψ)N荞ݎՕڼ޽ */
#define PEVC_TRIMR_RESETVALUE			0x00000000		/**< \brief (PEVC_TRIMR reset_value)N荞ݎՕڼ޽ */

#define PEVC_TRIMR_TRIM_Pos				0				/**< \brief (PEVC_TRIMR)N荞ݎՕ */
#define PEVC_TRIMR_TRIM_Msk				(0xFFFFFFFFu << PEVC_TRIMR_TRIM_Pos)
#define PEVC_TRIMR_TRIM(value)			((PEVC_TRIMR_TRIM_Msk & ((value) << PEVC_TRIMR_TRIM_Pos)))
#define   PEVC_TRIMR_TRIM_0					(0x0u <<  0)	/**< \brief (PEVC_TRIMR)Nj荞݋֎~ */
#define   PEVC_TRIMR_TRIM_1					(0x1u <<  0)	/**< \brief (PEVC_TRIMR)Nj荞݋ */
#define PEVC_TRIMR_MASK					0xFFFFFFFFu		/**< \brief (PEVC_TRIMR)MASKڼ޽ */

/* -------- PEVC_TRSR : (PEVCψ:0x030) (R/  32)Nڼ޽ -------- */
#define PEVC_TRSR_OFFSET				0x030			/**< \brief (PEVC_TRSRψ)Nڼ޽ */
#define PEVC_TRSR_RESETVALUE			0x00000000		/**< \brief (PEVC_TRSR reset_value)Nڼ޽ */

#define PEVC_TRSR_TRS_Pos				0				/**< \brief (PEVC_TRSR)N荞ݏ */
#define PEVC_TRSR_TRS_Msk				(0xFFFFFFFFu << PEVC_TRSR_TRS_Pos)
#define PEVC_TRSR_TRS(value)			((PEVC_TRSR_TRS_Msk & ((value) << PEVC_TRSR_TRS_Pos)))
#define   PEVC_TRSR_TRS_0					(0x0u <<  0)	/**< \brief (PEVC_TRSR)j͉ߋɎۑoȂ */
#define   PEVC_TRSR_TRS_1					(0x1u <<  0)	/**< \brief (PEVC_TRSR)j͉ߋɎۑo */
#define PEVC_TRSR_MASK					0xFFFFFFFFu		/**< \brief (PEVC_TRSR)MASKڼ޽ */

/* -------- PEVC_TRSCR : (PEVCψ:0x034) ( /W 32)Nԉڼ޽ -------- */
#define PEVC_TRSCR_OFFSET				0x034			/**< \brief (PEVC_TRSCRψ)Nԉڼ޽ */
#define PEVC_TRSCR_RESETVALUE			0x00000000		/**< \brief (PEVC_TRSCR reset_value)Nԉڼ޽ */

#define PEVC_TRSCR_TRSC_Pos				0				/**< \brief (PEVC_TRSCR)N荞ݏԉ */
#define PEVC_TRSCR_TRSC_Msk				(0xFFFFFFFFu << PEVC_TRSCR_TRSC_Pos)
#define PEVC_TRSCR_TRSC(value)			((PEVC_TRSCR_TRSC_Msk & ((value) << PEVC_TRSCR_TRSC_Pos)))
#define   PEVC_TRSCR_TRSC_0					(0x0u <<  0)	/**< \brief (PEVC_TRSCR)Ȃ */
#define   PEVC_TRSCR_TRSC_1					(0x1u <<  0)	/**< \brief (PEVC_TRSCR)TRSR[j] */
#define PEVC_TRSCR_MASK					0xFFFFFFFFu		/**< \brief (PEVC_TRSCR)MASKڼ޽ */

/* -------- PEVC_OVIER : (PEVCψ:0x040) ( /W 32)ް݊荞ݎՕڼ޽ -------- */
#define PEVC_OVIER_OFFSET				0x040			/**< \brief (PEVC_OVIERψ)ް݊荞ݎՕڼ޽ */
#define PEVC_OVIER_RESETVALUE			0x00000000		/**< \brief (PEVC_OVIER reset_value)ް݊荞ݎՕڼ޽ */

#define PEVC_OVIER_OVIE_Pos				0				/**< \brief (PEVC_OVIER)ް݊荞݋ */
#define PEVC_OVIER_OVIE_Msk				(0xFFFFFFFFu << PEVC_OVIER_OVIE_Pos)
#define PEVC_OVIER_OVIE(value)			((PEVC_OVIER_OVIE_Msk & ((value) << PEVC_OVIER_OVIE_Pos)))
#define   PEVC_OVIER_OVIE_0					(0x0u <<  0)	/**< \brief (PEVC_OVIER)Ȃ */
#define   PEVC_OVIER_OVIE_1					(0x1u <<  0)	/**< \brief (PEVC_OVIER)jpް݊荞݋ */
#define PEVC_OVIER_MASK					0xFFFFFFFFu		/**< \brief (PEVC_OVIER)MASKڼ޽ */

/* -------- PEVC_OVIDR : (PEVCψ:0x044) ( /W 32)ް݊荞ݎՕ֎~ڼ޽ -------- */
#define PEVC_OVIDR_OFFSET				0x044			/**< \brief (PEVC_OVIDRψ)ް݊荞ݎՕ֎~ڼ޽ */
#define PEVC_OVIDR_RESETVALUE			0x00000000		/**< \brief (PEVC_OVIDR reset_value)ް݊荞ݎՕ֎~ڼ޽ */

#define PEVC_OVIDR_OVID_Pos				0				/**< \brief (PEVC_OVIDR)ް݊荞݋֎~ */
#define PEVC_OVIDR_OVID_Msk				(0xFFFFFFFFu << PEVC_OVIDR_OVID_Pos)
#define PEVC_OVIDR_OVID(value)			((PEVC_OVIDR_OVID_Msk & ((value) << PEVC_OVIDR_OVID_Pos)))
#define   PEVC_OVIDR_OVID_0					(0x0u <<  0)	/**< \brief (PEVC_OVIDR)Ȃ */
#define   PEVC_OVIDR_OVID_1					(0x1u <<  0)	/**< \brief (PEVC_OVIDR)jpް݊荞݋ */
#define PEVC_OVIDR_MASK					0xFFFFFFFFu		/**< \brief (PEVC_OVIDR)MASKڼ޽ */

/* -------- PEVC_OVIMR : (PEVCψ:0x048) (R/  32)ް݊荞ݎՕڼ޽ -------- */
#define PEVC_OVIMR_OFFSET				0x048			/**< \brief (PEVC_OVIMRψ)ް݊荞ݎՕڼ޽ */
#define PEVC_OVIMR_RESETVALUE			0x00000000		/**< \brief (PEVC_OVIMR reset_value)ް݊荞ݎՕڼ޽ */

#define PEVC_OVIMR_OVIM_Pos				0				/**< \brief (PEVC_OVIMR)ް݊荞ݎՕ */
#define PEVC_OVIMR_OVIM_Msk				(0xFFFFFFFFu << PEVC_OVIMR_OVIM_Pos)
#define PEVC_OVIMR_OVIM(value)			((PEVC_OVIMR_OVIM_Msk & ((value) << PEVC_OVIMR_OVIM_Pos)))
#define   PEVC_OVIMR_OVIM_0					(0x0u <<  0)	/**< \brief (PEVC_OVIMR)j֎~pް݊荞 */
#define   PEVC_OVIMR_OVIM_1					(0x1u <<  0)	/**< \brief (PEVC_OVIMR)jpް݊荞 */
#define PEVC_OVIMR_MASK					0xFFFFFFFFu		/**< \brief (PEVC_OVIMR)MASKڼ޽ */

/* -------- PEVC_OVSR : (PEVCψ:0x050) (R/  32)ްݏڼ޽ -------- */
#define PEVC_OVSR_OFFSET				0x050			/**< \brief (PEVC_OVSRψ)ްݏڼ޽ */
#define PEVC_OVSR_RESETVALUE			0x00000000		/**< \brief (PEVC_OVSR reset_value)ްݏڼ޽ */

#define PEVC_OVSR_OVS_Pos				0				/**< \brief (PEVC_OVSR)ް݊荞ݏ */
#define PEVC_OVSR_OVS_Msk				(0xFFFFFFFFu << PEVC_OVSR_OVS_Pos)
#define PEVC_OVSR_OVS(value)			((PEVC_OVSR_OVS_Msk & ((value) << PEVC_OVSR_OVS_Pos)))
#define   PEVC_OVSR_OVS_0					(0x0u <<  0)	/**< \brief (PEVC_OVSR)jŵްݔȂ */
#define   PEVC_OVSR_OVS_1					(0x1u <<  0)	/**< \brief (PEVC_OVSR)jŵްݔ */
#define PEVC_OVSR_MASK					0xFFFFFFFFu		/**< \brief (PEVC_OVSR)MASKڼ޽ */

/* -------- PEVC_OVSCR : (PEVCψ:0x054) ( /W 32)ްݏԉڼ޽ -------- */
#define PEVC_OVSCR_OFFSET				0x054			/**< \brief (PEVC_OVSCRψ)ްݏԉڼ޽ */
#define PEVC_OVSCR_RESETVALUE			0x00000000		/**< \brief (PEVC_OVSCR reset_value)ްݏԉڼ޽ */

#define PEVC_OVSCR_OVSC_Pos				0				/**< \brief (PEVC_OVSCR)ްݏԉ */
#define PEVC_OVSCR_OVSC_Msk				(0xFFFFFFFFu << PEVC_OVSCR_OVSC_Pos)
#define PEVC_OVSCR_OVSC(value)			((PEVC_OVSCR_OVSC_Msk & ((value) << PEVC_OVSCR_OVSC_Pos)))
#define   PEVC_OVSCR_OVSC_0					(0x0u <<  0)	/**< \brief (PEVC_OVSCR)Ȃ */
#define   PEVC_OVSCR_OVSC_1					(0x1u <<  0)	/**< \brief (PEVC_OVSCR)ްݏޯj */
#define PEVC_OVSCR_MASK					0xFFFFFFFFu		/**< \brief (PEVC_OVSCR)MASKڼ޽ */

/* -------- PEVC_CHMX : (PEVCψ:0x100) (R/W 32)CHMXّd -------- */
#define PEVC_CHMX_OFFSET				0x100			/**< \brief (PEVC_CHMXψ)ّd */
#define PEVC_CHMX_RESETVALUE			0x00000000		/**< \brief (PEVC_CHMX reset_value)ّd */

#define PEVC_CHMX_EVMX_Pos				0				/**< \brief (PEVC_CHMX)ۑd */
#define PEVC_CHMX_EVMX_Msk				(0x3Fu << PEVC_CHMX_EVMX_Pos)
#define PEVC_CHMX_EVMX(value)			((PEVC_CHMX_EVMX_Msk & ((value) << PEVC_CHMX_EVMX_Pos)))
#define   PEVC_CHMX_EVMX_0					(0x0u <<  0)	/**< \brief (PEVC_CHMX)0 */
#define   PEVC_CHMX_EVMX_1					(0x1u <<  0)	/**< \brief (PEVC_CHMX)1 */
#define PEVC_CHMX_SMX_Pos				8				/**< \brief (PEVC_CHMX)ĳۑd */
#define PEVC_CHMX_SMX					(0x1u << PEVC_CHMX_SMX_Pos)
#define   PEVC_CHMX_SMX_0					(0x0u <<  8)	/**< \brief (PEVC_CHMX)ʰ޳ */
#define   PEVC_CHMX_SMX_1					(0x1u <<  8)	/**< \brief (PEVC_CHMX)ĳ */
#define PEVC_CHMX_MASK					0x0000013Fu		/**< \brief (PEVC_CHMX)MASKڼ޽ */

/* -------- PEVC_EVS : (PEVCψ:0x200) (R/W 32)EVSې^ -------- */
#define PEVC_EVS_OFFSET					0x200			/**< \brief (PEVC_EVSψ)ې^ */
#define PEVC_EVS_RESETVALUE				0x00000000		/**< \brief (PEVC_EVS reset_value)ې^ */

#define PEVC_EVS_EN_Pos					0				/**< \brief (PEVC_EVS)ې^틖 */
#define PEVC_EVS_EN						(0x1u << PEVC_EVS_EN_Pos)
#define   PEVC_EVS_EN_0						(0x0u <<  0)	/**< \brief (PEVC_EVS)Ȃ */
#define   PEVC_EVS_EN_1						(0x1u <<  0)	/**< \brief (PEVC_EVS)ې^틖 */
#define PEVC_EVS_IGFR_Pos				16				/**< \brief (PEVC_EVS)͕shg㏸ */
#define PEVC_EVS_IGFR					(0x1u << PEVC_EVS_IGFR_Pos)
#define   PEVC_EVS_IGFR_0					(0x0u << 16)	/**< \brief (PEVC_EVS)Ȃ */
#define   PEVC_EVS_IGFR_1					(0x1u << 16)	/**< \brief (PEVC_EVS)͕shg:ۓ͂ł̏㏸[No͂㏸ */
#define PEVC_EVS_IGFF_Pos				17				/**< \brief (PEVC_EVS)͕shg퉺~ */
#define PEVC_EVS_IGFF					(0x1u << PEVC_EVS_IGFF_Pos)
#define   PEVC_EVS_IGFF_0					(0x0u << 17)	/**< \brief (PEVC_EVS)Ȃ */
#define   PEVC_EVS_IGFF_1					(0x1u << 17)	/**< \brief (PEVC_EVS)͕shg:ۓ͂ł̉~[No͂㏸ */
#define PEVC_EVS_IGFON_Pos				18				/**< \brief (PEVC_EVS)͕shg㏸ */
#define PEVC_EVS_IGFON					(0x1u << PEVC_EVS_IGFON_Pos)
#define PEVC_EVS_MASK					0x00070001u		/**< \brief (PEVC_EVS)MASKڼ޽ */

/* -------- PEVC_IGFDR : (PEVCψ:0x300) (R/W 32)͕shg핪ڼ޽ -------- */
#define PEVC_IGFDR_OFFSET				0x300			/**< \brief (PEVC_IGFDRψ)͕shg핪ڼ޽ */
#define PEVC_IGFDR_RESETVALUE			0x00000000		/**< \brief (PEVC_IGFDR reset_value)͕shg핪ڼ޽ */

#define PEVC_IGFDR_IGFDR_Pos			0				/**< \brief (PEVC_IGFDR)͕shg핪ڼ޽ */
#define PEVC_IGFDR_IGFDR_Msk			(0xFu << PEVC_IGFDR_IGFDR_Pos)
#define PEVC_IGFDR_IGFDR(value)			((PEVC_IGFDR_IGFDR_Msk & ((value) << PEVC_IGFDR_IGFDR_Pos)))
#define PEVC_IGFDR_MASK					0x0000000Fu		/**< \brief (PEVC_IGFDR)MASKڼ޽ */

/* -------- PEVC_PARAMETER : (PEVCψ:0x3F8) (R/  32)Ұ ڼ޽ -------- */
#define PEVC_PARAMETER_OFFSET			0x3F8			/**< \brief (PEVC_PARAMETERψ)Ұ ڼ޽ */
#define PEVC_PARAMETER_RESETVALUE		0x14061824		/**< \brief (PEVC_PARAMETER reset_value)Ұ ڼ޽ */

#define PEVC_PARAMETER_IGF_COUNT_Pos	0				/**< \brief (PEVC_PARAMETER)͕shg퐔 */
#define PEVC_PARAMETER_IGF_COUNT_Msk	(0xFFu << PEVC_PARAMETER_IGF_COUNT_Pos)
#define PEVC_PARAMETER_IGF_COUNT(value)	((PEVC_PARAMETER_IGF_COUNT_Msk & ((value) << PEVC_PARAMETER_IGF_COUNT_Pos)))
#define PEVC_PARAMETER_EVS_COUNT_Pos	8				/**< \brief (PEVC_PARAMETER)ې^퐔 */
#define PEVC_PARAMETER_EVS_COUNT_Msk	(0xFFu << PEVC_PARAMETER_EVS_COUNT_Pos)
#define PEVC_PARAMETER_EVS_COUNT(value)	((PEVC_PARAMETER_EVS_COUNT_Msk & ((value) << PEVC_PARAMETER_EVS_COUNT_Pos)))
#define PEVC_PARAMETER_EVIN_Pos			16				/**< \brief (PEVC_PARAMETER)ۓ/ */
#define PEVC_PARAMETER_EVIN_Msk			(0xFFu << PEVC_PARAMETER_EVIN_Pos)
#define PEVC_PARAMETER_EVIN(value)		((PEVC_PARAMETER_EVIN_Msk & ((value) << PEVC_PARAMETER_EVIN_Pos)))
#define PEVC_PARAMETER_TRIGOUT_Pos		24				/**< \brief (PEVC_PARAMETER)No//gp */
#define PEVC_PARAMETER_TRIGOUT_Msk		(0xFFu << PEVC_PARAMETER_TRIGOUT_Pos)
#define PEVC_PARAMETER_TRIGOUT(value)	((PEVC_PARAMETER_TRIGOUT_Msk & ((value) << PEVC_PARAMETER_TRIGOUT_Pos)))
#define PEVC_PARAMETER_MASK				0xFFFFFFFFu		/**< \brief (PEVC_PARAMETER)MASKڼ޽ */

/* -------- PEVC_VERSION : (PEVCψ:0x3FC) (R/  32)ڼ޽ -------- */
#define PEVC_VERSION_OFFSET				0x3FC			/**< \brief (PEVC_VERSIONψ)ڼ޽ */
#define PEVC_VERSION_RESETVALUE			0x00000200		/**< \brief (PEVC_VERSION reset_value)ڼ޽ */

#define PEVC_VERSION_VERSION_Pos		0				/**< \brief (PEVC_VERSION)Ŕԍ */
#define PEVC_VERSION_VERSION_Msk		(0xFFFu << PEVC_VERSION_VERSION_Pos)
#define PEVC_VERSION_VERSION(value)		((PEVC_VERSION_VERSION_Msk & ((value) << PEVC_VERSION_VERSION_Pos)))
#define PEVC_VERSION_VARIANT_Pos		16				/**< \brief (PEVC_VERSION)ώԍ */
#define PEVC_VERSION_VARIANT_Msk		(0xFu << PEVC_VERSION_VARIANT_Pos)
#define PEVC_VERSION_VARIANT(value)		((PEVC_VERSION_VARIANT_Msk & ((value) << PEVC_VERSION_VARIANT_Pos)))
#define PEVC_VERSION_MASK				0x000F0FFFu		/**< \brief (PEVC_VERSION)MASKڼ޽ */

/** \brief PevcChmxʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RwReg   PEVC_CHMX;		/**< \brief (PEVCψ:0x000)ّd */
} PevcChmx;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief PevcEvsʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RwReg   PEVC_EVS;			/**< \brief (PEVCψ:0x000)ې^ */
} PevcEvs;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief PEVCʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  RoReg   PEVC_CHSR;		/**< \brief (PEVCψ:0x000)ُڼ޽ */
  WoReg   PEVC_CHER;		/**< \brief (PEVCψ:0x004)ًڼ޽ */
  WoReg   PEVC_CHDR;		/**< \brief (PEVCψ:0x008)ً֎~ڼ޽ */
  RoReg8  Reserved1[0x4];
  WoReg   PEVC_SEV;			/**< \brief (PEVCψ:0x010)ĳ */
  RoReg   PEVC_BUSY;		/**< \brief (PEVCψ:0x014)/gpZ */
  RoReg8  Reserved2[0x8];
  WoReg   PEVC_TRIER;		/**< \brief (PEVCψ:0x020)N荞ݎՕڼ޽ */
  WoReg   PEVC_TRIDR;		/**< \brief (PEVCψ:0x024)N荞ݎՕ֎~ڼ޽ */
  RoReg   PEVC_TRIMR;		/**< \brief (PEVCψ:0x028)N荞ݎՕڼ޽ */
  RoReg8  Reserved3[0x4];
  RoReg   PEVC_TRSR;		/**< \brief (PEVCψ:0x030)Nڼ޽ */
  WoReg   PEVC_TRSCR;		/**< \brief (PEVCψ:0x034)Nԉڼ޽ */
  RoReg8  Reserved4[0x8];
  WoReg   PEVC_OVIER;		/**< \brief (PEVCψ:0x040)ް݊荞ݎՕڼ޽ */
  WoReg   PEVC_OVIDR;		/**< \brief (PEVCψ:0x044)ް݊荞ݎՕ֎~ڼ޽ */
  RoReg   PEVC_OVIMR;		/**< \brief (PEVCψ:0x048)ް݊荞ݎՕڼ޽ */
  RoReg8  Reserved5[0x4];
  RoReg   PEVC_OVSR;		/**< \brief (PEVCψ:0x050)ްݏڼ޽ */
  WoReg   PEVC_OVSCR;		/**< \brief (PEVCψ:0x054)ްݏԉڼ޽ */
  RoReg8  Reserved6[0xA8];
  PevcChmx PEVC_CHMX[19];	/**< \brief (PEVCψ:0x100)PevcChmxQ [TRIGOUT_BITS] */
  RoReg8  Reserved7[0xB4];
  PevcEvs PEVC_EVS[31];		/**< \brief (PEVCψ:0x200)PevcEvsQ [EVIN_BITS] */
  RoReg8  Reserved8[0x84];
  RwReg   PEVC_IGFDR;		/**< \brief (PEVCψ:0x300)͕shg핪ڼ޽ */
  RoReg8  Reserved9[0xF4];
  RoReg   PEVC_PARAMETER;	/**< \brief (PEVCψ:0x3F8)Ұ ڼ޽ */
  RoReg   PEVC_VERSION;		/**< \brief (PEVCψ:0x3FC)ڼ޽ */
} Pevc;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_PEVC_COMPONENT_ */
