/**
 * \file
 *
 * \brief AVR,UC3,ARM{\pʓo߰Ļ޽ͯ ̧
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef IOPORT_H
#define IOPORT_H

#ifdef __cplusplus
extern "C" {
#endif

#include <parts.h>
#include <compiler.h>

/**
 * \defgroup ioport_group ʓo߰API
 *
 * \ref ioport_quickstart B
 *
 * MEGA,MEGA_RF,XMEGA,UC3,ARM޲ɓnWIȋKł̔ėpo(GPIO)
 * `ԐݒƐp̋ʓo߰ ޽łB
 *
 * ߰ ݐ亰ނ͊eՂɑ΂čœKA萔lŎgp鎞ɊȌō
 * ȎsԂ̗𐶐܂B
 *
 * \section dependencies ˑ
 * ײނ͈ȉ̒PʕɈˑ܂B
 * - \ref sysclk_group ۯxƋ@\ɑ΂
 * @{
 */

/**
 * \def IOPORT_CREATE_PIN(port, pin)
 * \brief o߰ ݔԍ쐬
 *
 * o߰ċ@\Ŏg߂̓o߰ ݔԍ쐬
 *
 * \param  port o߰(Ⴆ΁AI񂾊{\ɉPORTA,PA,܂PIOA)
 * \param  pin  o߰Ă̓o݂0wW
 */

/** \brief o߰ ݕ */
enum ioport_direction {
	IOPORT_DIR_INPUT,		/*!< o߰ē͕ */
	IOPORT_DIR_OUTPUT,		/*!< o߰ďo͕ */
};

/** \brief o߰  */
enum ioport_value {
	IOPORT_PIN_LEVEL_LOW,	/*!< o߰ ݒlLow */
	IOPORT_PIN_LEVEL_HIGH,	/*!< o߰ ݒlHigh */
};

#if MEGA_RF
/** \brief o߰Ē[m` */
enum ioport_sense {
	IOPORT_SENSE_LEVEL,     /*!< o߰ Lowيm  */
	IOPORT_SENSE_BOTHEDGES, /*!< o߰ ㏸Ɖ~̗[m */
	IOPORT_SENSE_FALLING,   /*!< o߰ ~[m */
	IOPORT_SENSE_RISING,    /*!< o߰ ㏸[m */
};
#elif SAM && !SAM4L
/** \brief o߰Ē[m` */
enum ioport_sense {
	IOPORT_SENSE_BOTHEDGES, /*!< o߰ ㏸Ɖ~̗[m */
	IOPORT_SENSE_FALLING,   /*!< o߰ ~[m */
	IOPORT_SENSE_RISING,    /*!< o߰ ㏸[m */
	IOPORT_SENSE_LEVEL_LOW, /*!< o߰ Lowيm  */
	IOPORT_SENSE_LEVEL_HIGH,/*!< o߰ Highيm  */
};
#else
enum ioport_sense {
	IOPORT_SENSE_BOTHEDGES, /*!< o߰ ㏸Ɖ~̗[m */
	IOPORT_SENSE_RISING,    /*!< o߰ ㏸[m */
	IOPORT_SENSE_FALLING,   /*!< o߰ ~[m */
};
#endif


#if XMEGA
# include "xmega/ioport.h"
# if defined(IOPORT_XMEGA_COMPAT)
#  include "xmega/ioport_compat.h"
# endif
#elif MEGA
#  include "mega/ioport.h"
#elif UC3
# include "uc3/ioport.h"
#elif SAM
# if SAM4L
#  include "sam/ioport_gpio.h"
# else
#  include "sam/ioport_pio.h"
# endif
#endif

/**
 * \brief o߰ ޽Agp
 *
 * ̊֐͓o߰ ޽ő̂ǂ̊֐gpOɌĂ΂Ȃ
 * Ȃ܂B
 */
static inline void ioport_init(void)
{
	arch_ioport_init();
}

/**
 * \brief \ref IOPORT_CREATE_PIN() ō쐬ꂽ݂ɊÂo߰ ݂
 *
 * \param  pin o߰ 
 */
static inline void ioport_enable_pin(ioport_pin_t pin)
{
	arch_ioport_enable_pin(pin);
}

/**
 * \brief Po߰Ăŕ݂
 *
 * \param  port o߰
 * \param  mask ߰ēł݂̎Օ
 */
static inline void ioport_enable_port(ioport_port_t port,
		ioport_port_mask_t mask)
{
	arch_ioport_enable_port(port, mask);
}

/**
 * \brief IOPORT_CREATE_PIN() ō쐬ꂽ݂ɊÂo߰ ݂֎~
 *
 * \param  pin ֎~o߰ 
 */
static inline void ioport_disable_pin(ioport_pin_t pin)
{
	arch_ioport_disable_pin(pin);
}

/**
 * \brief Po߰Ăŕ݂֎~
 *
 * \param  port ֎~o߰
 * \param  mask ֎~߰ēł݂̎Օ
 */
static inline void ioport_disable_port(ioport_port_t port,
		ioport_port_mask_t mask)
{
	arch_ioport_disable_port(port, mask);
}

/**
 * \brief Po߰Ăŕ݂̓`Ԃٱ߁A޳݂Ȃǂ̂悤Ȍ`Ԑݒɐݒ
 *
 * \param  port `Ԑݒ肷o߰
 * \param  mask `Ԑݒ肷݂ݎՕ
 * \param  mode w肵݂ɑ΂Č`Ԃ邽߂̓Օ(\ref oport_modes)
 */
static inline void ioport_set_port_mode(ioport_port_t port,
		ioport_port_mask_t mask, ioport_mode_t mode)
{
	arch_ioport_set_port_mode(port, mask, mode);
}

/**
 * \brief Po߰Ăɑ΂ݓ`Ԃݒ
 *
 * \param  pin  `Ԑݒ肷o߰
 * \param  mode w肵݂ɑ΂Č`Ԃ邽߂̓Օ(\ref oport_modes)
 */
static inline void ioport_set_pin_mode(ioport_pin_t pin, ioport_mode_t mode)
{
	arch_ioport_set_pin_mode(pin, mode);
}

/**
 * \brief w肵o߰Ăŕ݂̓`Ԃؾ
 *
 * \param  port `Ԑݒ肷o߰
 * \param  mask `Ԑݒ肪ؾĂ݂̎Օ
 */
static inline void ioport_reset_port_mode(ioport_port_t port,
		ioport_port_mask_t mask)
{
	arch_ioport_set_port_mode(port, mask, 0);
}

/**
 * \brief Po߰ ݂ɑ΂ݓ`Ԑݒؾ
 *
 * \param  pin `Ԑݒ肷o߰
 */
static inline void ioport_reset_pin_mode(ioport_pin_t pin)
{
	arch_ioport_set_pin_mode(pin, 0);
}

/**
 * \brief Po߰Ă݌Qɑ΂ēo͕ݒ
 *
 * \param  port `Ԑݒ肷o߰
 * \param  mask `Ԑݒ肷݂ݎՕ
 * \param  dir  w肵݂ɑ΂Đݒ肷(\ref ioport_direction)
 */
static inline void ioport_set_port_dir(ioport_port_t port,
		ioport_port_mask_t mask, enum ioport_direction dir)
{
	arch_ioport_set_port_dir(port, mask, dir);
}

/**
 * \brief Po߰Ăɑ΂ĕݒ
 *
 * \param  pin `Ԑݒ肷o߰
 * \param  dir w肵݂ɑ΂Đݒ肷(\ref ioport_direction)
 */
static inline void ioport_set_pin_dir(ioport_pin_t pin,
		enum ioport_direction dir)
{
	arch_ioport_set_pin_dir(pin, dir);
}

/**
 * \brief o߰Ăw肵_lɐݒ
 *
 * \param  pin   `Ԑݒ肷o߰
 * \param  level ݂̘_l
 */
static inline void ioport_set_pin_level(ioport_pin_t pin, bool level)
{
	arch_ioport_set_pin_level(pin, level);
}

/**
 * \brief P߰Ăœo߰ ݂̌Qw肵_lɐݒ
 * value.
 *
 * \param  port  o߰
 * \param  mask  ύX݂ݎՕ
 * \param  level ύX݂
 */
static inline void ioport_set_port_level(ioport_port_t port,
		ioport_port_mask_t mask, ioport_port_mask_t level)
{
	arch_ioport_set_port_level(port, mask, level);
}

/**
 * \brief ͂ƂČ`Ԑݒ肳ꂽo߰ ݂̌ݒn擾
 *
 * \param  pin ǂ܂o߰ 
 * \return w肵݂݂̘̌_l
 */
static inline bool ioport_get_pin_level(ioport_pin_t pin)
{
	return arch_ioport_get_pin_level(pin);
}

/**
 * \brief ͂ƂČ`Ԑݒ肳ꂽP߰Ăŏ̓o߰ ݂̌ݒn擾
 *
 * \param  port ǂ܂o߰
 * \param  mask ǂ܂݂ݎՕ
 * \return ՕƂĕԂAǂݍ߰Ă̎w肵݂̘_
 */
static inline ioport_port_mask_t ioport_get_port_level(ioport_pin_t port,
		ioport_port_mask_t mask)
{
	return arch_ioport_get_port_level(port, mask);
}

/**
 * \brief ȑOɏo͂ƂČ`Ԑݒ肳ꂽo߰Ă̒l(݂)؂ւ
 *
 * \param  pin ؂ւo߰ 
 */
static inline void ioport_toggle_pin_level(ioport_pin_t pin)
{
	arch_ioport_toggle_pin_level(pin);
}

/**
 * \brief P߰Ăɔzuꂽ̓o߰ ݂̒l(݂)؂ւ
 *
 * \param  port ύXo߰
 * \param  mask ؂ւ݂ݎՕ
 */
static inline void ioport_toggle_port_level(ioport_port_t port,
		ioport_port_mask_t mask)
{
	arch_ioport_toggle_port_level(port, mask);
}

/**
 * \brief Po߰ ݂݊m`Ԃݒ
 *
 * \param  pin       `Ԑݒ肳o߰ 
 * \param  pin_sense ݂ɑ΂Ċm[(\ref ioport_sense)
 */
static inline void ioport_set_pin_sense_mode(ioport_pin_t pin,
		enum ioport_sense pin_sense)
{
	arch_ioport_set_pin_sense_mode(pin, pin_sense);
}

/**
 * \brief P߰Ăŕo߰ ݂݊m`Ԃݒ
 *
 * \param  port      `Ԑݒ肷o߰
 * \param  mask      ݂̒[m`Ԑݒ肳邩ޯĎՕ
 * \param  pin_sense ݂ɑ΂Ċm[(\ref ioport_sense)
 */
static inline void ioport_set_port_sense_mode(ioport_port_t port,
		ioport_port_mask_t mask,
		enum ioport_sense pin_sense)
{
	arch_ioport_set_port_sense_mode(port, mask, pin_sense);
}

/**
 * \brief ݎʎq߰Ďʎqɕϊ
 *
 * \param  pin ϊo߰ ݎʎq
 * \retval ^ꂽݎʎqɑ΂߰Ďʎq
 */
static inline ioport_port_t ioport_pin_to_port_id(ioport_pin_t pin)
{
	return arch_ioport_pin_to_port_id(pin);
}

/**
 * \brief ݎʎq߰Ăŗ^ꂽ݂ɑ΂ޯĎՕɕϊ
 *
 * \param  pin ϊo߰ ݎʎq
 * \retval ߰Ăŗ^ݎʎqɑΉޯĐݒޯĎՕ
 */
static inline ioport_port_mask_t ioport_pin_to_mask(ioport_pin_t pin)
{
	return arch_ioport_pin_to_mask(pin);
}

/** @} */

/**
 * \page ioport_quickstart ʓo߰ ޽pJn̎
 *
 * ͎gpʂ̑Ił̻޽`Ԑݒ肵Ďgp@̒iKIȎw
 *  \ref ioport_group ɑ΂鑦Jn̎łB
 *
 * gpʂ͏̺ޒfЂ܂݂܂B\ݒpiKł̺ޒfЂ͓Ǝ
 * ɕʂ邱ƂłAgpiḰAႦ΁A剞p֐ɕʂ邱
 * ł܂B
 *
 * \section ioport_quickstart_basic {IȎgp
 * ̎gpʂł͖t͗p110݂LEDp1`Ԑݒ肵܂B̌
 * ɖt̏ԂǂłLEDɏo͂܂B
 *
 * \section ioport_quickstart_basic_setup \ݒiK
 *
 * \subsection ioport_quickstart_basic_setup_code ޗ
 * \code
 * #define MY_LED    IOPORT_CREATE_PIN(PORTA, 5)
 * #define MY_BUTTON IOPORT_CREATE_PIN(PORTA, 6)
 *
 * ioport_init();
 *
 * ioport_set_pin_dir(MY_LED, IOPORT_DIR_OUTPUT);
 * ioport_set_pin_dir(MY_BUTTON, IOPORT_DIR_INPUT);
 * ioport_set_pin_mode(MY_BUTTON, IOPORT_MODE_PULLUP);
 * \endcode
 *
 * \subsection ioport_quickstart_basic_setup_flow Ƃ̗
 * -# ėpo(GPIO)̼ٖ^邱ƂLpŁA 
 *    \ref IOPORT_CREATE_PIN ϸۂōsƂł܂BLEDp1Atp1
 *    `܂B
 *   - \code
 *     #define MY_LED    IOPORT_CREATE_PIN(PORTA, 5)
 *     #define MY_BUTTON IOPORT_CREATE_PIN(PORTA, 6)
 *     \endcode
 *   - \note \ref IOPORT_CREATE_PIN ϸۂƊ{\ԂňقȂ߰Ė̗Lp:
 *     - MEGA,MEGA_RF,XMEGA: ߰Ē`APORTA,PORTB,`Ƃ 
 *                           \ref IOPORT_CREATE_PIN ϸۂgpĂB
 *     - UC3: ޲ ͯ ̧قݒ`EĂ𒼐ڎĝł֗
 *            BႦ΁AAVR32_PIN_PB06
 *     - SAM: ޲ ͯ ̧قݒ`EĂ𒼐ڎĝł֗
 *            BႦ΁APIO_PA5_IDX<br>
 *            \ref IOPORT_CREATE_PIN PIOA,PIOB,`߰Ē`Ƃgp邱Ƃ
 *            ł܂B
 * -# oͻ޽܂B͈ʓIɕKvƂꍇɂ̓o͒P
 *    ʕ܂B
 *   - \code ioport_init(); \endcode
 * -# LEDėpo͂o͂ƂĐݒ
 *   - \code ioport_set_pin_dir(MY_LED, IOPORT_DIR_OUTPUT); \endcode
 * -# tėpo͂͂ƂĐݒ
 *   - \code ioport_set_pin_dir(MY_BUTTON, IOPORT_DIR_INPUT); \endcode
 * -# tėpo͂ɑ΂ٱ߂
 *   - \code ioport_set_pin_mode(MY_BUTTON, IOPORT_MODE_PULLUP); \endcode
 *
 * \section ioport_quickstart_basic_usage giK
 *
 * \subsection ioport_quickstart_basic_usage_code ޗ
 * \code
 * bool value;
 *
 * value = ioport_get_pin_level(MY_BUTTON);
 * ioport_set_pin_level(MY_LED, value);
 * \endcode
 *
 * \subsection ioport_quickstart_basic_usage_flow Ƃ̗
 * -# ԋLpްٕϐ`
 *   - \code bool value; \endcode
 * -# tقϐlɓǂݏo
 *   - \code value = ioport_get_pin_level(MY_BUTTON); \endcode
 * -# LEDt̓ǂݏolɐݒ
 *   - \code ioport_set_pin_level(MY_LED, value); \endcode
 *
 * \section ioport_quickstart_advanced xȎgp
 * - \subpage ioport_quickstart_use_case_1 : ߰ 
 */

/**
 * \page ioport_quickstart_use_case_1 ߰ sxȎgp
 *
 * ̏ꍇł1߰đŜ݂ǂݏoēǂ񂾒lʂ߰Ăɏ܂B
 *
 * \section ioport_quickstart_use_case_1_setup \ݒiK
 *
 * \subsection ioport_quickstart_use_case_1_setup_code ޗ
 * \code
 * #define IN_PORT  IOPORT_PORTA
 * #define OUT_PORT IOPORT_PORTB
 * #define MASK     0x00000060
 *
 * ioport_init();
 *
 * ioport_set_port_dir(IN_PORT, MASK, IOPORT_DIR_INPUT);
 * ioport_set_port_dir(OUT_PORT, MASK, IOPORT_DIR_OUTPUT);
 * \endcode
 *
 * \subsection ioport_quickstart_basic_setup_flow Ƃ̗
 * -# ߰ ٖ^邱ƂLpłB
 *   - \code
 *     #define IN_PORT  IOPORT_PORTA
 *     #define OUT_PORT IOPORT_PORTB
 *     \endcode
 *   - \note ߰Ė͊{\ԂňႢ܂B
 *     - MEGA_RF,MEGA,XMEGA: ߰ėpɍD܂閼OAIOPORT_PORTA,IOPORT_PORTB,`
 *                           ܂B
 *     - UC3: eI/O̎wWlA0,1,`gpĂB
 *     - SAM: ߰ėpɍD܂閼OAIOPORT_PIOA,IOPORT_PIOB,`܂B
 * -# ȉƋɓ߂ޯėp̎Օ`邱ƂLpłB
 *     - \code #define MASK     0x00000060 \endcode
 * -# o߰ ޽܂B͈ʓIɕKvƂꍇɓo͒P
 *    ʕ܂B
 *   - \code ioport_init(); \endcode
 * -# Set one of the ports as input:
 *   - \code ioport_set_pin_dir(IN_PORT, MASK, IOPORT_DIR_INPUT); \endcode
 * -# Set the other port as output:
 *   - \code ioport_set_pin_dir(OUT_PORT, MASK, IOPORT_DIR_OUTPUT); \endcode
 *
 * \section ioport_quickstart_basic_usage giK
 *
 * \subsection ioport_quickstart_basic_usage_code ޗ
 * \code
 * ioport_port_mask_t value;
 *
 * value = ioport_get_port_level(IN_PORT, MASK);
 * ioport_set_port_level(OUT_PORT, MASK, value);
 * \endcode
 *
 * \subsection ioport_quickstart_basic_usage_flow Ƃ̗
 * -# ߰ĒlLpɕϐ`
 *   - \code ioport_port_mask_t value; \endcode
 * -# 1߰Ăǂݏo
 *   - \code value = ioport_get_port_level(IN_PORT, MASK); \endcode
 * -# ǂްo͂𑼂߰Ăɏo
 *   - \code ioport_set_port_level(OUT_PORT, MASK, value); \endcode
 */

#ifdef __cplusplus
}
#endif

#endif /* IOPORT_H */
