/**
 * \file
 *
 * \brief sؐײ
 *
 * 쌠 (c) 2010-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef NVM_H
#define NVM_H

#include <compiler.h>
#include <ccp.h>

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \defgroup nvm_group NVMײ
 *
 * \ref xmega_nvm_quickstart B
 *
 * \brief AVR XMEGAsؐ(NVM)pײގ
 *
 * XMEGA NVMXMEGA޲̓s؂̪܂B۸ 
 * ؁AEEPROMA[͂̒PʕɂĲ̪邱Ƃł܂B葽
 * ɂĂ͊e⏕Pʕ̎B
 *
 * \note GCCׯ⏕PʕgpꍇAmakȩقްė̈`Ԑݒ肷邱
 *       ƂĒuĂB⏕Pʕł葽̏B
 *
 * \section xmega_nvm_quickstart_section Jn̎
 * \ref xmega_nvm_quickstart B
 */

/**
 * \defgroup nvm_generic_group NVMײވʓIPʕ̈
 * \ingroup nvm_group
 * \brief NVMײޗpx֐
 *
 * ̊֐ \ref nvm_group "NVMײ" ̊֐ɑ΂ߊ֐łB
 *
 * @{
 */

/**
 * \brief ꂩNVMIҋ@
 *
 * ̊֐͉ꂩNVMWďI҂܂Bꂩ̈ȑȎ삪
 * Ă邱ƂmłȂꍇAꂩNVMOɂ̊֐gpĂ
 * B
 */
static inline void nvm_wait_until_ready( void )
{
	do {
		// NVM҂ԁAs~
	} while ((NVM.STATUS & NVM_NVMBUSY_bm) == NVM_NVMBUSY_bm);
}

/**
 * \brief s؎sw
 *
 * ̊֐NVM.CTRLڼ޽CMDEXޯĂݒ肷OCCPڼ޽ݒ肵܂B
 *
 * \note ̊֐ĂԑOɐNVMw߂NVM.CMDڼ޽ɐݒ肳Ȃ΂Ȃ
 *       B
 */
static inline void nvm_exec(void)
{
	ccp_write_io((uint8_t *)&NVM.CTRLA, NVM_CMDEX_bm);
}

/**
 * \brief s؎sww
 *
 * ̊֐NVM.CMDڼ޽Ɏw߂ݒ肵ǍNVM.CTRLAڼ޽CMDEXޯĂ
 * ƂɂĎsw߂s܂B
 *
 * \note ֐NVM.CMDڼ޽ۑĕ܂Å֐荞݂Ă΂
 *       ꍇÅ֐Ă΂OɊ荞݂֎~Ȃ΂Ȃ܂B
 *
 * \param  nvm_command sNVMw
 */
static inline void nvm_issue_command(NVM_CMD_t nvm_command)
{
	uint8_t old_cmd;

	old_cmd = NVM.CMD;
	NVM.CMD = nvm_command;
	ccp_write_io((uint8_t *)&NVM.CTRLA, NVM_CMDEX_bm);
	NVM.CMD = old_cmd;
}

/**
 * \brief LDI߂p1޲ēǂݍ
 * \internal
 *
 * ̊֐͎w肳NVM.CMDݒ肵ALPM߂Ŏw肷޲ ڽp1޲
 * Ăǂ݂܂BNVM.CMD͎gpɕ܂B
 *
 * \note ۸ /NVM킪荞ݏٰ݂籸ꍇÅ֐
 *       点OɊ荞݂֎~ׂłB
 *
 * \param  nvm_cmd LPMsOɐݒ肷NVMw
 * \param  address [޲ĕψ(̾)
 */
uint8_t nvm_read_byte(uint8_t nvm_cmd, uint16_t address);


/**
 * \brief SPMݎs
 * \internal
 *
 * ̊֐͎w肷NVM.CMDݒ肵CCPݒ肵Ǎׯɏ߂SPM
 * ߂𑖂点܂B
 *
 * \note ۸ /NVM킪荞ݏٰ݂籸ꍇÅ֐
 *       点OɊ荞݂֎~ׂłB
 *
 * \param  addr    SPMŎsڽ
 * \param  nvm_cmd NVM.CMDڼ޽ŎgpNVMw
 */
void nvm_common_spm(uint32_t addr, uint8_t nvm_cmd);

//! @}

/**
 * \defgroup nvm_signature_group NVMײގ[̈
 * \ingroup nvm_group
 * \brief [̈
 *
 * [߂̊֐Bȉx܂B
 * - iƎ[񂩂̒lǂݍ
 * - ޲IDǂݍ
 * - ޲ǂݍ
 * - ޲ʔԓǂݍ
 *
 * \note ̊֐̂NVM.CMDڼ޽ύX܂Bp荞݂۸
 *       ыԱ(IAR EWł__flashʒuwq܂GCCłpgm_read_byte)g
 *       pꍇAEEPROM֐𑖂点鎞Ɋ荞݂֎~邱ƂKv
 *       łBȂ΁A۸ыԓǂݍ݂͕sɂ܂Beʊ֐
 *       ΂鎑B
 * \note ֐͊ɐms蓾āÂɐmsԊ荞݂W邽߁A荞ݏ
 *       ٰ(ISR)ł̒Pʕ̊֐gpȂłBĂ̒Pʕ
 *       ̊֐ISR̊OŎgpiŝǂEEPROMsɂA߰
 *       ɏՕύX܂B
 * @{
 */

/**
 * \brief ޲ID܂ލ\
 *
 * ̍\̂޲޲IDi[̂Ɏgp邱Ƃł܂B
 */
struct nvm_device_id {
	union {
		struct {
			uint8_t devid0;
			uint8_t devid1;
			uint8_t devid2;
		};
		uint8_t byte[3];
	};
};

/**
 * \brief ޲ʔԂ܂ލ\
 *
 * ̍\̂޲̒ʔԂi[̂Ɏgp邱Ƃł܂B
 */
struct nvm_device_serial {
	union {
		struct {
			uint8_t lotnum0;
			uint8_t lotnum1;
			uint8_t lotnum2;
			uint8_t lotnum3;
			uint8_t lotnum4;
			uint8_t lotnum5;
			uint8_t wafnum;
			uint8_t coordx0;
			uint8_t coordx1;
			uint8_t coordy0;
			uint8_t coordy1;
		};
		uint8_t byte[11];
	};
};

/**
 * \brief i[̍Z޲Ă̕ψ(̾)𓾂܂B
 *
 * \param  regname i[ڼ޽̖O
 * \retval i[ڼ޽̕ψ
 */
#if defined(__GNUC__)
# define nvm_get_production_signature_row_offset(regname) \
		offsetof(NVM_PROD_SIGNATURES_t, regname)
#elif defined(__ICCAVR__)
# define nvm_get_production_signature_row_offset(regname) (regname##_offset)
#else
#  error Unknown compiler
#endif

/**
 * \brief i[񂩂1޲ēǂݍ
 *
 * ̊֐͗^ꂽڽ޲̐i[񂩂1޲Ăǂ݂܂B
 *
 * \note ̊֐NVM.CMDڼ޽ύX܂Bp荞݂۸ыԱ(IAR
 *        EWł__flashʒuwq܂GCCłpgm_read_byte)gpꍇAEEPR
 *       OM֐𑖂点鎞Ɋ荞݂֎~邱ƂKvłBȂ
 *       ΁A۸ыԓǂݍ݂͕sɂ܂B
 *
 * \param  address [޲ĕψ(̾)
 */
static inline uint8_t nvm_read_production_signature_row(uint8_t address)
{
	return nvm_read_byte(NVM_CMD_READ_CALIB_ROW_gc, address);
}

/**
 * \brief gpҎ[񂩂1޲ēǂݍ
 *
 * ̊֐͗^ꂽڽ޲̎gpҎ[񂩂1޲Ăǂ݂܂B
 *
 * \note ̊֐NVM.CMDڼ޽ύX܂Bp荞݂۸ыԱ(IAR
 *        EWł__flashʒuwq܂GCCłpgm_read_byte)gpꍇAEEPR
 *       OM֐𑖂点鎞Ɋ荞݂֎~邱ƂKvłBȂ
 *       ΁A۸ыԓǂݍ݂͕sɂ܂B
 *
 * \param  address [޲ĕψ(̾)
 */
static inline uint8_t nvm_read_user_signature_row(uint16_t address)
{
	return nvm_read_byte(NVM_CMD_READ_USER_SIG_ROW_gc, address);
}

/**
 * \brief ޲IDǂݍ
 *
 * ̊֐޲Ɋi[ꂽ޲IDԂ܂B
 *
 * \retval storage ޲IDi[\̂ւ̈ʒuwq
 */
static inline void nvm_read_device_id(struct nvm_device_id *storage)
{
	storage->devid0 = MCU.DEVID0;
	storage->devid1 = MCU.DEVID1;
	storage->devid2 = MCU.DEVID2;
}

/**
 * \brief ޲ǂݍ
 *
 * ̊֐޲Ɋi[ꂽ޲Ԃ܂B
 *
 * \retval ݂޲Ȃ8ޯĒl
 */
static inline uint8_t nvm_read_device_rev(void)
{
	return MCU.REVID;
}

void nvm_read_device_serial(struct nvm_device_serial *storage);

//! @}


/**
 * \defgroup nvm_eeprom_group NVMײEEPROM̈
 * \ingroup nvm_group
 * \brief EEPROM߂̊֐
 *
 * EEPROM͓d͂苎ꂽɎްi[̂Ɏgp邱Ƃ
 * ܂B͈ʓIɍZްApԁAÍA܂͓d͂苎ꂽ
 * ɕی삳邱ƂKvȑްɎgp邱Ƃł܂B
 *
 * ̒Pʕ̊֐EEPROM𑀍삷̂I/Oڼ޽ gp܂B
 *
 * \note ̊֐NVM.CMDڼ޽ύX܂Bp荞݂۸ыԱ(IAR
 *        EWł__flashʒuwq܂GCCłpgm_read_byte)gpꍇAEEPR
 *       OM֐𑖂点鎞Ɋ荞݂֎~邱ƂKvłBȂ
 *       ΁A۸ыԓǂݍ݂͕sɂ܂B
 * @{
 */

#ifndef EEPROM_PAGE_SIZE
#  if XMEGA_A || XMEGA_AU || XMEGA_B || XMEGA_C || XMEGA_D || XMEGA_E
#    define EEPROM_PAGE_SIZE 32
#  else
#    error Unknown EEPROM page size
#  endif
#endif

#ifndef CONFIG_NVM_IGNORE_XMEGA_A3_D3_REVB_ERRATA
#  if XMEGA_A3 || XMEGA_D3
#    error This NVM driver does not support rev B of XMEGA A3/D3 devices. \
     Set CONFIG_NVM_IGNORE_XMEGA_A3_D3_REVB_ERRATA to disable this message
#  endif
#endif

/**
 * EEPROM ڽێް^
 */
typedef uint16_t eeprom_addr_t;


/*! \brief ްԂւEEPROM蓖ċ
 *
 *  ϸۂްԓEEPROM̊蓖Ă܂BEEPROMް ؓ
 *  EEPROM_STARTŎn܂܂Bǂݍݱ͒ʏSRAMƓlɍsƂ
 *  ܂B
 *
 *  \note ̊֐EEPROMɑ΂I/O蓖ı֎~܂A߰ޏƏ
 *        ݑ͖I/Oڼ޽ʂčsƂKvłB
 */
static inline void eeprom_enable_mapping(void)
{
#if !XMEGA_E
	NVM_CTRLB = NVM_CTRLB | NVM_EEMAPEN_bm;
#endif
}


/*! \brief ްԂւEEPORM蓖Ă֎~
 *
 *  ϸۂްԂւEEPROM̊蓖Ă֎~܂BI/O蓖ı
 *  ܂B
 */
static inline void eeprom_disable_mapping(void)
{
#if !XMEGA_E
	NVM_CTRLB = NVM_CTRLB & ~NVM_EEMAPEN_bm;
#endif
}

uint8_t nvm_eeprom_read_byte(eeprom_addr_t addr);
void nvm_eeprom_write_byte(eeprom_addr_t address, uint8_t value);
void nvm_eeprom_read_buffer(eeprom_addr_t address, void *buf, uint16_t len);
void nvm_eeprom_erase_and_write_buffer(eeprom_addr_t address, const void *buf, uint16_t len);

void nvm_eeprom_flush_buffer(void);
void nvm_eeprom_load_byte_to_buffer(uint8_t byte_addr, uint8_t value);
void nvm_eeprom_load_page_to_buffer(const uint8_t *values);
void nvm_eeprom_atomic_write_page(uint8_t page_addr);
void nvm_eeprom_split_write_page(uint8_t page_addr);
void nvm_eeprom_fill_buffer_with_value(uint8_t value);
void nvm_eeprom_erase_bytes_in_page(uint8_t page_addr);
void nvm_eeprom_erase_page(uint8_t page_addr);
void nvm_eeprom_erase_bytes_in_all_pages(void);
void nvm_eeprom_erase_all(void);

//! @}

/**
 * \defgroup nvm_flash_group NVMײ ׯ̈
 * \ingroup nvm_group
 * \brief ׯ ؂߂̊֐
 *
 * XMEGA޲̓ׯ ؂͉p̈Ap\̈Aް۰ޗ̈悩琬܂B
 * SĂ̗̈MCUp۸ ނi[邱Ƃł܂Ap\
 * ԂȂA͑̎ްi[̂Ɏgp邱Ƃł܂B
 *
 * ׯ ؏݂1x1߰ނsƂł܂B͓߰ފɏՕ
 * ްݒ肵Ă̌ɏݎw߂1𓮂Ƃ琬܂B߰ނ
 * OɏĂȂꍇAް͐Ȃł傤B
 *
 * ׯ ؂ɏƂł邽߂ɂ́Aްė̈悩瓮ݎw߂Kv
 * B
 * - IARgpAݶ ĂɂĎIɏ܂B
 * - GCCgpAҰ ̧قŎ蓮Ŏw肳邱ƂKvłBႦ΁A
 *   ATxmega128A1͌ڽ0x10000łްė̈AΉ޲ ڽ0x20000
 *   config.mkҰ ̧قɒǉ邱ƂKvłB
 *   LDFLAGS += -Wl,--section-start=.BOOT=0x20000
 *   ޲ɑ΂鐳ڽɂĂ޲ްĂB
 *
 * \note GCCׯ⏕PʕgpꍇAҰ ̧قްė̈`Ԑݒ肷邱
 *       ƂĒuĂB
 *
 * \note ̒Pʕ̊֐NVM.CMDڼ޽ύX܂Bp荞݂۸
 *       Ա(IAR EWł__flashʒuwq܂GCCłpgm_read_byte)gp
 *       ꍇAEEPROM֐𑖂点鎞Ɋ荞݂֎~邱ƂKv
 *       BȂ΁A۸ыԓǂݍ݂͕sɂ܂B
 * @{
 */

/**
 * \brief ޲Ăłׯ ߰ނ̑傫
 *
 * ° ͯ ̧ق޲Ăł߰ނ̑傫
 *
 * \note ߰ނ̑傫IARͯ ̧ق猻ݎĂÂɂꂪC
 *       ܂ײނŒ`邱ƂKvłB
 */
#ifdef __DOXYGEN__
#  define FLASH_SIZE
#  define FLASH_PAGE_SIZE
#else

// 8K޲ ޲
#  if AVR8_PART_IS_DEFINED(ATxmega8E5)
#    define FLASH_SIZE      (8*1024L)
#    define FLASH_PAGE_SIZE (128)

// 16K޲ ޲
#  elif AVR8_PART_IS_DEFINED(ATxmega16A4)            | \
		AVR8_PART_IS_DEFINED(ATxmega16A4U) | \
		AVR8_PART_IS_DEFINED(ATxmega16D4)  | \
		AVR8_PART_IS_DEFINED(ATxmega16C4)
#    define FLASH_SIZE      (16*1024L)
#    define FLASH_PAGE_SIZE (256)

#  elif AVR8_PART_IS_DEFINED(ATxmega16E5)
#    define FLASH_SIZE      (16*1024L)
#    define FLASH_PAGE_SIZE (128)

// 32K޲ ޲
#  elif AVR8_PART_IS_DEFINED(ATxmega32A4)          | \
		AVR8_PART_IS_DEFINED(ATxmega32A4U) | \
		AVR8_PART_IS_DEFINED(ATxmega32D4)  | \
		AVR8_PART_IS_DEFINED(ATxmega32C4)
#    define FLASH_SIZE      (32*1024L)
#    define FLASH_PAGE_SIZE (256)

#  elif AVR8_PART_IS_DEFINED(ATxmega32E5)
#    define FLASH_SIZE      (32*1024L)
#    define FLASH_PAGE_SIZE (128)

// 64K޲ ޲
#  elif AVR8_PART_IS_DEFINED(ATxmega64A1)          | \
		AVR8_PART_IS_DEFINED(ATxmega64A1U) | \
		AVR8_PART_IS_DEFINED(ATxmega64A3)  | \
		AVR8_PART_IS_DEFINED(ATxmega64A3U) | \
		AVR8_PART_IS_DEFINED(ATxmega64A4U) | \
		AVR8_PART_IS_DEFINED(ATxmega64B1)  | \
		AVR8_PART_IS_DEFINED(ATxmega64B3)  | \
		AVR8_PART_IS_DEFINED(ATxmega64C3)  | \
		AVR8_PART_IS_DEFINED(ATxmega64D3)  | \
		AVR8_PART_IS_DEFINED(ATxmega64D4)
#    define FLASH_SIZE      (64*1024L)
#    define FLASH_PAGE_SIZE (256)

// 128K޲ ޲
#  elif AVR8_PART_IS_DEFINED(ATxmega128A1)          | \
		AVR8_PART_IS_DEFINED(ATxmega128A1U) | \
		AVR8_PART_IS_DEFINED(ATxmega128A3)  | \
		AVR8_PART_IS_DEFINED(ATxmega128A3U) | \
		AVR8_PART_IS_DEFINED(ATxmega128C3) | \
		AVR8_PART_IS_DEFINED(ATxmega128D3)  | \
		AVR8_PART_IS_DEFINED(ATxmega128D4)
#    define FLASH_SIZE      (128*1024L)
#    define FLASH_PAGE_SIZE (512)

#  elif AVR8_PART_IS_DEFINED(ATxmega128A4U)         | \
		AVR8_PART_IS_DEFINED(ATxmega128B1)  | \
		AVR8_PART_IS_DEFINED(ATxmega128B3)
#    define FLASH_SIZE      (128*1024L)
#    define FLASH_PAGE_SIZE (256)

// 192K޲ ޲
#  elif AVR8_PART_IS_DEFINED(ATxmega192A3U) | \
		AVR8_PART_IS_DEFINED(ATxmega192C3)  | \
		AVR8_PART_IS_DEFINED(ATxmega192D3)
#    define FLASH_SIZE      (192*1024L)
#    define FLASH_PAGE_SIZE (512)

// 256K޲ ޲
#  elif AVR8_PART_IS_DEFINED(ATxmega256A3)           | \
		AVR8_PART_IS_DEFINED(ATxmega256A3U)  | \
		AVR8_PART_IS_DEFINED(ATxmega256A3B)  | \
		AVR8_PART_IS_DEFINED(ATxmega256A3BU) | \
		AVR8_PART_IS_DEFINED(ATxmega256C3)   | \
		AVR8_PART_IS_DEFINED(ATxmega256D3)
#    define FLASH_SIZE      (256*1024L)
#    define FLASH_PAGE_SIZE (512)

// 384K޲ ޲
#  elif AVR8_PART_IS_DEFINED(ATxmega384C3)
#    define FLASH_SIZE      (384*1024L)
#    define FLASH_PAGE_SIZE (512)
#  elif AVR8_PART_IS_DEFINED(ATxmega384D3)
#    define FLASH_SIZE      (384*1024L)
#    define FLASH_PAGE_SIZE (512)
#  else
#    error Flash page size needs to be defined.
#  endif
#endif

/**
 * ׯ  ڽێް^
 *
 */
#if (FLASH_SIZE >= 0x10000UL)	// :4KBׯ64KBׯXMEGA
typedef uint32_t flash_addr_t;
#else
typedef uint16_t flash_addr_t;
#endif

/**
 * IARׯ ؂𱸾̂Ɏgpׯ ߲^
 */
#if (FLASH_SIZE >= 0x10000UL)	// :4KBׯ64KBׯXMEGA
#  define IAR_FLASH_PTR __farflash
#else
#  define IAR_FLASH_PTR __flash
#endif

/**
 * \brief ׯ ؂޲Ă擾
 *
 * ޲ ڽwpׯ1޲Ă擾BIAR__flashʒuwqAGCC
 * ׯ ؂ް擾pgm_read_byte_xx֐܂B̊֐ͺ߲
 * ׊Ԃ̌݊̂߂Ɏgp܂B
 *
 * \param  addr 擾޲ ڽ
 * \return ۸ ؂޲
 */
static inline uint8_t nvm_flash_read_byte(flash_addr_t addr)
{
#if defined(__GNUC__)
	return pgm_read_byte_far(addr);
#elif defined(__ICCAVR__)
	uint8_t IAR_FLASH_PTR *flashptr = (uint8_t IAR_FLASH_PTR *)addr;
	return *flashptr;
#else
#  error Unknown compiler
#endif
}

/**
 * \brief ׯ ؂擾
 *
 * ޲ ڽwpׯ1擾BIAR__flashʒuwqAGCC
 * ׯ ؂ް擾pgm_read_byte_xx֐܂B̊֐ͺ߲׊
 * ̌݊̂߂Ɏgp܂B
 *
 * \param  addr 擾޲ ڽ(ŉޯĂ͖܂B)
 * \return ۸ ؂̌
 */
static inline uint16_t nvm_flash_read_word(flash_addr_t addr)
{
#if defined(__GNUC__)
	return pgm_read_word_far(addr);
#elif defined(__ICCAVR__)
	uint16_t IAR_FLASH_PTR *flashptr = (uint16_t IAR_FLASH_PTR *)addr;
	return *flashptr;
#endif
}

/**
 * \brief ׯ ߰ފɏՕj
 *
 * ׯpNVM߰ފɏՕ܂B͊ɏՕɉĂ
 * ꍇ \ref nvm_flash_load_word_to_buffer gpOɌĂ΂邱ƂKv
 * łB
 *
 */
static inline void nvm_flash_flush_buffer(void)
{
	nvm_wait_until_ready();
	nvm_common_spm(0, NVM_CMD_ERASE_FLASH_BUFFER_gc);
}

/**
 * \brief ׯ ߰ފɏՕɌݒ
 *
 * ׯpNVM߰ފɏՕɌݒ肵܂BɏՕɉĂȂ
 * ꍇÅ֐ĂԑO \ref nvm_flash_flush_bufferĂ΂Ȃ΂Ȃ܂
 * B
 *
 * \param  word_addr ްi[ڽB߰ނ̑傫𒴂ʑޯĂ͖
 *                   ܂B \ref FLASH_PAGE_SIZE
 * \param  data      ߰ފɏՕɐݒ肳ް
 */
void nvm_flash_load_word_to_buffer(uint32_t word_addr, uint16_t data);

/**
 * \brief p̈Ŝ
 *
 * p̈̑SĂ܂B
 */
static inline void nvm_flash_erase_app(void)
{
	nvm_wait_until_ready();
	nvm_common_spm(0, NVM_CMD_ERASE_APP_gc);
}

/**
 * \brief p̈߰ނ
 *
 * p̈1߰ނ܂B
 *
 * \param  page_addr 폜߰ނ޲ ڽ
 */
static inline void nvm_flash_erase_app_page(flash_addr_t page_addr)
{
	nvm_wait_until_ready();
	nvm_common_spm(page_addr, NVM_CMD_ERASE_APP_PAGE_gc);
}

/**
 * \brief p̈߰ޏ
 *
 * ߰ފɏՕɊi[ꂽްp̈߰ނɏ܂Bް̉
 * 邽߂ɏO߰ނ邱ƂKvłB
 *
 * \param  page_addr ߰ނ޲ ڽ
 */
static inline void nvm_flash_split_write_app_page(flash_addr_t page_addr)
{
	nvm_wait_until_ready();
	nvm_common_spm(page_addr, NVM_CMD_WRITE_APP_PAGE_gc);
}

/**
 * \brief p̈߰ނď
 *
 * p̈߰ނ߰ފɏՕɊi[ꂽް܂BƏ
 * ݂͔񕪒fōs܂B
 *
 * \param  page_addr Ͱނ޲ ڽ
 */
static inline void nvm_flash_atomic_write_app_page(flash_addr_t page_addr)
{
	nvm_wait_until_ready();
	nvm_common_spm(page_addr, NVM_CMD_ERASE_WRITE_APP_PAGE_gc);
}

void nvm_issue_flash_range_crc(flash_addr_t start_addr, flash_addr_t end_addr);

void nvm_flash_read_buffer(flash_addr_t address, void *buf, uint16_t len);

void nvm_flash_erase_and_write_buffer(flash_addr_t address, const void *buf,
	uint16_t len, bool b_blank_check);

/**
 * \brief ްė̈߰ނ
 *
 * ްė̈1߰ނ܂B
 *
 * \param  page_addr 폜߰ނ޲ ڽ
 */
static inline void nvm_flash_erase_boot_page(flash_addr_t page_addr)
{
	nvm_wait_until_ready();
	nvm_common_spm(page_addr, NVM_CMD_ERASE_BOOT_PAGE_gc);
}

/**
 * \brief ްė̈߰ޏ
 *
 * ߰ފɏՕɊi[ްްė̈߰ނɏ܂Bް̉
 * 邽߂ɏO߰ނ邱ƂKvłB
 *
 * \param  page_addr ߰ނ޲ ڽ
 */
static inline void nvm_flash_split_write_boot_page(flash_addr_t page_addr)
{
	nvm_wait_until_ready();
	nvm_common_spm(page_addr, NVM_CMD_WRITE_BOOT_PAGE_gc);
}

/**
 * \brief ްė̈߰ނď
 *
 * ްė̈߰ނ߰ފɏՕɊi[ꂽް܂FBƏ
 * ݂͔񕪒fōsȂ΂Ȃ܂B
 *
 * \param  page_addr ߰ނ޲ ڽ
 */
static inline void nvm_flash_atomic_write_boot_page(flash_addr_t page_addr)
{
	nvm_wait_until_ready();
	nvm_common_spm(page_addr, NVM_CMD_ERASE_WRITE_BOOT_PAGE_gc);
}

void nvm_user_sig_read_buffer(flash_addr_t address, void *buf, uint16_t len);
void nvm_user_sig_write_buffer(flash_addr_t address, const void *buf,
	uint16_t len, bool b_blank_check);

/**
 * \brief gpҍZ̈߰ނ
 *
 * gpҍZ̈߰ނ܂B1߰ނÂҰ͑SKv
 * Ƃ܂B
 */
static inline void nvm_flash_erase_user_section(void)
{
	nvm_wait_until_ready();
	nvm_common_spm(0, NVM_CMD_ERASE_USER_SIG_ROW_gc);
}

/**
 * \brief gpҍZ̈߰ޏ
 *
 * ߰ފɏՕɊi[ꂽްgpҍZ̈߰ɏ܂Bް̉
 * 邽߂ɏO߰ނ邱ƂKvłB1߰ނA
 * ̂Ұ͑SKvƂ܂B
 */
static inline void nvm_flash_write_user_page(void)
{
	nvm_wait_until_ready();
	nvm_common_spm(0, NVM_CMD_WRITE_USER_SIG_ROW_gc);
}

//! @}

/**
 * \defgroup nvm_fuse_lock_group NVMײ ˭ނƎ{ޯĂ̈
 * \ingroup nvm_group
 * \brief ˭ޓǂݍ݂Ǝ{ޯďݗp̊֐
 *
 * ˭ނ͏dvȼы@\ݒ肷̂ɎgpAOݲ̪炾
 * Ƃł܂Bpĳ˭ނǂނƂł܂B˭ނ͒do
 * Ⳬޯނ̂悤ؾČ̌`ԐݒAn`ԐݒAJTAGJTAGgpID
 * gp܂B
 *
 * {ޯĂ͊eׯ̈ł̕یقݒ肷̂Ɏgp܂B͊e
 * ׯ̈ł̓ǂ݂/܂͏ĥɎgp܂B{ޯĂ͂ƕی
 * قɐݒ肷邽߂ɊO݊Ɖpĳ珑Ƃł܂A
 * یقɂȂ悤ɐݒł܂Bߏ͎{ޯĂB
 * ̕@łB{ޯĂׯ ؂̎c肪ꂽŏ܂B۸
 * ˭ނ{ޯĂ1̒lA۸тɂꂽ˭ނ{ޯĂ0̒l
 * ܂B˭ނƎ{ޯĂ̗ׯ ۸ ؂̂悤ɍď݉\
 * B
 *
 * \note ̒Pʕ̊֐NVM.CMDڼ޽ύX܂Bp荞݂۸
 *       Ա(IAR EWł__flashʒuwq܂GCCłpgm_read_byte)gp
 *       ꍇAEEPROM֐𑖂点鎞Ɋ荞݂֎~邱ƂKv
 *       BȂ΁A۸ыԓǂݍ݂͕sɂ܂B
 * @{
 */

// e˭ ޲
enum fuse_byte_t {
	FUSEBYTE0 = 0,
	FUSEBYTE1 = 1,
	FUSEBYTE2 = 2,
	FUSEBYTE3 = 3,	// ݂޲ł͖gp
	FUSEBYTE4 = 4,
	FUSEBYTE5 = 5,
};

uint8_t nvm_fuses_read(enum fuse_byte_t fuse);

/**
 * \brief {ޯď
 *
 * {ޯĂ^ꂽlɏ܂B{ޯĂ͈ȑOɏꂽƈS
 * ݒɏƂł܂B{ޯĂɂׯsȂ
 * ΂Ȃ܂B
 *
 * \param  blbb_lock  ް۰ޗ̈{ޯ
 * \param  blba_lock  p̈{ޯ
 * \param  blbat_lock p\̈{ޯ
 * \param  lb_lock    ׯ/EEPROM{ޯ
 */
static inline void nvm_lock_bits_write(enum NVM_BLBB_enum blbb_lock,
	enum NVM_BLBA_enum blba_lock, enum NVM_BLBAT_enum blbat_lock,
	enum NVM_LB_enum lb_lock)
{
	nvm_wait_until_ready();
	NVM.DATA0 = (uint8_t)blbb_lock | (uint8_t)blba_lock | (uint8_t)blbat_lock |
		(uint8_t)lb_lock;
	nvm_issue_command(NVM_CMD_WRITE_LOCK_BITS_gc);
}

/**
 * \brief BLBB{ޯď
 *
 * ް۰ޗ̈p{ޯ(BLBB)܂B̎{ޯ(BLBA,BLBAT,LB)͕ς
 * ܂(A{Ȃɏ܂)B
 *
 * \param  blbb_lock ް۰ޗ̈{ޯ
 */
static inline void nvm_blbb_lock_bits_write(enum NVM_BLBB_enum blbb_lock)
{
	nvm_lock_bits_write(blbb_lock, NVM_BLBA_NOLOCK_gc, NVM_BLBAT_NOLOCK_gc,
		NVM_LB_NOLOCK_gc);
}

/**
 * \brief BLBA{ޯď
 *
 * p̈p{ޯ(BLBA)܂B̎{ޯ(BLBB,BLBAT,LB)͕ς܂
 * (A{Ȃɏ܂)B
 *
 * \param  blba_lock p̈{ޯ
 */
static inline void nvm_blba_lock_bits_write(enum NVM_BLBA_enum blba_lock)
{
	nvm_lock_bits_write(NVM_BLBB_NOLOCK_gc, blba_lock, NVM_BLBAT_NOLOCK_gc,
		NVM_LB_NOLOCK_gc);
}

/**
 * \brief BLBAT{ޯď
 *
 * p\̈p{ޯ(BLBAT)܂B̎{ޯ(BLBA,BLBB,LB)͕ς
 * (A{Ȃɏ܂)B
 *
 * \param  blbat_lock p\̈{ޯ
 */
static inline void nvm_blbat_lock_bits_write(enum NVM_BLBAT_enum blbat_lock)
{
	nvm_lock_bits_write(NVM_BLBB_NOLOCK_gc, NVM_BLBA_NOLOCK_gc, blbat_lock,
		NVM_LB_NOLOCK_gc);
}

/**
 * \brief LB{ޯď
 *
 * ׯEEPROMp{ޯ(LB)܂B̎{ޯ(BLBA,BLBAT,BLBB)͕ς
 * ܂(A{Ȃɏ܂)B
 *
 * \param  blbat_lock p\̈{ޯ
 * \param  lb_lock    ׯ/EEPROM{ޯ
 */
static inline void nvm_lb_lock_bits_write(enum NVM_LB_enum lb_lock)
{
	nvm_lock_bits_write(NVM_BLBB_NOLOCK_gc, NVM_BLBA_NOLOCK_gc,
		NVM_BLBAT_NOLOCK_gc, lb_lock);
}

//! @}

/**
 * \page xmega_nvm_quickstart XMEGA NVMײޗpJn̎
 *
 * ͓̎gpʂɑ΂Ăײނ`Ԑݒ肵Ďgp@̒iKIȎw
 * ł \ref nvm_group "NVMײ"pJn̎łB
 *
 * ŋLq鍀͗Ⴆ΁As؂̲̪KvȎ剞pJԂ܂
 * ̊֐ź߲ق邱Ƃł܂B
 *
 * \section xmega_nvm_quickstart_basic NVM̊{IȎg
 * {NVMײނ3̎dlʂ񎦂܂BŏEEPROM߰ނď
 * ꂽ؂A2ڂقݒł邱ƂmF邽߂BOD 
 * ˭ނɱA3ڂ͎gpҎ[񂩂ǂ݂܂B
 *
 * \section xmega_nvm_quickstart_eeprom_case gp1: EEPROM
 *
 * NVMײނׯ ؁AEEPROMA˭ށA{ޯĂ܂ޑ`̕s؂
 * ̪邽߂̋@\܂B̺ޗ߰ނEEPOMɏA؊
 * I/OpČ؂邽߂ɂǂݖ߂܂B
 *
 * \section xmega_nvm_quickstart_eeprom_case_setup_steps \ݒiK
 * ̎gpʂɕKvƂ\ݒiK͂܂B
 *
 * \subsection nvm_quickstart_eeprom_case_example_code ޗ
 *
 * \code
 * #define EXAMPLE_PAGE 2
 * #define EXAMPLE_ADDR EXAMPLE_PAGE * EEPROM_PAGE_SIZE
 *
 * uint8_t write_page[EEPROM_PAGE_SIZE];
 * uint8_t read_page[EEPROM_PAGE_SIZE];
 *
 * fill_page_with_known_data(write_page);
 * fill_page_with_zeroes(read_page);
 *
 * nvm_eeprom_load_page_to_buffer(write_page);
 * nvm_eeprom_atomic_write_page(EXAMPLE_PAGE);
 *
 * nvm_eeprom_read_buffer(EXAMPLE_ADDR,
 *         read_page, EEPROM_PAGE_SIZE);
 *
 * check_if_pages_are_equal(write_page, read_page);
 * \endcode
 *
 * \subsection nvm_quickstart_eeprom_case_workflow Ƃ̗
 *
 * -# ްi[ꏊ`ĔCӂEEPROM߰2Iт܂B
 *     - \code
 *       #define EXAMPLE_PAGE 2
 *       #define EXAMPLE_ADDR EXAMPLE_PAGE * EEPROM_PAGE_SIZE
 *       \endcode
 * -# 1͏߂ްA1͂ްǂނ߂2̕\`܂B
 *     - \code
 *     uint8_t write_page[EEPROM_PAGE_SIZE];
 *     uint8_t read_page[EEPROM_PAGE_SIZE];
 *       \endcode
 * -# ް\𖞂Aǂݍݗp\0ݒ肵܂B
 *     - \code
 *       fill_page_with_known_data(write_page);
 *       fill_page_with_zeroes(read_page);
 *       \endcode
 *     - \note ̊֐͐錾ĂȂAȂg̓K؂Ȋ֐
 *             uׂłB
 * -# ߰ނꎞEEPROM߰ފɏՕɐݒ
 *     - \code
 *       nvm_eeprom_load_page_to_buffer(write_page);
 *       \endcode
 *     - \attention Ŏgp֐؊蓖Ăꂽꍇɓ܂
 *                  B
 * -# ɏՕw肵߰ނ֔񕪒f߰ޏ݂s܂B
 *     - \code
 *       nvm_eeprom_atomic_write_page(EXAMPLE_PAGE);
 *       \endcode
 *     - \note \ref nvm_eeprom_atomic_write_page() ֐͐V߰ނO
 *             ߰ނ܂B폜Ȃł̕f()݂ɂĂ 
 *             \ref nvm_eeprom_split_write_page() B
 * -# read_page[]\߰ނǂݖ߂܂B
 *     - \code
 *       nvm_eeprom_read_buffer(EXAMPLE_ADDR,
 *               read_page, EEPROM_PAGE_SIZE);
 *       \endcode
 * -# ߰ނɏꂽ̂ƓƂmF܂B
 *     - \code
 *       check_if_pages_are_equal(write_page, read_page);
 *       \endcode
 *     - \note ̊֐͐錾ꂸAȂg̓K؂Ȋ֐Œuׂ
 *             łB
 *
 * \section xmega_nvm_quickstart_fuse_case gp2: ˭
 *
 * NVMײނ˭ނǂދ@\܂B
 * \ref nvm_fuse_lock_group B
 *
 * do(BOD)ق2.1Vɐݒ肳Ă邩ۂ𒲂ׂƎv܂B
 * ߂K鏑݊ɐڑ鎞˭ނƂɂĂĂ
 * B˭ނFUSEBYTE5̈ꕔłBBODLVL΁ALED0ONɂ܂B
 *
 * \section xmega_nvm_quickstart_fuse_case_setup_steps \ݒiK
 * ̎gpʂɕKvƂ\ݒiK͂܂B
 *
 * \subsection nvm_quickstart_fuse_case_example_code ޗ
 * \code
 * uint8_t fuse_value;
 * fuse_value = nvm_fuses_read(FUSEBYTE5);
 *
 * if ((fuse_value & NVM_FUSES_BODLVL_gm) == BODLVL_2V1_gc) {
 *     gpio_set_pin_low(LED0_GPIO);
 * }
 * \endcode
 *
 * \subsection nvm_quickstart_fuse_case_workflow Ƃ̗
 *
 * -# ˭ޓei[ϐ쐬܂B
 *     - \code
 *       uint8_t fuse_value;
 *       \endcode
 * -# ֐S˭ނ̒lABODLVLFUSEBYTE5Ɋi[܂Bϐ˭ނǂނ
 *    ߂ \ref nvm_fuses_read() ֐Ăт܂B
 *     - \code
 *       fuse_value = nvm_fuses_read(FUSEBYTE5);
 *       \endcode
 * -# ͓ǂݍݕ̍ŌłABODقۂLED_
 *    Ǝv܂B
 *     - \code
 *       if ((fuse_value & NVM_FUSES_BODLVL_gm) == BODLVL_2V1_gc) {
 *           gpio_set_pin_low(LED0_GPIO);
 *       }
 *       \endcode
 *
 * \section xmega_nvm_quickstart_signature_case gp3: [
 *
 * NVMײނ޲̎[ǂނ߂̋@\܂BłɊi[
 * ̂KvƂ̉ŁAgpҎ[񂩂P16޲Ăǂ݂܂B
 *
 * \section xmega_nvm_quickstart_signature_row_setup_steps \ݒiK
 * ̎gpʂɕKvƂ\ݒiK͂܂B
 *
 * \subsection xmega_nvm_quickstart_signature_row_example_code ޗ
 *
 * \code
 * #define START_ADDR 0x10
 * #define DATA_LENGTH 16
 *
 * uint8_t values[LENGTH];
 * uint8_t i;
 *
 * for (i = 0; i < DATA_LENGTH; i++) {
 *     values[i] = nvm_read_user_signature_row(START_ADDR + i);
 * }
 * \endcode
 *
 * \subsection nvm_quickstart_signature_case_workflow Ƃ̗
 *
 * -# JnڽްԂ̒`Aްi[ď̂ɕKvƂ
 *    ϐ쐬܂B
 *     - \code
 *       #define START_ADDR 0x10
 *       #define DATA_LENGTH 16
 *
 *       uint8_t values[LENGTH];
 *       uint8_t i;
 *       \endcode
 * -# gpҎ[ʂČJԂĖ]ްi[܂B
 *     - \code
 *       for (i = 0; i < DATA_LENGTH; i++) {
 *           values[i] = nvm_read_user_signature_row(START_ADDR + i);
 *       }
 *       \endcode
 *
 */

#ifdef __cplusplus
}
#endif

#endif /* NVM_H */
