/**
 * \file
 *
 * \brief x~ײ
 *
 * 쌠 (c) 2010 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef SLEEP_H
#define SLEEP_H

#include <compiler.h>

/**
 * \defgroup sleep_group x~ײ
 *
 * AVR XMEGAx~pײގłB
 *
 * \note ފԐڕׂŏɂ邽߁Å֐荞ݏ̓A
 ̊֐To minimize the code overhead, these functions do not feature
 * ܂͕ی삪KvłȂ悤ȉpŌĂ΂邽߁A͊荞ݕی삳ꂽ
 * @\ł͂܂Bی삪KvƂ悤ȏꍇAĂяoނɂĕۏ؂
 * Ȃ΂Ȃ܂B
 *
 * \section xmega_sleep_quickstart_section Jn̎
 * \ref xmega_sleep_quickstart B
 * @{
 */

#if defined(__ICCAVR__) || defined(__DOXYGEN__)
# include <intrinsics.h>
//! x~߂𔭍sϸ
# define sleep_enter() __sleep()

/**
 * \brief x~
 */
static inline void sleep_enable(void)
{
	SLEEP.CTRL |= SLEEP_SEN_bm;
}

/**
 * \brief x~֎~
 */
static inline void sleep_disable(void)
{
	SLEEP.CTRL &= ~SLEEP_SEN_bm;
}

#elif defined(__GNUC__)
# include <avr/sleep.h>
# define sleep_enter() sleep_cpu()

#else
# error Unsupported compiler.
#endif

/**
 * \brief Vx~ݒ
 *
 * \param  mode ޲I/Oͯ ̧ق̋x~
 */
static inline void sleep_set_mode(enum SLEEP_SMODE_enum mode)
{
	SLEEP.CTRL = mode | (SLEEP.CTRL & ~SLEEP_SMODE_gm);
}

//! @}

/**
 * \page xmega_sleep_quickstart XMEGAx~ײޗpJn̎
 *
 * ͓̎gpʂɑ΂ײނ`Ԑݒ肵Ďgp@̒iKIwł
 *  \ref sleep_group "x~ײ" pJn̎łB
 *
 * ŋLq鍀͗Ⴆ΁A޲Ŋex~𐧌䂵Ďs邱ƂKv
 * 剞pJԂ܂͑̉ꂩ֐ɕʂ邱Ƃł܂B
 *
 * \section xmega_sleep_quickstart_basic x~ײނ̊{IȎg
 * ̎gpʂܰ޳݋x~ֈڍs悤޲Ă̌ɋx~
 *֓܂BNオɋx~֎~܂B
 *
 * \section xmega_sleep_basic_usage giK
 * \subsection xmega_sleep_basic_usage_code ޗ
 * Ⴆ΁ApÇٓ̎JԂɒǉ܂B
 * \code
 * sleep_set_mode(SLEEP_SMODE_PDOWN_gc);
 * sleep_enable();
 * sleep_enter();
 * sleep_disable();
 * \endcode
 *
 * \subsection xmega_sleep_basic_usage Ƃ̗
 * -# gp鉽̋x~ݒ肵܂Bex~޲ ͯ ̧ى
 *    SLEEP_SMODE_enum񋓒`Ō邱Ƃł܂B
 *  - \code sleep_set_mode(SLEEP_SMODE_PDOWN_gc); \endcode
 * -# ޲x~֍ŝ邱Ƃ܂B
 *  - \code sleep_enable(); \endcode
 *  - \note ̊֐͋x~֍s޲̂߂ɌĂ΂Ȃ΂Ȃ܂B
 *          ႦꂪꂽƂ\łAӐ}ʋx~
 *          s޲~ߎ~߂邽߂̈Sȋ@\ŁAۯɋx~֍s
 *          ƂӐ}鎞ɂx~邱Ƃ܂B
 * -# x~ֈڍs܂B
 *  - \code sleep_enter(); \endcode
 *  - \attention S̊荞݂޲ɑ΂Nオ茳ƂĎgp悤Ɍv
 *               悷銄荞݂邱ƂmɂAex~ɑ΂Ă
 *               ̋Nオ茳p\ɂʂȒӂ𕥂ĂB
 *               ݂̋ȂƂ͓dOFF/ON܂ŕsmȋx~ɏI
 *               邩܂B
 * -# ޲x~NƁANオ茳(荞݌)Ɋ֘A銄荞ݏ
 *    sāA \ref sleep_enter() Ăяo̺̎ލs瑱܂BN
 *    オ莞ɋx~̋֎~mɂĂB
 *  - \code sleep_disable(); \endcode
 *
 *  \subsection xmega_sleep_basic_sleep_modes x~
 *  \ȋx~͎gp޲Ɉˑ܂B̒`邽߂
 *  ޲ްĂͯ ̧قQƂĂB
 *
 *  ƂATxmega32A4U޲͈ȉ̋x~܂B
 *  - ًx~:	SLEEP_SMODE_IDLE_gc
 *  - ܰ޳:		SLEEP_SMODE_PDOWN_gc
 *  - ܰ:		SLEEP_SMODE_PSAVE_gc
 *  - ޲:		SLEEP_SMODE_STDBY_gc
 *  - g޲:	SLEEP_SMODE_ESTDBY_gc
 */

#endif /* SLEEP_H */
