/**
 * \file
 *
 * \brief DALIԋ@\
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef DALI_STATE_H
#define DALI_STATE_H
#include "dali_usart.h"

typedef  struct {
	volatile uint8_t usart_rx_count;
	volatile uint8_t usart_rx_buf[USART_RX_MAX];
	uint8_t dali_send_status;
	uint8_t dali_rx_byte[2];
	uint8_t dali_rx_flag;
	volatile uint8_t state_time;
} dali_master_info_t;

dali_master_info_t master_info;

// dali_rx_flag̏Ԃ`
enum {RX_IDLE, RX_ONE_BYTE, RX_TWO_BYTES, RX_FAILUER};

/**
 *  \brief Ԏԑ
 */
void dali_state_time_inc(void);

/**
 *  \brief 呕uԏ
 */
void dali_state_init(void);

/**
 *  \brief DALI呕uԏ
 */
void dali_process_state(void);

#endif /* DALI_STATE_H */
