/**
 * \file
 *
 * \brief UǗ
 *
 * 쌠 (c) 2010-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef OSC_H_INCLUDED
#define OSC_H_INCLUDED

#include "parts.h"
#include "conf_clock.h"

#if SAM3S
# include "sam3s/osc.h"
#elif SAM3XA
# include "sam3x/osc.h"
#elif SAM3U
# include "sam3u/osc.h"
#elif SAM3N
# include "sam3n/osc.h"
#elif SAM4S
# include "sam4s/osc.h"
#elif SAM4E
# include "sam4e/osc.h"
#elif SAM4L
# include "sam4l/osc.h"
#elif SAM4N
# include "sam4n/osc.h"
#elif (UC3A0 || UC3A1)
# include "uc3a0_a1/osc.h"
#elif UC3A3
# include "uc3a3_a4/osc.h"
#elif UC3B
# include "uc3b0_b1/osc.h"
#elif UC3C
# include "uc3c/osc.h"
#elif UC3D
# include "uc3d/osc.h"
#elif UC3L
# include "uc3l/osc.h"
#elif XMEGA
# include "xmega/osc.h"
#else
# error Unsupported chip type
#endif

/**
 * \ingroup clk_group
 * \defgroup osc_group UǗ
 *
 * ̌Qߏ̔Ǔ`ԐݒƋ/֎~Ɋ֘A֐ƒ`܂݂܂B
 * RCUAOؽٗpUAOۯ킪̒PʕɂĎx
 * ܂B̑SĂʂɎĂ镨͂炪ʓIɒs\̌̎g
 * ňɐU邱ƂłB
 *
 * \par :Ű
 *
 * ȉ̗XMEGA AŊOUĎgp鏀̂҂@
 * ܂B U̎ʎq͊ՓLŁÂɓ菇SĂ̊ՂŎgp
 * ͌Aosc_enable()ɑ΂Ұ޲ɈႢ܂B
 * \code
	osc_enable(OSC_ID_XOSC);
	osc_wait_ready(OSC_ID_XOSC); \endcode
 *
 * \section osc_group_board L`
 * OU킪gpꍇA͂̊eXɑ΂Ĉȉ̒`񋟂
 * Ȃ΂Ȃ܂B
 *   - \b BOARD_<osc name>_HZ: Ǔ̎g
 *   - \b BOARD_<osc name>_STARTUP_US: msł̔U̎n
 *   - \b BOARD_<osc name>_TYPE: ڑ锭Ǔ^AAꂪؽق܂
 *                               Oۯ̂ǂ炩ƎX͂ǂ̸ؽق̎ށB
 *                               ̒l̈Ӗ͊ՓLłB
 *
 * @{
 */

//! \name UǗ
//@{
/**
 * \fn void osc_enable(uint8_t id)
 * \brief \a id̔U
 *
 * nԂƓ̒l͊ł̒`ɊÂĎIɌ߂܂B
 */
/**
 * \fn void osc_disable(uint8_t id)
 * \brief \a id̔U֎~
 */
/**
 * \fn osc_is_ready(uint8_t id)
 * \brief \a id̔U킪ǂ𔻒
 * \retval true  \a id̔U͑sŸۯƂĎgp
 * \retval false \a id̔U͑sĂ܂B
 */
/**
 * \fn uint32_t osc_get_rate(uint8_t id)
 * \brief \a id̔U̎gHzŕԂ܂B
 */

#ifndef __ASSEMBLY__

/**
 * \brief \a idɂĎʂꂽȔ܂őҋ@
 *
 * ̊֐\a idɂĎʂꂽU킪肵ĸۯƂĎgpɂ
 * ̂҂܂B
 *
 * \param  id ҂Uʂԍ
 */
static inline void osc_wait_ready(uint8_t id)
{
	while (!osc_is_ready(id)) {
		/* 邱ƂȂ */
	}
}

#endif /* __ASSEMBLY__ */

//@}

//! @}

#endif /* OSC_H_INCLUDED */
