/**
 * \file
 *
 * \brief PLLǗ
 *
 * 쌠 (c) 2010-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef CLK_PLL_H_INCLUDED
#define CLK_PLL_H_INCLUDED

#include "parts.h"
#include "conf_clock.h"

#if SAM3S
# include "sam3s/pll.h"
#elif SAM3XA
# include "sam3x/pll.h"
#elif SAM3U
# include "sam3u/pll.h"
#elif SAM3N
# include "sam3n/pll.h"
#elif SAM4S
# include "sam4s/pll.h"
#elif SAM4E
# include "sam4e/pll.h"
#elif SAM4L
# include "sam4l/pll.h"
#elif SAM4N
# include "sam4n/pll.h"
#elif (UC3A0 || UC3A1)
# include "uc3a0_a1/pll.h"
#elif UC3A3
# include "uc3a3_a4/pll.h"
#elif UC3B
# include "uc3b0_b1/pll.h"
#elif UC3C
# include "uc3c/pll.h"
#elif UC3D
# include "uc3d/pll.h"
#elif (UC3L0128 || UC3L0256 || UC3L3_L4)
# include "uc3l/pll.h"
#elif XMEGA
# include "xmega/pll.h"
#else
# error Unsupported chip type
#endif

/**
 * \ingroup clk_group
 * \defgroup pll_group PLLǗ
 *
 * ̌QߏPLĽ`ԐݒƋ/֎~Ɋ֘A֐ƒ`܂݂܂BPLL
 * ͓͐M(\em source)ACӂŌ`Ԑݒ\\em  ɂĎg
 * 𕪎ǍɌ`Ԑݒ\\em { ɂĎg{܂B
 *
 * ޲͓͕xA޲ł1ȊȎ̂ǂ̕
 * ws\ɏIł傤B޲͓͂Əo͂̐M̎g͈
 * ɑ΂ėlXȐ܂B
 *
 * \par :ҰłPLL0\ݒ
 *
 * ȉ̗͏ňꗗɂꂽ`ԐݒقpĎw肳ꂽҰgp
 * PLL0`Ԑݒ肵ċ@܂B
 * \code
	pll_enable_config_defaults(0); \endcode
 *
 * `Ԑݒ肷ɂ́AҰpPLL0(UC3A3LPLLCӑI)L
 * ш擮̂悤ȓL@\֎~邽߂ɂ̏菇gp邱Ƃł
 * B
 * \code
	struct pll_config pllcfg;
	if (pll_is_locked(pll_id)) {
		return; // Pll already running
	}
	pll_enable_source(CONFIG_PLL0_SOURCE);
	pll_config_defaults(&pllcfg, 0);
	pll_config_set_option(&pllcfg, PLL_OPT_WBM_DISABLE);
	pll_enable(&pllcfg, 0);
	pll_wait_for_lock(0); \endcode
 *
 * Ō̊֐Ăяo߂ƁAPLL0͎弽 ۯƂĎgp鏀
 * ܂B
 *
 * \section pll_group_config `Ԑݒ
 *
 * ePLL͉p`Ԑݒ̧قňȉ̌`ԐݒقɂČ߂Ұ̑g
 * ܂B
 *   - \b CONFIG_PLLn_SOURCE: PLL \a n̓͂ɐڑۯB
 *                            #pll_source enumɂĒ`ꂽl1łȂ
 *                            ΂Ȃ܂B
 *   - \b CONFIG_PLLn_MUL: PLL\a n̊{(H)
 *   - \b CONFIG_PLLn_DIV: PLL\a n̊蕪
 *
 * ̌`Ԑݒقpll_config_defaults()pll_get_default_rate()̌Ăяo
 * ̌ʂ߂܂B
 *
 * @{
 */

//! \name ߓLPLL
//@{
/**
 * \def PLL_MAX_STARTUP_CYCLES
 * \brief ᑬۯłPLLőn
 */
/**
 * \def NR_PLLS
 * \brief ߏPLL
 */

/**
 * \def PLL_MIN_HZ
 * \brief PLLłŒg
 */
/**
 * \def PLL_MAX_HZ
 * \brief PLLłōg
 */
/**
 * \def PLL_NR_OPTIONS
 * \brief PLLCӑIޯĐ
 */
//@}

/**
 * \enum pll_source
 * \brief PLLۯ
 */

//! \name PLL`Ԑݒ
//@{

/**
 * \struct pll_config
 * \brief PLL`Ԑݒʰ޳L\
 *
 * ̍\݂̂͌PLL`Ԑݒ\1܂͂葽޲Ll܂݂
 * B\̂̓e͈ʓIɊՊԂňقȂAgp҂PLL`ԐݒAPIʂ̂
 * Aǂ̗̈౸ׂł͂܂B
 */

/**
 * \fn void pll_config_init(struct pll_config *cfg,
 *              enum pll_source src, unsigned int div, unsigned int mul)
 * \brief WҰPLL`Ԑݒ
 *
 * \note ̊֐͔ɏ̎Ԃƒʏ͒萔ҰƂŌĂ΂Ɖ肳邽
 * ߁Aײ݂Œ`邩܂B.̲ײ݉͂̂悤ȏꍇɺޗ
 * Ȃ茸炵܂B
 *
 * \param  cfg PLL`Ԑݒ
 * \param  src PLLւ̓͂ƂĎgp锭U
 * \param  div PLL͕
 * \param  mul PLLH(A{)
 *
 * \return PLL\a src(\a mul / \a div){̎gős`Ԑݒ
 */
/**
 * \def pll_config_defaults(cfg, pll_id)
 * \brief ҰpPLL`Ԑݒ
 *
 * ̊֐߂A\a cfǧ`ԐݒPLLCONFIG_PLLx_SOURCE̎g
 * (CONFIG_PLLx_MUL / CONFIG_PLLx_DIV){ős`Ԑݒ܂݂܂B
 *
 * \param  cfg    PLL`Ԑݒ
 * \param  pll_id PLLɑ΂Ďgp
 */
/**
 * \def pll_get_default_rate(pll_id)
 * \brief \a pll_id̊葬xHzŎ擾
 */
/**
 * \fn void pll_config_set_option(struct pll_config *cfg,
 *              unsigned int option)
 * \brief \a cfǧ`Ԑݒ\a optionPLLCӑIޯĂݒ
 *
 * \param  cfg    ύXPLL`Ԑݒ
 * \param  option ݒ肷PLLCӑIޯ
 */
/**
 * \fn void pll_config_clear_option(struct pll_config *cfg,
 *              unsigned int option)
 * \brief \a cfǧ`Ԑݒ\a optionPLLCӑIޯĂ
 *
 * \param  cfg    ύXPLL`Ԑݒ
 * \param  option PLLCӑIޯ
 */
/**
 * \fn void pll_config_read(struct pll_config *cfg, unsigned int pll_id)
 * \brief \a pll_iď݊Ȍ`Ԑݒǂݍ
 *
 * \param  cfg    ݊Ȍ`Ԑݒi[`ԐݒP޼ު
 * \param  pll_id PLL̎ʎq
 */
/**
 * \fn void pll_config_write(const struct pll_config *cfg,
 *              unsigned int pll_id)
 * \brief \a pll_idPLL\a cfǧ`Ԑݒ
 *
 * \param  cfg    ɂPLL`Ԑݒ\`ԐݒP޼ު
 * \param  pll_id XVPLL̎ʎq
 */

//@}

//! \name PLLʰ޳ł̑ݍp
//@{
/**
 * \fn void pll_enable(const struct pll_config *cfg,
 *              unsigned int pll_id)
 * \brief \a cfǧ`Ԑݒ\a pll_idPLL
 *
 * \param  cfg    PLL`Ԑݒ
 * \param  pll_id PLL̎ʎq
 */
/**
 * \fn void pll_disable(unsigned int pll_id)
 * \brief \a pll_idɂĎʂPLL֎~
 *
 * ̊֐Ă΂ꂽA\a pll_idɂĎʂPLL֎~܂Bʰ޳
 * Ŋi[ꂽPLL`Ԑݒ͂ɂĉeyڂ邩ꂸÂɌĂяo
 * `Ԑݒŕ邱ƂKvȏꍇAPLL֎~O
 * pll_config_read()sA܂PLLɏꂽŌ̌`Ԑݒ邩̂ǂ炩ɂׂłB
 *
 * \param  pll_id ֎~PLL̎ʎq
 */
/**
 * \fn bool pll_is_locked(unsigned int pll_id)
 * \brief PLLŒ艻Ă邩ۂ𔻒
 *
 * \param  pll_id ׂPLL̎ʎq
 *
 * \retval true  PLL͌Œ艻AۯƂĎgp鏀Ă܂B
 * \retval false PLLŒ艻ȂA܂͋Ă܂B
 */
/**
 * \fn void pll_enable_source(enum pll_source src)
 * \brief PLL̋
 * sĂȂ΁A܂B
 *
 * \param  src PLL̎ʎq
 */
/**
 * \fn void pll_enable_config_defaults(unsigned int pll_id)
 * \brief `ԐݒPLL
 * PLLŒ艻ĂȂ΁APLL܂B
 *
 * \param  pll_id PLL̎ʎq
 */

/**
 * \brief Œ艻ɂȂ܂\a pll_idPLLҋ@
 *
 * \todo iҋ@Ƽђ~邽ߐԂgpĂB
 *
 * \param  pll_id ҂PLL̎ʎq
 *
 * \retval STATUS_OK   PLL͌Œ艻Ă܂B
 * \retval ERR_TIMEOUT Œ艻ɂȂPLL҂Ԓ
 */
static inline int pll_wait_for_lock(unsigned int pll_id)
{
	Assert(pll_id < NR_PLLS);

	while (!pll_is_locked(pll_id)) {
		/* 邱ƂȂ */
	}

	return 0;
}

//@}
//! @}

#endif /* CLK_PLL_H_INCLUDED */
