/**
 * \file
 *
 * \brief ߓL ۯǗ֐
 *
 * 쌠 (c) 2012-2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef CHIP_SYSCLK_H_INCLUDED
#define CHIP_SYSCLK_H_INCLUDED

#include <board.h>

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \page sysclk_quickstart  ۯǗ޽pJ̎(SAM4L)
 *
 * ͓̎gpʂɑ΂Ļ޽`Ԑݒ肵Ďgp@̒iKIȎwł
 * \ref sysclk_group " ۯǗ"޽p̑Jn̎łB
 *
 * \section sysclk_quickstart_usecases  ۯǗgp
 * - \ref sysclk_quickstart_basic
 *
 * \section sysclk_quickstart_basic  ۯǗ޽̊{IȎg
 * {ͼ ۯǗ޽ɑ΂{IȎgpʂ񎦂܂B̎gpʂ
 *  ۰ׂɎtꂽؽق̎g{̂ɓDFLLpĎ弽 
 * ۯ48MHzɌ`Ԑݒ肵܂B޽ ۯ͎弽 ۯ̑x牺܂B
 *
 * \subsection sysclk_quickstart_use_case_1_prereq OKv
 *  - Ȃ
 *
 * \subsection sysclk_quickstart_use_case_1_setup_steps 
 * pނɒǉ܂B
 * \code
 *    sysclk_init();
 * \endcode
 *
 * \subsection sysclk_quickstart_use_case_1_setup_steps_workflow Ƃ̗
 * -# conf_clock.h:ł̐ݒɏ]ļ ۯ`Ԑݒ肵܂B
 *    \code sysclk_init(); \endcode
 *
 * \subsection sysclk_quickstart_use_case_1_example_code ޗ
 *   Ȃconf_clock.hͯ ̧قňȉǉ܂͒߂OAق̑
 *   SĂ̒`𒍎߂ɂĂB
 *   \code
 *   #define CONFIG_SYSCLK_SOURCE        SYSCLK_SRC_DFLL0
 *
 *   // Fdfll = (Fclk * DFLL_mul) / DFLL_div
 *   #define CONFIG_DFLL0_SOURCE         GENCLK_SRC_OSC32K
 *   #define CONFIG_DFLL0_FREQ           48000000UL
 *   #define CONFIG_DFLL0_MUL            (CONFIG_DFLL0_FREQ / BOARD_OSC32_HZ)
 *   #define CONFIG_DFLL0_DIV            1
 *
 *   // Fbus = Fsys / (2 ^ BUS_div)
 *   #define CONFIG_SYSCLK_CPU_DIV       0
 *   #define CONFIG_SYSCLK_PBA_DIV       1
 *   #define CONFIG_SYSCLK_PBB_DIV       1
 *   #define CONFIG_SYSCLK_PBC_DIV       1
 *   #define CONFIG_SYSCLK_PBD_DIV       1
 *   \endcode
 *
 * \subsection sysclk_quickstart_use_case_1_example_workflow Ƃ̗
 *  -# ƂDFLL0Pʕ̏o͂gp悤ɼ ۯ`Ԑݒ肵܂B
 *   \code #define CONFIG_SYSCLK_SOURCE      SYSCLK_SRC_DFLL0 \endcode
 *  -# ƂOSC0OؽٔUgp悤DFLL0`Ԑݒ肵܂B
 *   \code #define CONFIG_DFLL0_SOURCE       GENCLK_SRC_OSC32K \endcode
 *  -# OSC0OUg48MHzɒ{悤DFLL0Pʕ`Ԑݒ肵܂B
 *   \code
 *   #define CONFIG_DFLL0_FREQ           48000000UL
 *   #define CONFIG_DFLL0_MUL            (CONFIG_DFLL0_FREQ / BOARD_OSC32_HZ)
 *   #define CONFIG_DFLL0_DIV            1
 *   \endcode
 *   \note gpҊɂāA\c BOARD_OSC0_HZOSC0Ɏtꂽؽق̎
 *         gƂĊ\c conf_board.h`Ԑݒ̧قŒ`ׂłB
 *  -# 48MHzSős悤Ɏۯ`Ԑݒ肵A ۯ̔(2~1)
 *     s悤Ɏ޽ړx܂B
 *    \code
 *    #define CONFIG_SYSCLK_CPU_DIV       0
 *    #define CONFIG_SYSCLK_PBA_DIV       1
 *    #define CONFIG_SYSCLK_PBB_DIV       1
 *    #define CONFIG_SYSCLK_PBC_DIV       1
 *    #define CONFIG_SYSCLK_PBD_DIV       1
 *    \endcode
 *    \note ̕l2ׂ̂ŁȂ͐WłBe
 *          `̏Œ߂conf_clock.h`̎QƂĂB
 */


/**
 * \weakgroup sysclk_group
 * @{
 */

//! \name  ۯ
//@{
#define SYSCLK_SRC_RCSYS		0	//!< RCU
#define SYSCLK_SRC_OSC0			1	//!< U0
#define SYSCLK_SRC_PLL0			2	//!< (ʑŒ艻H)PLL0
#define SYSCLK_SRC_DFLL			3	//!< DFLL(޼َgŒ艻H)
#define SYSCLK_SRC_RC80M		4	//!< 80MHz RCU
#define SYSCLK_SRC_RCFAST		5	//!< 4-8-12MHz RCU
#define SYSCLK_SRC_RC1M			6	//!< 1MHz RCU
//@}

//! \name USBۯ
//@{
#define USBCLK_SRC_OSC0			GENCLK_SRC_OSC0		//!< OSC0gp
#define USBCLK_SRC_PLL0			GENCLK_SRC_PLL0		//!< PLL0gp
#define USBCLK_SRC_DFLL			GENCLK_SRC_DFLL		//!< DFLLgp
#define USBCLK_SRC_GCLKIN0		GENCLK_SRC_GCLKIN0	//!< GCLKIN0gp
//@}

//! \name Օ\ȒPʕۯ޽wW
//@{
#define PM_CLK_GRP_CPU			0
#define PM_CLK_GRP_HSB			1
#define PM_CLK_GRP_PBA			2
#define PM_CLK_GRP_PBB			3
#define PM_CLK_GRP_PBC			4
#define PM_CLK_GRP_PBD			5
//@}

//! \name CPUۯhۯ
//@{
//! ߏޯ 
#define SYSCLK_OCD				0
//@}

//! \name HSBۯhۯ
//@{
#define SYSCLK_PDCA_HSB			0	//!< PDCA ̪
#define SYSCLK_HFLASHC_DATA		1	//!< ׯ ް ̪
#define SYSCLK_HRAMC1_DATA		2	//!< HRAMCް ̪
#define SYSCLK_USBC_DATA		3	//!< USBC DMAFIFO̪
#define SYSCLK_CRCCU_DATA		4	//!< CRCCUް ̪
#define SYSCLK_PBA_BRIDGE		5	//!< HSB<->PBAد
#define SYSCLK_PBB_BRIDGE		6	//!< HSB<->PBBد
#define SYSCLK_PBC_BRIDGE		7	//!< HSB<->PBCد
#define SYSCLK_PBD_BRIDGE		8	//!< HSB<->PBDد
#define SYSCLK_AESA_HSB			9	//!< VÍKi(AES)
//@}

//! \name PBAۯhۯ
//@{
#define SYSCLK_IISC				 0	//!< IISC
#define SYSCLK_SPI				 1	//!< SPI
#define SYSCLK_TC0				 2	//!< /0
#define SYSCLK_TC1				 3	//!< /1
#define SYSCLK_TWIM0			 4	//!< TWI呕u0
#define SYSCLK_TWIS0			 5	//!< TWI]u0
#define SYSCLK_TWIM1			 6	//!< TWI呕u1
#define SYSCLK_TWIS1			 7	//!< TWI]u1
#define SYSCLK_USART0			 8	//!< USART0
#define SYSCLK_USART1			 9	//!< USART1
#define SYSCLK_USART2			10	//!< USART2
#define SYSCLK_USART3			11	//!< USART3
#define SYSCLK_ADCIFE			12	//!< A/Dϊ
#define SYSCLK_DACC				13	//!< D/Aϊ
#define SYSCLK_ACIFC			14	//!< ۸ޔr
#define SYSCLK_GLOC				15	//!< ڑ_H
#define SYSCLK_ABDACB			16	//!< ABDACB
#define SYSCLK_TRNG				17	//!< TRNG
#define SYSCLK_PARC				18	//!< PARC
#define SYSCLK_CATB				19	//!< eʐڐG
#define SYSCLK_TWIM2			21	//!< TWI呕u2
#define SYSCLK_TWIM3			22	//!< TWI呕u3
#define SYSCLK_LCDCA			23	//!< LCD

//@}

//! \name PBBۯhۯ
//@{
#define SYSCLK_HFLASHC_REGS		0	//!< ׯڼ޽
#define SYSCLK_HRAMC1_REGS		1	//!< HRAMCڼ޽
#define SYSCLK_HMATRIX			2	//!< HSBz`Ԑݒ
#define SYSCLK_PDCA_PB			3	//!< PDCA޽ ̪
#define SYSCLK_CRCCU_REGS		4	//!< CRCCUڼ޽
#define SYSCLK_USBC_REGS		5	//!< USBCڼ޽
#define SYSCLK_PEVC				6	//!< PEVC
//@}

//! \name PBCۯhۯ
//@{
#define SYSCLK_PM				0	//!< PM`Ԑݒ
#define SYSCLK_CHIPID			1	//!< CHIPID
#define SYSCLK_SCIF				2	//!< ѐ̪
#define SYSCLK_FREQM			3	//!< gv
#define SYSCLK_GPIO				4	//!< ėpo
//@}

//! \name PBDۯhۯ
//@{
#define SYSCLK_BPM				0	//!< BPM`Ԑݒ
#define SYSCLK_BSCIF			1	//!< BSCIF`Ԑݒ
#define SYSCLK_AST				2	//!< 񓯊v
#define SYSCLK_WDT				3	//!< ޯ 
#define SYSCLK_EIC				4	//!< O荞ݐ
#define SYSCLK_PICOUART			5	//!< PICOUART
//@}

//! \name PBAۯhꂽۯՕ
//@{
#define PBA_DIVMASK_TIMER_CLOCK2	(1u << 0)		//!< TIMER_CLOCK2Օ
#define PBA_DIVMASK_TIMER_CLOCK3	(1u << 2)		//!< TIMER_CLOCK3Օ
#define PBA_DIVMASK_CLK_USART		(1u << 2)		//!< CLK_USART/DIVՕ
#define PBA_DIVMASK_TIMER_CLOCK4	(1u << 4)		//!< TIMER_CLOCK4Օ
#define PBA_DIVMASK_TIMER_CLOCK5	(1u << 6)		//!< TIMER_CLOCK5Օ
#define PBA_DIVMASK_Msk				(0x7Fu << 0)	//!< ޯė̈Օ
//@}

#ifndef __ASSEMBLY__

#include <compiler.h>
#include <dfll.h>
#include <osc.h>
#include <pll.h>
#include <genclk.h>

// `ԐݒȂ̏ꍇɑOuȂŒᑬۯ(RCOSC)gp
#ifndef CONFIG_SYSCLK_SOURCE
# define CONFIG_SYSCLK_SOURCE    SYSCLK_SRC_RCSYS
#endif /* CONFIG_SYSCLK_SOURCE */

/*
 * ɂׯ PicoCachegp
 * 0:PicoCache֎~A1:PicoCache
 */
#ifndef CONFIG_HCACHE_ENABLE
#define CONFIG_HCACHE_ENABLE          1
#endif

/**
 * \def CONFIG_SYSCLK_CPU_DIV
 * \brief \f$2^{CONFIG\_SYSCLK\_CPU\_DIV}\f$CPUۯg𕪎邽߂̼
 *        ق`Ԑݒ
 *
 * ̼ق`ȂꍇACPUۯg͕܂B
 *
 * ̼ق\ref conf_clock.hŒ`邩܂B
 */
#ifndef CONFIG_SYSCLK_CPU_DIV
# define CONFIG_SYSCLK_CPU_DIV   0
#endif /* CONFIG_SYSCLK_CPU_DIV */

/**
 * \def CONFIG_SYSCLK_INIT_HSBMASK
 * \brief sysclockPʕꂽ̓dONŋHSBۯpق`
 *        ԐݒBɂASĂHSBۯ͋̂܂܂ɂ܂Aߓd̂
 *        ɂ\c SYSCLOCK_xxxݒ̎Օɑ΂邱̒l`邱Ƃɂ
 *        ĎIɋ֎~܂B
 *
 * ̼ق`ȂꍇASĂHSBۯ͋ꂽ܂܂łB
 *
 * ̼ق\ref conf_clock.hŒ`邩܂B
 */
#ifdef __DOXYGEN__
# define CONFIG_SYSCLK_INIT_HSBMASK
#endif

/**
 * \def CONFIG_SYSCLK_PBA_DIV
 * \brief \f$2^{CONFIG\_SYSCLK\_PBA\_DIV}\f$PBAۯg𕪎邽߂̼
 *        ق`Ԑݒ
 *
 * ̼ق`ȂꍇAPBAۯg͕܂B
 *
 * ̼ق\ref conf_clock.hŒ`邩܂B
 */
#ifndef CONFIG_SYSCLK_PBA_DIV
# define CONFIG_SYSCLK_PBA_DIV   0
#endif /* CONFIG_SYSCLK_PBA_DIV */

/**
 * \def CONFIG_SYSCLK_PBB_DIV
 * \brief \f$2^{CONFIG\_SYSCLK\_PBB\_DIV}\f$PBBۯg𕪎邽߂̼
 *        ق`Ԑݒ
 *
 * ̼ق`ȂꍇAPBBۯg͕܂B
 *
 * ̼ق\ref conf_clock.hŒ`邩܂B
 */
#ifndef CONFIG_SYSCLK_PBB_DIV
# define CONFIG_SYSCLK_PBB_DIV   0
#endif /* CONFIG_SYSCLK_PBB_DIV */

/**
 * \def CONFIG_SYSCLK_PBC_DIV
 * \brief \f$2^{CONFIG\_SYSCLK\_PBC\_DIV}\f$PBCۯg𕪎邽߂̼
 *        ق`Ԑݒ
 *
 * ̼ق`ȂꍇAPBCۯg͕܂B
 *
 * ̼ق\ref conf_clock.hŒ`邩܂B
 */
#ifndef CONFIG_SYSCLK_PBC_DIV
# define CONFIG_SYSCLK_PBC_DIV   0
#endif /* CONFIG_SYSCLK_PBC_DIV */

/**
 * \def CONFIG_SYSCLK_PBD_DIV
 * \brief \f$2^{CONFIG\_SYSCLK\_PBD\_DIV}\f$PBDۯg𕪎邽߂̼
 *        ق`Ԑݒ
 *
 * ̼ق`ȂꍇAPBDۯg͕܂B
 *
 * ̼ق\ref conf_clock.hŒ`邩܂B
 */
#ifndef CONFIG_SYSCLK_PBD_DIV
# define CONFIG_SYSCLK_PBD_DIV   0
#endif /* CONFIG_SYSCLK_PBD_DIV */

/**
 * \def CONFIG_SYSCLK_INIT_CPUMASK
 * \brief sysclockPʕꂽ̓dONŋCPUۯpق`
 *        ԐݒBɂASĂCPUۯ͋̂܂܂ɂ܂Aߓd̂
 *        ɂ\c SYSCLOCK_xxxݒ̎Օɑ΂邱̒l`邱Ƃɂ
 *        ĎIɋ֎~܂B
 *
 * ̼ق`ȂꍇASĂCPUۯ͋ꂽ܂܂łB
 *
 * ̼ق\ref conf_clock.hŒ`邩܂B
 */
#ifdef __DOXYGEN__
# define CONFIG_SYSCLK_INIT_CPUMASK
#endif

/**
 * \def CONFIG_SYSCLK_INIT_PBAMASK
 * \brief sysclockPʕꂽ̓dONŋPBAۯpق`
 *        ԐݒBɂASĂPBAۯ͋̂܂܂ɂ܂Aߓd̂
 *        ɂ\c SYSCLOCK_xxxݒ̎Օɑ΂邱̒l`邱Ƃɂ
 *        ĎIɋ֎~܂B
 *
 * ̼ق`ȂꍇASĂPBAۯ͋ꂽ܂܂łB
 *
 * ̼ق\ref conf_clock.hŒ`邩܂B
 */
#ifdef __DOXYGEN__
# define CONFIG_SYSCLK_INIT_PBAMASK
#endif

/**
 * \def CONFIG_SYSCLK_INIT_PBBMASK
 * \brief sysclockPʕꂽ̓dONŋPBBۯpق`
 *        ԐݒBɂASĂPBBۯ͋̂܂܂ɂ܂Aߓd̂
 *        ɂ\c SYSCLOCK_xxxݒ̎Օɑ΂邱̒l`邱Ƃɂ
 *        ĎIɋ֎~܂B
 *
 * ̼ق`ȂꍇASĂPBBۯ͋ꂽ܂܂łB
 *
 * ̼ق\ref conf_clock.hŒ`邩܂B
 */
#ifdef __DOXYGEN__
# define CONFIG_SYSCLK_INIT_PBBMASK
#endif

/**
 * \def CONFIG_SYSCLK_INIT_PBCMASK
 * \brief sysclockPʕꂽ̓dONŋPBCۯpق`
 *        ԐݒBɂASĂPBCۯ͋̂܂܂ɂ܂Aߓd̂
 *        ɂ\c SYSCLOCK_xxxݒ̎Օɑ΂邱̒l`邱Ƃɂ
 *        ĎIɋ֎~܂B
 *
 * ̼ق`ȂꍇASĂPBCۯ͋ꂽ܂܂łB
 *
 * ̼ق\ref conf_clock.hŒ`邩܂B
 */
#ifdef __DOXYGEN__
# define CONFIG_SYSCLK_INIT_PBCMASK
#endif

/**
 * \def CONFIG_SYSCLK_INIT_PBDMASK
 * \brief sysclockPʕꂽ̓dONŋPBDۯpق`
 *        ԐݒBɂASĂPBDۯ͋̂܂܂ɂ܂Aߓd̂
 *        ɂ\c SYSCLOCK_xxxݒ̎Օɑ΂邱̒l`邱Ƃɂ
 *        ĎIɋ֎~܂B
 *
 * ̼ق`ȂꍇASĂPBDۯ͋ꂽ܂܂łB
 *
 * ̼ق\ref conf_clock.hŒ`邩܂B
 */
#ifdef __DOXYGEN__
# define CONFIG_SYSCLK_INIT_PBDMASK
#endif

/**
 * \def CONFIG_USBCLK_SOURCE
 * \brief USBWۯpق`Ԑݒ
 *
 * USBɎgpۯݒ肵܂B`Ԑݒ肳Ȃ΂Ȃ܂
 * B
 *
 * \c USBCLK_SRC_xxxݒ1ɒ`ĂBUSBKvƂȂꍇ
 * ͖`̂܂܂ɂĂB
 */
#ifdef __DOXYGEN__
# define CONFIG_USBCLK_SOURCE
#endif

/**
 * \def CONFIG_USBCLK_DIV
 * \brief USBWۯݒpق`Ԑݒ
 *
 * USBWۯpۯlݒ肵܂BUSBۯCONFIG_USBCLK_SOURCEőI΂
 * ꍇǍ`Ԑݒق`Ȃ΂Ȃ܂B
 *
 * \c GENCLK_DIV_MAX𒴂Ȃꂩ̒lƂĒ`ĂB͑I
 * 񂾋48MHz̸ۯg^܂B
 */
#ifdef __DOXYGEN__
# define CONFIG_USBCLK_DIV
#endif

/**
 * \name  ۯƂ̔hۯ₢킹
 *
 * ȉ̊֐ͼ ۯƂꂩhCPU޽̸ۯ݂̌̎g₢
 * 킹̂Ɏgp邩܂BႦ̊ՂlXߓ޽ 
 * ۯp̒ǉ̕⍲`ĂAsysclk_get_main_hz()sysclk_get_cpu_hz()
 * SĂ̊Ղŗp\Ɖ肷邱Ƃł܂B͒ʏAWIȺނ
 * ĒړIɖ₢킳邱ƂӐ}܂B
 */
//@{

/**
 * \brief 弽 ۯ݂̌̑xHzŕԂ܂B
 *
 * \todo ̊֐͎ۯU\ݒ肳ƌĕύXꂸAPLL0͏ɺ
 *       َ߲Ɍ`Ԑݒ肳ꂽ葬xősƉ肵܂BA͐\
 *       ̗R̂߂̓ʂȏꍇƂĎx]ށAłʓIȌ`Ԑݒł
 *       ɁA̓_ōXɂƓIȍ\ݒx邱ƂKv
 *       傤B
 */
#if (defined CONFIG_SYSCLK_DEFAULT_RETURNS_SLOW_OSC)
extern bool sysclk_initialized;
#endif
static inline uint32_t sysclk_get_main_hz(void)
{
#if (defined CONFIG_SYSCLK_DEFAULT_RETURNS_SLOW_OSC)
	if (!sysclk_initialized ) {
		return OSC_RCSYS_NOMINAL_HZ;
	}
#endif

	if (CONFIG_SYSCLK_SOURCE == SYSCLK_SRC_RCSYS) {
		return OSC_RCSYS_NOMINAL_HZ;
	}

#ifdef BOARD_OSC0_HZ
	else if (CONFIG_SYSCLK_SOURCE == SYSCLK_SRC_OSC0) {
		return BOARD_OSC0_HZ;
	}
#endif

#ifdef CONFIG_PLL0_SOURCE
	else if (CONFIG_SYSCLK_SOURCE == SYSCLK_SRC_PLL0) {
		return pll_get_default_rate(0);
	}
#endif

#ifdef CONFIG_DFLL0_SOURCE
	else if (CONFIG_SYSCLK_SOURCE == SYSCLK_SRC_DFLL) {
		return dfll_get_default_rate(0);
	}
#endif

	else if (CONFIG_SYSCLK_SOURCE == SYSCLK_SRC_RC80M) {
		return OSC_RC80M_NOMINAL_HZ;
	}

	else if (CONFIG_SYSCLK_SOURCE == SYSCLK_SRC_RCFAST) {
		if (CONFIG_RCFAST_FRANGE == 2) {
			return OSC_RCFAST12M_NOMINAL_HZ;
		} else if (CONFIG_RCFAST_FRANGE == 1) {
			return OSC_RCFAST8M_NOMINAL_HZ;
		} else {
			return OSC_RCFAST4M_NOMINAL_HZ;
		}
	}

	else if (CONFIG_SYSCLK_SOURCE == SYSCLK_SRC_RC1M) {
		return OSC_RC1M_NOMINAL_HZ;
	}


	else {
		/* unhandled_case(CONFIG_SYSCLK_SOURCE); */
		return 0;
	}
}

/**
 * \brief CPUۯ݂̌̑xHzŕԂB
 *
 * \todo ̊֐CPUɼ ۯgősƉ肵܂BŒCPU/޽
 *        ۯ(`Ԑݒ)(sɕύX邩Ȃ)ICPU/
 *         ۯ̍Œ2ȏ̋؏̎x]݂܂BSĂ޽ ۯɂ
 *        ĂłB
 *
 * \return HzłCPUۯ̎g
 */
static inline uint32_t sysclk_get_cpu_hz(void)
{
	return sysclk_get_main_hz() >> CONFIG_SYSCLK_CPU_DIV;
}

/**
 * \brief ޽(HSB)ۯ݂̌̑xHzŕԂB
 *
 * \return Hzł̍޽ ۯ̎g
 */
static inline uint32_t sysclk_get_hsb_hz(void)
{
	return sysclk_get_main_hz() >> CONFIG_SYSCLK_CPU_DIV;
}

/**
 * \brief ޽Aۯ݂̌̑xHzŕԂB
 *
 * \return Hzł̎޽Aۯ̎g
 */
static inline uint32_t sysclk_get_pba_hz(void)
{
	return sysclk_get_main_hz() >> CONFIG_SYSCLK_PBA_DIV;
}

/**
 * \brief ޽Bۯ݂̌̑xHzŕԂB
 *
 * \return Hzł̎޽Bۯ̎g
 */
static inline uint32_t sysclk_get_pbb_hz(void)
{
	return sysclk_get_main_hz() >> CONFIG_SYSCLK_PBB_DIV;
}

/**
 * \brief ޽Cۯ݂̌̑xHzŕԂB
 *
 * \return Hzł̎޽Cۯ̎g
 */
static inline uint32_t sysclk_get_pbc_hz(void)
{
	return sysclk_get_main_hz() >> CONFIG_SYSCLK_PBC_DIV;
}

/**
 * \brief ޽Dۯ݂̌̑xHzŕԂB
 *
 * \return Hzł̎޽Dۯ̎g
 */
static inline uint32_t sysclk_get_pbd_hz(void)
{
	return sysclk_get_main_hz() >> CONFIG_SYSCLK_PBD_DIV;
}

extern uint32_t sysclk_get_peripheral_bus_hz(const volatile void *module);
//@}

extern void sysclk_priv_enable_module(uint32_t bus_id, uint32_t module_index);
extern void sysclk_priv_disable_module(uint32_t bus_id, uint32_t module_index);

//! \name ۯ̋Ƌ֎~
//@{

/**
 * \brief CPUۯhPʕۯ
 * \param  module_index CPUMASKڼ޽ł̒Pʕۯ̎wW
 */
static inline void sysclk_enable_cpu_module(uint32_t module_index)
{
	sysclk_priv_enable_module(PM_CLK_GRP_CPU, module_index);
}

/**
 * \brief CPUۯhPʕۯ֎~
 * \param  module_index CPUMASKڼ޽ł̒Pʕۯ̎wW
 */
static inline void sysclk_disable_cpu_module(uint32_t module_index)
{
	sysclk_priv_disable_module(PM_CLK_GRP_CPU, module_index);
}

/**
 * \brief HSBۯhPʕۯ
 * \param  module_index HSBMASKڼ޽ł̒Pʕۯ̎wW
 */
static inline void sysclk_enable_hsb_module(uint32_t module_index)
{
	sysclk_priv_enable_module(PM_CLK_GRP_HSB, module_index);
}

/**
 * \brief HSBۯhPʕۯ֎~
 * \param  module_index HSBMASKڼ޽ł̒Pʕۯ̎wW
 */
static inline void sysclk_disable_hsb_module(uint32_t module_index)
{
	sysclk_priv_disable_module(PM_CLK_GRP_HSB, module_index);
}

extern void sysclk_enable_pba_module(uint32_t module_index);
extern void sysclk_disable_pba_module(uint32_t module_index);
extern void sysclk_enable_pbb_module(uint32_t module_index);
extern void sysclk_disable_pbb_module(uint32_t module_index);

/**
 * \brief PBCۯhPʕۯ
 * \param  module_index PBAMASKڼ޽ł̒Pʕۯ̎wW
 */
static inline void sysclk_enable_pbc_module(uint32_t module_index)
{
	sysclk_priv_enable_module(PM_CLK_GRP_PBC, module_index);
}

/**
 * \brief PBCۯhPʕۯ֎~
 * \param  module_index PBAMASKڼ޽ł̒Pʕۯ̎wW
 */
static inline void sysclk_disable_pbc_module(uint32_t module_index)
{
	sysclk_priv_disable_module(PM_CLK_GRP_PBC, module_index);
}

/**
 * \brief PBDۯhPʕۯ
 * \param  module_index PBDMASKڼ޽ł̒Pʕۯ̎wW
 */
static inline void sysclk_enable_pbd_module(uint32_t module_index)
{
	sysclk_priv_enable_module(PM_CLK_GRP_PBD, module_index);
}

/**
 * \brief PBDۯhPʕۯ֎~
 * \param  module_index PBDMASKڼ޽ł̒Pʕۯ̎wW
 */
static inline void sysclk_disable_pbd_module(uint32_t module_index)
{
	sysclk_priv_disable_module(PM_CLK_GRP_PBD, module_index);
}

/**
 * \brief PBAۯhPʕۯ
 * \param  module_index PBAMASKڼ޽ł̒Pʕۯ̎wW
 */
static inline void sysclk_enable_pba_divmask(uint32_t mask)
{
	uint32_t temp_mask;

	temp_mask = PM->PM_PBADIVMASK;
	temp_mask |= mask;
	PM->PM_UNLOCK = PM_UNLOCK_KEY(0xAAu)
			| PM_UNLOCK_ADDR((uint32_t)&PM->PM_PBADIVMASK - (uint32_t)PM);
	PM->PM_PBADIVMASK = temp_mask;
}

/**
 * \brief PBAۯhPʕۯ֎~
 * \param  module_index PBAMASKڼ޽ł̒Pʕۯ̎wW
 */
static inline void sysclk_disable_pba_divmask(uint32_t mask)
{
	uint32_t temp_mask;

	temp_mask = PM->PM_PBADIVMASK;
	temp_mask &= ~mask;
	PM->PM_UNLOCK = PM_UNLOCK_KEY(0xAAu)
			| PM_UNLOCK_ADDR((uint32_t)&PM->PM_PBADIVMASK - (uint32_t)PM);
	PM->PM_PBADIVMASK = temp_mask;
}

extern void sysclk_enable_peripheral_clock(const volatile void *module);
extern void sysclk_disable_peripheral_clock(const volatile void *module);

//@}

//! \name  ۯƑOǔ`Ԑݒ
//@{

extern void sysclk_set_prescalers(uint32_t cpu_shift,
		uint32_t pba_shift, uint32_t pbb_shift,
		uint32_t pbc_shift, uint32_t pbd_shift);
extern void sysclk_set_source(uint32_t src);

//@}

#if defined(CONFIG_USBCLK_SOURCE) || defined(__DOXYGEN__)

/**
 * \def USBCLK_STARTUP_TIMEOUT
 * \brief USBۯJn҂s
 */
#ifdef CONFIG_USBCLK_STARTUP_TIMEOUT
#   define USBCLK_STARTUP_TIMEOUT    (CONFIG_USBCLK_STARTUP_TIMEOUT)
#else
#   define USBCLK_STARTUP_TIMEOUT    (OSC0_STARTUP_TIMEOUT*(1000000/OSC_RCSYS_NOMINAL_HZ))
#endif

extern void sysclk_enable_usb(void);
extern void sysclk_disable_usb(void);
#endif

extern void sysclk_init(void);

#endif /* !__ASSEMBLY__ */

//! @}

#ifdef __cplusplus
}
#endif

#endif /* CHIP_SYSCLK_H_INCLUDED */
