/**
 * \file
 *
 * \brief Z҂xJԂpARM֐
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef _cycle_counter_h_
#define _cycle_counter_h_

#ifdef __cplusplus
extern "C" {
#endif


#include <compiler.h>

/**
 * @name Z҂xJԂɕ֗Ȋ֐
 *
 * @def delay_cycles
 * @brief w肵CPUԒx۸юs
 * @param  n ҂CPU
 *
 * @def cpu_delay_ms
 * @brief w肵msԒx۸юs
 * @param  delay ҂ms
 * @param  f_cpu HzłCPUg
 *
 * @def cpu_delay_us
 * @brief w肵sԒx۸юs
 * @param  delay ҂s
 * @param  f_cpu HzłCPUg
 *
 * @def cpu_ms_2_cy
 * @brief msCPUɕϊ
 * @param  ms    ms
 * @param  f_cpu HzłCPUg
 * @return ϊꂽCPU
 *
 * @def cpu_us_2_cy
 * @brief sCPUɕϊ
 * @param  us    s
 * @param  f_cpu HzłCPUg
 * @return ϊꂽCPU
 *
 * @{
 */

/**
 * \brief x̂߂̒xJԂ
 *
 * \note ̊֐ׯ҂ԂxԂɉeyڂȂ悤ɓSRAMő
 *       s܂B
 *
 * \param  n 
 */
void portable_delay_cycles(unsigned long n);

#define cpu_ms_2_cy(ms, f_cpu)  \
	(((uint64_t)(ms) * (f_cpu) + (uint64_t)(14e3-1ul)) / (uint64_t)14e3)
#define cpu_us_2_cy(us, f_cpu)  \
	(((uint64_t)(us) * (f_cpu) + (uint64_t)(14e6-1ul)) / (uint64_t)14e6)

#define delay_cycles	portable_delay_cycles

#define cpu_delay_ms(delay, f_cpu) delay_cycles(cpu_ms_2_cy(delay, f_cpu))
#define cpu_delay_us(delay, f_cpu) delay_cycles(cpu_us_2_cy(delay, f_cpu))
//! @}

#ifdef __cplusplus
}
#endif

#endif /* _cycle_counter_h_ */
