/**
 * \file
 *
 * \brief AVR,UC3,ARM{\pIOPORT޽ ͯ ̧
 *
 * 쌠 (c) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef IOPORT_H
#define IOPORT_H

#ifdef __cplusplus
extern "C" {
#endif

#include <parts.h>
#include <compiler.h>

/**
 * \defgroup ioport_group IOPORT API
 *
 * \ref ioport_quickstart B
 *
 * MEGA,MEGA_RF,XMEGA,UC3,ARM޲ɓnĕWIȋKGPIǑ݂`Ԑ
 * Ɛ̂߂̋IOPORT޽łB
 *
 * ߰ ݐ亰ނ͊eՂɑ΂čœKA萔lŎgp鎞ɊȌƍ
 * sԂ̗炷ׂłB
 *
 * \section dependencies ˑ
 * ײނ͈ȉ̒PʕɈˑ܂B
 * - ۯxƋ@\p \ref sysclk_group
 * @{
 */

/**
 * \def IOPORT_CREATE_PIN(port, pin)
 * \brief IOPORTݔԍ쐬
 *
 * IOPORT֐ŎgpIOPORTݔԍ쐬
 *
 * \param  port IOPORT߰(Ⴆ΁AIԊ{\ɉPORTA,PA܂PIOA)
 * \param  pin  I/O݂0IOPORTwW
 */

/** \brief IOPORTݕ */
enum ioport_direction {
	IOPORT_DIR_INPUT,			/*!< IOPORT͕@ */
	IOPORT_DIR_OUTPUT,			/*!< IOPORTo͕ */
};

/** \brief IOPORTl */
enum ioport_value {
	IOPORT_PIN_LEVEL_LOW,		/*!< IOPORTLowl */
	IOPORT_PIN_LEVEL_HIGH,		/*!< IOPORTHighl */
};

#if MEGA_RF
/** \brief IOPORT[m */
enum ioport_sense {
	IOPORT_SENSE_LEVEL,			/*!< IOPORT Lowيm */
	IOPORT_SENSE_BOTHEDGES,		/*!< IOPORT㏸/~̗[m */
	IOPORT_SENSE_FALLING,		/*!< IOPORT~[m */
	IOPORT_SENSE_RISING,		/*!< IOPORT㏸[m */
};
#elif SAM && !SAM4L
/** \brief IOPORT[m */
enum ioport_sense {
	IOPORT_SENSE_BOTHEDGES,		/*!< IOPORT㏸/~̗[m */
	IOPORT_SENSE_FALLING,		/*!< IOPORT~[m */
	IOPORT_SENSE_RISING,		/*!< IOPORT㏸[m */
	IOPORT_SENSE_LEVEL_LOW,		/*!< IOPORT Lowيm  */
	IOPORT_SENSE_LEVEL_HIGH,	/*!< IOPORT Highيm */
};
#else
enum ioport_sense {
	IOPORT_SENSE_BOTHEDGES,		/*!< IOPORT㏸/~̗[m */
	IOPORT_SENSE_RISING,		/*!< IOPORT㏸[m */
	IOPORT_SENSE_FALLING,		/*!< IOPORT~[m */
};
#endif


#if XMEGA
# include "xmega/ioport.h"
# if defined(IOPORT_XMEGA_COMPAT)
#  include "xmega/ioport_compat.h"
# endif
#elif MEGA
#  include "mega/ioport.h"
#elif UC3
# include "uc3/ioport.h"
#elif SAM
# if SAM4L
#  include "sam/ioport_gpio.h"
# elif SAMD20
#  include "sam0/ioport.h"
# else
#  include "sam/ioport_pio.h"
# endif
#endif

/**
 * \brief gp\ȏԂIOPORT޽
 *
 * ̊֐IOPORT޽̑̂ǂ̊֐gp̂ɂ旧ČĂ΂Ȃ
 * Ȃ܂B
 */
static inline void ioport_init(void)
{
	arch_ioport_init();
}

/**
 * \brief \ref IOPORT_CREATE_PIN() ō쐬ꂽ݂ɊÂIOPORT݂
 *
 * \param  pin IOPORT
 */
static inline void ioport_enable_pin(ioport_pin_t pin)
{
	arch_ioport_enable_pin(pin);
}

/**
 * \brief PIOPORT߰ē݂̕
 *
 * \param  port IOPORT߰
 * \param  mask ߰ē̋݂̎Օ
 */
static inline void ioport_enable_port(ioport_port_t port,
		ioport_port_mask_t mask)
{
	arch_ioport_enable_port(port, mask);
}

/**
 * \brief \ref IOPORT_CREATE_PIN() ō쐬ꂽ݂ɊÂIOPORT݂֎~
 *
 * \param  pin ֎~IOPORT
 */
static inline void ioport_disable_pin(ioport_pin_t pin)
{
	arch_ioport_disable_pin(pin);
}

/**
 * \brief PIOPORT߰ē݂̕֎~
 *
 * \param  port ֎~IOPORT߰
 * \param  mask ߰ē̋֎~݂̎Օ
 */
static inline void ioport_disable_port(ioport_port_t port,
		ioport_port_mask_t mask)
{
	arch_ioport_disable_port(port, mask);
}

/**
 * \brief PIOPRT߰ē݂̓̕ٱ߁A޳݂Ȃǂ̂悤Ȍ`Ԑݒ
 *        ɐݒ
 *
 * \param  port `Ԑݒ肷IOPORT߰
 * \param  mask `Ԑݒ肷݂ݎՕ
 * \param  mode w肷݂ɑ΂Č`Ԑݒ肷邽߂̓Օ(\ref ioport_modes)
 */
static inline void ioport_set_port_mode(ioport_port_t port,
		ioport_port_mask_t mask, ioport_mode_t mode)
{
	arch_ioport_set_port_mode(port, mask, mode);
}

/**
 * \brief PIOPORT݂ɑ΂ݓݒ
 *
 * \param  pin  `Ԑݒ肷IOPORT
 * \param  mode w肷݂ɑ΂Č`Ԑݒ肷邽߂̓Օ(\ref ioport_modes)
 */
static inline void ioport_set_pin_mode(ioport_pin_t pin, ioport_mode_t mode)
{
	arch_ioport_set_pin_mode(pin, mode);
}

/**
 * \brief w肷IOPORT߰Ăŕ݂̓ؾ
 *
 * \param  port `Ԑݒ肷IOPORT߰
 * \param  mask `Ԑݒ肪ؾĂ݂̂̎Օ
 */
static inline void ioport_reset_port_mode(ioport_port_t port,
		ioport_port_mask_t mask)
{
	arch_ioport_set_port_mode(port, mask, 0);
}

/**
 * \brief PIOPORT݂ɑ΂ē`Ԑݒؾ
 *
 * \param  pin `Ԑݒ肷IOPORT
 */
static inline void ioport_reset_pin_mode(ioport_pin_t pin)
{
	arch_ioport_set_pin_mode(pin, 0);
}

/**
 * \brief PIOPORT݌Qɓo͕ݒ
 *
 * \param  port `Ԑݒ肷IOPORT߰
 * \param  mask `Ԑݒ肷݂ݎՕ
 * \param  dir  w肷݂ɐݒ肷(\ref ioport_direction)
 */
static inline void ioport_set_port_dir(ioport_port_t port,
		ioport_port_mask_t mask, enum ioport_direction dir)
{
	arch_ioport_set_port_dir(port, mask, dir);
}

/**
 * \brief PIOPORT݂ɕݒ
 *
 * \param  pin `Ԑݒ肷IOPORT
 * \param  dir w肷݂ɐݒ肷(\ref ioport_direction)
 */
static inline void ioport_set_pin_dir(ioport_pin_t pin,
		enum ioport_direction dir)
{
	arch_ioport_set_pin_dir(pin, dir);
}

/**
 * \brief IOPORT݂Ɏw肷_lݒ
 *
 * \param  pin   `Ԑݒ肷IOPORT
 * \param  level ݂̘_l
 */
static inline void ioport_set_pin_level(ioport_pin_t pin, bool level)
{
	arch_ioport_set_pin_level(pin, level);
}

/**
 * \brief P߰ĂIOPORT݌Qw_lɐݒ
 *
 * \param  port  IOPORT߰
 * \param  mask  ύX݂ݎՕ
 * \param  level ύX݂
 */
static inline void ioport_set_port_level(ioport_port_t port,
		ioport_port_mask_t mask, ioport_port_mask_t level)
{
	arch_ioport_set_port_level(port, mask, level);
}

/**
 * \brief ͂ƂČ`Ԑݒ肳ꂽIOPORŤ݂ݒl擾
 *
 * \param  pin ǂIOPORT
 * \return w肵݂݂̘̌_l
 */
static inline bool ioport_get_pin_level(ioport_pin_t pin)
{
	return arch_ioport_get_pin_level(pin);
}

/**
 * \brief ͂ƂČ`Ԑݒ肳ꂽP߰Ă̏IOPORŤ݂ݒl擾
 *
 * \param  port ǂIOPORT߰
 * \param  mask ǂ݂ݎՕ
 * \return Logical ՕƂĕԂAǂ߰Ăw肵݂
 */
static inline ioport_port_mask_t ioport_get_port_level(ioport_pin_t port,
		ioport_port_mask_t mask)
{
	return arch_ioport_get_port_level(port, mask);
}

/**
 * \brief ȑOɏo͂ƂČ`Ԑݒ肳ꂽIOPORT݂̒l؂ւ
 *
 * \param  pin ؂ւIOPORT
 */
static inline void ioport_toggle_pin_level(ioport_pin_t pin)
{
	arch_ioport_toggle_pin_level(pin);
}

/**
 * \brief P߰ĂɒuꂽIOPORT݂̒l؂ւ
 *
 * \param  port ύXIOPORT߰
 * \param  mask ؂ւ݂ݎՕ
 */
static inline void ioport_toggle_port_level(ioport_port_t port,
		ioport_port_mask_t mask)
{
	arch_ioport_toggle_port_level(port, mask);
}

/**
 * \brief PIOIPORT݂݊mݒ
 *
 * \param  pin       `Ԑݒ肷IOPORT
 * \param  pin_sense ݂Ŋm[(\ref ioport_sense)
 */
static inline void ioport_set_pin_sense_mode(ioport_pin_t pin,
		enum ioport_sense pin_sense)
{
	arch_ioport_set_pin_sense_mode(pin, pin_sense);
}

/**
 * \brief P߰ĂŕIOPORT݂݊mݒ
 *
 * \param  port      `Ԑݒ肷IOPORT߰
 * \param  mask      ݂[mɌ`Ԑݒ肳ꍇޯĎՕ
 * \param  pin_sense ݂Ŋm[(\ref ioport_sense)
 */
static inline void ioport_set_port_sense_mode(ioport_port_t port,
		ioport_port_mask_t mask,
		enum ioport_sense pin_sense)
{
	arch_ioport_set_port_sense_mode(port, mask, pin_sense);
}

/**
 * \brief ݎʎq߰Ďʎqɕϊ
 *
 * \param  pin ϊIOPORTݎʎq
 * \retval Port ^ꂽݎʎqɑ΂߰Ďʎq
 */
static inline ioport_port_t ioport_pin_to_port_id(ioport_pin_t pin)
{
	return arch_ioport_pin_to_port_id(pin);
}

/**
 * \brief ݎʎq߰Ăŗ^ꂽ݂ɑ΂ޯĎՕɕύX
 *
 * \param  pin ϊIOPORTݎʎq
 * \retval ߰Ăŗ^ꂽݎʎqɑΉޯĂ̑gޯĎՕ
 */
static inline ioport_port_mask_t ioport_pin_to_mask(ioport_pin_t pin)
{
	return arch_ioport_pin_to_mask(pin);
}

/** @} */

/**
 * \page ioport_quickstart IOPORT޽pJn̎
 *
 * ͎gpʂ̑IŻ޽`Ԑݒ肵Ďg@̒iKIȎwł
 * \ref ioport_group pJn̎łB
 *
 * gpʂ͏̺ޒfЂ܂݂܂B\ݒiKł̺ޒfЂ͓Ǝ֐
 * ɕʂ邱ƂłAgiK͗Ⴆ΁A剞p֐ɕʂ邱Ƃł
 * ܂B
 *
 * \section ioport_quickstart_basic {IȎgp
 * ̎gpʂł͖t͗p1I/O݂LEDp1`Ԑݒ肵܂B
 * ɖtԂǂłLEDɏo͂܂B
 *
 * \section ioport_quickstart_basic_setup \ݒiK
 *
 * \subsection ioport_quickstart_basic_setup_code ޗ
 * \code
 * #define MY_LED    IOPORT_CREATE_PIN(PORTA, 5)
 * #define MY_BUTTON IOPORT_CREATE_PIN(PORTA, 6)
 *
 * ioport_init();
 *
 * ioport_set_pin_dir(MY_LED, IOPORT_DIR_OUTPUT);
 * ioport_set_pin_dir(MY_BUTTON, IOPORT_DIR_INPUT);
 * ioport_set_pin_mode(MY_BUTTON, IOPORT_MODE_PULLUP);
 * \endcode
 *
 * \subsection ioport_quickstart_basic_setup_flow Ƃ̗
 * -# GPIOɼٖ^̂LpŁA\ref IOPORT_CREATE_PIN ϸۂōs
 *    ܂BLEDp1Ɩtp1`܂B
 *   - \code
 *     #define MY_LED    IOPORT_CREATE_PIN(PORTA, 5)
 *     #define MY_BUTTON IOPORT_CREATE_PIN(PORTA, 6)
 *     \endcode
 *   - \note \ref IOPORT_CREATE_PIN ϸۂ̎gՂ߰Ė͊{\ԂňقȂ
 *           B
 *     - MEGA,MEGA_RF,XMEGA: PORTA,PORTB,`߰Ē`Ƌ\ref IOPORT_CREATE_PIN 
 *                           ϸۂg܂B
 *     - UC3: ޲ ͯ ̧ ݒ`𓾂邱Ƃł֗ŁA𒼐ځAႦ
 *            : AVR32_PIN_PB06Ǝg܂B
 *     - SAM: ޲ ͯ ̧ ݒ`𓾂邱Ƃł֗ŁA𒼐ځAႦ
 *            : PIO_PA5_IDXƎg܂BPIO_PA5_IDX<br>
 *            \ref IOPORT_CREATE_PIN PIOA PIOB,`߰Ē`ƋɎgp邱Ƃ
 *            ł܂B
 * -# IOPORT޽B͈ʓIɕKvƂꍇI/OPʕ
 *    B
 *   - \code ioport_init(); \endcode
 * -# LEDpGPIOo͂ƂĐݒ
 *   - \code ioport_set_pin_dir(MY_LED, IOPORT_DIR_OUTPUT); \endcode
 * -# tpGPIO͂ƂĐݒ
 *   - \code ioport_set_pin_dir(MY_BUTTON, IOPORT_DIR_INPUT); \endcode
 * -# tpGPIOɑ΂ٱ߂
 *   - \code ioport_set_pin_mode(MY_BUTTON, IOPORT_MODE_PULLUP); \endcode
 *
 * \section ioport_quickstart_basic_usage giK
 *
 * \subsection ioport_quickstart_basic_usage_code ޗ
 * \code
 * bool value;
 *
 * value = ioport_get_pin_level(MY_BUTTON);
 * ioport_set_pin_level(MY_LED, value);
 * \endcode
 *
 * \subsection ioport_quickstart_basic_usage_flow Workflow
 * -# ԋLpްϐ`
 *   - \code bool value; \endcode
 * -# tقϐlɓǂݏo
 *   - \code value = ioport_get_pin_level(MY_BUTTON); \endcode
 * -# t̓ǂݏolLEDɐݒ
 *   - \code ioport_set_pin_level(MY_LED, value); \endcode
 *
 * \section ioport_quickstart_advanced xȎgp
 * - \subpage ioport_quickstart_use_case_1 : ߰ 
 */

/**
 * \page ioport_quickstart_use_case_1 ߰ sxȎgp
 *
 * ̏ꍇA߰đŜ݂ǂݏoĕʂ߰Ăɓǂ񂾒l܂B
 *
 * \section ioport_quickstart_use_case_1_setup \ݒiK
 *
 * \subsection ioport_quickstart_use_case_1_setup_code ޗ
 * \code
 * #define IN_PORT  IOPORT_PORTA
 * #define OUT_PORT IOPORT_PORTB
 * #define MASK     0x00000060
 *
 * ioport_init();
 *
 * ioport_set_port_dir(IN_PORT, MASK, IOPORT_DIR_INPUT);
 * ioport_set_port_dir(OUT_PORT, MASK, IOPORT_DIR_OUTPUT);
 * \endcode
 *
 * \subsection ioport_quickstart_basic_setup_flow Workflow
 * -# ߰Ă̼ٖ^邱ƂLpłB
 *   - \code
 *     #define IN_PORT  IOPORT_PORTA
 *     #define OUT_PORT IOPORT_PORTB
 *     \endcode
 *   - \note ߰Ė͊{\ԂňႢ܂B
 *     - MEGA_RF,MEGA,XMEGA: ߰Ăɑ΂ė\ߒ`ꂽO܂B
 *                           : IOPORT_PORTA,IOPORT_PORTB,`
 *     - UC3: eI/O̎wWlgp: 0,1,`
 *     - SAM: ߰Ăɑ΂ė\ߒ`ꂽO܂B
 *            : IOPORT_PIOA,IOPORT_PIOB,`
 * -# ɓ߂ޯĂɑ΂Օ`̂LpłB
 *     - \code #define MASK     0x00000060 \endcode
 * -# I/O߰ ޽B͈ʓIɕKvƂꍇI/OPʕ
 *    ܂B
 *   - \code ioport_init(); \endcode
 * -# ߰Ă1͂ƂĐݒ
 *   - \code ioport_set_pin_dir(IN_PORT, MASK, IOPORT_DIR_INPUT); \endcode
 * -# ʂ߰Ăo͂ƂĐݒ
 *   - \code ioport_set_pin_dir(OUT_PORT, MASK, IOPORT_DIR_OUTPUT); \endcode
 *
 * \section ioport_quickstart_basic_usage giK
 *
 * \subsection ioport_quickstart_basic_usage_code ޗ
 * \code
 * ioport_port_mask_t value;
 *
 * value = ioport_get_port_level(IN_PORT, MASK);
 * ioport_set_port_level(OUT_PORT, MASK, value);
 * \endcode
 *
 * \subsection ioport_quickstart_basic_usage_flow Ƃ̗
 * -# ߰ ްLpϐ`
 *   - \code ioport_port_mask_t value; \endcode
 * -# 1߰Ăǂݍ
 *   - \code value = ioport_get_port_level(IN_PORT, MASK); \endcode
 * -# ǂްʂ߰ďo͂֏o
 *   - \code ioport_set_port_level(OUT_PORT, MASK, value); \endcode
 */

#ifdef __cplusplus
}
#endif

#endif /* IOPORT_H */
