/**
 * \file
 *
 * \brief x~Ǘ
 *
 * 쌠 (c) 2010 - 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef SLEEPMGR_H
#define SLEEPMGR_H

#include <compiler.h>
#include <parts.h>

#if (SAM3S || SAM3U || SAM3N || SAM3XA || SAM4S || SAM4E || SAM4N)
# include "sam/sleepmgr.h"
#elif XMEGA
# include "xmega/sleepmgr.h"
#elif UC3
# include "uc3/sleepmgr.h"
#elif SAM4L
# include "sam4l/sleepmgr.h"
#else
# error Unsupported device.
#endif

/**
 * \defgroup sleepmgr_group x~Ǘ
 *
 * x~Ǘͼ(Ⴆ΁AӋ@\ײށA޽A܂͉p)ł
 * ̂[x~ł̋x~޲uȂƂۏ؂邽߂̻޽
 * B
 *
 * ͌ʋx~p̎{v̎gpŁA0łȂ{vł󂢋x~
 * ł̋x~޲u܂Bײ/޽/p\ref sleepmgr_lock_mode 
 * \ref sleepmgr_unlock_modegp邱ƂɂĂ̌vύX邱
 * ł܂B{ɑ΂ėp\ȋx~̈ꗗɂĂ\ref sleepmgr_mode 
 * Ǎʂ̏ɂĂްĂQƂĂB
 *
 * p\ref conf_sleepmgr.h ̧قȂ΂Ȃ܂B
 *
 * x~ɂāA\ref CONFIG_SLEEPMGR_ENABLE قႦ΁A
 * \ref conf_sleepmgr.h Œ`Ȃ΂Ȃ܂B̼ق`Ȃ
 * ΁A֐͋U֐ŒuRAMSgp܂B
 *
 * @{
 */

/**
 * \def CONFIG_SLEEPMGR_ENABLE
 * \brief x~Ǘ邽߂̼ق`Ԑݒ
 *
 * ̼ق`ȂꍇA̻޽̊֐͋U֐Œu܂B
 * ͉pŋx~ǗKvƂȂꍇɺޗʂƎsԂ炷̂ɗLp
 * B
 *
 * ̼ق\ref conf_sleepmgr.h Œ`邩܂B
 */
#if defined(__DOXYGEN__) && !defined(CONFIG_SLEEPMGR_ENABLE)
#  define CONFIG_SLEEPMGR_ENABLE
#endif

/**
 * \enum sleepmgr_mode
 * \brief x~{
 *
 * ex~{pʎq
 */

/**
 * \brief {v
 *
 * 1ɐݒ肳Ō̂̂ASĂ̎{v0ɐݒB
 * \ref sleepmgr_enter_sleep ŋł[x~Z@ȒPɂ
 * 邽߂ɍs܂B
 */
static inline void sleepmgr_init(void)
{
#ifdef CONFIG_SLEEPMGR_ENABLE
	uint8_t i;

	for (i = 0; i < SLEEPMGR_NR_OF_MODES - 1; i++) {
		sleepmgr_locks[i] = 0;
	}
	sleepmgr_locks[SLEEPMGR_NR_OF_MODES - 1] = 1;
#endif /* CONFIG_SLEEPMGR_ENABLE */
}

/**
 * \brief x~ɑ΂Ď{v𑝉
 *
 * [x~ł̋x~޲uȂƂۏ؂邽߂\a mode ɑ΂
 * {v𑝉܂B
 *
 * \param  mode {x~
 */
static inline void sleepmgr_lock_mode(enum sleepmgr_mode mode)
{
#ifdef CONFIG_SLEEPMGR_ENABLE
	irqflags_t flags;

	Assert(sleepmgr_locks[mode] < 0xff);

	// dvȗ̈֓B
	flags = cpu_irq_save();

	++sleepmgr_locks[mode];

	// dvȗ̈𔲂oB
	cpu_irq_restore(flags);
#else
	UNUSED(mode);
#endif /* CONFIG_SLEEPMGR_ENABLE */
}

/**
 * \brief x~ɑ΂{v
 *
 * \a mode p̎{vB{v0ɒBꍇAx~Ǘ޲
 * [x~ł̋x~ɒuƂł܂B
 *
 * \param  mode x~
 */
static inline void sleepmgr_unlock_mode(enum sleepmgr_mode mode)
{
#ifdef CONFIG_SLEEPMGR_ENABLE
	irqflags_t flags;

	Assert(sleepmgr_locks[mode]);

	// dvȗ̈֓B
	flags = cpu_irq_save();

	--sleepmgr_locks[mode];

	// dvȗ̈𔲂oB
	cpu_irq_restore(flags);
#else
	UNUSED(mode);
#endif /* CONFIG_SLEEPMGR_ENABLE */
}

 /**
 * \brief ł[x~擾
 *
 * ł󂢋x~Ŏn߂āA0łȂŏ̎{v܂ŋx~{v
 * ʂČ܂B̌ɋł[x~삪Ԃ܂B
 */
static inline enum sleepmgr_mode sleepmgr_get_sleep_mode(void)
{
	enum sleepmgr_mode sleep_mode = SLEEPMGR_ACTIVE;

#ifdef CONFIG_SLEEPMGR_ENABLE
	uint8_t *lock_ptr = sleepmgr_locks;

	// ł󂢓Ŏn߂āA0łȂŏ̎{vT܂B
	while (!(*lock_ptr)) {
		lock_ptr++;
		sleep_mode = (enum sleepmgr_mode)(sleep_mode + 1);
	}

	// ł[x~ősleepmgr_unlock_mode()Ăяosꍇ
	// B
	Assert((uintptr_t)(lock_ptr - sleepmgr_locks) < SLEEPMGR_NR_OF_MODES);

#endif /* CONFIG_SLEEPMGR_ENABLE */

	return sleep_mode;
}

/**
 * \fn sleepmgr_enter_sleep
 * \brief ꂽł[ŋx~֍sB
 *
 * ł󂢋x~Ŏn߂āAŏ0łȂ{v܂ŋx~{v
 * ʂČ܂B̌޲͎{ɑΉx~ŋx~ɒu܂B
 *
 * \note ̊֐͋x~֍sOɊ荞݂BAłꂽ܂
 * ɂ܂B͊삪{Ă邽߂ɋx~΂ꍇɂKp
 * ܂B
 */

static inline void sleepmgr_enter_sleep(void)
{
#ifdef CONFIG_SLEEPMGR_ENABLE
	enum sleepmgr_mode sleep_mode;

	cpu_irq_disable();

	// ꂽł[x~TB
	sleep_mode = sleepmgr_get_sleep_mode();
	// ŏ̓(){ꍇɒɕA
	if (sleep_mode==SLEEPMGR_ACTIVE) {
		cpu_irq_enable();
		return;
	}
	// 荞݋ŋꂽł[x~ֈڍs
	sleepmgr_sleep(sleep_mode);
#else
	cpu_irq_enable();
#endif /* CONFIG_SLEEPMGR_ENABLE */
}

//! @}

#endif /* SLEEPMGR_H */
