/**
 * \file
 *
 * \brief P̪USBupCDC`Ԑݒ
 *
 * 쌠 (c) 2009 - 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page License
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _UDI_CDC_CONF_H_
#define _UDI_CDC_CONF_H_

#include "usb_protocol_cdc.h"
#include "conf_usb.h"

#ifndef  UDI_CDC_PORT_NB
# define  UDI_CDC_PORT_NB 1
#endif

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \addtogroup udi_cdc_group_single_desc
 * @{
 */

//! ߲Ă̑傫(߲0)
#define  USB_DEVICE_EP_CTRL_SIZE		64

#if XMEGA
/**
 * \name XMEGAp߲Č`Ԑݒ
 * XMEGA͓ԍ̴߲ĂINOUT̴߲ĂxÂXMEGA7܂ł
 * CDC߲Ăx邱Ƃł܂B
 */
//@{
#define  UDI_CDC_DATA_EP_IN_0			( 1 | USB_EP_DIR_IN)  // M
#define  UDI_CDC_DATA_EP_OUT_0			( 2 | USB_EP_DIR_OUT) // M
#define  UDI_CDC_COMM_EP_0				( 2 | USB_EP_DIR_IN)  // ʒm߲
#define  UDI_CDC_DATA_EP_IN_1			( 3 | USB_EP_DIR_IN)  // M
#define  UDI_CDC_DATA_EP_OUT_1			( 4 | USB_EP_DIR_OUT) // M
#define  UDI_CDC_COMM_EP_1				( 4 | USB_EP_DIR_IN)  // ʒm߲
#define  UDI_CDC_DATA_EP_IN_2			( 5 | USB_EP_DIR_IN)  // M
#define  UDI_CDC_DATA_EP_OUT_2			( 6 | USB_EP_DIR_OUT) // M
#define  UDI_CDC_COMM_EP_2				( 6 | USB_EP_DIR_IN)  // ʒm߲
#define  UDI_CDC_DATA_EP_IN_3			( 7 | USB_EP_DIR_IN)  // M
#define  UDI_CDC_DATA_EP_OUT_3			( 8 | USB_EP_DIR_OUT) // M
#define  UDI_CDC_COMM_EP_3				( 8 | USB_EP_DIR_IN)  // ʒm߲
#define  UDI_CDC_DATA_EP_IN_4			( 9 | USB_EP_DIR_IN)  // M
#define  UDI_CDC_DATA_EP_OUT_4			(10 | USB_EP_DIR_OUT) // M
#define  UDI_CDC_COMM_EP_4				(10 | USB_EP_DIR_IN)  // ʒm߲
#define  UDI_CDC_DATA_EP_IN_5			(11 | USB_EP_DIR_IN)  // M
#define  UDI_CDC_DATA_EP_OUT_5			(12 | USB_EP_DIR_OUT) // M
#define  UDI_CDC_COMM_EP_5				(12 | USB_EP_DIR_IN)  // ʒm߲
#define  UDI_CDC_DATA_EP_IN_6			(13 | USB_EP_DIR_IN)  // M
#define  UDI_CDC_DATA_EP_OUT_6			(14 | USB_EP_DIR_OUT) // M
#define  UDI_CDC_COMM_EP_6				(14 | USB_EP_DIR_IN)  // ʒm߲
//! CDC̪ɑ΂Ďgp2̴߲Ĕԍ
#define  USB_DEVICE_MAX_EP				(2*UDI_CDC_PORT_NB)
//@}

#else

/**
 * \name ߲Č`Ԑݒ
 * USBB,UDP,UDPHS,UOTGHS̪2܂łCDC̪x邱Ƃł܂B
 */
//@{
#  if UDI_CDC_PORT_NB > 2
#    error USBB, UDP, UDPHS and UOTGHS interfaces have not enought endpoints.
#  endif
#define  UDI_CDC_DATA_EP_IN_0			(1 | USB_EP_DIR_IN)		// M
#define  UDI_CDC_DATA_EP_OUT_0			(2 | USB_EP_DIR_OUT)	// M
#define  UDI_CDC_COMM_EP_0				(3 | USB_EP_DIR_IN)		// ʒm߲
#  if SAM3U
     /* 3Uɑ΂4̍ő߲Ă̑傫64ŁAʑMƂ56gp */
#    define  UDI_CDC_DATA_EP_IN_1		(6 | USB_EP_DIR_IN)		// M
#    define  UDI_CDC_DATA_EP_OUT_1		(5 | USB_EP_DIR_OUT)	// M
#    define  UDI_CDC_COMM_EP_1			(4 | USB_EP_DIR_IN)		// ʒm
#  else
#    define  UDI_CDC_DATA_EP_IN_1		(4 | USB_EP_DIR_IN)		// M
#    define  UDI_CDC_DATA_EP_OUT_1		(5 | USB_EP_DIR_OUT)	// M
#    define  UDI_CDC_COMM_EP_1			(6 | USB_EP_DIR_IN)		// ʒm
#  endif
//! CDC̪ɑ΂Ďgp3߲
#define  USB_DEVICE_MAX_EP				(3*UDI_CDC_PORT_NB)
//@}

#endif

/**
 * \name ̪ԍ
 */
//@{
#define  UDI_CDC_COMM_IFACE_NUMBER_0	 0
#define  UDI_CDC_DATA_IFACE_NUMBER_0	 1
#define  UDI_CDC_COMM_IFACE_NUMBER_1	 2
#define  UDI_CDC_DATA_IFACE_NUMBER_1	 3
#define  UDI_CDC_COMM_IFACE_NUMBER_2	 4
#define  UDI_CDC_DATA_IFACE_NUMBER_2	 5
#define  UDI_CDC_COMM_IFACE_NUMBER_3	 6
#define  UDI_CDC_DATA_IFACE_NUMBER_3	 7
#define  UDI_CDC_COMM_IFACE_NUMBER_4	 8
#define  UDI_CDC_DATA_IFACE_NUMBER_4	 9
#define  UDI_CDC_COMM_IFACE_NUMBER_5	10
#define  UDI_CDC_DATA_IFACE_NUMBER_5	11
#define  UDI_CDC_COMM_IFACE_NUMBER_6	12
#define  UDI_CDC_DATA_IFACE_NUMBER_6	13
//@}

//@}

#ifdef __cplusplus
}
#endif
#endif // _UDI_CDC_CONF_H_
