/**
 * \file
 *
 * \brief SMAPp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAM4L_SMAP_COMPONENT_
#define _SAM4L_SMAP_COMPONENT_

/* ========================================================================== */
/** SMAPpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAM4L_SMAP ъǗ ߰ */
/*@{*/

#define REV_SMAP					0x100

/* -------- SMAP_CR : (SMAPψ:0x00) ( /W 32)ڼ޽ -------- */
#define SMAP_CR_OFFSET				0x00			/**< \brief (SMAP_CRψ)ڼ޽ */
#define SMAP_CR_RESETVALUE			0x00000000		/**< \brief (SMAP_CR reset_value)ڼ޽ */

#define SMAP_CR_EN_Pos				0				/**< \brief (SMAP_CR) */
#define SMAP_CR_EN					(0x1u << SMAP_CR_EN_Pos)
#define SMAP_CR_DIS_Pos				1				/**< \brief (SMAP_CR)֎~ */
#define SMAP_CR_DIS					(0x1u << SMAP_CR_DIS_Pos)
#define SMAP_CR_CRC_Pos				2				/**< \brief (SMAP_CR)gp߰ޓǂݍ */
#define SMAP_CR_CRC					(0x1u << SMAP_CR_CRC_Pos)
#define SMAP_CR_FSPR_Pos			3				/**< \brief (SMAP_CR)ׯ⑫߰ޓǂݍ */
#define SMAP_CR_FSPR				(0x1u << SMAP_CR_FSPR_Pos)
#define SMAP_CR_CE_Pos				4				/**< \brief (SMAP_CR)ߏ */
#define SMAP_CR_CE					(0x1u << SMAP_CR_CE_Pos)
#define SMAP_CR_MASK				0x0000001Fu		/**< \brief (SMAP_CR)MASKڼ޽ */

/* -------- SMAP_SR : (SMAPψ:0x04) (R/  32)ڼ޽ -------- */
#define SMAP_SR_OFFSET				0x04			/**< \brief (SMAP_SRψ)ڼ޽ */
#define SMAP_SR_RESETVALUE			0x00000000		/**< \brief (SMAP_SR reset_value)ڼ޽ */

#define SMAP_SR_DONE_Pos			0				/**< \brief (SMAP_SR)I */
#define SMAP_SR_DONE				(0x1u << SMAP_SR_DONE_Pos)
#define SMAP_SR_HCR_Pos				1				/**< \brief (SMAP_SR) ؾĕێ */
#define SMAP_SR_HCR					(0x1u << SMAP_SR_HCR_Pos)
#define SMAP_SR_BERR_Pos			2				/**< \brief (SMAP_SR)޽ُ */
#define SMAP_SR_BERR				(0x1u << SMAP_SR_BERR_Pos)
#define SMAP_SR_FAIL_Pos			3				/**< \brief (SMAP_SR)Q */
#define SMAP_SR_FAIL				(0x1u << SMAP_SR_FAIL_Pos)
#define SMAP_SR_LCK_Pos				4				/**< \brief (SMAP_SR){ */
#define SMAP_SR_LCK					(0x1u << SMAP_SR_LCK_Pos)
#define SMAP_SR_EN_Pos				8				/**< \brief (SMAP_SR) */
#define SMAP_SR_EN					(0x1u << SMAP_SR_EN_Pos)
#define SMAP_SR_PROT_Pos			9				/**< \brief (SMAP_SR)ی */
#define SMAP_SR_PROT				(0x1u << SMAP_SR_PROT_Pos)
#define SMAP_SR_DBGP_Pos			10				/**< \brief (SMAP_SR)ޯޑ */
#define SMAP_SR_DBGP				(0x1u << SMAP_SR_DBGP_Pos)
#define SMAP_SR_STATE_Pos			24				/**< \brief (SMAP_SR) */
#define SMAP_SR_STATE_Msk			(0x7u << SMAP_SR_STATE_Pos)
#define SMAP_SR_STATE(value)		((SMAP_SR_STATE_Msk & ((value) << SMAP_SR_STATE_Pos)))
#define SMAP_SR_MASK				0x0700071Fu		/**< \brief (SMAP_SR)MASKڼ޽ */

/* -------- SMAP_SCR : (SMAPψ:0x08) ( /W 32)ԉڼ޽ -------- */
#define SMAP_SCR_OFFSET				0x08			/**< \brief (SMAP_SCRψ)ԉڼ޽ */
#define SMAP_SCR_RESETVALUE			0x00000000		/**< \brief (SMAP_SCR reset_value)ԉڼ޽ */

#define SMAP_SCR_DONE_Pos			0				/**< \brief (SMAP_SCR)I */
#define SMAP_SCR_DONE				(0x1u << SMAP_SCR_DONE_Pos)
#define SMAP_SCR_HCR_Pos			1				/**< \brief (SMAP_SCR) ڼ޽ێ */
#define SMAP_SCR_HCR				(0x1u << SMAP_SCR_HCR_Pos)
#define SMAP_SCR_BERR_Pos			2				/**< \brief (SMAP_SCR)޽ُ */
#define SMAP_SCR_BERR				(0x1u << SMAP_SCR_BERR_Pos)
#define SMAP_SCR_FAIL_Pos			3				/**< \brief (SMAP_SCR)Q */
#define SMAP_SCR_FAIL				(0x1u << SMAP_SCR_FAIL_Pos)
#define SMAP_SCR_LCK_Pos			4				/**< \brief (SMAP_SCR){ُ */
#define SMAP_SCR_LCK				(0x1u << SMAP_SCR_LCK_Pos)
#define SMAP_SCR_MASK				0x0000001Fu		/**< \brief (SMAP_SCR)MASKڼ޽ */

/* -------- SMAP_ADDR : (SMAPψ:0x0C) (R/W 32)ڽ ڼ޽ -------- */
#define SMAP_ADDR_OFFSET			0x0C			/**< \brief (SMAP_ADDRψ)ڽ ڼ޽ */
#define SMAP_ADDR_RESETVALUE		0x00000000		/**< \brief (SMAP_ADDR reset_value)ڽ ڼ޽ */

#define SMAP_ADDR_ADDR_Pos			2				/**< \brief (SMAP_ADDR)ڽl */
#define SMAP_ADDR_ADDR_Msk			(0x3FFFFFFFu << SMAP_ADDR_ADDR_Pos)
#define SMAP_ADDR_ADDR(value)		((SMAP_ADDR_ADDR_Msk & ((value) << SMAP_ADDR_ADDR_Pos)))
#define SMAP_ADDR_MASK				0xFFFFFFFCu		/**< \brief (SMAP_ADDR)MASKڼ޽ */

/* -------- SMAP_LENGTH : (SMAPψ:0x10) (R/W 32)ڼ޽ -------- */
#define SMAP_LENGTH_OFFSET			0x10			/**< \brief (SMAP_LENGTHψ)ڼ޽ */
#define SMAP_LENGTH_RESETVALUE		0x00000000		/**< \brief (SMAP_LENGTH reset_value)ڼ޽ */

#define SMAP_LENGTH_LENGTH_Pos		2				/**< \brief (SMAP_LENGTH)ڼ޽ */
#define SMAP_LENGTH_LENGTH_Msk		(0x3FFFFFFFu << SMAP_LENGTH_LENGTH_Pos)
#define SMAP_LENGTH_LENGTH(value)	((SMAP_LENGTH_LENGTH_Msk & ((value) << SMAP_LENGTH_LENGTH_Pos)))
#define SMAP_LENGTH_MASK			0xFFFFFFFCu		/**< \brief (SMAP_LENGTH)MASKڼ޽ */

/* -------- SMAP_DATA : (SMAPψ:0x14) (R/W 32)ް ڼ޽ -------- */
#define SMAP_DATA_OFFSET			0x14			/**< \brief (SMAP_DATAψ)ް ڼ޽ */
#define SMAP_DATA_RESETVALUE		0x00000000		/**< \brief (SMAP_DATA reset_value)ް ڼ޽ */

#define SMAP_DATA_DATA_Pos			0				/**< \brief (SMAP_DATA)Wް ڼ޽ */
#define SMAP_DATA_DATA_Msk			(0xFFFFFFFFu << SMAP_DATA_DATA_Pos)
#define SMAP_DATA_DATA(value)		((SMAP_DATA_DATA_Msk & ((value) << SMAP_DATA_DATA_Pos)))
#define SMAP_DATA_MASK				0xFFFFFFFFu		/**< \brief (SMAP_DATA)MASKڼ޽ */

/* -------- SMAP_VERSION : (SMAPψ:0x28) (R/  32)ڼ޽ -------- */
#define SMAP_VERSION_OFFSET			0x28			/**< \brief (SMAP_VERSIONψ)ڼ޽ */
#define SMAP_VERSION_RESETVALUE		0x00000100		/**< \brief (SMAP_VERSION reset_value)ڼ޽ */

#define SMAP_VERSION_VERSION_Pos	0				/**< \brief (SMAP_VERSION)Ŕԍ */
#define SMAP_VERSION_VERSION_Msk	(0xFFFu << SMAP_VERSION_VERSION_Pos)
#define SMAP_VERSION_VERSION(value)	((SMAP_VERSION_VERSION_Msk & ((value) << SMAP_VERSION_VERSION_Pos)))
#define SMAP_VERSION_VARIANT_Pos	16				/**< \brief (SMAP_VERSION)ώԍ */
#define SMAP_VERSION_VARIANT_Msk	(0xFu << SMAP_VERSION_VARIANT_Pos)
#define SMAP_VERSION_VARIANT(value)	((SMAP_VERSION_VARIANT_Msk & ((value) << SMAP_VERSION_VARIANT_Pos)))
#define SMAP_VERSION_MASK			0x000F0FFFu		/**< \brief (SMAP_VERSION)MASKڼ޽ */

/* -------- SMAP_CIDR : (SMAPψ:0xF0) (R/  32)IDڼ޽ -------- */
#define SMAP_CIDR_OFFSET			0xF0			/**< \brief (SMAP_CIDRψ)IDڼ޽ */

#define SMAP_CIDR_VERSION_Pos		0				/**< \brief (SMAP_CIDR)޲̔ */
#define SMAP_CIDR_VERSION_Msk		(0x1Fu << SMAP_CIDR_VERSION_Pos)
#define SMAP_CIDR_VERSION(value)	((SMAP_CIDR_VERSION_Msk & ((value) << SMAP_CIDR_VERSION_Pos)))
#define SMAP_CIDR_EPROC_Pos			5				/**< \brief (SMAP_CIDR)gݍ۾ */
#define SMAP_CIDR_EPROC_Msk			(0x7u << SMAP_CIDR_EPROC_Pos)
#define SMAP_CIDR_EPROC(value)		((SMAP_CIDR_EPROC_Msk & ((value) << SMAP_CIDR_EPROC_Pos)))
#define SMAP_CIDR_NVPSIZ_Pos		8				/**< \brief (SMAP_CIDR)s۸ ؗe */
#define SMAP_CIDR_NVPSIZ_Msk		(0xFu << SMAP_CIDR_NVPSIZ_Pos)
#define SMAP_CIDR_NVPSIZ(value)		((SMAP_CIDR_NVPSIZ_Msk & ((value) << SMAP_CIDR_NVPSIZ_Pos)))
#define SMAP_CIDR_NVPSIZ2_Pos		12				/**< \brief (SMAP_CIDR)2s۸ ؗe */
#define SMAP_CIDR_NVPSIZ2_Msk		(0xFu << SMAP_CIDR_NVPSIZ2_Pos)
#define SMAP_CIDR_NVPSIZ2(value)	((SMAP_CIDR_NVPSIZ2_Msk & ((value) << SMAP_CIDR_NVPSIZ2_Pos)))
#define SMAP_CIDR_SRAMSIZ_Pos		16				/**< \brief (SMAP_CIDR)SRAMe */
#define SMAP_CIDR_SRAMSIZ_Msk		(0x1Fu << SMAP_CIDR_SRAMSIZ_Pos)
#define SMAP_CIDR_SRAMSIZ(value)	((SMAP_CIDR_SRAMSIZ_Msk & ((value) << SMAP_CIDR_SRAMSIZ_Pos)))
#define SMAP_CIDR_ARCH_Pos			21				/**< \brief (SMAP_CIDR){\ʎq */
#define SMAP_CIDR_ARCH_Msk			(0x7Fu << SMAP_CIDR_ARCH_Pos)
#define SMAP_CIDR_ARCH(value)		((SMAP_CIDR_ARCH_Msk & ((value) << SMAP_CIDR_ARCH_Pos)))
#define SMAP_CIDR_NVPTYP_Pos		28				/**< \brief (SMAP_CIDR)s۸ ،` */
#define SMAP_CIDR_NVPTYP_Msk		(0x7u << SMAP_CIDR_NVPTYP_Pos)
#define SMAP_CIDR_NVPTYP(value)		((SMAP_CIDR_NVPTYP_Msk & ((value) << SMAP_CIDR_NVPTYP_Pos)))
#define SMAP_CIDR_EXT_Pos			31				/**< \brief (SMAP_CIDR)g׸ */
#define SMAP_CIDR_EXT				(0x1u << SMAP_CIDR_EXT_Pos)
#define SMAP_CIDR_MASK				0xFFFFFFFFu		/**< \brief (SMAP_CIDR)MASKڼ޽ */

/* -------- SMAP_EXID : (SMAPψ:0xF4) (R/  32)IDgڼ޽r -------- */
#define SMAP_EXID_OFFSET			0xF4			/**< \brief (SMAP_EXIDψ)IDgڼ޽r */

#define SMAP_EXID_EXID_Pos			0				/**< \brief (SMAP_EXID)IDg */
#define SMAP_EXID_EXID_Msk			(0xFFFFFFFFu << SMAP_EXID_EXID_Pos)
#define SMAP_EXID_EXID(value)		((SMAP_EXID_EXID_Msk & ((value) << SMAP_EXID_EXID_Pos)))
#define SMAP_EXID_MASK				0xFFFFFFFFu		/**< \brief (SMAP_EXID)MASKڼ޽ */

/* -------- SMAP_IDR : (SMAPψ:0xFC) (R/  32)APʎqڼ޽ -------- */
#define SMAP_IDR_OFFSET				0xFC			/**< \brief (SMAP_IDRψ)APʎqڼ޽ */
#define SMAP_IDR_RESETVALUE			0x003E0000		/**< \brief (SMAP_IDR reset_value)APʎqڼ޽ */

#define SMAP_IDR_APIDV_Pos			0				/**< \brief (SMAP_IDR)APʕώ */
#define SMAP_IDR_APIDV_Msk			(0xFu << SMAP_IDR_APIDV_Pos)
#define SMAP_IDR_APIDV(value)		((SMAP_IDR_APIDV_Msk & ((value) << SMAP_IDR_APIDV_Pos)))
#define SMAP_IDR_APID_Pos			4				/**< \brief (SMAP_IDR)AP */
#define SMAP_IDR_APID_Msk			(0xFu << SMAP_IDR_APID_Pos)
#define SMAP_IDR_APID(value)		((SMAP_IDR_APID_Msk & ((value) << SMAP_IDR_APID_Pos)))
#define SMAP_IDR_CLSS_Pos			16				/**< \brief (SMAP_IDR) */
#define SMAP_IDR_CLSS				(0x1u << SMAP_IDR_CLSS_Pos)
#define SMAP_IDR_IC_Pos				17				/**< \brief (SMAP_IDR)JEP-106ʕ */
#define SMAP_IDR_IC_Msk				(0x7Fu << SMAP_IDR_IC_Pos)
#define SMAP_IDR_IC(value)			((SMAP_IDR_IC_Msk & ((value) << SMAP_IDR_IC_Pos)))
#define SMAP_IDR_CC_Pos				24				/**< \brief (SMAP_IDR)JEP-106p */
#define SMAP_IDR_CC_Msk				(0xFu << SMAP_IDR_CC_Pos)
#define SMAP_IDR_CC(value)			((SMAP_IDR_CC_Msk & ((value) << SMAP_IDR_CC_Pos)))
#define SMAP_IDR_REVISION_Pos		28				/**< \brief (SMAP_IDR) */
#define SMAP_IDR_REVISION_Msk		(0xFu << SMAP_IDR_REVISION_Pos)
#define SMAP_IDR_REVISION(value)	((SMAP_IDR_REVISION_Msk & ((value) << SMAP_IDR_REVISION_Pos)))
#define SMAP_IDR_MASK				0xFFFF00FFu		/**< \brief (SMAP_IDR)MASKڼ޽ */

/** \brief SMAPʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  WoReg   SMAP_CR;			/**< \brief (SMAPψ:0x00)ڼ޽ */
  RoReg   SMAP_SR;			/**< \brief (SMAPψ:0x04)ڼ޽ */
  WoReg   SMAP_SCR;			/**< \brief (SMAPψ:0x08)ԉڼ޽ */
  RwReg   SMAP_ADDR;		/**< \brief (SMAPψ:0x0C)ڽ ڼ޽ */
  RwReg   SMAP_LENGTH;		/**< \brief (SMAPψ:0x10)ڼ޽ */
  RwReg   SMAP_DATA;		/**< \brief (SMAPψ:0x14)ް ڼ޽ */
  RoReg8  Reserved1[0x10];
  RoReg   SMAP_VERSION;		/**< \brief (SMAPψ:0x28)ڼ޽ */
  RoReg8  Reserved2[0xC4];
  RoReg   SMAP_CIDR;		/**< \brief (SMAPψ:0xF0)IDڼ޽ */
  RoReg   SMAP_EXID;		/**< \brief (SMAPψ:0xF4)IDgڼ޽r */
  RoReg8  Reserved3[0x4];
  RoReg   SMAP_IDR;			/**< \brief (SMAPψ:0xFC)APʎqڼ޽ */
} Smap;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAM4L_SMAP_COMPONENT_ */
