/**
 * \file
 *
 * \brief CDCp֐
 *
 * 쌠 (c) 2011-2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include <asf.h>
#include "conf_usb.h"
#include "ui.h"
#include "uart.h"
// UI not used
//#define _ENABLE_UI_	
static volatile bool main_b_cdc_enable = false;

/*! \brief ֐Bs͂Ŏn܂܂B
 */
int main(void)
{
	irq_initialize_vectors();
	cpu_irq_enable();

	// x~Ǘ
	sleepmgr_init();

	sysclk_init();
	board_init();
#ifdef _ENABLE_UI_
	ui_init();
	ui_powerdown();
#endif

	// VBUSĎF؂邽߂USBKwJn
	udc_start();

	// USBǗ荞݂ɂčs邽߁AJԂ͓d͓삾Ǘ
	// ܂B
	while (true) {
		sleepmgr_enter_sleep();
	}
}

void main_suspend_action(void)
{
#ifdef _ENABLE_UI_
	ui_powerdown();
#endif
}

void main_resume_action(void)
{
#ifdef _ENABLE_UI_
	ui_wakeup();
#endif
}

void main_sof_action(void)
{
#ifdef _ENABLE_UI_
	if (!main_b_cdc_enable)
		return;
	ui_process(udd_get_frame_number());
#endif
}

bool main_cdc_enable(uint8_t port)
{
	main_b_cdc_enable = true;
	// ʐMJB
	uart_open(port);
	return true;
}

void main_cdc_disable(uint8_t port)
{
	main_b_cdc_enable = false;
	// ʐMB
	uart_close(port);
}

void main_cdc_set_dtr(uint8_t port, bool b_enable)
{
	if (b_enable) {
		// νĒ[COMJB
		ui_com_open(port);
	}else{
		// νĒ[COMB
		ui_com_close(port);
	}
}

/**
 * \mainpage ASF USBuCDC
 *
 * \section intro 
 * ۼުĂUSBPʕAtmel MCUUSBuCDC@܂B
 * AVR4907pLq͂̎ɂĂ̂葽̏񋟂܂B
 *
 * \section desc ʐMu׽(CDC)̐
 * ʐMu׽(CDC)͖\޽(USB:Universal Serial Bus)ł̒ʐM̑SĂ̌`
 * ėp̕@łB̸׽޼ٓdb۸ޕϕAXADSL⹰ٕ
 * ̂悤ȯܰû悤ȒʐMu̐ڑ\ɂ܂B
 * CDCu͂Ȃ蕡Gȑu̎ƓɁAUSBł̒ʐMɑ΂ɊȒP
 * ȕ@ƂĎgp邱Ƃł܂BႦ΁ACDCuνđł̉pJ啝
 * ɊȒPɂ鉼zCOM߰Ăɐ邱Ƃł܂B
 *
 * \section startup n
 * ۼުĂ͎MCUUSARTUSB CDC̪Ԃ̋nłB
 *
 * ۼުĂŁAUSBνĂƂPCgp܂B:
 * USBUSARTºȸq܂B
 * - USARTӋ@\USART̪ɐڑ܂B
 * - B(gݍݑ)A(PCνđ)ւ̹قŉpUSBν(Ⴆ΁APC)ɐڑ
 *   B
 * p͉zCOM߰ĂƂē܂(Windows޲ Ȱެ)B
 * - COM߰(RS232ƉzCOM)łJ܂B
 * - COM߰Ăɑ΂115200bps܂łœ`ԐݒIт܂B
 * - ʲ߰ قŕ͂Ă𑼕őԂ܂B
 *
 * \note
 * PCł̊̍ŏ̐ڑŁAڰèݸ т͐VӋ@\o܂B:
 * - ͐Vʰ޳̲ݽİ ޳J܂B
 * - ̲ݽİقɑ΂Windows UpdateɌq邽߂"A͂܂B"
 *   Iт܂B
 * - ""د܂B
 * - ײINF̧قɊւWindowsɂċ߂ꂽAtmel Studio"Solution 
 *   Explorer"޳Ŏިڸؓatmel_devices_cdc.inf̧قIт܂B
 * - ""د܂B
 *
 * \copydoc UI
 *
 * \section example ۼުĂɂ
 *
 * ۼުĂ͂Ȃ̒PʕQgp܂B:
 * - {Pʕ:
 *   nAAۯA荞݁Ad͊Ǘ
 * - USBuKwCDCPʕ:
 *   <br>services/usb/
 *   <br>services/usb/udc/
 *   <br>services/usb/class/cdc/
 * - ʂȎ:
 *    - main.c,
 *      <br>ۯ
 *      <br>荞ݏ
 *      <br>UIǗ
 *      <br>
 *    - uart_xmega.c,
 *      <br>XMEGA޲pRS232دނ̎
 *    - uart_uc3.c,
 *      <br>UC3޲pRS232دނ̎
 *    - uart_sam.c,
 *      <br>SAM޲pRS232دނ̎
 *    - eړIΏۗpL"./examples/product_board/":
 *       - conf_foo.h ePʕ̌`Ԑݒ
 *       - ui.c       gpҲ̪(LEDAtA`)̎
 */
