/**
 * \file
 *
 * \brief AVR XMEGA XCL(XMEGA_H)ڑ_H(GL)⏕Pʕײ
 *
 *
 * 쌠 (C) 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _XCL_GL_H_
#define _XCL_GL_H_

#include "compiler.h"
#include "parts.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \ingroup xcl_group
 * \defgroup xcl_gl_group XMEGA_H(XCL)ڑ_H(GL)⏕Pʕ
 *
 * ̌QLUT⏕Pʕ`Ԑݒ肷邽߂̊֐񋟂܂B
 * - xcl_lut_type()LUT``Ԑݒ
 * - xcl_lut0_output()LUT0o͂ݒ
 * - xcl_lut_config_delay()LUTx`ƈʒu`Ԑݒ
 * - xcl_lut_in0(),xcl_lut_in1(),xcl_lut_in2(),xcl_lut_in3()LUT͌`ƈʒu
 *   `Ԑݒ
 * - xcl_lut0_truth()xcl_lut1_truth()LUTQƕ\̓e`Ԑݒ
 *
 * \note ̌Q̊֐ĝɐ旧AXCLPʕxcl_enable()ŋ
 * ׂŁAXCLPʕɐڑꂽXMEGA߰Ăxcl_port()֐pđI΂ׂ
 * B
 *
 * @{
 */

/* ! XCLڑ_H(GL)`Ԑݒ\ */
struct xcl_glue_logic_config_t {
	uint8_t ctrla;
	uint8_t ctrlb;
	uint8_t ctrlc;
	uint8_t ctrld;
};

/* ! XCL LUT0o͌`Ԑݒ */
enum xcl_lut0_output_t {
	LUT0_OUT_DISABLE	= XCL_LUTOUTEN_DISABLE_gc,	/* !< LUT0o͋֎~ */
	LUT0_OUT_PIN0		= XCL_LUTOUTEN_PIN0_gc,		/* !< 0LUT0o */
	LUT0_OUT_PIN4		= XCL_LUTOUTEN_PIN4_gc,		/* !< 4LUT0o */
};

/* ! XCL LUT``Ԑݒ */
enum xcl_lut_conf_t {
	LUT_2LUT2IN			= XCL_LUTCONF_2LUT2IN_gc,	/* !< 2̓Ɨ2LUT */
	LUT_2LUT1IN			= XCL_LUTCONF_2LUT1IN_gc,	/* !< d͂ 2̓Ɨ2LUT */
	LUT_2LUT3IN			= XCL_LUTCONF_2LUT3IN_gc,	/* !< 1̋ʓ͂22LUT */
	LUT_1LUT3IN			= XCL_LUTCONF_1LUT3IN_gc,	/* !< 13LUT */
	LUT_CONF_MUX		= XCL_LUTCONF_MUX_gc,		/* !< 2LUTɂĐ䂳12͑d */
	LUT_CONF_DLATCH		= XCL_LUTCONF_DLATCH_gc,	/* !< 22LUTɂĐ䂳1Dׯ */
	LUT_CONF_RSLATCH	= XCL_LUTCONF_RSLATCH_gc,	/* !< 1RSׯLUT */
	LUT_CONF_DFF		= XCL_LUTCONF_DFF_gc,		/* !< 2̓Ɨ2LUTɂċ쓮ް1D-FF */
};

/* ! XCLLUT݌`Ԑݒ */
enum xcl_lut_in_src_t {
	LUT_IN_EVSYS	= 0,			/* !< ƂđI΂ꎖۼ */
	LUT_IN_XCL		= 0x01,			/* !< ƂđI΂ꂽXCL */
	LUT_IN_PINL		= 0x02,			/* !< ƂđI΂ꂽʑ߰  */
	LUT_IN_PINH		= 0x03,			/* !> ƂđI΂ꂽʑ߰  */
};

/* ! XCLLUTx``Ԑݒ */
enum xcl_delay_type_t {
	DLY11 = XCL_DLYSEL_DLY11_gc,	/* !< LUT1LUT0̗ɑ΂1x */
	DLY12 = XCL_DLYSEL_DLY12_gc,	/* !< LUT1ɑ΂1xLUT0ɑ΂2x */
	DLY21 = XCL_DLYSEL_DLY21_gc,	/* !< LUT1ɑ΂2xLUT0ɑ΂1x */
	DLY22 = XCL_DLYSEL_DLY22_gc,	/* !< LUT1LUT0̗ɑ΂2x */
};

/* ! XCLLUTxʒu`Ԑݒ */
enum xcl_delay_position_t {
	LUT_DLY_DISABLE	= 0x00,			/* !< xȂ */
	LUT_DLY_IN		= 0x01,			/* !< LUT͂Œx */
	LUT_DLY_OUT		= 0x02,			/* !< LUTo͂Œx */
};

/* ! XCLLUTQƕ\_@\`Ԑݒ */
enum xcl_lut_thruth_t {
	AND		= 0x8,	/* !< AND_@\ */
	NAND	= 0x7,	/* !< NAND_@\ */
	OR		= 0xE,	/* !< OR_@\ */
	XOR		= 0x6,	/* !< XOR_@\ */
	NOR		= 0x1,	/* !< NOR_@\ */
	XNOR	= 0x9,	/* !< XNOR_@\ */
	NOT_IN0	= 0x5,	/* !< IN0͂NOT_@\(IN1) */
	NOT_IN1	= 0x3,	/* !< IN1͂NOT_@\(IN0) */
	NOT_IN2	= 0x5,	/* !< IN2͂NOT_@\(IN3) */
	NOT_IN3	= 0x3,	/* !< IN3͂NOT_@\(IN2) */
	IN0		= 0xA,	/* !< IN0͂𕡐(IN1) */  
	IN1		= 0xC,	/* !< IN1͂𕡐(IN0) */
	IN2		= 0xA,	/* !< IN2͂𕡐(IN3) */  
	IN3		= 0xC,	/* !< IN3͂𕡐(IN2) */  
};

/**
 * \brief XCLLUT0o͂`Ԑݒ
 *
 * ̊֐XCLLUT0o(OUT0)`Ԑݒ肵܂B
 *
 * \param  lut0out I񂾏o
 */
static inline void xcl_lut0_output(enum xcl_lut0_output_t lut0out)
{
	XCL.CTRLA &= ~XCL_LUT0OUTEN_gm;
	XCL.CTRLA |= lut0out;
}

/**
 * \brief XCLLUT`Ԑݒ^`Ԑݒ
 *
 * ̊֐XCL``Ԑݒ肵܂B
 *
 * \param  lutconf ILUT`
 */
static inline void xcl_lut_type(enum xcl_lut_conf_t lutconf)
{
	XCL.CTRLA &= ~XCL_LUTCONF_gm;
	XCL.CTRLA |= lutconf;
}

/**
 * \brief XCLLUT IN0͂`Ԑݒ
 *
 * ̊֐IN0͂`Ԑݒ肵܂B
 *
 * \param  in IIN0`
 */
static inline void xcl_lut_in0(enum xcl_lut_in_src_t in)
{
	XCL.CTRLB &= ~XCL_IN0SEL_gm;
	XCL.CTRLB |= in << XCL_IN0SEL_gp;
}

/**
 * \brief XCLLUT IN1͂`Ԑݒ
 *
 * ̊֐IN1͂`Ԑݒ肵܂B
 *
 * \param  in IIN1`
 */
static inline void xcl_lut_in1(enum xcl_lut_in_src_t in)
{
	XCL.CTRLB &= ~XCL_IN1SEL_gm;
	XCL.CTRLB |= in << XCL_IN1SEL_gp;
}

/**
 * \brief XCLLUT IN2͂`Ԑݒ
 *
 * ̊֐IN2͂`Ԑݒ肵܂B
 *
 * \param  in IIN2`
 */
static inline void xcl_lut_in2(enum xcl_lut_in_src_t in)
{
	XCL.CTRLB &= ~XCL_IN2SEL_gm;
	XCL.CTRLB |= in << XCL_IN2SEL_gp;
}

/**
 * \brief XCLLUT IN3͂`Ԑݒ
 *
 * ̊֐IN3͂`Ԑݒ肵܂B
 *
 * \param  in IIN3`
 */
static inline void xcl_lut_in3(enum xcl_lut_in_src_t in)
{
	XCL.CTRLB &= ~XCL_IN3SEL_gm;
	XCL.CTRLB |= in << XCL_IN3SEL_gp;
}

/**
 * \brief XCLLUTx`Ԑݒ
 *
 * ̊֐XCLLUTxق`Ԑݒ肵܂B
 *
 * \param  dly_type     x`(LUT0/LUT1܂͗)
 * \param  lut0_dly_pos LUT0pxوʒu
 * \param  lut1_dly_pos LUT1pxوʒu
 */
static inline void xcl_lut_config_delay(enum xcl_delay_type_t dly_type,
		enum xcl_delay_position_t lut0_dly_pos,
		enum xcl_delay_position_t lut1_dly_pos)
{
	XCL.CTRLC = 0;
	XCL.CTRLC |= (uint8_t)dly_type | (uint8_t)lut0_dly_pos
			| (uint8_t)lut1_dly_pos << XCL_DLY1CONF_gp;
}

/**
 * \brief XCLLUT0Qƕ\`Ԑݒ
 *
 * ̊֐͗vꂽ_@\ɏ]ĈvLUT`ԐݒXCLLUT0`Ԑݒ
 * ܂B
 *
 * \param  thruth Qƕ\̒l
 */
static inline void xcl_lut0_truth(enum xcl_lut_thruth_t thruth)
{
	XCL.CTRLD &= ~XCL_TRUTH0_gm;
	XCL.CTRLD |= thruth << XCL_TRUTH0_gp;
}

/**
 * \brief XCLLUT1Qƕ\`Ԑݒ
 *
 * ̊֐͗vꂽ_@\ɏ]ĈvLUT`ԐݒXCLLUT1`Ԑݒ
 * ܂B
 *
 * \param  thruth Qƕ\̒l
 */
static inline void xcl_lut1_truth(enum xcl_lut_thruth_t thruth)
{
	XCL.CTRLD &= ~XCL_TRUTH1_gm;
	XCL.CTRLD |= thruth << XCL_TRUTH1_gp;
}

/** @} */

#ifdef __cplusplus
}
#endif

#endif  /* _XCL_GL_H_ */
